defint a-z

#include once "/sdl/sdl.bi"
#include once "/sdl/sdl_image.bi"

declare function checmouse (x0, y0, x1, y1)
declare sub deinit ()
declare sub drawBox (x0, y0, x1, y1, col as uint32)
declare sub drawTabs ()
declare sub drawWin ()
declare sub drawWinDisplay ()
declare sub drawWinDisplayOption (rx, ry, icon_temp as sdl_surface ptr, txt$)
declare sub drawWinDisplayOptionQuality (rx, ry, icon_temp as sdl_surface ptr, txt$)
declare sub drawWinDisplayOptionFSAA (rx, ry, icon_temp as sdl_surface ptr, txt$)
declare sub drawWinInput ()
declare sub drawWinInputGameController ()
declare sub drawWinInputKeyboard ()
declare sub drawWinVideo ()
declare sub font_loadfont (font$)
declare sub font_print (x, y, txt$)
declare function font_len (txt$)
declare function getInput ()
declare sub init ()
declare sub main ()
declare sub upd_joyStatus ()
declare sub updateUI_display ()
declare sub updateUI_displayCheckButton (rx, ry, opt)
declare sub updateUI_displayCheckButtonQuality (rx, ry, opt)
declare sub updateUI_displayCheckButtonFSAA (rx, ry, opt)
declare sub updateUI_input ()
declare sub updateUI_inputGameController ()
declare sub updateUI_inputKeyboard ()
declare sub updateUI_video ()

dim shared video as sdl_surface ptr, videoBuffer as sdl_surface ptr
dim shared keys as uint8 ptr
dim shared mouse as uint8, mousex, mousey, event as SDL_EVENT

dim shared waitticks, ticks

dim shared srcRect as sdl_rect
dim shared dstRect as sdl_rect

dim shared fmt as sdl_pixelFormat ptr
dim shared colorgrey as uint32
dim shared colorDkGrey as uint32
dim shared colorWhite as uint32
dim shared colorLtGrey as uint32
dim shared colorLtBlue as uint32
dim shared colorLtGreen as uint32
dim shared colorGreyBlue as uint32


dim shared configBar as sdl_surface ptr
dim shared icon_linesmoothing as sdl_surface ptr
dim shared icon_outlines as sdl_surface ptr
dim shared icon_dome as sdl_surface ptr
dim shared icon_buildings as sdl_surface ptr
dim shared icon_hudhousing as sdl_surface ptr
dim shared icon_hudquality as sdl_surface ptr
dim shared icon_envmap as sdl_surface ptr
dim shared icon_bloom as sdl_surface ptr

dim shared icon_enginewind as sdl_surface ptr
dim shared icon_fsaa as sdl_surface ptr

'font info
dim shared fontimg(96) as sdl_surface ptr, charWidth(96), charMinx(96)
const PATH_FONTS="data/fontimg/"

'available video modes
dim shared nVideoModes(2), videoMode(2, 99, 1)

const nTabs = 3
const WIN_VIDEO = 0, WIN_INPUT = 1, WIN_DISPLAY = 2

dim shared win, tabname$(nTabs - 1)
dim shared winBuffer(nTabs - 1) as sdl_surface ptr, updWinBuffer

const VIDEO_FULLSCREEN = 1, VIDEO_WINDOWED = 0
CONST INPUT_KEYBOARD = 0, INPUT_GAMECONTROLLER = 1

type configVarType
    xres    as integer
    yres    as integer
    nBits   as byte
    fullScreen  as byte
    inputType   as byte
    axisMin(5)  as single
    axisMax(5)  as single
    axisCenter(5)   as single
    joystick    as byte
    control(12)  as byte
    displayOption(23)  as byte
end type

#define OPTION_OUTLINES 0
#define OPTION_LINESMOOTHING 1
#DEFINE OPTION_ENGINEWIND 2
#DEFINE OPTION_DOME 3
#DEFINE OPTION_BUILDINGS 4
'#DEFINE OPTION_HUDQUALITY 5
#define OPTION_BLOOM 5
#DEFINE OPTION_HUDHOUSING 6
#DEFINE OPTION_FSAA 7
#DEFINE OPTION_ENVMAP 8
dim shared configVars as configVarType

'joystick info
dim shared lastJoy, lastAxis

'gamepad ui
dim shared colWidth(9)

const nControlNames = 99
const CONTROL_NOTSET = 0
CONST CONTROL_JOY_B1 = 1, CONTROL_JOY_B2 = 2, CONTROL_JOY_B3 = 3, CONTROL_JOY_B4 = 4
CONST CONTROL_JOY_B5 = 5, CONTROL_JOY_B6 = 6, CONTROL_JOY_B7 = 7, CONTROL_JOY_B8 = 8
CONST CONTROL_JOY_B9 = 9, CONTROL_JOY_B10 = 10, CONTROL_JOY_B11 = 11, CONTROL_JOY_B12 = 12
CONST CONTROL_JOY_B13 = 13, CONTROL_JOY_B14 = 14, CONTROL_JOY_B15 = 15, CONTROL_JOY_B16 = 16

CONST CONTROL_AXIS_0_NEGATIVE = 17, CONTROL_AXIS_0_POSITIVE = 18
CONST CONTROL_AXIS_1_NEGATIVE = 19, CONTROL_AXIS_1_POSITIVE = 20
CONST CONTROL_AXIS_2_NEGATIVE = 21, CONTROL_AXIS_2_POSITIVE = 22
CONST CONTROL_AXIS_3_NEGATIVE = 23, CONTROL_AXIS_3_POSITIVE = 24
CONST CONTROL_AXIS_4_NEGATIVE = 25, CONTROL_AXIS_4_POSITIVE = 26
CONST CONTROL_AXIS_5_NEGATIVE = 27, CONTROL_AXIS_5_POSITIVE = 28

#DEFINE CONTROL_KB_A 29
#DEFINE CONTROL_KB_B 30
#DEFINE CONTROL_KB_C 31
#DEFINE CONTROL_KB_D 32
#DEFINE CONTROL_KB_E 33
#DEFINE CONTROL_KB_F 34
#DEFINE CONTROL_KB_G 35
#DEFINE CONTROL_KB_H 36
#DEFINE CONTROL_KB_I 37
#DEFINE CONTROL_KB_J 38
#DEFINE CONTROL_KB_K 39
#DEFINE CONTROL_KB_L 40
#DEFINE CONTROL_KB_M 41
#DEFINE CONTROL_KB_N 42
#DEFINE CONTROL_KB_O 43
#DEFINE CONTROL_KB_P 44
#DEFINE CONTROL_KB_Q 45
#DEFINE CONTROL_KB_R 46
#DEFINE CONTROL_KB_S 47
#DEFINE CONTROL_KB_T 48
#DEFINE CONTROL_KB_U 49
#DEFINE CONTROL_KB_V 50
#DEFINE CONTROL_KB_W 51
#DEFINE CONTROL_KB_X 52
#DEFINE CONTROL_KB_Y 53
#DEFINE CONTROL_KB_Z 54
#DEFINE CONTROL_KB_0 55
#DEFINE CONTROL_KB_1 56
#DEFINE CONTROL_KB_2 57
#DEFINE CONTROL_KB_3 58
#DEFINE CONTROL_KB_4 59
#DEFINE CONTROL_KB_5 60
#DEFINE CONTROL_KB_6 61
#DEFINE CONTROL_KB_7 62
#DEFINE CONTROL_KB_8 63
#DEFINE CONTROL_KB_9 64
#DEFINE CONTROL_KB_KP0 65
#DEFINE CONTROL_KB_KP1 66
#DEFINE CONTROL_KB_KP2 67
#DEFINE CONTROL_KB_KP3 68
#DEFINE CONTROL_KB_KP4 69
#DEFINE CONTROL_KB_KP5 70
#DEFINE CONTROL_KB_KP6 71
#DEFINE CONTROL_KB_KP7 72
#DEFINE CONTROL_KB_KP8 73
#DEFINE CONTROL_KB_KP9 74
#DEFINE CONTROL_KB_LCTRL    75
#DEFINE CONTROL_KB_RCTRL    76
#DEFINE CONTROL_KB_LSHIFT   77
#DEFINE CONTROL_KB_RSHIFT   78
#DEFINE CONTROL_KB_SPACE    79
#DEFINE CONTROL_KB_TAB      80
#DEFINE CONTROL_KB_RETURN   81
#DEFINE CONTROL_KB_LALT     82
#DEFINE CONTROL_KB_RALT     83

#DEFINE CONTROL_KB_UP       84
#DEFINE CONTROL_KB_DOWN     85
#DEFINE CONTROL_KB_LEFT     86
#DEFINE CONTROL_KB_RIGHT    87

#DEFINE CONTROL_KB_INSERT   88
#DEFINE CONTROL_KB_HOME     89
#DEFINE CONTROL_KB_END      90
#DEFINE CONTROL_KB_DELETE   91
#DEFINE CONTROL_KB_PAGEUP   92
#DEFINE CONTROL_KB_PAGEDOWN 93

#DEFINE CONTROL_KB_KP_PERIOD    94
#DEFINE CONTROL_KB_KP_DIVIDE    95
#DEFINE CONTROL_KB_KP_MULTIPLY  96
#DEFINE CONTROL_KB_KP_MINUS     97
#DEFINE CONTROL_KB_KP_PLUS      98
#DEFINE CONTROL_KB_KP_ENTER     99


dim shared controlName$(nControlNames), controlNameLen

dim shared popupMsg$, msgTicks, joywaitTicks

init
main


function checkmouse (x0, y0, x1, y1)
    
    ret = 0
    if mousex >= x0 and mousex <= x1 and mousey >= y0 and mousey <= y1 then ret = 1
    
    checkmouse = ret
end function

sub deinit
    
    sdl_quit
    end
    
end sub

sub drawBox (x0, y0, x1, y1, col as uint32)
    
    dstRect.x = x0
    dstRect.y = y0
    dstRect.w = x1 - x0 + 1
    dstRect.h = y1 - y0 + 1
    
    sdl_fillRect videoBuffer, @dstRect, col
    dstRect.x += 1
    dstRect.y += 1
    dstRect.w -= 2
    dstRect.h -= 2
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
end sub


sub drawTabs
    
    dstRect.x = 0
    dstRect.y = 0
    dstRect.w = 640
    dstRect.h = 24
    sdl_fillrect videoBuffer, @dstRect, colorDkGrey
    
    tabWidth = 100
    tabSpace = 8
    tabEndY = 22
    
    dim tabColor as uint32
    for tb = 0 to nTabs - 1
        for col = 0 to 15
            dstRect.x = col + tb * (TabWidth + tabSpace)
            dstRect.y = tabEndY - col
            if tb = win then dstRect.y += 1
            dstRect.w = tabWidth - col * 2
            dstRect.h = 1
            
            tabColor = colorGrey
            if tb = win then tabColor = colorLtGrey
            sdl_FillRect videoBuffer, @dstRect, tabColor
        next
    next
    
    tabname$(WIN_VIDEO) = "Video"
    tabname$(WIN_INPUT) = "Input"
    tabname$(WIN_DISPLAY) = "Display"
    for tb = 0 to nTabs - 1
        wdth = font_len(tabname$(tb))
        if tb <> win then font_print tb * (TabWidth + tabSpace) + (TabWidth - wdth) / 2, 9, tabname$(tb)
        if tb = win then font_print tb * (TabWidth + tabSpace) + (TabWidth - wdth) / 2, 10, tabname$(tb)
    next
    
    buttonWidth = 80
    buttonSpace = 8
    buttonEndY = 22
    
    nbuttons = 3
    dim buttonName$(3)
    buttonname$(0) = "Exit"
    buttonname$(1) = "Reload"
    buttonname$(2) = "Save"
    
    for tb = 0 to nbuttons - 1
        for col = 0 to 15
            dstRect.x = 640 - (tb + 1) * (buttonWidth) - tb * buttonSpace + col
            dstRect.y = tabEndY - col
            dstRect.w = buttonWidth - col * 2
            dstRect.h = 1
            
            tabColor = colorGreyBlue
            sdl_FillRect videoBuffer, @dstRect, tabColor
        next
        
        wdth = font_len(buttonname$(tb))
        font_print dstRect.x + (dstRect.w - wdth) / 2, 9, buttonname$(tb)
    next
    
    
end sub

sub drawUI
    
    if updWinBuffer = 1 then
        drawTabs
        drawWin
        sdl_blitSurface videoBuffer, null, winBuffer(win), null
    end if
    
    updWinBuffer = 0
    
    sdl_blitSurface winBuffer(win), null, videoBuffer, null
    if win = WIN_VIDEO then updateUI_video
    if win = WIN_INPUT then updateUI_input
    if win = WIN_DISPLAY then updateUI_display
    
    tabWidth = 100
    tabSpace = 8
    tabEndY = 20
    
    for tb = 0 to nTabs - 1
        wdth = font_len(tabname$(tb))
        
        x0 = tb * (TabWidth + tabSpace)
        y0 = 6
        x1 = x0 + TabWidth
        y1 = y0 + 16
        if mousex >= x0 and mousex <= x1 and mousey >= y0 and mousey <= y1 then
            if mouse and SDL_BUTTON(1) then win = tb
        end if
    next
    
    buttonWidth = 80
    buttonSpace = 8
    buttonEndY = 22
    
    nbuttons = 3
    for tb = 0 to nbuttons - 1
        x0 = 640 - (tb + 1) * (buttonWidth) - tb * buttonSpace
        y0 = 6
        x1 = x0 + buttonWidth
        y1 = y0 + 16
        if mousex >= x0 and mousex <= x1 and mousey >= y0 and mousey <= y1 then
            if mouse and SDL_BUTTON(1) then
                if tb = 0 then deinit
                if tb = 1 then
                    open "configVars.dat" for input as #1
                        input #1, configVars.xres
                        input #1, configVars.yres
                        input #1, configVars.nBits
                        input #1, configVars.fullScreen
                        input #1, configVars.inputType
                        for axis = 0 to 5
                            input #1, configVars.axisMin(axis)
                            input #1, configVars.axisMax(axis)
                            'input #1, configVars.axisCenter(axis)
                        next
                        input #1, configVars.joystick
                        for control = 0 to 12
                            input #1, configVars.control(control)
                        next
                        for displayoption = 0 to 23
                            input #1, configVars.displayOption(displayOption)
                        next
                    close #1
                    updWinBuffer = 1
                    msgTicks = sdl_getTicks + 2000
                    popupMsg$ = "Game Configuration Restored!"
                end if
                if tb = 2 then 
                    open "configVars.dat" for output as #1
                        print #1, configVars.xres
                        print #1, configVars.yres
                        print #1, configVars.nBits
                        print #1, configVars.fullScreen
                        print #1, configVars.inputType
                        for axis = 0 to 5
                            print #1, configVars.axisMin(axis)
                            print #1, configVars.axisMax(axis)
                            'print #1, configVars.axisCenter(axis)
                        next
                        print #1, configVars.joystick
                        for control = 0 to 12
                            print #1, configVars.control(control)
                        next
                        for displayoption = 0 to 23
                            print #1, configVars.displayOption(displayOption)
                        next
                    close #1
                    msgTicks = sdl_getTicks + 2000
                    popupMsg$ = "Game Configuration Saved!"
                end if
                
            end if
        end if
    next
    
    if msgTicks > ticks then
        wdth = font_len(popupMsg$) + 32
        x0 = 320 - wdth / 2
        y0 = 240 - 32
        x1 = x0 + wdth
        y1 = y0 + 64
        
        drawBox x0, y0, x1, y1, colordkgrey
        drawBox x0 + 8, y0 + 8, x1 - 8, y1 - 8, colorltBlue
        font_print 320 - font_len(popupMsg$) / 2, 240 - 6, popupMsg$
    end if
    
end sub


sub drawWin
    
    dstRect.x = 0
    dstRect.y = 24
    dstRect.w = 640
    dstRect.h = 456
    sdl_fillrect videoBuffer, @dstRect, colorGrey

    if win = WIN_INPUT then drawWinInput
    if win = WIN_VIDEO then drawWinVideo
    if win = WIN_DISPLAY then drawWinDisplay
    
end sub

sub drawWinDisplay
    
    
    font_print 8, 32, "Display Settings:"
    
    exit sub
    colx2 = 240
    drawBox 8, 47, colx2 - 16, 63, colordkgrey
    drawBox colx2, 47, 640- 8, 63, colordkgrey
    font_print 16, 50, "General:"
    font_print colx2 + 8, 50, "Effects:"
    
    drawWinDisplayOption 0, 16 + 50 * 1, icon_linesmoothing, "Line Smoothing"
    drawWinDisplayOption 0, 16 + 50 * 2, icon_outlines, "Polygon Outlines"
    drawWinDisplayOption 0, 16 + 50 * 3, icon_dome, "City Dome"
    drawWinDisplayOption 0, 16 + 50 * 4, icon_buildings, "Buildings"
    'drawWinDisplayOption 0, 16 + 50 * 5, icon_hudhousing, "Hud Housing"
    drawWinDisplayOption 0, 16 + 50 * 5, icon_envmap, "Environment Mapping"
    
    colx2 = 240
    drawWinDisplayOption colx2, 16 + 50 * 1, icon_enginewind, "Engine Wind"
    drawWinDisplayOptionFSAA colx2, 16 + 50 * 2, icon_fsaa, "Full Screen Anti-Aliasing"
    drawWinDisplayOption colx2, 16 + 50 * 3, icon_bloom, "Bloom"
    'drawWinDisplayOptionQuality colx2, 16 + 50 * 3, icon_hudquality, "Hud Quality"
    
end sub

sub drawWinDisplayOption (rx, ry, icon_temp as sdl_surface ptr, txt$)
    
    wdth = 36
    lenOff = font_len("OFF")
    lenOn = font_len("ON")
    
    
    dstRect.x = rx + 8
    dstRect.y = ry
    x0 = rx + 100
    x1 = rx + 140
    y0 = dstRect.y + 20
    sdl_blitSurface icon_temp, null, videoBuffer, @dstRect
    drawBox x0, y0, x0 + wdth, y0 + 16, colordkGrey
    font_print x0 + (wdth - lenON) / 2, y0 + 2, "ON"
    drawBox x1, y0, x1 + wdth, y0 + 16, colordkGrey
    font_print x1 + (wdth - lenOFF) / 2, y0 + 2, "OFF"
    
end sub

sub drawWinDisplayOptionQuality (rx, ry, icon_temp as sdl_surface ptr, txt$)
    
    wdth = 36
    dim optn$(4)
    optn$(1) = "Poor"
    optn$(2) = "Fair"
    optn$(3) = "Good"
    optn$(4) = "Excellent"
    
    dstRect.x = rx + 8
    dstRect.y = ry
    
    x0 = rx + 80
    y0 = dstRect.y + 20
    
    sdl_blitSurface icon_temp, null, videoBuffer, @dstRect
    font_print rx + 78, int(dstRect.y) + 4, txt$
    
    for i = 1 to 4
        wdth = font_len(optn$(i))
        drawBox x0, y0, x0 + wdth + 8, y0 + 16, colordkGrey
        font_print x0 + 4, y0 + 2, optn$(i)
        x0 += wdth + 16
    next
    
end sub

sub drawWinDisplayOptionFSAA (rx, ry, icon_temp as sdl_surface ptr, txt$)
    
    wdth = 36
    dim optn$(4)
    optn$(3) = "8x"
    optn$(2) = "4x"
    optn$(1) = "2x"
    optn$(0) = "None"
    
    dstRect.x = rx + 8
    dstRect.y = ry
    
    x0 = rx + 100'80
    y0 = dstRect.y + 20
    
    sdl_blitSurface icon_temp, null, videoBuffer, @dstRect
    font_print rx + 78, int(dstRect.y) + 4, txt$
    
    for i = 0 to 3
        wdth = font_len(optn$(i))
        drawBox x0, y0, x0 + wdth + 8, y0 + 16, colordkGrey
        font_print x0 + 4, y0 + 2, optn$(i)
        x0 += wdth + 16
    next
    
end sub


sub drawWinInput
    
    dstRect.x = 0
    dstRect.y = 24
    sdl_blitSurface configBar, null, videoBuffer, @dstRect
    
    font_print 160, 32, "Input Type:"
    
    maxLen = font_len("Game Controller")
    
    dstRect.x = 264
    dstRect.y = 30
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorDkGrey
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("Keyboard")) / 2, dstRect.y + 2, "Keyboard"
    
    dstRect.x = 264
    dstRect.y = 30 + 22
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorDkGrey
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("Game Controller")) / 2, dstRect.y + 2, "Game Controller"
    
    if configVars.inputType = INPUT_KEYBOARD then drawWinInputKeyboard
    if configVars.inputType = INPUT_GAMECONTROLLER then drawWinInputGameController
end sub

sub drawWinInputGameController
    maxLen = font_len("Game Controller")
    
    dstRect.x = 264
    dstRect.y = 30 + 22
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorLtGreen
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("Game Controller")) / 2, dstRect.y + 2, "Game Controller"
    
    
    font_print 160, 80, "Joystick:"
    
    if lastjoy = -1 then
        font_print 240, 80, "None Detected!"
        exit sub
    end if
    maxLen = 0
    for i = 0 to lastJoy
        ln = font_len(str$(i))
        if ln > maxLen then maxLen = ln
    next
    
    for i = 0 to lastJoy
        dstRect.x = 264 + i * (8 + maxLen + 16)
        dstRect.y = 78
        dstRect.h = 16
        dstRect.w = maxLen + 8
        
        colr = colorDkGrey
        if configVars.joystick = i then colr = colorLtGreen
        sdl_fillRect videoBuffer, @dstRect, colr
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (dstRect.w - font_len(str$(i))) / 2, dstRect.y + 1, str$(i)
    next
    
    font_print 160, 106, "Move each analog axis to its extreme to calibrate"
    
    wdth = 52
    dstRect.x = 580
    dstRect.y = 102
    dstRect.w = 52
    dstRect.h = 16
    
    sdl_fillRect videoBuffer, @dstRect, colorDkGrey
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.w -= 2
    dstRect.h -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (wdth - font_len("Reset")) / 2, 104, "Reset"
    
    font_print 440, 210, "Click to Set"
    font_print 160, 210, "Flying Controls:"
    
    dim controls$(11)
    controls$(0) = "Rotate Left"
    controls$(1) = "Rotate Right"
    controls$(2) = "Strafe Left"
    controls$(3) = "Strafe Right"
    controls$(4) = "Thrust"
    controls$(5) = "Reverse"
    controls$(6) = "Land / Activate Check Point"
    controls$(7) = "Mission Window / Accept"
    controls$(8) = "Mini Map Toggle / Cancel"
    controls$(9) = "Previous"
    controls$(10) = "Next"
    controls$(11) = "Use"
    
    
    wdth = controlNameLen + 16
    
    for i = 0 to 8
        font_print 200, 226 + i * 18, controls$(i)
        
        dstRect.x = 440
        dstRect.y = 225 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i))
    next
    
    font_print 160, 400, "Weapon Controls:"
    
    for i = 0 to 2
        font_print 200, 416 + i * 18, controls$(i + 9)
        
        dstRect.x = 440
        dstRect.y = 415 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i+9))
    next
    
    
    
end sub

sub drawWinInputKeyboard
    maxLen = font_len("Game Controller")
    
    dstRect.x = 264
    dstRect.y = 30
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorLtGreen
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("Keyboard")) / 2, dstRect.y + 2, "Keyboard"
    
    font_print 440, 80, "Click to Set"
    font_print 160, 80, "Flying Controls:"
    
    dim controls$(11)
    controls$(0) = "Rotate Left"
    controls$(1) = "Rotate Right"
    controls$(2) = "Strafe Left"
    controls$(3) = "Strafe Right"
    controls$(4) = "Thrust"
    controls$(5) = "Reverse"
    controls$(6) = "Land / Activate Check Point"
    controls$(7) = "Mission Window / Accept"
    controls$(8) = "Mini Map Toggle / Cancel"
    controls$(9) = "Previous"
    controls$(10) = "Next"
    controls$(11) = "Use"
    
    wdth = controlNameLen + 16
    
    for i = 0 to 8
        font_print 200, 96 + i * 18, controls$(i)
        
        dstRect.x = 440
        dstRect.y = 95 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i))
    next
    
    font_print 160, 270, "Weapon Controls:"
    
    for i = 0 to 2
        font_print 200, 286 + i * 18, controls$(i + 9)
        
        dstRect.x = 440
        dstRect.y = 285 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i+9))
    next
    
end sub


sub drawWinVideo
    
    font_print 8, 32, "Selected Resolution:"
    
    maxLen = 0
    for tb = 0 to 2
        if nVideoModes(tb) > 0 then
            for mode = 0 to nVideoModes(tb) - 1
                ln = font_len(str$(videoMode(tb, mode, 0)) + "x" + str$(videoMode(tb, mode, 1)))
                if ln > maxLen then maxLen = ln
            next
        end if
    next
    
    
    nCols = int((640 - 16) / (maxLen + 16))
    maxLen = (640 - 16) / nCols - 16
    col = 0
    
    basey = 64
    for tb = 0 to 2
        if nVideoModes(tb) > 0 then
            font_print 8, basey, "Bit Depth: " + str$(tb * 8 + 16)
            
            col = 0
            row = 1
            for mode = nVideoModes(tb) - 1 to 0 step -1
                dstRect.x = 8 + col * (maxLen + 16)
                dstRect.y = basey + row * 18
                dstRect.h = 16
                dstRect.w = maxLen + 8
                
                sdl_fillRect videoBuffer, @dstRect, colorDkGrey
                dstRect.x += 1
                dstRect.y += 1
                dstRect.w -= 2
                dstRect.h -= 2
                sdl_fillRect videoBuffer, @dstRect, colorGrey
                
                font_print 8 + col * (maxLen + 16) + 8, basey + row * 18 + 2, str$(videoMode(tb, mode, 0)) + "x" + str$(videoMode(tb, mode, 1))
                col += 1
                if col = nCols and mode > 0 then
                    col = 0
                    row += 1
                end if
                
            next
            basey += (row + 2) * 18
        end if
    next
    
    maxLen = font_len("FullScreen")
    
    dstRect.x = 640 - 8 - maxLen - 16
    dstRect.y = 32
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorDkGrey
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("FullScreen")) / 2, dstRect.y + 2, "FullScreen"
    
    dstRect.x = 640 - 8 - maxLen - 16
    dstRect.y = 32 + 20
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    sdl_fillRect videoBuffer, @dstRect, colorDkGrey
    
    dstRect.x += 1
    dstRect.y += 1
    dstRect.h -= 2
    dstRect.w -= 2
    
    sdl_fillRect videoBuffer, @dstRect, colorGrey
    
    font_print dstRect.x + (maxLen + 16 - font_len("Windowed")) / 2, dstRect.y + 2, "Windowed"
end sub


sub font_loadfont (font$)
        
    fontfolder$ = PATH_FONTS + font$ + "/"
    fontwidth = 12
    fontheight = 12
    
    dim tempimg as SDL_Surface ptr
    dim temp as uinteger ptr, cc as unsigned integer
    'x/y/u/v
    
    for ch = 32 to 126
        fil$ = fontfolder$ + ltrim$(rtrim$(str$(ch))) + ".png"
        fontimg(ch-32) = IMG_Load(fil$)
        
        SDL_SetAlpha fontimg(ch-32), SDL_SRCALPHA, 255
        
        tempimg = fontimg(ch-32)
        
        minx = fontwidth
        maxx = 0
        cc = 16777215
        for x = 0 to fontwidth - 1
            for y = 0 to fontheight - 1
                temp = tempimg->pixels + y * tempimg->pitch + x * tempimg->format->BytesPerPixel
                if *temp <> cc then
                    if x < minx then minx = x
                    if x > maxx then maxx = x
                end if
            next
        next
        
        minx = minx - 1
        if minx < 0 then minx = 0
        if maxx - minx < 3 then
            minx = minx - 2
            maxx = maxx + 2
        end if
        
        charwidth(ch-32) = maxx-minx + 1
        if ch = 32 then charwidth(0) = 10
        charMinx(ch-32) = minx
        
    next
    
    
end sub

sub font_print (x, y, txt$)
    
    basex = x
    lentxt = len(txt$)
    for char = 1 to lentxt
        m$ = mid$(txt$, char, 1)
        masc = asc(m$) - 32
        if masc > -1 and masc < 97 then
        
            srcRect.x = charMinx(masc)
            srcRect.y = 0
            srcRect.h = 16
            srcRect.w = charWidth(masc)
            
            dstRect.x = basex
            dstRect.y = y
            
            sdl_blitSurface fontImg(masc), @srcRect, videoBuffer, @dstRect
            
            basex += srcRect.w
        end if
    next
    
end sub

function font_len (txt$)
    wdth = 0
    
    lentxt = len(txt$)
    for char = 1 to lentxt
        m$ = mid$(txt$, char, 1)
        masc = asc(m$) - 32
        if masc > -1 and masc < 97 then wdth += charWidth(masc)
    next
    
    font_len = wdth
end function


function getInput
    
    waitticks = sdl_getTicks + 200
    ret = -1
    
    while sdl_getTicks < waitticks: wend
    
    dim axis!(5)
    
    do
    
        sdl_pumpEvents
        keys = sdl_getKeyState (null)
        
        
        if configVars.inputType = INPUT_GAMECONTROLLER and lastjoy > -1 then
            temp = getjoystick(configVars.joystick, buttons, axis!(0), axis!(1), axis!(2), axis!(3), axis!(4), axis!(5))
            
            for i = 0 to 15
                num = 2 ^ i
                if buttons and num then
                    ret = i + 1
                    exit do
                end if
            next
            
            for axi = 0 to lastAxis
                if axis!(axi) = configVars.axisMin!(axi) then
                    ret = axi * 2 + 0 + 17
                    exit do
                end if
                if axis!(axi) = configVars.axisMax!(axi) then
                    ret = axi * 2 + 1 + 17
                    exit do
                end if
            next
        end if
        
        if configVars.inputType = INPUT_KEYBOARD then
            if keys[SDLK_A] then ret = CONTROL_KB_A
            if keys[SDLK_B] then ret = CONTROL_KB_B
            if keys[SDLK_C] then ret = CONTROL_KB_C
            if keys[SDLK_D] then ret = CONTROL_KB_D
            if keys[SDLK_E] then ret = CONTROL_KB_E
            if keys[SDLK_F] then ret = CONTROL_KB_F
            if keys[SDLK_G] then ret = CONTROL_KB_G
            if keys[SDLK_H] then ret = CONTROL_KB_H
            if keys[SDLK_I] then ret = CONTROL_KB_I
            if keys[SDLK_J] then ret = CONTROL_KB_J
            if keys[SDLK_K] then ret = CONTROL_KB_K
            if keys[SDLK_L] then ret = CONTROL_KB_L
            if keys[SDLK_M] then ret = CONTROL_KB_M
            if keys[SDLK_N] then ret = CONTROL_KB_N
            if keys[SDLK_O] then ret = CONTROL_KB_O
            if keys[SDLK_P] then ret = CONTROL_KB_P
            if keys[SDLK_Q] then ret = CONTROL_KB_Q
            if keys[SDLK_R] then ret = CONTROL_KB_R
            if keys[SDLK_S] then ret = CONTROL_KB_S
            if keys[SDLK_T] then ret = CONTROL_KB_T
            if keys[SDLK_U] then ret = CONTROL_KB_U
            if keys[SDLK_V] then ret = CONTROL_KB_V
            if keys[SDLK_W] then ret = CONTROL_KB_W
            if keys[SDLK_X] then ret = CONTROL_KB_X
            if keys[SDLK_Y] then ret = CONTROL_KB_Y
            if keys[SDLK_Z] then ret = CONTROL_KB_Z
            if keys[SDLK_0] then ret = CONTROL_KB_0
            if keys[SDLK_1] then ret = CONTROL_KB_1
            if keys[SDLK_2] then ret = CONTROL_KB_2
            if keys[SDLK_3] then ret = CONTROL_KB_3
            if keys[SDLK_4] then ret = CONTROL_KB_4
            if keys[SDLK_5] then ret = CONTROL_KB_5
            if keys[SDLK_6] then ret = CONTROL_KB_6
            if keys[SDLK_7] then ret = CONTROL_KB_7
            if keys[SDLK_8] then ret = CONTROL_KB_8
            if keys[SDLK_9] then ret = CONTROL_KB_9
            if keys[SDLK_KP0] then ret = CONTROL_KB_KP0
            if keys[SDLK_KP1] then ret = CONTROL_KB_KP1
            if keys[SDLK_KP2] then ret = CONTROL_KB_KP2
            if keys[SDLK_KP3] then ret = CONTROL_KB_KP3
            if keys[SDLK_KP4] then ret = CONTROL_KB_KP4
            if keys[SDLK_KP5] then ret = CONTROL_KB_KP5
            if keys[SDLK_KP6] then ret = CONTROL_KB_KP6
            if keys[SDLK_KP7] then ret = CONTROL_KB_KP7
            if keys[SDLK_KP8] then ret = CONTROL_KB_KP8
            if keys[SDLK_KP9] then ret = CONTROL_KB_KP9
            if keys[SDLK_LCTRL] then ret = CONTROL_KB_LCTRL
            if keys[SDLK_RCTRL] then ret = CONTROL_KB_RCTRL
            if keys[SDLK_LSHIFT] then ret = CONTROL_KB_LSHIFT
            if keys[SDLK_RSHIFT] then ret = CONTROL_KB_RSHIFT
            if keys[SDLK_LALT] then ret = CONTROL_KB_LALT
            if keys[SDLK_RALT] then ret = CONTROL_KB_RALT
            if keys[SDLK_SPACE] then ret = CONTROL_KB_SPACE
            if keys[SDLK_TAB] then ret = CONTROL_KB_TAB
            if keys[SDLK_RETURN] then ret = CONTROL_KB_RETURN
            
            if keys[SDLK_UP] then ret = CONTROL_KB_UP
            if keys[SDLK_DOWN] then ret = CONTROL_KB_DOWN
            if keys[SDLK_LEFT] then ret = CONTROL_KB_LEFT
            if keys[SDLK_RIGHT] then ret = CONTROL_KB_RIGHT
            if keys[SDLK_INSERT] then ret = CONTROL_KB_INSERT
            if keys[SDLK_HOME] then ret = CONTROL_KB_HOME
            if keys[SDLK_END] then ret = CONTROL_KB_END
            if keys[SDLK_DELETE] then ret = CONTROL_KB_DELETE
            if keys[SDLK_PAGEUP] then ret = CONTROL_KB_PAGEUP
            if keys[SDLK_PAGEDOWN] then ret = CONTROL_KB_PAGEDOWN
            if keys[SDLK_KP_PERIOD] then ret = CONTROL_KB_KP_PERIOD
            if keys[SDLK_KP_DIVIDE] then ret = CONTROL_KB_KP_DIVIDE
            if keys[SDLK_KP_MULTIPLY] then ret = CONTROL_KB_KP_MULTIPLY
            if keys[SDLK_KP_MINUS] then ret = CONTROL_KB_KP_MINUS
            if keys[SDLK_KP_PLUS] then ret = CONTROL_KB_KP_PLUS
            if keys[SDLK_KP_ENTER] then ret = CONTROL_KB_KP_ENTER
        end if
        if ret > -1 then exit do
    
        if keys[SDLK_ESCAPE] then exit do

    loop
    
    getInput = ret
    
end function


sub init
    if sdl_init(SDL_EVERYTHING) <> 0 then
        print "could not init sdl"
        sleep
        end
    end if
    
    video = sdl_setVideoMode (640, 480, 16, SDL_DOUBLEBUF)
    if video = 0 then
        sdl_quit
        print "could not set video mode"
        sleep
        end
    end if
    
    SDL_WM_SetCaption "Game Configuration", ""


    fmt = video->format
    colorGrey = sdl_mapRGB(fmt, 128, 128, 128)
    colorDkGrey = sdl_mapRGB(fmt, 96, 96, 96)
    colorWhite = sdl_mapRGB(fmt, 255, 255, 255)
    colorLtGrey = sdl_mapRGB(fmt, 168, 168, 160)
    colorLtBlue = sdl_mapRGb(fmt, 192, 192, 255)
    colorLtGreen = sdl_mapRGb(fmt, 128, 255, 128)
    colorGreyBlue = sdl_mapRGb(fmt, 128,128, 160)
    
    
    configBar = IMG_Load("data/config/configBar.bmp")
    icon_outlines = IMG_Load("data/config/icon_outlines.png")
    icon_enginewind = IMG_Load("data/config/icon_enginewind.png")
    icon_linesmoothing = IMG_Load("data/config/icon_linesmoothing.png")
    icon_dome = IMG_Load("data/config/icon_dome.png")
    icon_buildings = IMG_Load("data/config/icon_buildings.png")
    icon_hudhousing = IMG_Load("data/config/icon_hudhousing.png")
    icon_hudquality = IMG_Load("data/config/icon_hudquality.png")
    icon_fsaa = IMG_Load("data/config/icon_fsaa.png")
    icon_envmap = IMG_Load("data/config/icon_envmap.png")
    icon_bloom = IMG_Load("data/config/icon_bloom.png")
    
    win = 0

    font_loadfont "vera12"
    
    'find available resolutions
    dim tempFmt as sdl_pixelFormat ptr
    dim tempSurface as sdl_surface ptr
    dim modes as sdl_rect ptr ptr
    dim zero as sdl_rect ptr ptr
    
    
    tempSurface = sdl_DisplayFormat(video)
    tempFmt = tempSurface->format
    
    for bits = 0 to 2
        nBits = bits * 8 + 16
        tempFmt->BitsPerPixel = nBits
        
        SDL_FLAGS = SDL_HWSURFACE OR SDL_OPENGL OR SDL_GL_DOUBLEBUFFER OR SDL_FULLSCREEN
        modes = sdl_listModes (tempFmt, SDL_FLAGS)
        
        if modes then
            'print modes[1]->w
    
            a = 1
            i = 0
            while modes[a]
                'print modes[i]->w, modes[i]->h
                pass = 1
                for f = 0 to i - 1
                    if videoMode(bits, f, 0) = modes[a]->w and videoMode(bits, f, 1) = modes[a]->h then pass = 0
                next
                if pass = 1 then
                    if modes[a]->h > 400 then
                        videoMode(bits, i, 0) = modes[a]->w
                        videoMode(bits, i, 1) = modes[a]->h
                        i += 1
                    end if
                end if
                a += 1
            wend
            nVideoModes(bits) = i 
        end if
        
    next
    
    lastjoy = -1
    for joy = 0 to 15
        success = getjoystick(joy, buttons, x!, y!)
        if success = 0 then lastjoy = joy
    next
    
    dim axis!(5)
        
    lastAxis = -1
    if lastjoy > -1 then
        temp = getjoystick(configVars.joystick, buttons, axis!(0), axis!(1), axis!(2), axis!(3), axis!(4), axis!(5))
        lastAxis = 0
        for i = 0 to 5
            if axis!(i) >= -1 and axis!(i) <= 1 then lastAxis = i
        next
    end if
    
    open "data/config/controlName.dat" for input as #1
    i = 0
    while not eof(1)
        input #1, a$
        if i <= nControlNames then controlName$(i) = a$
        i += 1
    wend
    close #1
    
    maxLen = 0
    for i = 0 to nControlNames
        ln = font_len(controlName$(i))
        if ln > maxLen then maxLen = ln
    next
    
    controlNameLen = maxLen
    
    
    open "configVars.dat" for input as #1
        input #1, configVars.xres
        input #1, configVars.yres
        input #1, configVars.nBits
        input #1, configVars.fullScreen
        input #1, configVars.inputType
        for axis = 0 to 5
            input #1, configVars.axisMin(axis)
            input #1, configVars.axisMax(axis)
            'input #1, configVars.axisCenter(axis)
        next
        input #1, configVars.joystick
        for control = 0 to 12
            input #1, configVars.control(control)
        next
        for displayoption = 0 to 23
            input #1, configVars.displayOption(displayOption)
        next
    close #1
    
    
    
    if lastJoy = -1 then configVars.inputType = INPUT_KEYBOARD
    
    videoBuffer = sdl_displayFormat(video)
    for tb = 0 to nTabs - 1
        winBuffer(tb) = sdl_displayFormat(video)
        win = tb
        drawTabs
        drawWin
        sdl_BlitSurface videoBuffer, null, winBuffer(tb), null
    next
    
    win = 0
    
end sub


sub main   
    do
        
        sdl_pumpEvents
        keys = sdl_getKeyState (null)
        mouse = sdl_getMouseState (@mousex, @mousey)
        if keys[SDLK_F12] then deinit
        
        while SDL_PollEvent(@event)
            if event.type = SDL_EXIT then deInit
        wend
    
        
        drawUI
        
        sdl_BlitSurface videoBuffer, null, video, null
        sdl_flip video
        
        ticks = sdl_getTicks
        
        sleep 2
    loop    
end sub

sub upd_joyStatus ()
    
    if win <> WIN_INPUT then exit sub
    if joywaitticks > sdl_getTicks then exit sub
    
    olastJoy = lastJoy
    lastjoy = -1
    for joy = 0 to 15
        success = getjoystick(joy, buttons, x!, y!)
        if success = 0 then lastjoy = joy
    next
    
    dim axis!(5)
        
    lastAxis = -1
    if lastjoy > -1 then
        temp = getjoystick(configVars.joystick, buttons, axis!(0), axis!(1), axis!(2), axis!(3), axis!(4), axis!(5))
        lastAxis = 0
        for i = 0 to 5
            if axis!(i) >= -1 and axis!(i) <= 1 then lastAxis = i
        next
    end if
    
    if olastJoy <> lastJoy then upWinBuffer = 1
    
    joywaitTicks = sdl_getTicks + 150
    
end sub


sub updateUI_display
    
    exit sub
    updateUI_displayCheckButton 0, 16 + 50 * 1, OPTION_LINESMOOTHING
    updateUI_displayCheckButton 0, 16 + 50 * 2, OPTION_OUTLINES
    updateUI_displayCheckButton 0, 16 + 50 * 3, OPTION_DOME
    updateUI_displayCheckButton 0, 16 + 50 * 4, OPTION_BUILDINGS
    'updateUI_displayCheckButton 0, 16 + 50 * 5, OPTION_HUDHOUSING
    updateUI_displayCheckButton 0, 16 + 50 * 5, OPTION_ENVMAP
    
    
    colx2 = 240
    updateUI_displayCheckButton colx2, 16 + 50 * 1, OPTION_ENGINEWIND
    updateUI_displayCheckButtonFSAA colx2, 16 + 50 * 2, OPTION_FSAA
    updateUI_displayCheckButton colx2, 16 + 50 * 3, OPTION_BLOOM
    'updateUI_displayCheckButtonQuality colx2, 16 + 50 * 3, OPTION_HUDQUALITY
    
end sub

sub updateUI_displayCheckButton (rx, ry, opt)
    
    wdth = 36
    lenOff = font_len("OFF")
    lenOn = font_len("ON")
    
    dstRect.x = rx + 8
    dstRect.y = ry
    x0 = rx + 100
    x1 = rx + 140
    y0 = dstRect.y + 20
    
    if configVars.displayOption(opt) = 1 then
        drawBox x0, y0, x0 + wdth, y0 + 16, colorLtGreen
        font_print x0 + (wdth - lenON) / 2, y0 + 2, "ON"
    end if
    if configVars.displayOption(opt) = 0 then
        drawBox x1, y0, x1 + wdth, y0 + 16, colorltGreen
        font_print x1 + (wdth - lenOFF) / 2, y0 + 2, "OFF"
    end if
    if checkmouse(x0, y0, x0 + wdth, y0 + 16) then 
        drawBox x0, y0, x0 + wdth, y0 + 16, colorLtBlue
        font_print x0 + (wdth - lenON) / 2, y0 + 2, "ON"
        if waitticks < ticks then
            if mouse and SDL_BUTTON(1) then configVars.displayOption(opt) = 1
        end if
    end if
    if checkmouse(x1, y0, x1 + wdth, y0 + 16) then
        drawBox x1, y0, x1 + wdth, y0 + 16, colorLtBlue
        font_print x1 + (wdth - lenOFF) / 2, y0 + 2, "OFF"
        if waitticks < ticks then
            if mouse and SDL_BUTTON(1) then configVars.displayOption(opt) = 0
        end if
    end if
end sub

sub updateUI_displayCheckButtonQuality (rx, ry, opt)
    
    wdth = 36
    dim optn$(4)
    optn$(1) = "Poor"
    optn$(2) = "Fair"
    optn$(3) = "Good"
    optn$(4) = "Excellent"
    
    dstRect.x = rx + 8
    dstRect.y = ry
    
    x0 = rx + 80
    y0 = dstRect.y + 20
    
    quality = configVars.displayOption(opt)
    if quality < 1 then quality = 1
    if quality > 4 then quality = 4
    configVars.displayOption(opt) = quality
    
    for i = 1 to 4
        wdth = font_len(optn$(i))
        if quality = i then
            drawBox x0, y0, x0 + wdth + 8, y0 + 16, colorLtGreen
            font_print x0 + 4, y0 + 2, optn$(i)
        end if
        if checkmouse(x0, y0, x0 + wdth + 8, y0 + 16) then 
            drawBox x0, y0, x0 + wdth + 8, y0 + 16, colorLtBlue
            font_print x0 + 4, y0 + 2, optn$(i)
            if waitticks < ticks then
                if mouse and SDL_BUTTON(1) then configVars.displayOption(opt) = i
            end if
        end if
        x0 += wdth + 16
        
    next
end sub

sub updateUI_displayCheckButtonFSAA (rx, ry, opt)
    
    wdth = 36
    dim optn$(4)
    optn$(3) = "8x"
    optn$(2) = "4x"
    optn$(1) = "2x"
    optn$(0) = "None"
    
    dstRect.x = rx + 8
    dstRect.y = ry
    
    x0 = rx + 100'80
    y0 = dstRect.y + 20
    
    quality = configVars.displayOption(opt)
    for i = 0 to 3
        wdth = font_len(optn$(i))
        if quality = i then
            drawBox x0, y0, x0 + wdth + 8, y0 + 16, colorLtGreen
            font_print x0 + 4, y0 + 2, optn$(i)
        end if
        if checkmouse(x0, y0, x0 + wdth + 8, y0 + 16) then 
            drawBox x0, y0, x0 + wdth + 8, y0 + 16, colorLtBlue
            font_print x0 + 4, y0 + 2, optn$(i)
            if waitticks < ticks then
                if mouse and SDL_BUTTON(1) then configVars.displayOption(opt) = i
            end if
        end if
        x0 += wdth + 16
        
    next
end sub


sub updateUI_input
    
    upd_joyStatus
    maxLen = font_len("Game Controller")
    
    dstRect.x = 264
    dstRect.y = 30
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
        sdl_fillRect videoBuffer, @dstRect, colorLtBlue
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.h -= 2
        dstRect.w -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (maxLen + 16 - font_len("Keyboard")) / 2, dstRect.y + 2, "Keyboard"
        
        if mouse and SDL_BUTTON(1) then
            configVars.inputType = INPUT_KEYBOARD
            updWinBuffer = 1
        end if
    end if
    
    dstRect.x = 264
    dstRect.y = 30 + 22
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
        sdl_fillRect videoBuffer, @dstRect, colorLtBlue
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.h -= 2
        dstRect.w -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (maxLen + 16 - font_len("Game Controller")) / 2, dstRect.y + 2, "Game Controller"
        
        if mouse and SDL_BUTTON(1) then
            configVars.inputType = INPUT_GAMECONTROLLER
            updWinBuffer = 1
        end if
    end if
    
    if configVars.inputType = INPUT_KEYBOARD then updateUI_inputKeyboard
    if configVars.inputType = INPUT_GAMECONTROLLER then updateUI_inputGameController

    
end sub

sub updateUI_inputGameController
    
    maxLen = 0
    for i = 0 to lastJoy
        ln = font_len(str$(i))
        if ln > maxLen then maxLen = ln
    next
    
    for i = 0 to lastJoy
        dstRect.x = 264 + i * (8 + maxLen + 16)
        dstRect.y = 78
        dstRect.h = 16
        dstRect.w = maxLen + 8
        
        if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
            sdl_fillRect videoBuffer, @dstRect, colorLtBlue
            
            dstRect.x += 1
            dstRect.y += 1
            dstRect.w -= 2
            dstRect.h -= 2
            sdl_fillRect videoBuffer, @dstRect, colorGrey
            
            font_print dstRect.x + (dstRect.w - font_len(str$(i))) / 2, dstRect.y + 1, str$(i)
            if mouse and SDL_BUTTON(1) then
                configVars.joystick = i
                updWinBuffer = 1
                for i = 0 to 5
                    configVars.axisMin(i) = 0
                    configVars.axisMax(i) = 0
                next
            end if
        end if
    next
    
    colWidth(0) = 50
    colWidth(1) = 120
    colWidth(2) = 120
    colWidth(3) = 120
    
    dim axis!(5)
    temp = getjoystick(configVars.joystick, buttons, axis!(0), axis!(1), axis!(2), axis!(3), axis!(4), axis!(5))
    
    for i = 0 to 5
        if axis!(i) < configVars.axisMin(i) then configVars.axisMin(i) = axis!(i)
        if axis!(i) > configVars.axisMax(i) then configVars.axisMax(i) = axis!(i)
    next
    
    
    for i = 0 to lastAxis + 1
        dstRect.x = 160
        dstRect.y = 120 + i * 16
        dstRect.h = 17
        dstRect.w = colWidth(0) + 16 + 1
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        if i = 0 then
            font_print dstRect.x + (dstRect.w - font_len("Axis")) / 2, dstRect.y + 2, "Axis"
        else
            font_print dstRect.x + 8, dstRect.y + 2, "AXIS_" + str$(i - 1)
        end if
    next
    
    
    
    for i = 0 to lastAxis + 1
        dstRect.x = 160 + colWidth(0) + 16
        dstRect.y = 120 + i * 16
        dstRect.h = 17
        dstRect.w = colWidth(1) + 16 + 1
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        if i = 0 then
            font_print dstRect.x + (dstRect.w - font_len("Min")) / 2, dstRect.y + 2, "Min"
        else
            font_print dstRect.x + 8, dstRect.y + 2, str$(configVars.axisMin(i - 1))
        end if
        
    next
    
    
    for i = 0 to lastAxis + 1
        dstRect.x = 160 + colWidth(0) + 16 + colWidth(1) + 16
        dstRect.y = 120 + i * 16
        dstRect.h = 17
        dstRect.w = colWidth(2) + 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        if i = 0 then
            font_print dstRect.x + (dstRect.w - font_len("Max")) / 2, dstRect.y + 2, "Max"
        else
            font_print dstRect.x + 8, dstRect.y + 2, str$(configVars.axisMax(i - 1))
        end if
        
    next
    
    for i = 0 to lastAxis + 1
        dstRect.x = 160 + colWidth(0) + 16 + colWidth(1) + 16 + colWidth(2) + 16
        dstRect.y = 120 + i * 16
        dstRect.h = 17
        dstRect.w = colWidth(3) + 16
        
        sdl_fillRect videobuffer, @dstRect, colorDkGrey
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        if i = 0 then
            font_print dstRect.x + (dstRect.w - font_len("Center")) / 2, dstRect.y + 2, "Center"
        else
            font_print dstRect.x + 8, dstRect.y + 2, str$(axis!(i - 1))
            'if axis!(i - 1) < 0 then font_print dstRect.x + 8, dstRect.y + 2, str$(int(axis!(i - 1) / configVars.axisMin!(i - 1) * 128))
        end if
        
    next
    
    wdth = 52
    dstRect.x = 580
    dstRect.y = 102
    dstRect.w = 52
    dstRect.h = 16
    
    if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
        sdl_fillRect videoBuffer, @dstRect, colorLtBlue
    
        dstRect.x += 1
        dstRect.y += 1
        dstRect.w -= 2
        dstRect.h -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (wdth - font_len("Reset")) / 2, 104, "Reset"
        if mouse and SDL_BUTTON(1) then
            for i = 0 to 5
                configVars.axisMin!(i) = 0
                configVars.axisMax!(i) = 0
            next
        end if
        
    end if
    
    dim controls$(11)
    controls$(0) = "Rotate Left"
    controls$(1) = "Rotate Right"
    controls$(2) = "Strafe Left"
    controls$(3) = "Strafe Right"
    controls$(4) = "Thrust"
    controls$(5) = "Reverse"
    controls$(6) = "Land / Activate Check Point"
    controls$(7) = "Mission Window / Accept"
    controls$(8) = "Mini Map Toggle / Cancel"
    controls$(9) = "Previous"
    controls$(10) = "Next"
    controls$(11) = "Use"
    
    wdth = controlNameLen + 16
    for i = 0 to 8
        dstRect.x = 440
        dstRect.y = 225 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
            sdl_fillRect videoBuffer, @dstRect, colorLtBlue
            dstRect.x += 1
            dstRect.y += 1
            dstRect.w -= 2
            dstRect.h -= 2
            
            sdl_fillRect videoBuffer, @dstRect, colorGrey
            font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i))
            if mouse and SDL_BUTTON(1) then
                ret = getInput
                if ret > -1 then
                    configVars.control(i) = ret
                    updWinBuffer = 1
                end if
            end if
        end if
    next
    
    for i = 0 to 2
        dstRect.x = 440
        dstRect.y = 415 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
            sdl_fillRect videoBuffer, @dstRect, colorLtBlue
            dstRect.x += 1
            dstRect.y += 1
            dstRect.w -= 2
            dstRect.h -= 2
            
            sdl_fillRect videoBuffer, @dstRect, colorGrey
            font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i + 9))
            if mouse and SDL_BUTTON(1) then
                ret = getInput
                if ret > -1 then
                    configVars.control(i + 9) = ret
                    updWinBuffer = 1
                end if
            end if
        end if
    next
end sub

sub updateUI_inputKeyboard
    
    dim controls$(11)
    controls$(0) = "Rotate Left"
    controls$(1) = "Rotate Right"
    controls$(2) = "Strafe Left"
    controls$(3) = "Strafe Right"
    controls$(4) = "Thrust"
    controls$(5) = "Reverse"
    controls$(6) = "Land / Activate Check Point"
    controls$(7) = "Mission Window / Accept"
    controls$(8) = "Mini Map Toggle / Cancel"
    controls$(9) = "Previous"
    controls$(10) = "Next"
    controls$(11) = "Use"
    
    wdth = controlNameLen + 16
    
    for i = 0 to 8
        dstRect.x = 440
        dstRect.y = 95 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
            sdl_fillRect videoBuffer, @dstRect, colorLtBlue
            dstRect.x += 1
            dstRect.y += 1
            dstRect.w -= 2
            dstRect.h -= 2
            
            sdl_fillRect videoBuffer, @dstRect, colorGrey
            font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i))
            if mouse and SDL_BUTTON(1) then
                ret = getInput
                if ret > -1 then
                    configVars.control(i) = ret
                    updWinBuffer = 1
                end if
            end if
        end if
    next
    
    for i = 0 to 2
        dstRect.x = 440
        dstRect.y = 285 + i * 18
        dstRect.w = wdth
        dstRect.h = 16
        
        if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then 
            sdl_fillRect videoBuffer, @dstRect, colorLtBlue
            dstRect.x += 1
            dstRect.y += 1
            dstRect.w -= 2
            dstRect.h -= 2
            
            sdl_fillRect videoBuffer, @dstRect, colorGrey
            font_print dstRect.x + 8, dstRect.y + 1, controlName$(configVars.control(i + 9))
            if mouse and SDL_BUTTON(1) then
                ret = getInput
                if ret > -1 then
                    configVars.control(i + 9) = ret
                    updWinBuffer = 1
                end if
            end if
        end if
    next
    
end sub


sub updateUI_video
    
    font_print 188, 32, str$(configVars.xres) + "x" + str$(configVars.yres) + "x" + str$(configVars.nBits) + " bit"
    
    maxLen = 0
    for tb = 0 to 2
        if nVideoModes(tb) > 0 then
            for mode = 0 to nVideoModes(tb) - 1
                ln = font_len(str$(videoMode(tb, mode, 0)) + "x" + str$(videoMode(tb, mode, 1)))
                if ln > maxLen then maxLen = ln
            next
        end if
    next
    
    
    
    nCols = int((640 - 16) / (maxLen + 16))
    maxLen = (640 - 16) / nCols - 16
    col = 0
    
    basey = 64
    for tb = 0 to 2
        if nVideoModes(tb) > 0 then
            col = 0
            row = 1
            for mode = nVideoModes(tb) - 1 to 0 step -1
                dstRect.x = 8 + col * (maxLen + 16)
                dstRect.y = basey + row * 18
                dstRect.h = 16
                dstRect.w = maxLen + 8
                if configVars.nBits = tb * 8 + 16 and configVars.xres = videoMode(tb, mode, 0) and configVars.yres = videoMode(tb, mode, 1) then
                    sdl_fillRect videoBuffer, @dstRect, colorLtGreen
                    dstRect.x += 1
                    dstRect.y += 1
                    dstRect.w -= 2
                    dstRect.h -= 2
                    sdl_fillRect videoBuffer, @dstRect, colorGrey
                    
                    font_print 8 + col * (maxLen + 16) + 8, basey + row * 18 + 2, str$(videoMode(tb, mode, 0)) + "x" + str$(videoMode(tb, mode, 1))
                end if
                
                dstRect.x = 8 + col * (maxLen + 16)
                dstRect.y = basey + row * 18
                dstRect.h = 16
                dstRect.w = maxLen + 8
                if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then
                    sdl_fillRect videoBuffer, @dstRect, colorLtBlue
                    dstRect.x += 1
                    dstRect.y += 1
                    dstRect.w -= 2
                    dstRect.h -= 2
                    sdl_fillRect videoBuffer, @dstRect, colorGrey
                    
                    font_print 8 + col * (maxLen + 16) + 8, basey + row * 18 + 2, str$(videoMode(tb, mode, 0)) + "x" + str$(videoMode(tb, mode, 1))
                    if mouse and SDL_BUTTON(1) then
                        configVars.nBits = tb * 8 + 16
                        configVars.xres = videoMode(tb, mode, 0)
                        configVars.yres = videoMode(tb, mode, 1)
                    end if
                end if
                
                col += 1
                if col = nCols and mode > 0 then
                    col = 0
                    row += 1
                end if
                
            next
            basey += (row + 2) * 18
        end if
    next

    maxLen = font_len("FullScreen")
    
    dstRect.x = 640 - 8 - maxLen - 16
    dstRect.y = 32
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    colr = colorDkGrey
    if configVars.fullScreen = VIDEO_FULLSCREEN then colr = colorLtGreen
    if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then colr = colorLtBlue
    if colr <> colorDkGrey then
        sdl_fillRect videoBuffer, @dstRect, colr
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.h -= 2
        dstRect.w -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (maxLen + 16 - font_len("FullScreen")) / 2, dstRect.y + 2, "FullScreen"
        
        if colr = colorLtBlue then
            if mouse and SDL_BUTTON(1) then configVars.fullScreen = VIDEO_FULLSCREEN
        end if
    end if
    
    dstRect.x = 640 - 8 - maxLen - 16
    dstRect.y = 32 + 20
    dstRect.h = 18
    dstRect.w = maxLen + 16
    
    
    colr = colorDkGrey
    if configVars.fullScreen = VIDEO_WINDOWED then colr = colorLtGreen
    if mousex >= dstRect.x and mousey >= dstRect.y and mousex < dstRect.x + dstRect.w and mousey < dstRect.y + dstRect.h then colr = colorLtBlue
    if colr <> colorDkGrey then
        sdl_fillRect videoBuffer, @dstRect, colr
        
        dstRect.x += 1
        dstRect.y += 1
        dstRect.h -= 2
        dstRect.w -= 2
        
        sdl_fillRect videoBuffer, @dstRect, colorGrey
        
        font_print dstRect.x + (maxLen + 16 - font_len("Windowed")) / 2, dstRect.y + 2, "Windowed"
        
        if colr = colorLtBlue then
            if mouse and SDL_BUTTON(1) then configVars.fullScreen = VIDEO_WINDOWED
        end if
    end if
    
    
end sub


sub wait_delay (amt)
    
    waitticks = sdl_getTicks + amt

end sub
