Function Load_Texture( Byref Texture As Gluint, Byref Filename As String ) As Integer
    Dim As Integer ret_val
    glGenTextures( 1, @Texture )
    glBindTexture(GL_TEXTURE_2D, Texture )
    Glenable( GL_TEXTURE_2D )
    
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
    
    Dim SprWidth As Integer
    Dim SprHeight As Integer
    png.dimensions( filename, SprWidth, SprHeight )
    Dim As Any Ptr buffer = png.load( filename, PNG.TARGET_OPENGL )
    
    If buffer = 0 Then 
        Return 0
    Else
        ret_val = 1
    End If
    
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGB, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    
    imagedestroy(buffer)
    Return ret_val
End Function


Function Load_TextureL( Byref Texture As Gluint, Byref Filename As String ) As Integer
    Dim As Integer ret_val
    glGenTextures( 1, @Texture )
    glBindTexture(GL_TEXTURE_2D, Texture )
    Glenable( GL_TEXTURE_2D )
    
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST )
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
    
    
    
    Dim SprWidth As Integer
    Dim SprHeight As Integer
    png.dimensions( filename, SprWidth, SprHeight )
    Dim As Any Ptr buffer = png.load( filename, PNG.TARGET_OPENGL )
    
    If buffer = 0 Then 
        Return 0
    Else
        ret_val = 1
    End If
    
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGB, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    
    imagedestroy(buffer)
    Return ret_val
End Function


Function Load_TextureM( Byref Texture As Gluint, Byref Filename As String ) As Integer
    Dim As Integer ret_val
    glGenTextures( 1, @Texture )
    glBindTexture(GL_TEXTURE_2D, Texture )
    Glenable( GL_TEXTURE_2D )
    
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST )
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
    
    
    
    Dim SprWidth As Integer
    Dim SprHeight As Integer
    png.dimensions( filename, SprWidth, SprHeight )
    Dim As Any Ptr buffer = png.load( filename, PNG.TARGET_OPENGL )
    
    If buffer = 0 Then 
        Return 0
    Else
        ret_val = 1
    End If
    
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGB, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGB, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    
    imagedestroy(buffer)
    Return ret_val
End Function


Function Load_TextureA( Byref Texture As Gluint, Byref Filename As String ) As Integer
    Dim As Integer ret_val
    glGenTextures( 1, @Texture )
    glBindTexture(GL_TEXTURE_2D, Texture )
    Glenable( GL_TEXTURE_2D )
    
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR_MIPMAP_LINEAR )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR )
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
    
    Dim SprWidth As Integer
    Dim SprHeight As Integer
    png.dimensions( filename, SprWidth, SprHeight )
    Dim As Any Ptr buffer = png.load( filename, PNG.TARGET_OPENGL )
    
    If buffer = 0 Then 
        Return 0
    Else
        ret_val = 1
    End If
    
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    
    imagedestroy(buffer)
    Return ret_val
End Function



Function Load_TextureAL ( Byref Texture As Gluint, Byref Filename As String ) As Integer
    Dim As Integer ret_val
    glGenTextures( 1, @Texture )
    glBindTexture(GL_TEXTURE_2D, Texture )
    Glenable( GL_TEXTURE_2D )
    
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST )
    glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST )
    glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
    
    Dim SprWidth As Integer
    Dim SprHeight As Integer
    png.dimensions( filename, SprWidth, SprHeight )
    Dim As Any Ptr buffer = png.load( filename, PNG.TARGET_OPENGL )
    
    If buffer = 0 Then 
        Return 0
    Else
        ret_val = 1
    End If
    
    glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, SprWidth, SprHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    gluBuild2DMipmaps( GL_TEXTURE_2D, GL_RGBA, SprWidth, SprHeight, GL_RGBA, GL_UNSIGNED_BYTE, buffer )
    
    imagedestroy(buffer)
    Return ret_val
End Function
