


function font_draw(x1 as integer,y1 as integer,text as string) as integer
    
	dim as integer txtlen, xoff, char, charpx, px, i
	dim as single xs, ys
	
	txtlen = len(text)
	
	if txtlen = 0 then exit function
    
    xs = fontData.xScale
    ys = fontData.yScale
    
    xoff = fontData.xOffset
    
    
    glPushMatrix
    glEnable GL_TEXTURE_2D
    glTranslatef x1,y1,0
    glScalef xs, ys, 0            
            
    for i=0 to txtlen-1
      char = asc(mid(text,i+1,1)) - 32
      glBindTexture GL_TEXTURE_2D, fontimg(char)
      
      glCallList fontDL(char)
      charpx = charwidth(char) + xoff
      glTranslatef charpx, 0, 0
      px += charpx
    next
    
    px -= xoff
    
    glDisable GL_TEXTURE_2D
    glPopMatrix
    
    return px*xs
    
end function



  
sub font_loadfont (font as string)
    
    dim fontfolder as string, i as integer
	
	fontfolder = PATH_FONTS + font + "/"
    fontwidth = 16
    fontheight = 16
	fontData.width = 16
	fontData.height = 16
	fontData.xScale = .75
	fontData.yScale = .75
    
    glGenTextures 95, @fontimg(0)
	dim as any ptr tempimg
    dim pnts(3,3) as single
    dim temp as uinteger ptr, cc as unsigned integer
    'x/y/u/v
    
    pnts(0,0) = 0
    pnts(0,1) = 0
    pnts(1,0) = 0
    pnts(1,1) = 1
    pnts(2,0) = 1
    pnts(2,1) = 1
    pnts(3,0) = 1
    pnts(3,1) = 0
    
	dim ch as integer, fil as string, minx as integer, maxx as integer, x as integer, y as integer
	dim as integer w, h
    
    for ch = 32 to 126
        fil = fontfolder + ltrim(rtrim(str(ch))) + ".png"
        tempimg = PNG.load(fil, PNG.TARGET_OPENGL )'IMG_Load(fil)
        
        'SDL_SetAlpha tempimg, SDL_SRCALPHA, 255
        
        glBindTexture GL_TEXTURE_2D, fontimg(ch-32)

        glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT 
		glTexParameterf GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT 
		glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,GL_LINEAR
        glTexParameteri GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,GL_LINEAR

        glTexImage2D GL_TEXTURE_2D, 0, GL_RGBA, fontData.width, fontData.height, 0, GL_RGBA, GL_UNSIGNED_BYTE, tempimg

        minx = fontData.width
        maxx = 0
        cc = 16777215
        for x = 0 to fontData.width - 1
            for y = 0 to fontData.height - 1
                temp = tempimg + y * 16 * 4 + x * 4
                if *temp <> cc then
                    if x < minx then minx = x
                    if x > maxx then maxx = x
                end if
            next
        next
        
        minx = minx - 1
        if minx < 0 then minx = 0
        if maxx - minx < 3 then
            minx = minx - 2
            maxx = maxx + 2
        end if
        
        charwidth(ch-32) = maxx-minx + 1
        if ch = 32 then charwidth(0) = 10
        
        pnts(0,2) = minx / 15
        pnts(0,3) = .02
        pnts(1,2) = minx / 15
        pnts(1,3) = .95
        pnts(2,2) = maxx / 15
        pnts(2,3) = .95
        pnts(3,2) = maxx / 15
        pnts(3,3) = .02
        
        fontdl(ch-32) = glGenLists(1)
        glNewList fontdl(ch-32), GL_COMPILE
            glBegin GL_QUADS
                for i = 0 to 3
                    glTexCoord2f pnts(i,2), 1 - pnts(i,3)
                    glVertex2f pnts(i,0) * charwidth(ch-32), pnts(i, 1) * fontheight
                next
            glEnd
        glEndList
        'SDL_FreeSurface tempimg
		imagedestroy tempimg
    next
    
    
end sub



sub font_xy(byref length as integer, byref height as integer, byref text as string)
    
	dim as integer txtlen, xoff, i, char, charx, px
	dim as single xs, ys
	
    txtlen = len(text)
	if txtlen = 0 then exit sub
    
    xs = fontData.xScale
    ys = fontData.yScale
        
    xoff = fontData.xOffset
    
    for i=0 to txtlen-1
      char = asc(mid(text,i+1,1)) - 32
      charx = charwidth(char) + xoff
      px += charx * xs
    next
    
    px -= xoff
    
    length = px
    height = fontheight * ys
    
end sub


  
sub fprint (xloc as integer, yloc as integer, txt as string)
	
	dim d as integer
    d = font_draw (xloc * fontData.width * fontData.xScale, yloc  * fontData.height * fontData.yScale, txt)
    
end sub
