sub Render_Model_Plain (byval Model as Model3D Ptr)

	
	dim as integer tri, pnt, point_id, normal
	
	glBegin GL_TRIANGLES
	
		for tri = 0 to Model->max_triangles - 1
		
			for pnt = 1 to 3
			
				normal = Model->triangles[tri].vnormal(pnt)
				point_id = Model->triangles[tri].point_id(pnt)
				
				glNormal3fv( @Model->vnormals[normal].X )
				glVertex3fv( @Model->vertices[point_id].X )
				
			
			next
		
		next
	
	glEnd

end sub


sub Render_Model_SubDivide (byval Model as Model3D ptr, byval ratio as single)

	dim as integer tri, pnt, normal_id, point_id, material_id
	dim as Vector3D normals(5), points(5)
	
	glBegin GL_TRIANGLES
		
		for tri = 0 to Model->max_triangles - 1
		
			material_id = Model->triangles[tri].material
			
			for pnt = 1 to 3
			
				normal_id = Model->triangles[tri].vnormal(pnt)
				normals(pnt - 1).X = Model->vnormals[normal_id].x
				normals(pnt - 1).y = Model->vnormals[normal_id].y
				normals(pnt - 1).z = Model->vnormals[normal_id].z
			
			next
			
			normals(3).x = normals(1).x + normals(0).x
			normals(3).y = normals(1).y + normals(0).y
			normals(3).z = normals(1).z + normals(0).z
			
			normals(4).x = normals(2).x + normals(1).x
			normals(4).y = normals(2).y + normals(1).y
			normals(4).z = normals(2).z + normals(1).z
			
			normals(5).x = normals(0).x + normals(2).x
			normals(5).y = normals(0).y + normals(2).y
			normals(5).z = normals(0).z + normals(2).z
			
			for pnt = 3 to 5
				normals(pnt).x /= 2
				normals(pnt).y /= 2
				normals(pnt).z /= 2
			next
			
			for pnt = 1 to 3
			
				point_id = Model->triangles[tri].point_id(pnt)
				points(pnt - 1).x = Model->vertices[point_id].x
				points(pnt - 1).y = Model->vertices[point_id].y
				points(pnt - 1).z = Model->vertices[point_id].z
			
			next
			
			points(3).x = points(1).x + points(0).x
			points(3).y = points(1).y + points(0).y
			points(3).z = points(1).z + points(0).z
			
			points(4).x = points(2).x + points(1).x
			points(4).y = points(2).y + points(1).y
			points(4).z = points(2).z + points(1).z
			
			points(5).x = points(0).x + points(2).x
			points(5).y = points(0).y + points(2).y
			points(5).z = points(0).z + points(2).z
			
			for pnt = 3 to 5
				points(pnt).x /= 2
				points(pnt).y /= 2
				points(pnt).z /= 2
			next
			
			glColor3f Model->materials[material_id].R * ratio, Model->materials[material_id].G * ratio, Model->materials[material_id].B * ratio
			
			for pnt = 0 to 2
				if pnt = 0 then point_id = 0
				if pnt = 1 then point_id = 3
				if pnt = 2 then point_id = 5
				glNormal3fv @normals(point_id).x
				glVertex3fv @points(point_id).x
			next
			
			for pnt = 0 to 2
				if pnt = 0 then point_id = 3
				if pnt = 1 then point_id = 1
				if pnt = 2 then point_id = 4
				glNormal3fv @normals(point_id).x
				glVertex3fv @points(point_id).x
			next
			
			for pnt = 0 to 2
				if pnt = 0 then point_id = 5
				if pnt = 1 then point_id = 4
				if pnt = 2 then point_id = 2
				glNormal3fv @normals(point_id).x
				glVertex3fv @points(point_id).x
			next
			
			for pnt = 0 to 2
				if pnt = 0 then point_id = 3
				if pnt = 1 then point_id = 4
				if pnt = 2 then point_id = 5
				glNormal3fv @normals(point_id).x
				glVertex3fv @points(point_id).x
			next
			
		
		next
	glEnd
	
end sub



sub Render_Model_Cell (byval Model as Model3D Ptr)

	
	dim as integer tri, pnt, point_id, normal, material_id
	dim as single ratio
	ratio = .4
	
	glDepthMask GL_FALSE
	glCullFace GL_FRONT
	glPolygonMode GL_BACK, GL_LINE
	
	'Render_Model_SubDivide Model, .4
	glBegin GL_TRIANGLES
	
		for tri = 0 to Model->max_triangles - 1
		
			for pnt = 1 to 3
			
				normal = Model->triangles[tri].vnormal(pnt)
				point_id = Model->triangles[tri].point_id(pnt)
				material_id = Model->triangles[tri].material
				
				
				glNormal3fv( @Model->vnormals[normal].X )
				glColor3f Model->materials[material_id].R * ratio, Model->materials[material_id].G * ratio, Model->materials[material_id].B * ratio
				glVertex3fv( @Model->vertices[point_id].X )
				
			
			next
		
		next
	
	glEnd
	
	glDepthMask GL_TRUE
	glCullFace GL_BACK
	
	
	glPolygonMode GL_FRONT_AND_BACK, GL_FILL
	Render_Model_SubDivide Model, 1
	
	
	
end sub


sub Render_Model_Color (byval Model as Model3D Ptr)

	
	dim as integer tri, pnt, point_id, normal, material_id
	
	glBegin GL_TRIANGLES
	
		for tri = 0 to Model->max_triangles - 1
		
			for pnt = 1 to 3
			
				normal = Model->triangles[tri].vnormal(pnt)
				point_id = Model->triangles[tri].point_id(pnt)
				material_id = Model->triangles[tri].material
				
				
				glNormal3fv( @Model->vnormals[normal].X )
				glColor3fv(  @Model->materials[material_id].R )
				glVertex3fv( @Model->vertices[point_id].X )
				
			
			next
		
		next
	
	glEnd

end sub


sub Render_Model_Color_Alpha (byval Model as Model3D Ptr, alpha as single)

	
	dim as integer tri, pnt, point_id, normal, material_id
	
	glBegin GL_TRIANGLES
	
		for tri = 0 to Model->max_triangles - 1
		
			for pnt = 1 to 3
			
				normal = Model->triangles[tri].vnormal(pnt)
				point_id = Model->triangles[tri].point_id(pnt)
				material_id = Model->triangles[tri].material
				
				
				glNormal3fv( @Model->vnormals[normal].X )
				glColor4f  Model->materials[material_id].R, Model->materials[material_id].G, Model->materials[material_id].B, alpha
				glVertex3fv( @Model->vertices[point_id].X )
				
			
			next
		
		next
	
	glEnd

end sub


Sub UnloadMesh( Byref Model As Model3D Ptr )
    Model->max_vertices  = 0
    Model->max_triangles = 0
    Model->max_surfaces  = 0
	Deallocate( Model->volume )
    Deallocate( Model->vertices )
    'Model->vertices = 0
    Deallocate( Model->vNormals )
    'Model->vNormals = 0
    Deallocate( Model->triangles )
    'Model->triangles = 0
    Deallocate( Model )
    'Model = 0
End Sub



sub Model_FindExtents (byval Model as Model3D ptr, byref minx as single, byref miny as single, byref minz as single, byref maxx as single, byref maxy as single, byref maxz as single)


	dim as single x, y, z
	dim as integer pnt
	
	
	minx = 9999
	miny = 9999
	minz = 9999
	maxx = -9999
	maxy = -9999
	maxz = -9999
	
	for pnt = 0 to Model->max_vertices - 1
	
		x = Model->vertices[pnt].X
		y = Model->vertices[pnt].Y
		z = Model->vertices[pnt].Z
		
		
		if x < minx then minx = x
		if x > maxx then maxx = x
		if y < miny then miny = y
		if y > maxy then maxy = y
		if z < minz then minz = z
		if z > maxz then maxz = z
		
	next


end sub



sub Model_Normalize (byval Model as Model3D ptr)

	
	dim as single minx, miny, minz, maxx, maxy, maxz, dx, dy, dz
	
	dim as single x0, y0, z0, dist, maxDist
	maxDist = -9999
	
	Model_FindExtents Model, minx, miny, minz, maxx, maxy, maxz
	
	dim as integer pnt
	for pnt = 0 to Model->max_vertices - 1
		x0 = Model->vertices[pnt].X
		y0 = Model->vertices[pnt].Y
		z0 = Model->vertices[pnt].Z
		
		dist = sqr(x0 * x0 + y0 * y0 + z0 * z0)
		
		if dist > maxDist then maxDist = dist
	next
	
	for pnt = 0 to Model->max_vertices - 1
		Model->vertices[pnt].X /= maxDist
		Model->vertices[pnt].Y /= maxDist
		Model->vertices[pnt].Z /= maxDist
	next
	
	
end sub



sub Model_Scale (byval Model as Model3D ptr, ratio as single)

	
	dim as integer pnt
	for pnt = 0 to Model->max_vertices - 1
		Model->vertices[pnt].X *= ratio
		Model->vertices[pnt].Y *= ratio
		Model->vertices[pnt].Z *= ratio
	next
	
	
end sub

