Type Triangle3D
    point_id(1 To 3) As Uinteger
    texcoord(1 To 3) As UV2D
    neighbor(1 To 3) As Uinteger
    con(1 to 3)      As Integer
    Visible          As Integer
    normal           As Vector3D
	vnormal(1 to 3)  As Uinteger
    Plane            As Vector4D
    Group            As Integer
    Posit            As Vector3D
	material		 As integer
End Type



type ModelMaterialType
    materialName as string * 16
    r   as single
    g   as single
    b   as single
    hardness as single
    hasTex  as byte
    texture as gluint
	alpha	as single
end type



type volume3D
	fcnt		as integer
	Volume		as Vector3D ptr
end type


type volumeDB
	cached			as byte
	volumeHandle	as volume3d ptr
	volumeHandleLow	as volume3d ptr
end type


Type Model3D
    max_vertices  As Uinteger
    max_triangles As Uinteger
	max_uvs		  As Uinteger
    max_surfaces  As Uinteger
	max_normals	  As Uinteger
	max_materials as uinteger
	materials	  as ModelMaterialType ptr
    vertices      As Vector3D Ptr
	vertexColors  as Rgbalpha Ptr
    vnormals      As Vector3D Ptr
	Volume        as Vector3D ptr
    triangles     As Triangle3D Ptr
	uvs			  as UV2D Ptr
	fCnt          as integer
End Type


type ModelDBType
	modelFile		as string * 64
	modelHandle		as Model3D Ptr
end type


dim shared modelDB as modelDBType ptr, modelDBLength as integer
modelDB = callocate(sizeof(modelDBType))



Declare Sub Load_Obj( Byval Filename As String, Byref Model As Model3D Ptr, byval texture_offset as integer )

Declare sub Render_Model_Plain ( byval Model as Model3D ptr)
Declare sub Render_Model_Cell (byval Model as Model3D Ptr)
Declare sub Render_Model_Color (byval Model as Model3D Ptr)
DECLARE sub Render_Model_Color_Alpha (byval Model as Model3D Ptr, alpha as single)
Declare Sub Render_Model_Shadow( Byval Model As Model3D Ptr )
Declare sub Render_Model_SubDivide (byval Model as Model3D ptr, byval ratio as single)
DECLARE Sub UnloadMesh( Byref Model As Model3D Ptr )
Declare sub Model_FindExtents (byval Model as Model3D ptr, byref minx as single, byref miny as single, byref minz as single, byref maxx as single, byref maxy as single, byref maxz as single)
Declare sub Model_Normalize (byval Model as Model3D ptr)
Declare sub Model_Scale (byval Model as Model3D ptr, ratio as single)