sub PhaseData_Calculate_Totals ()

	dim as integer g, w, s
	
	dim as GeneratorClassType ptr gen
	dim as WaveClassType ptr wave
	dim as WaveSpawnType ptr spawn
	
	dim as integer totalSpawn, totalHealth, totalProjectiles


	for g = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
	
		gen = @PhaseDataGlobals.phaseSequence.generator[g]
		totalProjectiles += gen->nProjectiles
		
	next
	
	for w = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
	
		wave = @PhaseDataGlobals.phaseSequence.wave[w]
		totalSpawn += wave->nSpawn
		totalhealth += wave->nSpawn * wave->maxHealth
		
	next
	
	PhaseDataGlobals.phaseSequence.totalSpawn = totalSpawn
	PhaseDataGlobals.phaseSequence.totalHealth = totalHealth
	PhaseDataGlobals.phaseSequence.totalProjectiles = totalProjectiles
	
	

end sub


sub PhaseData_Generator_Load (gen as GeneratorClassType ptr, filenum as integer)

	dim as integer genClass, i
	
	
	input #filenum, gen->title
	input #filenum, gen->class
	genClass = gen->class
	
	input #filenum, gen->position.x
	input #filenum, gen->position.y
	input #filenum, gen->position.z
	
	input #filenum, gen->angle.x
	input #filenum, gen->angle.y
	input #filenum, gen->angle.z
	
	input #filenum, gen->preAngularVelocity.x
	input #filenum, gen->preAngularVelocity.y
	input #filenum, gen->preAngularVelocity.z

	if genClass = GC_BLOCK_TORUS then
		input #filenum, gen->blockSize
		input #filenum, gen->length
		input #filenum, gen->innerRadius
		input #filenum, gen->outterRadius
	end if
	
	if genClass = GC_HEX_TUNNEL then
		input #filenum, gen->rows
		input #filenum, gen->radius
		input #filenum, gen->iterations
		input #filenum, gen->cellSpacing
		input #filenum, gen->cellBorder
		input #filenum, gen->textureScrollSpeed
	end if
	
	if genClass = GC_META_BALL_CLOUD then
		input #filenum, gen->cloudSize
		input #filenum, gen->radius
	end if
	
	if genClass = GC_META_BALL_DISC then
		input #filenum, gen->cloudSize
		input #filenum, gen->length
		input #filenum, gen->innerRadius
		input #filenum, gen->outterRadius
	end if
	
	input #filenum, gen->nProjectiles
	input #filenum, gen->nVicinityColors
	input #filenum, gen->nColorLights
	input #filenum, gen->shadowColor.r
	input #filenum, gen->shadowColor.g
	input #filenum, gen->shadowColor.b
	
	gen->nProjectilesReturn = -1
	gen->rowsReturn = -1
	
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
	
	
	for i = 0 to gen->nVicinityColors - 1
		input #filenum, gen->vicinityColor[i].position.x
		input #filenum, gen->vicinityColor[i].position.y
		input #filenum, gen->vicinityColor[i].position.z
		input #filenum, gen->vicinityColor[i].fallOff
		input #filenum, gen->vicinityColor[i].color.r
		input #filenum, gen->vicinityColor[i].color.g
		input #filenum, gen->vicinityColor[i].color.b
	next
	
	for i = 0 to gen->nColorLights - 1
		input #filenum, gen->colorLight[i].position.x
		input #filenum, gen->colorLight[i].position.y
		input #filenum, gen->colorLight[i].position.z
		input #filenum, gen->colorLight[i].fallOff
		input #filenum, gen->colorLight[i].color.r
		input #filenum, gen->colorLight[i].color.g
		input #filenum, gen->colorLight[i].color.b
	next

end sub


sub PhaseData_Init_Block_Torus_Regenerate (gen as generatorClassType ptr)


	dim as integer nBoxes, i
	nBoxes = gen->nProjectiles
	
	dim as single an, radius
	
	gen->preAngularVelocityAngle.x = 0
	gen->preAngularVelocityAngle.y = 0
	gen->preAngularVelocityAngle.z = 0
	
	gen->mass = 500
	
	for i = 0 to nBoxes - 1
		an = rnd * 360
		radius = gen->innerRadius + rnd * (gen->outterRadius - gen->innerRadius)
		gen->projectile[i].class = GPC_BLOCK_TORUS_BLOCK
		PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], GPC_BLOCK_TORUS_BLOCK
		gen->projectile[i].position.x = radius * cos(3.1415 / 180 * an)
		gen->projectile[i].position.y = rnd * gen->length - gen->length / 2
		gen->projectile[i].position.z = radius * sin(3.1415 / 180 * an)
		gen->projectile[i].angle.x = 0
		gen->projectile[i].angle.y = an
		gen->projectile[i].angle.z = 0
		gen->projectile[i].active = 1
		PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
	next
	
end sub


sub PhaseData_Init_Hex_Tunnel_Regenerate (gen as generatorClassType ptr)

	dim as integer a, nRows, iter, b, i
	
	nRows = gen->rows
	iter = gen->iterations
	
	dim as single an, radius
	
	gen->preAngularVelocityAngle.x = 0
	gen->preAngularVelocityAngle.y = 0
	gen->preAngularVelocityAngle.z = 0
	
	gen->mass = 500
	
	dim as single circ, h0
	
	circ = 2 * 3.1415 * gen->radius
	h0 = circ / (gen->iterations * 2)
	
	i = 0
	for a = 0 to nRows - 1	
		for b = 0 to iter - 1
			gen->projectile[i].class = GPC_HEX_TUNNEL_HEX
			gen->projectile[i].angle.x = 0
			gen->projectile[i].angle.y = 360 * b / iter
			gen->projectile[i].angle.z = 0
			gen->projectile[i].position.x = gen->radius * cos(3.14159 * 2 * b / iter)
			gen->projectile[i].position.y = -h0 * nRows / 2 + h0 * a
			gen->projectile[i].position.z = gen->radius * sin(3.14159 * 2 * b / iter)
			PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], gen->projectile[i].class
			gen->projectile[i].active = 1
			PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
			i+= 1
		next
		
		for b = 0 to iter - 1
			gen->projectile[i].class = GPC_HEX_TUNNEL_HEX
			gen->projectile[i].angle.x = 0
			gen->projectile[i].angle.y = 360 * (b+.5) / iter
			gen->projectile[i].angle.z = 0
			gen->projectile[i].position.x = gen->radius * cos(3.14159 * 2 * (b+.5) / iter)
			gen->projectile[i].position.y = -h0 * nRows / 2 + h0 * a + h0 / 2
			gen->projectile[i].position.z = gen->radius * sin(3.14159 * 2 * (b+.5) / iter)
			PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], gen->projectile[i].class
			gen->projectile[i].active = 1
			PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
			i+= 1
		next
		
	next
	
end sub


sub PhaseData_Init_Meta_Ball_Cloud_Regenerate (gen as generatorClassType ptr)

	
	dim as integer nBoxes, i
	nBoxes = gen->nProjectiles
	
	dim as single an, radius
	
	gen->preAngularVelocityAngle.x = 0
	gen->preAngularVelocityAngle.y = 0
	gen->preAngularVelocityAngle.z = 0
	
	gen->mass = 500
	
	for i = 0 to nBoxes - 1
		an = rnd * 360
		gen->projectile[i].class = GPC_META_BALL
		PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], GPC_META_BALL
		gen->projectile[i].position.x = rnd * 1 - .5
		gen->projectile[i].position.y = rnd * 1 - .5
		gen->projectile[i].position.z = rnd * 1 - .5
		math_normalize3f gen->projectile[i].position
		gen->projectile[i].position.x *= gen->radius
		gen->projectile[i].position.y *= gen->radius
		gen->projectile[i].position.z *= gen->radius
		gen->projectile[i].active = 1
		PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
	next
	
end sub


sub PhaseData_Init_Meta_Ball_Disc_Regenerate (gen as generatorClassType ptr)

	
	dim as integer nBoxes, i
	nBoxes = gen->nProjectiles
	
	dim as single an, radius
	
	gen->preAngularVelocityAngle.x = 0
	gen->preAngularVelocityAngle.y = 0
	gen->preAngularVelocityAngle.z = 0
	
	gen->mass = 500
	
	for i = 0 to nBoxes - 1
		an = rnd * 360
		radius = gen->innerRadius + rnd * (gen->outterRadius - gen->innerRadius)
		gen->projectile[i].class = GPC_META_BALL
		PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], GPC_META_BALL
		gen->projectile[i].position.x = radius * cos(3.1415 / 180 * an)
		gen->projectile[i].position.y = rnd * gen->length - gen->length / 2
		gen->projectile[i].position.z = radius * sin(3.1415 / 180 * an)
		gen->projectile[i].active = 1
		PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
	next
	
end sub


sub PhaseData_Init_Wave_Regenerate (wave as WaveClassType ptr)

	
	dim as integer nSpawn, i, g
	dim as single spawnTimeOffset, d
	dim as vector3D positionR
	
	
	nSpawn = wave->nSpawn
	'wave->startTime = PhaseDataGlobals.phaseSequence.startTime + PhaseDataGlobals.phaseSequence.startTimeOffset
	
	spawnTimeOffset = wave->time / nSpawn
	
	wave->spawn = callocate(nSpawn * sizeof(WaveSpawnType))
	wave->radius = 0
	
	for i = 0 to nSpawn - 1
	
		wave->spawn[i].spawnTime = -1 
		wave->spawn[i].active = 0
		
		positionR.x = rnd * wave->positionOffset.x * 2 - wave->positionOffset.x / 2
		positionR.y = rnd * wave->positionOffset.y * 2 - wave->positionOffset.y / 2
		positionR.z = rnd * wave->positionOffset.z * 2 - wave->positionOffset.z / 2
		
		d = positionR.x * positionR.x + positionR.y * positionR.y + positionR.z * positionR.z
		if d <> 0 then math_normalize3f positionR
		
		wave->spawn[i].position.x = wave->position.x + positionR.x
		wave->spawn[i].position.y = wave->position.y + positionR.y
		wave->spawn[i].position.z = wave->position.z + positionR.z
		
		wave->spawn[i].angle.x = 0
		wave->spawn[i].angle.y = 0
		wave->spawn[i].angle.z = 0
		wave->spawn[i].ringAngle.x = 0
		wave->spawn[i].ringAngle.y = 0
		wave->spawn[i].ringAngle.z = 0
		wave->spawn[i].spawnIndex = i
		
		wave->spawn[i].pulse = 0
		wave->spawn[i].detonate = 0
		wave->spawn[i].orbitalClass = 0
		if wave->pattern = WP_ORBITAL then wave->spawn[i].orbitalClass = int(rnd * 3)
		
		wave->spawn[i].health = wave->maxHealth
		
		wave->spawn[i].velocity.x = 0
		wave->spawn[i].velocity.y = 0
		wave->spawn[i].velocity.z = 0
		
		if wave->class = WC_FLIES then PhaseData_Init_Wave_Regenerate_Spawn_Flies wave, @wave->spawn[i]
		if wave->class = WC_BOSS_DRAGON then PhasePlayer_Init_Spawn_Models wave, @wave->spawn[i]
		
		wave->spawn[i].totalProjectiles = 0
		for g = 0 to wave->spawn[i].nGenerators - 1
			wave->spawn[i].totalProjectiles += wave->spawn[i].generator[g].nProjectiles
		next
		
	next
	
	
	
end sub



sub PhaseData_Init_Wave_Regenerate_Spawn_Flies (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)


	dim as integer nWedges
	dim as single wedgeRadius
	
	nWedges = 20
	wedgeRadius = .25
	
	spawn->nGenerators = 2
	spawn->generator = callocate(spawn->nGenerators * sizeOf(GeneratorClassType))
	
	
	spawn->generator[0].nProjectiles = nWedges
	spawn->generator[0].projectile = callocate (spawn->generator[0].nProjectiles * sizeOf(GenProjectileType))
	spawn->generator[1].nProjectiles = nWedges
	spawn->generator[1].projectile = callocate (spawn->generator[0].nProjectiles * sizeOf(GenProjectileType))
	
	
	dim as integer i, a
	dim as single an
	dim as GeneratorClassType ptr gen
	
	for a = 0 to 1
		gen = @spawn->generator[a]
		gen->nVicinityColors = 2
		gen->nColorLights = 1
		gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
		gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
		gen->preAngularVelocityAngle.x = 90 * a
		gen->preAngularVelocityAngle.y = 0
		gen->preAngularVelocityAngle.z = 0
		gen->position.x = spawn->position.x
		gen->position.y = spawn->position.y
		gen->position.z = spawn->position.z
		gen->preAngularVelocity.x = 0
		gen->preAngularVelocity.y = 0
		gen->preAngularVelocity.z = 500
		gen->mass = 200
		
		gen->vicinityColor[0].position.x = 0
		gen->vicinityColor[0].position.y = -1
		gen->vicinityColor[0].position.z = 0
		gen->vicinityColor[0].color.r = 1
		gen->vicinityColor[0].color.g = 1
		gen->vicinityColor[0].color.b = 1
		gen->vicinityColor[0].fallOff = 2
		
		gen->vicinityColor[1].position.x = 0
		gen->vicinityColor[1].position.y = 1
		gen->vicinityColor[1].position.z = 0
		gen->vicinityColor[1].color.r = .8
		gen->vicinityColor[1].color.g = .8
		gen->vicinityColor[1].color.b = 1
		gen->vicinityColor[1].fallOff = 2
		
		gen->colorLight[0].position.x = 0
		gen->colorLight[0].position.y = 0
		gen->colorLight[0].position.z = 0
		gen->colorLight[0].color.r = 1
		gen->colorLight[0].color.g = 1
		gen->colorLight[0].color.b = 1
		gen->colorLight[0].falloff = 5
		
		for i = 0 to nWedges - 1
			an = i * 360 / nWedges
			PhaseData_Projectile_Set_Mesh gen, @spawn->generator[a].projectile[i], GPC_RING_WEDGE
			gen->projectile[i].position.x = wedgeRadius * cos(3.1415 / 180 * an)
			gen->projectile[i].position.y = wedgeRadius * sin(3.1415 / 180 * an)
			gen->projectile[i].position.z = 0
			gen->projectile[i].angle.x = 0
			gen->projectile[i].angle.y = 0
			gen->projectile[i].angle.z = an
			gen->projectile[i].active = 1
			PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
		next
	next
	
end sub


sub PhaseData_PhaseSequence_Load (filename as string)


	dim as integer filenum, i
	
	
	cls
	filenum = freefile
	
	PhaseData_PhaseSequence_Unload
	
	open filename for input as #filenum
		input #filenum, PhaseDataGlobals.phaseSequence.roomClass
		input #filenum, PhaseDataGlobals.phaseSequence.phaseTitle
		input #filenum, PhaseDataGlobals.phaseSequence.nGenerators
		input #filenum, PhaseDataGlobals.phaseSequence.nWaves
		
		input #filenum, PhaseDataGlobals.phaseSequence.cameraOffset
		input #filenum, PhaseDataGlobals.phaseSequence.cameraVelocityH
		input #filenum, PhaseDataGlobals.phaseSequence.cameraVelocityV
		
		PhaseDataGlobals.phaseSequence.generator = callocate(PhaseDataGlobals.phaseSequence.nGenerators * sizeof(GeneratorClassType))
		PhaseDataGlobals.phaseSequence.wave = callocate(PhaseDataGlobals.phaseSequence.nWaves * sizeof(WaveClassType))
		
		for i = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
			PhaseData_Generator_Load @PhaseDataGlobals.phaseSequence.generator[i], filenum
			
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_BLOCK_TORUS then PhaseData_Init_Block_Torus_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_HEX_TUNNEL then PhaseData_Init_Hex_Tunnel_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_META_BALL_CLOUD then PhaseData_Init_Meta_Ball_Cloud_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_META_BALL_DISC then PhaseData_Init_Meta_Ball_Disc_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			
		next
		
		for i = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
			PhaseData_Wave_Load @PhaseDataGlobals.phaseSequence.Wave[i], filenum
			
			PhaseData_Init_Wave_Regenerate @PhaseDataGlobals.phaseSequence.Wave[i]
			
		next
		
		
	close #filenum
	

	PhaseData_Calculate_Totals
	
end sub



sub PhaseData_PhaseSequence_Unload ()

	dim as integer g, i, p
	
	
	for g = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
		for p = 0 to PhaseDataGlobals.phaseSequence.generator[g].nProjectiles - 1
		
			deallocate PhaseDataGlobals.phaseSequence.generator[g].projectile[p].mesh.vertices
			deallocate PhaseDataGlobals.phaseSequence.generator[g].projectile[p].mesh.triangles
			
		next
		
		deallocate PhaseDataGlobals.phaseSequence.generator[g].projectile
		deallocate PhaseDataGlobals.phaseSequence.generator[g].vicinityColor
		deallocate PhaseDataGlobals.phaseSequence.generator[g].colorLight
	next
	
	deallocate PhaseDataGlobals.phaseSequence.generator
	
	
	dim as integer a, b
	dim as WaveClassType ptr wave
	dim as WaveSpawnType ptr spawn
	
	
	for a = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
	
		wave = @PhaseDataGlobals.phaseSequence.wave[a]
		for b = 0 to wave->nSpawn - 1
		
			spawn = @PhaseDataGlobals.phaseSequence.wave[a].spawn[b]
			for g = 0 to spawn->nGenerators - 1
				for p = 0 to spawn->generator[g].nProjectiles - 1
				
					deallocate spawn->generator[g].projectile[p].mesh.vertices
					deallocate spawn->generator[g].projectile[p].mesh.triangles
					
				next
				
				deallocate spawn->generator[g].projectile
				deallocate spawn->generator[g].vicinityColor
				deallocate spawn->generator[g].colorLight
				
			next
			
			deallocate spawn->generator
		next
		
		deallocate wave->spawn
	next
	
	deallocate PhaseDataGlobals.phaseSequence.wave


end sub


sub PhaseData_Projectile_Set_Mesh (gen as GeneratorClassType ptr, proj as GenProjectileType ptr, gpClass as integer)

	proj->mesh.max_vertices = 0
	proj->mesh.max_triangles = 0
	
	dim as single scale
	dim as integer axis, i, a, b, nSegs, triOfs, pntOfs
	dim as vector3D blockCorner0, blockCorner1, blockCorner2, blockCorner3
	
	if gpClass = GPC_BLOCK_TORUS_BLOCK then
	
		proj->mesh.max_vertices = 8
		proj->mesh.max_triangles = 12
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		scale = gen->blockSize
		blockCorner0.x = -1 * (rnd * .8 + .1) * scale
		blockCorner0.y = +1 * (rnd * .8 + .1) * scale
		blockCorner0.z = -1 * (rnd * .8 + .1) * scale
		
		blockCorner1.x = +1 * (rnd * .8 + .1) * scale
		blockCorner1.y = -1 * (rnd * .8 + .1) * scale
		blockCorner1.z = +1 * (rnd * .8 + .1) * scale
		
		
		axis = int(rnd * 3)
		if axis = 0 then
			blockCorner0.x *= rnd * 10
			blockCorner1.x *= rnd * 10
		elseif axis = 1 then
			blockCorner0.y *= rnd * 10
			blockCorner1.y *= rnd * 10
		elseif axis = 2 then
			blockCorner0.z *= rnd * 10
			blockCorner1.z *= rnd * 10
		end if
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner1.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner1.x, blockCorner0.y, blockCorner0.z
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 4, blockCorner0.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 5, blockCorner0.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 6, blockCorner1.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 7, blockCorner1.x, blockCorner1.y, blockCorner0.z
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 2, 3, 7, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 3, 0, 3, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 4, 0, 4, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 5, 1, 0, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 6, 1, 5, 6
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 7, 2, 1, 6
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 8, 2, 6, 7
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 9, 3, 2, 7
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 10, 7, 6, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 11, 4, 7, 5
		
		for i = 0 to 11
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		PhaseData_Projectile_Calc_MeanVertex proj
		PhaseData_Projectile_Calc_stdDeviation proj
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
	
	elseif gpClass = GPC_RING_WEDGE then
	
		
		proj->mesh.max_vertices = 6
		proj->mesh.max_triangles = 8
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		
		scale = .05
		blockCorner0.x = -.5 * scale
		blockCorner0.y = +1 * scale
		blockCorner0.z = -.5 * scale
		
		blockCorner1.x = +.5 * scale
		blockCorner1.y = +1 * scale
		blockCorner1.z = +.5 * scale
		
		blockCorner2.x = 0
		blockCorner2.y = -1 * scale
		blockCorner2.z = -.5 * scale
		
		blockCorner3.x = 0
		blockCorner3.y = -1 * scale
		blockCorner3.z = +.5 * scale
		
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner1.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner1.x, blockCorner0.y, blockCorner0.z
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 4, blockCorner2.x, blockCorner2.y, blockCorner2.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 5, blockCorner3.x, blockCorner3.y, blockCorner3.z
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 2, 0, 4, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 3, 1, 0, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 4, 2, 5, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 5, 3, 2, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 6, 1, 5, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 7, 3, 4, 0
		
		
		for i = 0 to 7
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
		
	
	elseif gpClass = GPC_RING_SPIKE then
	
		
		proj->mesh.max_vertices = 5
		proj->mesh.max_triangles = 6
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		
		scale = .05
		blockCorner0.x = -.5 * scale
		blockCorner0.y = +.5 * scale
		blockCorner0.z = -.5 * scale
		
		blockCorner1.x = -.5 * scale
		blockCorner1.y = -.5 * scale
		blockCorner1.z = +.5 * scale
		
		blockCorner2.x = 1 * scale
		blockCorner2.y = 0
		blockCorner2.z = 0
		
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner0.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner0.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 4, blockCorner2.x, blockCorner2.y, blockCorner2.z
		
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 2, 0, 3, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 3, 3, 2, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 4, 2, 1, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 5, 1, 0, 4
		
		
		for i = 0 to 5
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
		
	elseif gpClass = GPC_META_BALL then
	
		
		proj->mesh.max_vertices = 4
		proj->mesh.max_triangles = 2
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		
		scale = .05
		blockCorner0.x = -.5 * scale
		blockCorner0.y = +.5 * scale
		blockCorner0.z = 0
		
		blockCorner1.x = +.5 * scale
		blockCorner1.y = -.5 * scale
		blockCorner1.z = 0
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner1.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner1.x, blockCorner0.y, blockCorner0.z
		
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		
		for a = 0 to 1
			for b = 1 to 3
				proj->mesh.triangles[a].color(b).r = 1
				proj->mesh.triangles[a].color(b).g = 1
				proj->mesh.triangles[a].color(b).b = 1
			next
		next
		
		proj->mesh.triangles[0].color(3).g = 0
		proj->mesh.triangles[0].color(3).b = 0
		
		proj->mesh.triangles[1].color(3).g = 0
		proj->mesh.triangles[1].color(3).b = 0
		
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
		
	elseif gpClass = GPC_BALL_BLOCK then
	
		proj->mesh.max_vertices = 8
		proj->mesh.max_triangles = 12
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		scale = .1 * proj->blockSize
		blockCorner0.x = -1 * scale
		blockCorner0.y = +1 * scale
		blockCorner0.z = -.5 * scale
		
		blockCorner1.x = +1 * scale
		blockCorner1.y = -1 * scale
		blockCorner1.z = +.5 * scale
		
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner1.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner1.x, blockCorner0.y, blockCorner0.z
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 4, blockCorner0.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 5, blockCorner0.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 6, blockCorner1.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 7, blockCorner1.x, blockCorner1.y, blockCorner0.z
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 2, 3, 7, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 3, 0, 3, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 4, 0, 4, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 5, 1, 0, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 6, 1, 5, 6
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 7, 2, 1, 6
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 8, 2, 6, 7
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 9, 3, 2, 7
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 10, 7, 6, 5
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 11, 4, 7, 5
		
		for i = 0 to 11
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		PhaseData_Projectile_Calc_MeanVertex proj
		PhaseData_Projectile_Calc_stdDeviation proj
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
		
	elseif gpClass = GPC_FIN_LEFT then
	
		nSegs = 8
		
		proj->mesh.max_vertices = 4 * nSegs * 2
		proj->mesh.max_triangles = 2 * nSegs * 2
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		dim as single aLen, blen, clen, aWid, sRatioA, sRatioB
		
		aLen = proj->blockSize
		bLen = aLen * .5
		cLen = aLen - bLen
		aWid = aLen * .7
		for i = 0 to nSegs - 1
			scale = 1
			sRatioA = i / nSegs
			sRatioB = sRatioA + 1 / nSegs
			
			blockCorner0.z = -aWid * sRatioB
			blockCorner0.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner0.x = -(bLen + cLen * sRatioB * sin(3.14159 / 2 * sRatioB))
			
			blockCorner1.z = -aWid * sRatioB
			blockCorner1.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner1.x = -aLen * sRatioB * sin(3.14159 / 2 * sRatioB)
			
			blockCorner2.z = -aWid * sRatioA
			blockCorner2.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner2.x = -aLen * sRatioA * sin(3.14159 / 2 * sRatioA)
			
			blockCorner3.z = -aWid * sRatioA
			blockCorner3.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner3.x = -(bLen + cLen * sRatioA * sin(3.14159 / 2 * sRatioA))
			
			
			pntOfs = i * 4
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 1, blockCorner1.x, blockCorner1.y, blockCorner1.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 2, blockCorner2.x, blockCorner2.y, blockCorner2.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 3, blockCorner3.x, blockCorner3.y, blockCorner3.z
			
			triOfs = i * 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 0, pntOfs + 0, pntOfs + 1, pntOfs + 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 1, pntOfs + 3, pntOfs + 0, pntOfs + 2
			
		next
		
		for i = 0 to nSegs - 1
			scale = 1
			sRatioA = i / nSegs
			sRatioB = sRatioA + 1 / nSegs
			
			blockCorner0.z = -aWid * sRatioA
			blockCorner0.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner0.x = -(bLen + cLen * sRatioA * sin(3.14159 / 2 * sRatioA))
			
			blockCorner1.z = -aWid * sRatioA
			blockCorner1.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner1.x = -aLen * sRatioA * sin(3.14159 / 2 * sRatioA)
			
			blockCorner2.z = -aWid * sRatioB
			blockCorner2.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner2.x = -aLen * sRatioB * sin(3.14159 / 2 * sRatioB)
			
			blockCorner3.z = -aWid * sRatioB
			blockCorner3.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner3.x = -(bLen + cLen * sRatioB * sin(3.14159 / 2 * sRatioB))
			
			
			pntOfs = i * 4 + 32
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 1, blockCorner1.x, blockCorner1.y, blockCorner1.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 2, blockCorner2.x, blockCorner2.y, blockCorner2.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 3, blockCorner3.x, blockCorner3.y, blockCorner3.z
			
			triOfs = i * 2 + 16
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 0, pntOfs + 0, pntOfs + 1, pntOfs + 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 1, pntOfs + 3, pntOfs + 0, pntOfs + 2
			
		next
		
		for i = 0 to proj->mesh.max_triangles - 1
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		PhaseData_Projectile_Calc_MeanVertex proj
		PhaseData_Projectile_Calc_stdDeviation proj
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
		
	elseif gpClass = GPC_FIN_RIGHT then
	
		nSegs = 8
		
		proj->mesh.max_vertices = 4 * nSegs * 2
		proj->mesh.max_triangles = 2 * nSegs * 2
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		dim as single aLen, blen, clen, aWid, sRatioA, sRatioB
		
		aLen = proj->blockSize
		bLen = aLen * .5
		cLen = aLen - bLen
		aWid = aLen * .7
		for i = 0 to nSegs - 1
			scale = 1
			sRatioA = i / nSegs
			sRatioB = sRatioA + 1 / nSegs
			
			blockCorner3.z = aWid * sRatioB
			blockCorner3.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner3.x = -(bLen + cLen * sRatioB * sin(3.14159 / 2 * sRatioB))
			
			blockCorner2.z = aWid * sRatioB
			blockCorner2.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner2.x = -aLen * sRatioB * sin(3.14159 / 2 * sRatioB)
			
			blockCorner1.z = aWid * sRatioA
			blockCorner1.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner1.x = -aLen * sRatioA * sin(3.14159 / 2 * sRatioA)
			
			blockCorner0.z = aWid * sRatioA
			blockCorner0.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner0.x = -(bLen + cLen * sRatioA * sin(3.14159 / 2 * sRatioA))
			
			
			pntOfs = i * 4
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 1, blockCorner1.x, blockCorner1.y, blockCorner1.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 2, blockCorner2.x, blockCorner2.y, blockCorner2.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 3, blockCorner3.x, blockCorner3.y, blockCorner3.z
			
			triOfs = i * 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 0, pntOfs + 0, pntOfs + 1, pntOfs + 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 1, pntOfs + 3, pntOfs + 0, pntOfs + 2
			
		next
		
		for i = 0 to nSegs - 1
			scale = 1
			sRatioA = i / nSegs
			sRatioB = sRatioA + 1 / nSegs
			
			blockCorner3.z = aWid * sRatioA
			blockCorner3.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner3.x = -(bLen + cLen * sRatioA)
			
			blockCorner2.z = aWid * sRatioA
			blockCorner2.y = cos(3.14159 / 2 * sRatioA) * 1 - 1
			blockCorner2.x = -aLen * sRatioA
			
			blockCorner1.z = aWid * sRatioB
			blockCorner1.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner1.x = -aLen * sRatioB
			
			blockCorner0.z = aWid * sRatioB
			blockCorner0.y = cos(3.14159 / 2 * sRatioB) * 1 - 1
			blockCorner0.x = -(bLen + cLen * sRatioB)
			
			
			pntOfs = i * 4 + 32
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 1, blockCorner1.x, blockCorner1.y, blockCorner1.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 2, blockCorner2.x, blockCorner2.y, blockCorner2.z
			PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, pntOfs + 3, blockCorner3.x, blockCorner3.y, blockCorner3.z
			
			triOfs = i * 2 + 16
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 0, pntOfs + 0, pntOfs + 1, pntOfs + 2
			PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, triOfs + 1, pntOfs + 3, pntOfs + 0, pntOfs + 2
			
		next
		
		for i = 0 to proj->mesh.max_triangles - 1
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
		next
		
		PhaseData_Projectile_Calc_MeanVertex proj
		PhaseData_Projectile_Calc_stdDeviation proj
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
	
	elseif gpClass = GPC_HEX_TUNNEL_HEX then
	
		proj->mesh.max_vertices = 6
		proj->mesh.max_triangles = 8
		proj->lock = 0
		
		proj->mesh.vertices = callocate(proj->mesh.max_vertices * sizeof(Vector3D))
		proj->mesh.triangles = callocate(proj->mesh.max_triangles * sizeof(GPTriangleType))
		
		dim as single an0, an1, an2, an3, circ, h0, anW
		dim as single v0, v1, v2, v3, u0, u1, u2, u, v
		dim as integer point_id
		
		anW = 360 / (gen->iterations * 2)
		
		anW *= (1 - gen->cellSpacing  / 10)
		
		an0 = -anw / 2 - anW / 6
		an1 = -anW / 2 + anW / 6
		an3 = anW / 2 + anW / 6
		an2 = anW / 2 - anW / 6

		circ = 2 * 3.1415 * gen->radius
		h0 = circ / (gen->iterations * 2)
		h0 *= (1 - gen->cellSpacing / 10)
		
		
		blockCorner0.x = -gen->radius + gen->radius * cos(3.1515 / 180 * an2)
		blockCorner1.x = -gen->radius + gen->radius * cos(3.1515 / 180 * an1)
		
		blockCorner0.y = h0 / 2
		blockCorner1.y = -h0 / 2
		
		blockCorner0.z = gen->radius * sin(3.1515 / 180 * an2)
		blockCorner1.z = gen->radius * sin(3.1515 / 180 * an1)
		
		
		blockCorner2.x = -gen->radius + gen->radius * cos(3.1515 / 180 * an3)
		blockCorner3.x = -gen->radius + gen->radius * cos(3.1515 / 180 * an0)
		
		blockCorner2.y = 0
		blockCorner3.y = 0
		
		blockCorner2.z = gen->radius * sin(3.1515 / 180 * an3)
		blockCorner3.z = gen->radius * sin(3.1515 / 180 * an0)
		
		
		v0 = (proj->angle.y + an0) / 360
		v1 = (proj->angle.y + an1) / 360
		v2 = (proj->angle.y + an2) / 360
		v3 = (proj->angle.y + an3) / 360
		
		
		u0 = (proj->position.y - h0 / 2) * 1.3 / 1000
		u1 = (proj->position.y) * 1.3 / 1000
		u2 = (proj->position.y + h0 / 2) * 1.3 / 1000
		
		
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 0, blockCorner0.x, blockCorner0.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 1, blockCorner0.x, blockCorner1.y, blockCorner0.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 2, blockCorner1.x, blockCorner1.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 3, blockCorner1.x, blockCorner0.y, blockCorner1.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 4, blockCorner2.x, blockCorner2.y, blockCorner2.z
		PhaseData_Projectile_Set_Mesh_Vertex @proj->mesh, 5, blockCorner3.x, blockCorner3.y, blockCorner3.z
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 0, 0, 1, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 1, 3, 0, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 2, 3, 2, 1
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 3, 0, 3, 1
		
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 4, 4, 1, 0
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 5, 0, 1, 4
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 6, 5, 3, 2
		PhaseData_Projectile_Set_Mesh_Triangle_Point_ID @proj->mesh, 7, 5, 2, 3
		
		for i = 0 to 7
			PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals @proj->mesh, i
			for a = 1 to 3
				point_id = proj->mesh.triangles[i].point_id(a)
				if point_id = 0 then
					v = v2
					u = u2
				elseif point_id = 1 then
					v = v2
					u = u0
				elseif point_id = 2 then
					v = v1
					u = u0
				elseif point_id = 3 then
					v = v1
					u = u2
				elseif point_id = 4 then
					v = v3
					u = u1
				elseif point_id = 5 then
					v = v0
					u = u1
				end if
				proj->mesh.triangles[i].uv(a).u = u
				proj->mesh.triangles[i].uv(a).v = v
			next
		next
		
		PhaseData_Projectile_Calc_MeanVertex proj
		PhaseData_Projectile_Calc_totalDeviation proj
		
		proj->accelVector.x = 0
		proj->accelVector.y = 0
		proj->accelVector.z = 0
		
		proj->accelMag = 0
		
		proj->velocity.x = 0
		proj->velocity.y = 0
		proj->velocity.z = 0
	
	end if
	
end sub



sub PhaseData_Projectile_Set_Mesh_Vertex (byref mesh as GPMeshType ptr, index as integer, x as single, y as single, z as single)

	mesh->vertices[index].x = x
	mesh->vertices[index].y = y
	mesh->vertices[index].z = z
	
end sub


sub PhaseData_Projectile_Set_Mesh_Triangle_Point_ID (byref mesh as GPMeshType ptr, index as integer, a as integer, b as integer, c as integer)

	mesh->triangles[index].point_id(1) = a
	mesh->triangles[index].point_id(2) = b
	mesh->triangles[index].point_id(3) = c
	
end sub


sub PhaseData_Projectile_Set_Mesh_Triangle_Point_Normals (byref mesh as GPMeshType ptr, index as integer)

	dim as vector3d v1, v2, v3, nv1, nv2, nv3, n1, n2, n3
	
	v1 = mesh->vertices[mesh->triangles[index].point_id(1)]
	v2 = mesh->vertices[mesh->triangles[index].point_id(2)]
	v3 = mesh->vertices[mesh->triangles[index].point_id(3)]
	
	nv1.x = v3.x - v1.x
	nv1.y = v3.y - v1.y
	nv1.z = v3.z - v1.z
	
	nv2.x = v2.x - v1.x
	nv2.y = v2.y - v1.y
	nv2.z = v2.z - v1.z
	
	n1 = math_cross(nv2, nv1)
	
	nv1.x = v1.x - v2.x
	nv1.y = v1.y - v2.y
	nv1.z = v1.z - v2.z
	
	nv2.x = v3.x - v2.x
	nv2.y = v3.y - v2.y
	nv2.z = v3.z - v2.z
	
	n2 = math_cross(nv2, nv1)
	
	nv1.x = v2.x - v3.x
	nv1.y = v2.y - v3.y
	nv1.z = v2.z - v3.z
	
	nv2.x = v1.x - v3.x
	nv2.y = v1.y - v3.y
	nv2.z = v1.z - v3.z
	
	n3 = math_cross(nv2, nv1)
	
	mesh->triangles[index].vnormal(1) = n1
	mesh->triangles[index].vnormal(2) = n2
	mesh->triangles[index].vnormal(3) = n3

end sub



sub PhaseData_Projectile_Calc_Colors (gen as GeneratorClassType ptr, proj as GenProjectileType ptr)

	dim as vector3d n1, n2, n3
	dim as vector3d v1, v2, v3
	dim as rgbalpha c1, c2, c3
	dim as integer c0
	dim as vector3d light0
	dim as rgbalpha light0c, light1c, light2c, light3c
	
	dim as integer index, i
	dim as single d1
	dim as single matrix(16)
	dim as vector4d mPoint
	
	for index = 0 to proj->mesh.max_triangles - 1
	
		Matrix_LoadIdentity @matrix(0)
		Matrix_Rotate @matrix(0), proj->angle.x, 1, 0, 0
		Matrix_Rotate @matrix(0), proj->angle.y, 0, 1, 0
		Matrix_Rotate @matrix(0), proj->angle.z, 0, 0, 1
		Matrix_Translate @matrix(0), proj->position.x, proj->position.y, proj->position.z
		
		for i = 1 to 3
		
			mPoint.x = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].x
			mPoint.y = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].y
			mPoint.z = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].z
			mPoint.w = 1
			
			Matrix_Multiply_Point @matrix(0), mPoint
			
			if i = 1 then 
				v1.x = mPoint.x
				v1.y = mPoint.y
				v1.z = mPoint.z
			elseif i = 2 then
				v2.x = mPoint.x
				v2.y = mPoint.y
				v2.z = mPoint.z
			elseif i = 3 then
				v3.x = mPoint.x
				v3.y = mPoint.y
				v3.z = mPoint.z
			end if
			
			mPoint.x = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].x + proj->mesh.triangles[index].vnormal(i).x
			mPoint.y = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].y + proj->mesh.triangles[index].vnormal(i).y
			mPoint.z = proj->mesh.vertices[proj->mesh.triangles[index].point_id(i)].z + proj->mesh.triangles[index].vnormal(i).z
			mPoint.w = 1
			
			Matrix_Multiply_Point @matrix(0), mPoint
			
			if i = 1 then 
				n1.x = mPoint.x - v1.x
				n1.y = mPoint.y - v1.y
				n1.z = mPoint.z - v1.z
				math_normalize3f n1
			elseif i = 2 then
				n2.x = mPoint.x - v2.x
				n2.y = mPoint.y - v2.y
				n2.z = mPoint.z - v2.z
				math_normalize3f n2
			elseif i = 3 then
				n3.x = mPoint.x - v3.x
				n3.y = mPoint.y - v3.y
				n3.z = mPoint.z - v3.z
				math_normalize3f n3
			end if
			
			
			
		next
		
		'---- calc color based on vicinity
		
		c1.r = 0: c1.g = 0: c1.b = 0
		c2.r = 0: c2.g = 0: c2.b = 0
		c3.r = 0: c3.g = 0: c3.b = 0
		
		for c0 = 0 to gen->nVicinityColors - 1
			light0.x = gen->vicinityColor[c0].position.x
			light0.y = gen->vicinityColor[c0].position.y
			light0.z = gen->vicinityColor[c0].position.z
			
			light0c.r = gen->vicinityColor[c0].color.r
			light0c.g = gen->vicinityColor[c0].color.g
			light0c.b = gen->vicinityColor[c0].color.b
		
			PhaseData_Projectile_Calc_Colors_Vicinity light0, light0c, v1, c1, gen->vicinityColor[c0].fallOff
			PhaseData_Projectile_Calc_Colors_Vicinity light0, light0c, v2, c2, gen->vicinityColor[c0].fallOff
			PhaseData_Projectile_Calc_Colors_Vicinity light0, light0c, v3, c3, gen->vicinityColor[c0].fallOff
		next
		
		
		'---- calc color based on color light
		light1c.r = gen->shadowColor.r
		light1c.g = gen->shadowColor.g
		light1c.b = gen->shadowColor.b
		
		light2c.r = gen->shadowColor.r
		light2c.g = gen->shadowColor.g
		light2c.b = gen->shadowColor.b
		
		light3c.r = gen->shadowColor.r
		light3c.g = gen->shadowColor.g
		light3c.b = gen->shadowColor.b
		
		for c0 = 0 to gen->nColorLights - 1
			light0.x = gen->colorLight[c0].position.x
			light0.y = gen->colorLight[c0].position.y
			light0.z = gen->colorLight[c0].position.z
			
			light0c.r = gen->colorLight[c0].color.r
			light0c.g = gen->colorLight[c0].color.g
			light0c.b = gen->colorLight[c0].color.b
			
			PhaseData_Projectile_Calc_Colors_Angle light0, light0c, light1c, v1, c1, n1, gen->colorLight[c0].fallOff
			PhaseData_Projectile_Calc_Colors_Angle light0, light0c, light2c, v2, c2, n2, gen->colorLight[c0].fallOff
			PhaseData_Projectile_Calc_Colors_Angle light0, light0c, light3c, v3, c3, n3, gen->colorLight[c0].fallOff
			
		next
		
		'----
		
		if gen->nColorLights > 0 then
			proj->mesh.triangles[index].color(1) = light1c
			proj->mesh.triangles[index].color(2) = light2c
			proj->mesh.triangles[index].color(3) = light3c
		else
			proj->mesh.triangles[index].color(1) = c1
			proj->mesh.triangles[index].color(2) = c2
			proj->mesh.triangles[index].color(3) = c3
		end if
	next
	
	
end sub


sub PhaseData_Projectile_Calc_Colors_Vicinity (byval light0 as Vector3D, byval light0c as rgbalpha, byval v1 as vector3d, byref c1 as rgbalpha, fallOff as single)

	dim as single d1
	d1 = sqr((v1.x - light0.x) ^ 2 + (v1.y - light0.y) ^ 2 + (v1.z - light0.z) ^ 2) / fallOff
	if d1 < 0 then d1 = 0
	if d1 > 1 then d1 = 1
	d1 = 1 - d1
	
	c1.r = c1.r + (light0c.r - c1.r) * d1
	c1.g = c1.g + (light0c.g - c1.g) * d1
	c1.b = c1.b + (light0c.b - c1.b) * d1
	c1.a = 1
end sub


sub PhaseData_Projectile_Calc_Colors_Angle (byval light0 as Vector3D, byval light0c as rgbalpha, byref light1c as rgbalpha, byval v1 as vector3d, byval c1 as rgbalpha, byval n1 as vector3d, fallOff as single)

	dim as vector4d lv, v2
	dim as single d1, dist, d2
	
	lv.x = light0.x - v1.x
	lv.y = light0.y - v1.y
	lv.z = light0.z - v1.z
	lv.w = 0
	
	dist = sqr(lv.x * lv.x + lv.y * lv.y + lv.z * lv.z)
	math_normalize lv
	
	v2.x = n1.x
	v2.y = n1.y
	v2.z = n1.z
	v2.w = 0
	
	d1 = math_dot(lv, v2)
	if d1 < 0 then d1 = 0
	if d1 > 1 then d1 = 1
	
	light1c.r = light1c.r + (light0c.r * c1.r - light1c.r) * d1
	light1c.g = light1c.g + (light0c.g * c1.g - light1c.g) * d1
	light1c.b = light1c.b + (light0c.b * c1.b - light1c.b) * d1
	light1c.a = 1
end sub


sub PhaseData_Projectile_Calc_MeanVertex (proj as GenProjectileType ptr)

	dim as integer vert
	dim as vector3d meanVertex
	
	proj->mesh.meanVertex.x = 0
	proj->mesh.meanVertex.y = 0
	proj->mesh.meanVertex.z = 0
	
	for vert = 0 to proj->mesh.max_vertices - 1
		proj->mesh.meanVertex.x += proj->mesh.vertices[vert].x
		proj->mesh.meanVertex.y += proj->mesh.vertices[vert].y
		proj->mesh.meanVertex.z += proj->mesh.vertices[vert].z
	next
	
	proj->mesh.meanVertex.x /= proj->mesh.max_vertices
	proj->mesh.meanVertex.y /= proj->mesh.max_vertices
	proj->mesh.meanVertex.z /= proj->mesh.max_vertices
	
end sub


sub PhaseData_Projectile_Calc_stdDeviation (proj as GenProjectileType ptr)

	dim as single sumD, sumDsq, d, dx, dy, dz, maxd
	dim as integer n, vert
	
	sumD = 0
	sumDsq = 0
	
	maxd = 0
	n = proj->mesh.max_vertices
	
	for vert = 0 to n - 1
		dx = proj->mesh.vertices[vert].x
		dy = proj->mesh.vertices[vert].y
		dz = proj->mesh.vertices[vert].z
		
		d = sqr(dx * dx + dy * dy + dz * dz)
		
		if d > maxd then maxd = d
		
		sumD += d
		
		sumDsq += d*d
	next
	
	proj->mesh.stdDeviation = sqr((sumDsq - (sumD * sumD) / N) / N)
	
	
end sub


sub PhaseData_Projectile_Calc_totalDeviation (proj as GenProjectileType ptr)

	dim as single sumD, sumDsq, d, dx, dy, dz, maxd
	dim as integer n, vert
	
	sumD = 0
	sumDsq = 0
	
	maxd = 0
	n = proj->mesh.max_vertices
	
	for vert = 0 to n - 1
		dx = proj->mesh.vertices[vert].x
		dy = proj->mesh.vertices[vert].y
		dz = proj->mesh.vertices[vert].z
		
		d = sqr(dx * dx + dy * dy + dz * dz)
		
		if d > maxd then maxd = d
	next
	
	proj->mesh.stdDeviation = maxd * .8
	
	
end sub


sub PhaseData_Wave_Load (wave as WaveClassType ptr, filenum as integer)

	input #filenum, wave->title
	input #filenum, wave->time
	input #filenum, wave->startTime
	input #filenum, wave->speed
	input #filenum, wave->class
	input #filenum, wave->pattern
	input #filenum, wave->nSpawn
	input #filenum, wave->position.x
	input #filenum, wave->position.y
	input #filenum, wave->position.z
	input #filenum, wave->positionOffset.x
	input #filenum, wave->positionOffset.y
	input #filenum, wave->positionOffset.z
	input #filenum, wave->maxHealth
	input #filenum, wave->rateOfFire
	input #filenum, wave->bulletPattern
	input #filenum, wave->bulletClass
	
	wave->speed *= (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
	wave->maxHealth *= (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
	wave->rateOfFire *= (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
	wave->nSpawn *= (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
	
end sub