


type WinNewMeshType
	generatorClass	as integer
end type


type WinNewPhaseType
	roomClass		as integer
	phaseTitle		as string
end type


type WinNewWaveType
	class			as integer
end type


type WinWavePropertiesType
	wave			as WaveClassType ptr
	waitTicks		as integer
end type

type WinMeshPropertiesType
	gen				as GeneratorClassType ptr
	forceRegen		as integer
	waitTicks		as integer
end type



type WinSelectTableType
	returnWindow	as integer
	title			as string
	options			as string
	returnValue		as integer ptr
	returnOffset	as integer
	
	cellWidth		as integer
	nColumns		as integer
	nRows			as integer
	overallWidth	as integer
	overallHeight	as integer	
end type

type WinSelectColorType
	returnWindow	as integer
	title			as string
	rgb				as rgbalpha
	hsv				as hsv
	returnRGB		as rgbalpha ptr
end type


type WinCoorBoxType
	returnWindow	as integer
	title			as string
	returnVal		as Vector3D ptr
	originalVal		as Vector3D
	charLimit		as integer
end type


type WinTextBoxType
	returnWindow	as integer
	title			as string
	returnValue		as string ptr
	text			as string
	charLimit		as integer
end type

type WinNumberBoxType
	returnWindow	as integer
	title			as string
	returnValue		as single ptr
	value			as single
	charLimit		as integer
	text			as string
end type

	

type WinSequencerType
	selGenerator	as integer
	selWave			as integer
end type



declare function PhaseEditor_CheckMouse_Inside(x0 as integer, y0 as integer, w as integer, h as integer) as integer

declare sub PhaseEditor_Render_Gui_BarWindow (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, barHeight as integer, win as integer)
declare sub PhaseEditor_Render_Gui_Button (title as string, x0 as integer, y0 as integer, w0 as integer, centerCode as integer, win as integer)
declare sub PhaseEditor_Render_Gui_ColorButton (r0 as single, g0 as single, b0 as single, x0 as integer, y0 as integer, w0 as integer, win as integer)
declare sub PhaseEditor_Render_Gui_IconButton (x0 as integer, y0 as integer, w0 as integer, h0 as integer, win as integer)
declare sub PhaseEditor_Render_Gui_Layer ()
declare sub PhaseEditor_Render_Gui_Textbox (text as string, x0 as integer, y0 as integer, w0 as integer, win as integer)
declare sub PhaseEditor_Render_Gui_Window (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, win as integer)
declare sub PhaseEditor_Render_Gui_WindowGame (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, win as integer)

declare sub PhaseEditor_SetColor (cc as integer, win as integer)
declare sub PhaseEditor_Update_WindowAlpha (win as integer)


'--- windows
declare sub PhaseEditor_Render_Gui_Sequencer ()
declare sub PhaseEditor_Render_Gui_NewMesh ()

declare sub PhaseEditor_Render_Gui_NewPhase ()
declare sub PhaseEditor_Window_Init_NewPhase ()

declare sub PhaseEditor_Render_Gui_NewWave ()
declare sub PhaseEditor_Window_Init_NewWave ()

declare sub PhaseEditor_Render_Gui_SelectTable ()
declare sub PhaseEditor_Window_Init_SelectTable (options as string)

declare sub PhaseEditor_Render_Gui_SelectColor ()
declare sub PhaseEditor_Window_Init_SelectColor (c0 as rgbalpha)

declare sub PhaseEditor_Render_Gui_TextBoxWindow ()
declare sub PhaseEditor_Window_Init_TextBoxWindow (text as string, limit as integer)

declare sub PhaseEditor_Render_Gui_NumberBoxWindow ()
declare sub PhaseEditor_Window_Init_NumberBoxWindow (value as single, limit as integer)

declare sub PhaseEditor_Render_Gui_MeshProperties ()
declare sub PhaseEditor_Window_Init_MeshProperties ()

declare sub PhaseEditor_Render_Gui_WaveProperties ()
declare sub PhaseEditor_Window_Init_WaveProperties ()

declare sub PhaseEditor_Render_Gui_CoorBoxWindow ()
declare sub PhaseEditor_Window_Init_CoorBoxWindow (limit as integer)


'---- menus
declare sub PhaseEditor_Init_New_Phase ()


#DEFINE BS_NONE			0
#DEFINE BS_MOUSE_OVER	1
#DEFINE BS_MOUSE_LEFT_DOWN		2
#DEFINE BS_MOUSE_RIGHT_DOWN		3


#DEFINE WIN_SEQUENCER			0
#DEFINE WIN_NEW_MESH			1
#DEFINE WIN_NEW_MESH_SELECTGENCLASS		2
#DEFINE WIN_NEW_PHASE			3
#DEFINE WIN_NEW_WAVE			4
#DEFINE WIN_MESH_PROPERTIES		5
#DEFINE WIN_WAVE_PROPERTIES		6

#DEFINE WIN_SELECT_TABLE		50
#DEFINE WIN_TEXT_BOX			51
#DEFINE WIN_SELECT_COLOR		52
#DEFINE WIN_NUMBER_BOX			53
#DEFINE WIN_COOR_BOX			54



#DEFINE PEC_SEQ					0
#DEFINE PEC_SEQ_DARK			1
#DEFINE PEC_SEQ_TITLE			2
#DEFINE PEC_SEQ_SEPARATOR		3

#DEFINE PEC_BUTTON_EDGE			10
#DEFINE PEC_BUTTON_BOTTOM		11
#DEFINE PEC_BUTTON_TOP			12
#DEFINE PEC_BUTTON_TITLE		13
#DEFINE PEC_BUTTON_TITLE_HIGHLIGHT	14
#DEFINE PEC_BUTTON_TITLE_DEPRESSED	15
#DEFINE PEC_TEXTBOX_BG			16
#DEFINE PEC_WINDOW_BG			17
#DEFINE PEC_WINDOW_TITLE_BG		18
#DEFINE PEC_WINDOW_TITLE_BG_G	19
#DEFINE PEC_WINDOW_TITLE_BG_SELECTED	20
#DEFINE PEC_WINDOW_TITLE_BG_SELECTED_G	21
#DEFINE PEC_BARWINDOW			22

#DEFINE PMC_WINDOW_BG			50
#DEFINE PMC_WINDOW_BG_DARK		51
#DEFINE PMC_WINDOW_TITLE_BG		52
#DEFINE PMC_WINDOW_TITLE_BG_G	53
#DEFINE PMC_WINDOW_TITLE_BG_SELECTED	54
#DEFINE PMC_WINDOW_TITLE_BG_SELECTED_G	55

#DEFINE BUTTON_CENTER			1
#DEFINE	TEXTBOX_CENTER			1

