function PhaseEditor_CheckMouse_Inside(x0 as integer, y0 as integer, w as integer, h as integer) as integer

	dim ret as integer, button as integer
	
	ret = BS_NONE
	
	if PhaseEditorGlobals.windowLock = 1 then 
		PhaseEditor_CheckMouse_Inside = BS_NONE
		exit function
	end if
	
	if PhaseEditorGlobals.mousex >= x0 and PhaseEditorGlobals.mousex <= x0 + w then
		if PhaseEditorGlobals.mousey >= y0 and PhaseEditorGlobals.mousey <= y0 + h then
			'--- perform mouse down test
			ret = BS_MOUSE_OVER
			
			if PhaseEditorGlobals.waitTicks < system_time * 1000 then
				if glfwGetMouseButton(GLFW_MOUSE_BUTTON_LEFT) = GLFW_PRESS then ret = BS_MOUSE_LEFT_DOWN
				if glfwGetMouseButton(GLFW_MOUSE_BUTTON_RIGHT) = GLFW_PRESS then ret = BS_MOUSE_RIGHT_DOWN
			end if
		end if
	end if
	
	if ret > BS_MOUSE_OVER then PhaseEditorGlobals.waitTicks = system_time * 1000 + 200
	PhaseEditor_CheckMouse_Inside = ret
	
	
end function



sub PhaseEditor_Render_Gui_BarWindow (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, barHeight as integer, win as integer)

	dim as single m
	m = -2
	dim i as integer
	dim as integer lx0, ly0, lx1, ly1, x2, y2
	
	x2 = x0 - (y1 - y0) / 2
	
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_WINDOW_BG, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		glVertex2f x1, y1
		glVertex2f x1, y0
	glEnd
	


	glBegin GL_LINES
		PhaseEditor_SetColor colBG, win
		for i = x2 to x1 step 6
			lx0 = i
			ly0 = y0
			ly1 = y1
			lx1 = lx0 + (ly1 - ly0) / 2
			
			if lx1 > x1 then
				lx1 = x1
				ly1 = ly0 + (lx1 - lx0) * 2
			end if
			
			if lx0 < x0 then
				lx0 = x0
				ly0 = ly1 - (lx1 - lx0) * 2
			end if
			
			glVertex2f lx0, ly0
			glVertex2f lx1, ly1
		next
	glEnd
	
	
	dim as integer alt, nBars
	alt = 0
	nBars = (y1 - y0) / barHeight
	for i = 0 to nBars - 1
		y2 = y0 + i * barHeight
		
		if alt = 1 then
			glBegin GL_QUADS
				PhaseEditor_SetColor PEC_BARWINDOW, win
				glVertex2f x0 + 2, y2
				glVertex2f x0 + 2, y2 + barheight - 1
				glVertex2f x1 - 2, y2 + barHeight - 1
				glVertex2f x1 - 2, y2
			glEnd
		end if
		alt = 1 - alt
		glBegin GL_LINES
			glcolor3f 0, 0, 0
			glVertex2f x0, y2
			glVertex2f x1, y2
		glEnd
	next
	
	
	glBegin GL_LINES
		PhaseEditor_SetColor colBorder, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		
		glVertex2f x0, y1
		glVertex2f x1, y1
		
		glVertex2f x1, y1
		glVertex2f x1, y0
		
		glVertex2f x1, y0
		glVertex2f x0, y0
	glEnd


end sub



sub PhaseEditor_Render_Gui_Button (title as string, x0 as integer, y0 as integer, w0 as integer, centerCode as integer, win as integer)

	
	PhaseEditorGlobals.mouseLeft = 0
	PhaseEditorGlobals.mouseRight = 0
	
	dim as integer w, h, s, e, wd2
	
	font_xy w, h, title
	wd2 = w / 2
	s = 5
	e = 3
	
	w += 20
	h = 17
	
	if w0 > 0 then w = w0
	
	dim as integer status
	status = BS_NONE
	if PhaseEditorGlobals.winActive(win) = 1 then status = PhaseEditor_CheckMouse_Inside(x0, y0, w, h)
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + s, y0 + h
		glVertex2f x0 + w - s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0, y0 + h - s
		glVertex2f x0 + s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		
		glVertex2f x0 + w - s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + w - s, y0 + h
		glVertex2f x0 + w, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w, y0 + s
	glEnd
	
	glBegin GL_LINES
		PhaseEditor_SetColor PEC_BUTTON_EDGE, win
		if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
		'if status > BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_DEPRESSED, win
		glVertex2f x0, y0
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0 + w - s, y0
		glVertex2f x0 + w, y0 + s
		
		glVertex2f x0 + w, y0 + s
		glVertex2f x0 + w, y0 + h
		
		glVertex2f x0 + w, y0 + h
		glVertex2f x0 + s, y0 + h
		
		glVertex2f x0 + s, y0 + h
		glVertex2f x0, y0 + h - s
		
		glVertex2f x0, y0 + h - s
		glVertex2f x0, y0
	glEnd
	
	if status = BS_NONE then PhaseEditor_SetColor PEC_BUTTON_TITLE, win
	if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
	'if status > BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_DEPRESSED, win
	
	if centerCode = 0 then font_draw x0 + s, y0 + e, title
	if centerCode = BUTTON_CENTER then font_draw x0 + w / 2 - wd2, y0 + e, title
	
	if status = BS_MOUSE_LEFT_DOWN then PhaseEditorGlobals.mouseLeft = 1
	if status = BS_MOUSE_RIGHT_DOWN then PhaseEditorGlobals.mouseRight = 1

end sub



sub PhaseEditor_Render_Gui_ColorButton (r0 as single, g0 as single, b0 as single, x0 as integer, y0 as integer, w0 as integer, win as integer)

	
	PhaseEditorGlobals.mouseLeft = 0
	PhaseEditorGlobals.mouseRight = 0
	
	dim as integer w, h, s, e
	
	s = 5
	e = 3
	
	h = 17
	
	w = w0
	
	dim as integer status
	status = BS_NONE
	if PhaseEditorGlobals.winActive(win) = 1 then status = PhaseEditor_CheckMouse_Inside(x0, y0, w, h)
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + s, y0 + h
		glVertex2f x0 + w - s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0, y0 + h - s
		glVertex2f x0 + s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		
		glVertex2f x0 + w - s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + w - s, y0 + h
		glVertex2f x0 + w, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w, y0 + s
		
		glColor3f r0, g0, b0
		glVertex2f x0 + s + 2, y0 + 2
		glVertex2f x0 + s + 2, y0 + h - 3
		glVertex2f x0 + w - s - 2, y0 + h - 3
		glVertex2f x0 + w - s - 2, y0 + 2
	glEnd
	
	glBegin GL_LINES
		PhaseEditor_SetColor PEC_BUTTON_EDGE, win
		if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
		glVertex2f x0, y0
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0 + w - s, y0
		glVertex2f x0 + w, y0 + s
		
		glVertex2f x0 + w, y0 + s
		glVertex2f x0 + w, y0 + h
		
		glVertex2f x0 + w, y0 + h
		glVertex2f x0 + s, y0 + h
		
		glVertex2f x0 + s, y0 + h
		glVertex2f x0, y0 + h - s
		
		glVertex2f x0, y0 + h - s
		glVertex2f x0, y0
	glEnd
	
	
	if status = BS_MOUSE_LEFT_DOWN then PhaseEditorGlobals.mouseLeft = 1
	if status = BS_MOUSE_RIGHT_DOWN then PhaseEditorGlobals.mouseRight = 1

end sub


sub PhaseEditor_Render_Gui_IconButton (x0 as integer, y0 as integer, w0 as integer, h0 as integer, win as integer)

	
	PhaseEditorGlobals.mouseLeft = 0
	PhaseEditorGlobals.mouseRight = 0
	
	dim as integer w, h, s, e
	
	s = 5
	e = 3
	
	w = w0
	h = h0
	
	dim as integer status
	status = BS_NONE
	if PhaseEditorGlobals.winActive(win) = 1 then status = PhaseEditor_CheckMouse_Inside(x0, y0, w, h)
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + s, y0 + h
		glVertex2f x0 + w - s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0, y0 + h - s
		glVertex2f x0 + s, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + s, y0
		
		glVertex2f x0 + w - s, y0
		PhaseEditor_SetColor PEC_BUTTON_BOTTOM, win
		glVertex2f x0 + w - s, y0 + h
		glVertex2f x0 + w, y0 + h
		PhaseEditor_SetColor PEC_BUTTON_TOP, win
		glVertex2f x0 + w, y0 + s
	glEnd
	
	glBegin GL_LINES
		PhaseEditor_SetColor PEC_BUTTON_EDGE, win
		if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
		'if status > BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_DEPRESSED, win
		glVertex2f x0, y0
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0 + w - s, y0
		glVertex2f x0 + w, y0 + s
		
		glVertex2f x0 + w, y0 + s
		glVertex2f x0 + w, y0 + h
		
		glVertex2f x0 + w, y0 + h
		glVertex2f x0 + s, y0 + h
		
		glVertex2f x0 + s, y0 + h
		glVertex2f x0, y0 + h - s
		
		glVertex2f x0, y0 + h - s
		glVertex2f x0, y0
	glEnd
	
	if status = BS_MOUSE_LEFT_DOWN then PhaseEditorGlobals.mouseLeft = 1
	if status = BS_MOUSE_RIGHT_DOWN then PhaseEditorGlobals.mouseRight = 1

end sub


sub PhaseEditor_Render_Gui_Layer ()


	system_2dplane_set_full
	'---- draw gui elements
	
	
	PhaseEditor_Render_Gui_Sequencer
	PhaseEditor_Render_Gui_NewPhase
	PhaseEditor_Render_Gui_NewMesh
	PhaseEditor_Render_Gui_NewWave
	PhaseEditor_Render_Gui_MeshProperties
	PhaseEditor_Render_Gui_WaveProperties
	
	PhaseEditor_Render_Gui_SelectColor
	PhaseEditor_Render_Gui_SelectTable
	PhaseEditor_Render_Gui_TextBoxWindow
	PhaseEditor_Render_Gui_NumberBoxWindow
	PhaseEditor_Render_Gui_CoorBoxWindow
	
	'---- end drawing	
	system_2dplane_clear


end sub


sub PhaseEditor_Render_Gui_Textbox (text as string, x0 as integer, y0 as integer, w0 as integer, win as integer)

	
	PhaseEditorGlobals.mouseLeft = 0
	PhaseEditorGlobals.mouseRight = 0
	
	dim as integer w, h, s, e
	
	font_xy w, h, text
	s = 5
	e = 3
	
	w += 20
	h = 17
	
	if w0 > 0 then w = w0
	
	dim as integer status
	status = BS_NONE
	'if PhaseEditorGlobals.winActive(win) = 1 then status = PhaseEditor_CheckMouse_Inside(x0, y0, w, h)
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_TEXTBOX_BG, win
		glVertex2f x0 + s, y0
		glVertex2f x0 + s, y0 + h
		glVertex2f x0 + w - s, y0 + h
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0, y0
		glVertex2f x0, y0 + h - s
		glVertex2f x0 + s, y0 + h
		glVertex2f x0 + s, y0
		
		glVertex2f x0 + w - s, y0
		glVertex2f x0 + w - s, y0 + h
		glVertex2f x0 + w, y0 + h
		glVertex2f x0 + w, y0 + s
	glEnd
	
	glBegin GL_LINES
		'PhaseEditor_SetColor PEC_BUTTON_EDGE, win
		'if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
		'if status > BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_DEPRESSED, win
		PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
		glVertex2f x0, y0
		glVertex2f x0 + w - s, y0
		
		glVertex2f x0 + w - s, y0
		glVertex2f x0 + w, y0 + s
		
		glVertex2f x0 + w, y0 + s
		glVertex2f x0 + w, y0 + h
		
		glVertex2f x0 + w, y0 + h
		glVertex2f x0 + s, y0 + h
		
		glVertex2f x0 + s, y0 + h
		glVertex2f x0, y0 + h - s
		
		glVertex2f x0, y0 + h - s
		glVertex2f x0, y0
	glEnd
	
	PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
	'if status = BS_NONE then PhaseEditor_SetColor PEC_BUTTON_TITLE, win
	'if status = BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_HIGHLIGHT, win
	'if status > BS_MOUSE_OVER then PhaseEditor_SetColor PEC_BUTTON_TITLE_DEPRESSED, win
	font_draw x0 + s, y0 + e, text
	
	'if status = BS_MOUSE_LEFT_DOWN then PhaseEditorGlobals.mouseLeft = 1
	'if status = BS_MOUSE_RIGHT_DOWN then PhaseEditorGlobals.mouseRight = 1

end sub

sub PhaseEditor_Render_Gui_Window (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, win as integer)

	dim as single m
	m = -2
	dim i as integer
	dim as integer lx0, ly0, lx1, ly1, x2
	
	x2 = x0 - (y1 - y0) / 2
	
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PEC_WINDOW_BG, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		glVertex2f x1, y1
		glVertex2f x1, y0
	glEnd
	
	
	glBegin GL_LINES
		PhaseEditor_SetColor colBG, win
		for i = x2 to x1 step 6
			lx0 = i
			ly0 = y0
			ly1 = y1
			lx1 = lx0 + (ly1 - ly0) / 2
			
			if lx1 > x1 then
				lx1 = x1
				ly1 = ly0 + (lx1 - lx0) * 2
			end if
			
			if lx0 < x0 then
				lx0 = x0
				ly0 = ly1 - (lx1 - lx0) * 2
			end if
			
			glVertex2f lx0, ly0
			glVertex2f lx1, ly1
		next
	glEnd
	
	glBegin GL_QUADS
		if PhaseEditorGlobals.winLock(win) = 1 then PhaseEditor_SetColor PEC_WINDOW_TITLE_BG, win
		if PhaseEditorGlobals.winLock(win) = 0 then PhaseEditor_SetColor PEC_WINDOW_TITLE_BG_SELECTED, win
		glVertex2f x0 + 2, y0 + 2
		glVertex2f x0 + 2, y0 + 19
		if PhaseEditorGlobals.winLock(win) = 1 then PhaseEditor_SetColor PEC_WINDOW_TITLE_BG_G, win
		if PhaseEditorGlobals.winLock(win) = 0 then PhaseEditor_SetColor PEC_WINDOW_TITLE_BG_SELECTED_G, win
		glVertex2f x1 - 2, y0 + 19
		glVertex2f x1 - 2, y0 + 2
	glEnd

	glBegin GL_LINES
		PhaseEditor_SetColor colBorder, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		
		glVertex2f x0, y1
		glVertex2f x1, y1
		
		glVertex2f x1, y1
		glVertex2f x1, y0
		
		glVertex2f x1, y0
		glVertex2f x0, y0
	glEnd


end sub


sub PhaseEditor_Render_Gui_WindowGame (x0 as integer, y0 as integer, x1 as integer, y1 as integer, colBorder as integer, colBG as integer, win as integer)

	dim as single m
	m = -2
	dim i as integer
	dim as integer lx0, ly0, lx1, ly1, x2
	
	x2 = x0 - (y1 - y0) / 2
	
	
	glBegin GL_QUADS
		PhaseEditor_SetColor PMC_WINDOW_BG, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		glVertex2f x1, y1
		glVertex2f x1, y0
	glEnd
	
	#ifdef 0
	glBegin GL_LINES
		PhaseEditor_SetColor colBG, win
		for i = x2 to x1 step 6
			lx0 = i
			ly0 = y0
			ly1 = y1
			lx1 = lx0 + (ly1 - ly0) / 2
			
			if lx1 > x1 then
				lx1 = x1
				ly1 = ly0 + (lx1 - lx0) * 2
			end if
			
			if lx0 < x0 then
				lx0 = x0
				ly0 = ly1 - (lx1 - lx0) * 2
			end if
			
			glVertex2f lx0, ly0
			glVertex2f lx1, ly1
		next
	glEnd
	
	#endif
	glBegin GL_QUADS
		if PhaseEditorGlobals.winLock(win) = 1 then PhaseEditor_SetColor PMC_WINDOW_TITLE_BG, win
		if PhaseEditorGlobals.winLock(win) = 0 then PhaseEditor_SetColor PMC_WINDOW_TITLE_BG_SELECTED, win
		glVertex2f x0 + 2, y0 + 2
		glVertex2f x0 + 2, y0 + 19
		if PhaseEditorGlobals.winLock(win) = 1 then PhaseEditor_SetColor PMC_WINDOW_TITLE_BG_G, win
		if PhaseEditorGlobals.winLock(win) = 0 then PhaseEditor_SetColor PMC_WINDOW_TITLE_BG_SELECTED_G, win
		glVertex2f x1 - 2, y0 + 19
		glVertex2f x1 - 2, y0 + 2
	glEnd

	glBegin GL_LINES
		PhaseEditor_SetColor colBorder, win
		glVertex2f x0, y0
		glVertex2f x0, y1
		
		glVertex2f x0, y1
		glVertex2f x1, y1
		
		glVertex2f x1, y1
		glVertex2f x1, y0
		
		glVertex2f x1, y0
		glVertex2f x0, y0
	glEnd
	
	

end sub


sub PhaseEditor_SetColor (cc as integer, win as integer)

	dim alpha as single
	
	alpha = PhaseEditorGlobals.winAlpha(win)
	select case cc
		case PEC_SEQ
			glColor4f .5, .5, .5, alpha
		case PEC_SEQ_DARK
			glColor4f .2, .2, .2, alpha
		case PEC_SEQ_TITLE
			glColor4f .8, .8, .72, alpha
		case PEC_SEQ_SEPARATOR
			glColor4f .4, .4, .38, alpha
			
		case PEC_BUTTON_EDGE
			glColor4f .4, .4, .3, alpha
		case PEC_BUTTON_BOTTOM
			glColor4f 0, 0, 0, alpha
		case PEC_BUTTON_TOP
			glColor4f .3, .3, .3, alpha
		case PEC_BUTTON_TITLE
			glColor4f .8, .8, .72, alpha
			
		case PEC_BUTTON_TITLE_HIGHLIGHT
			glColor4f .9, .2, .1, alpha
			
		case PEC_BUTTON_TITLE_DEPRESSED
			glColor4f .1, .1, .1, alpha
			
		case PEC_TEXTBOX_BG
			glColor4f .1, .1, .1, alpha
			
		case PEC_WINDOW_BG
			glColor4f .1, .1, .1, alpha * .8
		case PEC_WINDOW_TITLE_BG
			glColor4f .3, .3, .3, alpha * .6
		case PEC_WINDOW_TITLE_BG_G
			glColor4f .3, .3, .3, alpha * .3
		case PEC_WINDOW_TITLE_BG_SELECTED
			glColor4f .9, .2, .1, alpha * .6
		case PEC_WINDOW_TITLE_BG_SELECTED_G
			glColor4f .9, .2, .1, alpha * .3
			
		case PEC_BARWINDOW
			glColor4f .1, .1, .1, alpha * .6
			
			
		case PMC_WINDOW_BG
			glColor4f .7, .7, .7, .85 * alpha
		case PMC_WINDOW_TITLE_BG
			glColor4f .9, .9, .9, alpha * .6
		case PMC_WINDOW_TITLE_BG_G
			glColor4f .9, .9, .9, alpha * .3
		case PMC_WINDOW_TITLE_BG_SELECTED
			glColor4f .1, .2, .9, alpha * .6
		case PMC_WINDOW_TITLE_BG_SELECTED_G
			glColor4f .1, .7, .9, alpha * .3
		case PMC_WINDOW_BG_DARK
			glColor4f .6, .6, .6, .8 * alpha
	end select
	
	
end sub




sub PhaseEditor_Update_WindowAlpha (win as integer)
	
	dim active as integer
	dim alpha as single
	alpha = PhaseEditorGlobals.winAlpha(win)
	active = PhaseEditorGlobals.winActive(win)

	if active = 0 then alpha -= .1 * fpsr
	if active = 1 then alpha += .1 * fpsr
	
	if alpha < 0 then alpha = 0
	if alpha > 1 then alpha = 1
	
	PhaseEditorGlobals.winAlpha(win) = alpha
	
end sub
