

sub PhaseEditor_Init_GeneratorClasses ()


	PhaseEditorGlobals.generatorClass(GC_CAMERA).title = "Camera"
	PhaseEditorGlobals.generatorClass(GC_BLOCK_TORUS).title = "Block Torus"
	PhaseEditorGlobals.generatorClass(GC_HEX_TUNNEL).title = "Hex Tunnel"
	PhaseEditorGlobals.generatorClass(GC_META_BALL_CLOUD).title = "Meta Ball Cloud"
	PhaseEditorGlobals.generatorClass(GC_META_BALL_DISC).title = "Meta Ball Disc"
	
	dim i as integer
	
	for i = 0 to 99
		if PhaseEditorGlobals.generatorClass(i).title <> "" then PhaseEditorGlobals.generatorClassLast = i
	next

end sub


sub PhaseEditor_Init_Camera ()

	dim as GeneratorClassType ptr gen
	gen = @PhaseDataGlobals.phaseSequence.generator[0]
	
	gen->title = PhaseEditorGlobals.generatorClass(GC_CAMERA).title
	gen->position.z = 20 			'camera offset
	gen->preAngularVelocity.x = 5  	'cameraVelocityH
	gen->PreAngularVelocity.y = 10  'cameraVelocityV
	
end sub
	
	
	
sub PhaseEditor_Init_Block_Torus (genID as integer)

	dim as GeneratorClassType ptr gen
	
	gen = @PhaseDataGlobals.phaseSequence.generator[genID]
	
	dim as integer i
	
	gen->position.x = 0
	gen->position.y = 0
	gen->position.z = 0
	
	gen->angle.x = 0
	gen->angle.y = 0
	gen->angle.z = 0
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->blockSize = .2
	gen->length = 0
	gen->innerRadius = 5
	gen->outterRadius = 5
	
	gen->nProjectiles = 400
	gen->nProjectilesReturn = -1
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))
	
	gen->nColorLights = 1
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nVicinityColors = 2
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	
	gen->vicinityColor[0].position.x = -10
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = .9
	gen->vicinityColor[0].color.g = .2
	gen->vicinityColor[0].color.b = .1
	gen->vicinityColor[0].fallOff = 20
	
	gen->vicinityColor[1].position.x = 10
	gen->vicinityColor[1].position.y = 0
	gen->vicinityColor[1].position.z = 0
	gen->vicinityColor[1].color.r = 1
	gen->vicinityColor[1].color.g = .4
	gen->vicinityColor[1].color.b = .2
	gen->vicinityColor[1].fallOff = 20
	
	gen->colorLight[0].position.x = 0
	gen->colorLight[0].position.y = 10
	gen->colorLight[0].position.z = 0
	gen->colorLight[0].color.r = .9
	gen->colorLight[0].color.g = .9
	gen->colorLight[0].color.b = .8
	gen->colorLight[0].fallOff = 10
	
	gen->shadowColor.r = .1
	gen->shadowColor.g = .05
	gen->shadowColor.b = .025
		
	PhaseData_Init_Block_Torus_Regenerate gen
	
end sub





sub PhaseEditor_Init_Block_Torus_ReSize (gen as GeneratorClassType ptr, nProjectiles as integer)

	dim as integer i
	
	for i = 0 to gen->nProjectiles - 1
		Deallocate gen->projectile[i].mesh.vertices
		Deallocate gen->projectile[i].mesh.triangles
	next
	Deallocate gen->projectile
	
	gen->nProjectiles = nProjectiles
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))	
	
end sub


sub PhaseEditor_Init_Hex_Tunnel (genID as integer)

	dim as GeneratorClassType ptr gen
	
	gen = @PhaseDataGlobals.phaseSequence.generator[genID]
	
	dim as integer i
	
	gen->position.x = 0
	gen->position.y = 0
	gen->position.z = 0
	
	gen->angle.x = 0
	gen->angle.y = 0
	gen->angle.z = 0
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->radius = 5
	gen->iterations = 7
	gen->rows = 2
	gen->rowsReturn = -1
	gen->cellSpacing = 1
	gen->cellBorder = 0
	gen->textureScrollSpeed = 0
	
	gen->nProjectiles = gen->rows * gen->iterations * 2
	gen->nProjectilesReturn = -1
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))
	
	gen->nColorLights = 1
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nVicinityColors = 2
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	
	gen->vicinityColor[0].position.x = -10
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = .9
	gen->vicinityColor[0].color.g = .2
	gen->vicinityColor[0].color.b = .1
	gen->vicinityColor[0].fallOff = 20
	
	gen->vicinityColor[1].position.x = 10
	gen->vicinityColor[1].position.y = 0
	gen->vicinityColor[1].position.z = 0
	gen->vicinityColor[1].color.r = 1
	gen->vicinityColor[1].color.g = .4
	gen->vicinityColor[1].color.b = .2
	gen->vicinityColor[1].fallOff = 20
	
	gen->colorLight[0].position.x = 0
	gen->colorLight[0].position.y = 10
	gen->colorLight[0].position.z = 0
	gen->colorLight[0].color.r = .9
	gen->colorLight[0].color.g = .9
	gen->colorLight[0].color.b = .8
	gen->colorLight[0].fallOff = 10
	
	gen->shadowColor.r = .1
	gen->shadowColor.g = .05
	gen->shadowColor.b = .025
		
	PhaseData_Init_Hex_Tunnel_Regenerate gen
	
end sub





sub PhaseEditor_Init_Hex_Tunnel_ReSize (gen as GeneratorClassType ptr, rows as integer)

	dim as integer i
	
	
	for i = 0 to gen->nProjectiles - 1
		Deallocate gen->projectile[i].mesh.vertices
		Deallocate gen->projectile[i].mesh.triangles
	next
	Deallocate gen->projectile
	
	gen->rows = rows
	gen->nProjectiles = gen->rows * gen->iterations * 2
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))	
	
end sub



sub PhaseEditor_Init_Meta_Ball_Cloud (genID as integer)

	dim as GeneratorClassType ptr gen
	
	gen = @PhaseDataGlobals.phaseSequence.generator[genID]
	
	dim as integer i
	
	gen->position.x = 0
	gen->position.y = 0
	gen->position.z = 0
	
	gen->angle.x = 0
	gen->angle.y = 0
	gen->angle.z = 0
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->cloudSize = 1
	gen->radius = 5
	
	gen->nProjectiles = 50
	gen->nProjectilesReturn = -1
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))
	
	gen->nColorLights = 0
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nVicinityColors = 2
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	
	gen->vicinityColor[0].position.x = -10
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = .9
	gen->vicinityColor[0].color.g = .2
	gen->vicinityColor[0].color.b = .1
	gen->vicinityColor[0].fallOff = 20
	
	gen->vicinityColor[1].position.x = 10
	gen->vicinityColor[1].position.y = 0
	gen->vicinityColor[1].position.z = 0
	gen->vicinityColor[1].color.r = 1
	gen->vicinityColor[1].color.g = .4
	gen->vicinityColor[1].color.b = .2
	gen->vicinityColor[1].fallOff = 20
	
	gen->shadowColor.r = .1
	gen->shadowColor.g = .05
	gen->shadowColor.b = .025
		
	PhaseData_Init_Meta_Ball_Cloud_Regenerate gen
	
end sub





sub PhaseEditor_Init_Meta_Ball_Cloud_ReSize (gen as GeneratorClassType ptr, nProjectiles as integer)

	dim as integer i
	
	for i = 0 to gen->nProjectiles - 1
		Deallocate gen->projectile[i].mesh.vertices
		Deallocate gen->projectile[i].mesh.triangles
	next
	Deallocate gen->projectile
	
	gen->nProjectiles = nProjectiles
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))	
	
end sub



sub PhaseEditor_Init_Meta_Ball_Disc (genID as integer)

	dim as GeneratorClassType ptr gen
	
	gen = @PhaseDataGlobals.phaseSequence.generator[genID]
	
	dim as integer i
	
	gen->position.x = 0
	gen->position.y = 0
	gen->position.z = 0
	
	gen->angle.x = 0
	gen->angle.y = 0
	gen->angle.z = 0
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->cloudSize = 1
	gen->length = 0
	gen->innerRadius = 5
	gen->outterRadius = 5
	
	gen->nProjectiles = 40
	gen->nProjectilesReturn = -1
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))
	
	gen->nColorLights = 0
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nVicinityColors = 2
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	
	gen->vicinityColor[0].position.x = -10
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = .9
	gen->vicinityColor[0].color.g = .2
	gen->vicinityColor[0].color.b = .1
	gen->vicinityColor[0].fallOff = 20
	
	gen->vicinityColor[1].position.x = 10
	gen->vicinityColor[1].position.y = 0
	gen->vicinityColor[1].position.z = 0
	gen->vicinityColor[1].color.r = 1
	gen->vicinityColor[1].color.g = .4
	gen->vicinityColor[1].color.b = .2
	gen->vicinityColor[1].fallOff = 20
	
	gen->shadowColor.r = .1
	gen->shadowColor.g = .05
	gen->shadowColor.b = .025
		
	PhaseData_Init_Meta_Ball_Disc_Regenerate gen
	
end sub





sub PhaseEditor_Init_Meta_Ball_Disc_ReSize (gen as GeneratorClassType ptr, nProjectiles as integer)

	dim as integer i
	
	for i = 0 to gen->nProjectiles - 1
		Deallocate gen->projectile[i].mesh.vertices
		Deallocate gen->projectile[i].mesh.triangles
	next
	Deallocate gen->projectile
	
	gen->nProjectiles = nProjectiles
	gen->projectile = callocate(gen->nProjectiles * sizeof(GenProjectileType))	
	
end sub


sub PhaseEditor_Generator_RemoveColor (gen as GeneratorClassType ptr, colorType as integer, index as integer)

	dim c0 as GeneratorColorType ptr
	dim as integer n
	
	if colorType = RC_VICINITY_COLOR then
		c0 = gen->vicinityColor
		n = gen->nVicinityColors
	elseif colorType = RC_COLOR_LIGHT then
		c0 = gen->colorLight
		n = gen->nColorLights
	end if
	
	dim as integer i, a
	for i = 0 to n - 1
		if i <> index then
			c0[a].position.x = c0[i].position.x
			c0[a].position.y = c0[i].position.y
			c0[a].position.z = c0[i].position.z
			
			c0[a].fallOff = c0[i].fallOff
			
			c0[a].color.r = c0[i].color.r
			c0[a].color.g = c0[i].color.g
			c0[a].color.b = c0[i].color.b
			c0[a].color.a = c0[i].color.a
		end if
		a += 1
	next
	
	n -= 1
	c0 = reallocate(c0, n * sizeof(GeneratorColorType))
	
	if colorType = RC_VICINITY_COLOR then gen->nVicinityColors = n
	if colorType = RC_COLOR_LIGHT then gen->nColorLights = n
	

end sub



sub PhaseEditor_PhaseSequence_Save (filename as string)


	dim as integer filenum, i
	
	filenum = freefile
	
	open filename for output as #filenum
		print #filenum, PhaseDataGlobals.phaseSequence.roomClass
		print #filenum, PhaseDataGlobals.phaseSequence.phaseTitle
		print #filenum, PhaseDataGlobals.phaseSequence.nGenerators
		print #filenum, PhaseDataGlobals.phaseSequence.nWaves
		
		print #filenum, PhaseDataGlobals.phaseSequence.cameraOffset
		print #filenum, PhaseDataGlobals.phaseSequence.cameraVelocityH
		print #filenum, PhaseDataGlobals.phaseSequence.cameraVelocityV
		
		for i = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
			PhaseEditor_Generator_Save @PhaseDataGlobals.phaseSequence.generator[i], filenum
		next
		
		for i = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
			PhaseEditor_Wave_Save @PhaseDataGlobals.phaseSequence.wave[i], filenum
		next
		
	close #filenum
	

end sub



sub PhaseEditor_Generator_Save (gen as GeneratorClassType ptr, filenum as integer)

	dim as integer genClass, i
	
	genClass = gen->class
	print #filenum, gen->title
	print #filenum, genClass
	print #filenum, gen->position.x
	print #filenum, gen->position.y
	print #filenum, gen->position.z
	
	print #filenum, gen->angle.x
	print #filenum, gen->angle.y
	print #filenum, gen->angle.z
	
	print #filenum, gen->preAngularVelocity.x
	print #filenum, gen->preAngularVelocity.y
	print #filenum, gen->preAngularVelocity.z

	if genClass = GC_BLOCK_TORUS then
		print #filenum, gen->blockSize
		print #filenum, gen->length
		print #filenum, gen->innerRadius
		print #filenum, gen->outterRadius
	end if
	
	if genClass = GC_HEX_TUNNEL then
		print #filenum, gen->rows
		print #filenum, gen->radius
		print #filenum, gen->iterations
		print #filenum, gen->cellSpacing
		print #filenum, gen->cellBorder
		print #filenum, gen->textureScrollSpeed
	end if
	
	if genClass = GC_META_BALL_CLOUD then
		print #filenum, gen->cloudSize
		print #filenum, gen->radius
	end if
	
	if genClass = GC_META_BALL_DISC then
		print #filenum, gen->cloudSize
		print #filenum, gen->length
		print #filenum, gen->innerRadius
		print #filenum, gen->outterRadius
	end if

	print #filenum, gen->nProjectiles
	print #filenum, gen->nVicinityColors
	print #filenum, gen->nColorLights
	print #filenum, gen->shadowColor.r
	print #filenum, gen->shadowColor.g
	print #filenum, gen->shadowColor.b
	
	for i = 0 to gen->nVicinityColors - 1
		print #filenum, gen->vicinityColor[i].position.x
		print #filenum, gen->vicinityColor[i].position.y
		print #filenum, gen->vicinityColor[i].position.z
		print #filenum, gen->vicinityColor[i].fallOff
		print #filenum, gen->vicinityColor[i].color.r
		print #filenum, gen->vicinityColor[i].color.g
		print #filenum, gen->vicinityColor[i].color.b
	next
	
	for i = 0 to gen->nColorLights - 1
		print #filenum, gen->colorLight[i].position.x
		print #filenum, gen->colorLight[i].position.y
		print #filenum, gen->colorLight[i].position.z
		print #filenum, gen->colorLight[i].fallOff
		print #filenum, gen->colorLight[i].color.r
		print #filenum, gen->colorLight[i].color.g
		print #filenum, gen->colorLight[i].color.b
	next

end sub
