

sub PhaseEditor_Render_Scene ()


	dim as integer genID, genClass
	dim as GeneratorClassType ptr gen
	
	glDisable GL_LIGHTING
	
	glPushMatrix
	
		PhaseDataGlobals.phaseSequence.generator[0].angle.x += PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.x * system_ticksPassed / 1000
		PhaseDataGlobals.phaseSequence.generator[0].angle.y += PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.y * system_ticksPassed / 1000
	
		for genID = 1 to PhaseDataGlobals.phaseSequence.nGenerators - 1
		
			gen = @PhaseDataGlobals.phaseSequence.generator[genID]
			genClass = gen->class
			
			if genClass = GC_BLOCK_TORUS then PhaseEditor_Render_Scene_Block_Torus gen
			if genClass = GC_HEX_TUNNEL then PhaseEditor_Render_Scene_Hex_Tunnel gen
			if genClass = GC_META_BALL_CLOUD then PhaseEditor_Render_Scene_Meta_Ball_Cloud gen
			if genClass = GC_META_BALL_DISC then PhaseEditor_Render_Scene_Meta_Ball_Disc gen
			
		next
	
	
	glPopMatrix


end sub




sub PhaseEditor_Render_Scene_Block_Torus (gen as GeneratorClassType ptr)

	
	dim as single length, innerRadius, outterRadius
	dim as integer proj, vert, tri, pointid
	
	gen->preAngularVelocityAngle.x += gen->preAngularVelocity.x * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.y += gen->preAngularVelocity.y * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.z += gen->preAngularVelocity.z * system_ticksPassed / 1000

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			PhaseEditor_Render_Scene_Align_Projectile @gen->projectile[proj]
			
			if gen->preAngularVelocityAngle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
			if gen->preAngularVelocityAngle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
			if gen->preAngularVelocityAngle.z <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
			
			if gen->angle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.x, 1, 0, 0
			if gen->angle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.y, 0, 1, 0
			if gen->angle.z <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.z, 0, 0, 1
			
			Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
			if PhaseDataGlobals.phaseSequence.generator[0].angle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
			if PhaseDataGlobals.phaseSequence.generator[0].angle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
			
			Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			glBegin GL_TRIANGLES
				glColor3f 1, 1, 1
				for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
					for vert = 1 to 3
						pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
						glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
						glNormal3fv @gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x
						glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
					next
				next
			glEnd
			#ifdef 0
			glBegin GL_LINES
				glColor3f 1, 1, 1
				for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
					for vert = 1 to 3
						pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
						glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
						glVertex3f gen->projectile[proj].mesh.vertices[pointid].x + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x, _
							gen->projectile[proj].mesh.vertices[pointid].y + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).y, _
							gen->projectile[proj].mesh.vertices[pointid].z + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).z
					next
				next
			glEnd
			#endif
		glPopMatrix
	next

end sub


sub PhaseEditor_Render_Scene_Hex_Tunnel (gen as GeneratorClassType ptr)

	
	dim as single length, innerRadius, outterRadius
	dim as integer proj, vert, tri, pointid
	
	gen->preAngularVelocityAngle.x += gen->preAngularVelocity.x * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.y += gen->preAngularVelocity.y * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.z += gen->preAngularVelocity.z * system_ticksPassed / 1000

	gen->textureScroll += 16 / 1000
	
	glEnable GL_TEXTURE_2D
	glBindTexture GL_TEXTURE_2D, PhaseEditorGlobals.chromeTex

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			PhaseEditor_Render_Scene_Align_Projectile @gen->projectile[proj]
			
			if gen->preAngularVelocityAngle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
			if gen->preAngularVelocityAngle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
			if gen->preAngularVelocityAngle.z <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
			
			if gen->angle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.x, 1, 0, 0
			if gen->angle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.y, 0, 1, 0
			if gen->angle.z <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.z, 0, 0, 1
			
			Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
			if PhaseDataGlobals.phaseSequence.generator[0].angle.x <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
			if PhaseDataGlobals.phaseSequence.generator[0].angle.y <> 0 then Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
			
			Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			glBegin GL_TRIANGLES
				for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
					for vert = 1 to 3
						pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
						glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
						glTexCoord2f gen->projectile[proj].mesh.triangles[tri].uv(vert).u + gen->textureScroll, gen->projectile[proj].mesh.triangles[tri].uv(vert).v + gen->textureScroll / 10
						glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
					next
				next
			glEnd
		glPopMatrix
	next
	
	glDisable GL_TEXTURE_2D

end sub


sub PhaseEditor_Render_Scene_Meta_Ball_Cloud (gen as GeneratorClassType ptr)

	dim as integer proj, vert, tri, pointid
	
	gen->preAngularVelocityAngle.x += gen->preAngularVelocity.x * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.y += gen->preAngularVelocity.y * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.z += gen->preAngularVelocity.z * system_ticksPassed / 1000
	
	dim as integer nSlices, g
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	glDisable GL_DEPTH_TEST

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.z, 0, 0, 1
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.x, 1, 0, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
				
				't/r to camera coordinates
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
				
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			nSlices = 24
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 1
					glVertex2f 0, 0
					
					an0 = 360 * g / nSlices
					an1 = an0 + 360 / nSlices
					radius = gen->cloudSize
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
			nSlices = 8
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 1
					glVertex2f 0, 0
					
					an0 = rnd * 360
					an1 = an0 + rnd * 90
					radius = gen->cloudSize
					radius += rnd * radius
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
		glPopMatrix
	next
	
	glDepthMask GL_TRUE
	glEnable GL_DEPTH_TEST

end sub


sub PhaseEditor_Render_Scene_Meta_Ball_Disc (gen as GeneratorClassType ptr)

	dim as integer proj, vert, tri, pointid
	
	gen->preAngularVelocityAngle.x += gen->preAngularVelocity.x * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.y += gen->preAngularVelocity.y * system_ticksPassed / 1000
	gen->preAngularVelocityAngle.z += gen->preAngularVelocity.z * system_ticksPassed / 1000
	
	dim as integer nSlices, g
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.z, 0, 0, 1
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.x, 1, 0, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
				
				't/r to camera coordinates
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
				
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			nSlices = 12
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 1
					glVertex2f 0, 0
					
					an0 = 360 * g / nSlices
					an1 = an0 + 360 / nSlices
					radius = gen->cloudSize
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
			
		glPopMatrix
	next
	
	glDepthMask GL_TRUE
	

end sub


sub PhaseEditor_Render_Scene_Align_Projectile (byval proj as GenProjectileType ptr)
	
	Matrix_Rotate @proj->matrix(0), proj->angle.x, 1, 0, 0
	Matrix_Rotate @proj->matrix(0), proj->angle.y, 0, 1, 0
	Matrix_Rotate @proj->matrix(0), proj->angle.z, 0, 0, 1
	Matrix_Translate @proj->matrix(0), proj->position.x, proj->position.y, proj->position.z
	
end sub