type WinHSDataType

	hs			as integer
	
end type


type WinOptionsType
	resolution	as integer
	fullscreen	as integer
	musicOn		as integer
	musicOnReset	as integer
	musicOnInitial	as integer
	sfxOn		as integer
	bitDepth	as integer
	musicVol	as integer
	sfxVol		as integer
	sensitivity	as integer
	res			as Vector3D
	invertMouse	as integer
	difficulty	as integer
end type


type WinNewHighScoreType
	name		as string
end type


type GradSliderType
	position	as Vector3D
	angle		as Vector3D
	velocity	as Vector3D
	velocityMag	as single
end type


type PhaseMenuGlobalsType


	initialized	as byte
	exitCode	as byte

	waitTicks	as integer
	
	nSliders		as integer
	gradSlider(20)	as GradSliderType
	
	titleMID		as integer
	titleDL			as integer
	titleZoom		as single
	titleZoomSpeed	as single
	titleAngle		as single
	titleStartZoom	as single
	titleFade		as integer
	
	waveFade		as single
	waveNumber		as integer
	waveMID			as integer
	gameOverMID		as integer
	GOOOHMID		as integer
	GOOOTMID		as integer
	scoreMID		as integer
	theEndMID		as integer
	
	hud_healthMID	as integer
	hud_clockMID	as integer
	hud_ammoMID		as integer
	hud_shieldMID	as integer
	
	uiFade			as single
	
	destination		as integer
	
	mousex			as integer
	mousey			as integer
	mouseLeft		as integer
	mouseRight		as integer
	
	curWindow		as integer

	winAlpha(99)	as single
	winActive(99)	as integer
	winLock(99)		as integer
	
	windowLock		as integer
	
	winNewHighScore	as WinNewHighScoreType
	winHSData		as WinHSDataType
	
	winOptions		as WinOptionsType
	videoMode(99)	as GLFWVidMode
	nVideoModes		as integer
	restart			as integer

end type



declare sub PhaseMenu_Render_Gui_Layer ()

declare sub PhaseMenu_Render_Gui_Credits ()
declare sub PhaseMenu_Render_Gui_Controls ()
declare sub PhaseMenu_Render_Gui_Main ()
declare sub PhaseMenu_Render_Gui_Options ()
declare sub PhaseMenu_Render_Gui_NewHighScore ()
declare sub PhaseMenu_Render_Gui_HighScores ()
declare sub PhaseMenu_Render_Gui_HSData ()


declare sub PhaseEditor_Render_Gui_SelectTable_Game ()



dim shared PhaseMenuGlobals as PhaseMenuGlobalsType


#DEFINE WIN_MAIN				0
#DEFINE	WIN_OPTIONS				1
#DEFINE WIN_CREDITS				2
#DEFINE WIN_CONTROLS			3
#DEFINE WIN_HIGH_SCORES			4
#DEFINE WIN_NEW_HIGH_SCORE		5
#DEFINE WIN_HS_DATA				6
#DEFINE WIN_PAUSED_MAIN			7

#DEFINE D_GAME		1
#DEFINE D_END		2
#DEFINE D_EXIT		3