

sub PhasePlayer_Bullets_Add (owner as integer, bClass as integer, bPattern as integer, position as Vector3D, accelMag as single)

	PhasePlayer_Bullets_upd_LastBullet
	
	'--- add code
	dim as integer b, bi
	
	b = 0
	do
		if PhasePlayerGlobals.bullet[b].active = 0 then exit do
		if b >= PhasePlayerGlobals.nBullets then exit do
		b += 1
	loop
	
	if b >= PhasePlayerGlobals.nBullets then exit sub
	
	PhasePlayerGlobals.bullet[b].active = 1
	PhasePlayerGlobals.bullet[b].class = bClass
	PhasePlayerGlobals.bullet[b].pattern = bPattern
	
	PhasePlayerGlobals.bullet[b].position.x = position.x
	PhasePlayerGlobals.bullet[b].position.y = position.y
	PhasePlayerGlobals.bullet[b].position.z = position.z
	
	if bClass = BC_TYPE_I then
	
		PhasePlayerGlobals.bullet[b].velocity.x = rnd * 1 - .5
		PhasePlayerGlobals.bullet[b].velocity.y = rnd * 1 - .5 
		PhasePlayerGlobals.bullet[b].velocity.z = rnd * 1 - .5
		PhasePlayerGlobals.bullet[b].homeTime = system_ticks + 1000
		
		math_normalize3f PhasePlayerGlobals.bullet[b].velocity
		
		PhasePlayerGlobals.bullet[b].velocity.x /= 2
		PhasePlayerGlobals.bullet[b].velocity.y /= 2
		PhasePlayerGlobals.bullet[b].velocity.z /= 2
		
	end if
	
	PhasePlayer_Init_Bullet_Regenerate @PhasePlayerGlobals.bullet[b]

	PhasePlayer_Bullets_upd_LastBullet

end sub




sub PhasePlayer_Init_Bullet_Regenerate (bullet as BulletType ptr)

	dim as integer g, p
	
	if bullet->nGenerators > 0 then
		dim as integer g, i, p
		
		for g = 0 to bullet->nGenerators - 1
			for p = 0 to bullet->generator[g].nProjectiles - 1
			
				deallocate bullet->generator[g].projectile[p].mesh.vertices
				deallocate bullet->generator[g].projectile[p].mesh.triangles
				
			next
			
			deallocate bullet->generator[g].projectile
			deallocate bullet->generator[g].vicinityColor
			deallocate bullet->generator[g].colorLight
		next
		
		deallocate bullet->generator
	end if
	
	if bullet->class = BC_TYPE_I then PhasePlayer_Init_Bullet_Regenerate_Type_I bullet


end sub


sub PhasePlayer_Init_Bullet_Regenerate_Type_I (bullet as BulletType ptr)

	
	bullet->nGenerators = 1
	bullet->generator = callocate(bullet->nGenerators * sizeof(GeneratorClassType))
	
	
	dim as GeneratorClassType ptr gen
	
	gen = @bullet->generator[0]
	
	gen->position.x = bullet->position.x
	gen->position.y = bullet->position.y
	gen->position.z = bullet->position.z
	
	gen->angle.x = 0
	gen->angle.y = 0
	gen->angle.z = 45
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 500
	gen->preAngularVelocity.z = 0
	
	gen->mass = 50
	
	gen->nVicinityColors = 1
	gen->nColorLights = 0
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	gen->shadowColor.r = 1
	gen->shadowColor.g = 0
	gen->shadowColor.b = 0
	
	gen->nProjectiles = 6
	gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
	
	gen->vicinityColor[0].position.x = 0
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = 1
	gen->vicinityColor[0].color.g = 0
	gen->vicinityColor[0].color.b = 0
	gen->vicinityColor[0].fallOff = .7
	
	
	dim as single spikeRadius, an
	dim as integer i
	
	spikeRadius = .075
	for i = 0 to 3
		an = i * 90
		PhaseData_Projectile_Set_Mesh gen, @gen->projectile[i], GPC_RING_SPIKE
		gen->projectile[i].position.x = spikeRadius * cos(3.1415 / 180 * an)
		gen->projectile[i].position.y = spikeRadius * sin(3.1415 / 180 * an)
		gen->projectile[i].position.z = 0
		gen->projectile[i].angle.x = 0
		gen->projectile[i].angle.y = 0
		gen->projectile[i].angle.z = -an
		gen->projectile[i].active = 1
		PhaseData_Projectile_Calc_Colors gen, @gen->projectile[i]
	next
	
	for i = 0 to 1
		an = i * 180 + 90
		PhaseData_Projectile_Set_Mesh gen, @gen->projectile[4+i], GPC_RING_SPIKE
		gen->projectile[4+i].position.x = spikeRadius * cos(3.1415 / 180 * an)
		gen->projectile[4+i].position.z = spikeRadius * sin(3.1415 / 180 * an)
		gen->projectile[4+i].position.y = 0
		gen->projectile[4+i].angle.x = 0
		gen->projectile[4+i].angle.y = an
		gen->projectile[4+i].angle.z = 0
		gen->projectile[4+i].active = 1
		PhaseData_Projectile_Calc_Colors gen, @gen->projectile[4+i]
	next
	
	
end sub


sub PhasePlayer_Bullets_Clear_Bullets ()

	dim as integer m
	
	PhasePlayerGlobals.lastBullet = -1
	
	for m = 0 to PhasePlayerGlobals.nBullets - 1
		PhasePlayerGlobals.Bullet[m].active = 0
	next
	
end sub


sub PhasePlayer_Bullets_Upd_LastBullet ()

	dim as integer m
	
	PhasePlayerGlobals.lastBullet = -1
	
	for m = 0 to PhasePlayerGlobals.nBullets - 1
		if PhasePlayerGlobals.Bullet[m].active = 1 then PhasePlayerGlobals.lastBullet = m
	next
	
end sub
	
	
	
sub PhasePlayer_Bullets_Upd_Bullets ()

	'--- update bullet position
	dim as integer b
	dim as BulletType ptr bullet
	dim as single d
	
	
	for b = 0 to PhasePlayerGlobals.lastBullet
		
		bullet = @PhasePlayerGlobals.bullet[b]
		if bullet->active = 1 then
		
			if bullet->pattern = BP_ONE_SHOT then PhasePlayer_Bullets_Upd_Bullet_One_Shot bullet
			if bullet->pattern = BP_BOMB then PhasePlayer_Bullets_Upd_Bullet_Bomb bullet
			
			PhasePlayer_Projectiles_Upd_Bullet_Projectiles bullet
			PhasePlayer_Missiles_CheckImpact_Bullet bullet
			
			'--- if bullet is exiting the playing field set it to inactive
			d = sqr(bullet->position.x * bullet->position.x + bullet->position.y * bullet->position.y + bullet->position.z * bullet->position.z)
			if d > 35 then bullet->active = 0
			
		elseif bullet->active = 2 then
		
			PhasePlayer_Projectiles_Upd_Bullet_Projectiles bullet
		
		end if
	
	next
	
	
end sub


sub PhasePlayer_Bullets_Upd_Bullet_One_Shot (bullet as BulletType ptr)

	dim as single vSpeed, d, jutter, jd2
	dim as vector3d delta
	dim as vector4d position
	
	Matrix_LoadIdentity @bullet->matrix(0)
	
	't/r to camera coordinates
	Matrix_Rotate @bullet->matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
	Matrix_Rotate @bullet->matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
	
	Matrix_Translate @bullet->matrix(0), 0, 0, PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	Matrix_Rotate @bullet->matrix(0), -(PhaseDataGlobals.phaseSequence.generator[0].angle.y + (PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.y * 4.3) * system_ticksPassed / 1000), 0, 1, 0
	Matrix_Rotate @bullet->matrix(0), -(PhaseDataGlobals.phaseSequence.generator[0].angle.x + (PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.x * 4.3) * system_ticksPassed / 1000), 1, 0, 0
	
	position.x = 0
	position.y = 0
	position.z = -1
	position.w = 1
	
	
	Matrix_Multiply_Point @bullet->matrix(0), position
	PhasePlayerGlobals.cameraPosition.x = position.x
	PhasePlayerGlobals.cameraPosition.y = position.y
	PhasePlayerGlobals.cameraPosition.z = position.z
	

	delta.x = position.x - bullet->position.x
	delta.y = position.y - bullet->position.y
	delta.z = position.z - bullet->position.z
	
	d = sqr(delta.x * delta.x + delta.y * delta.y + delta.z * delta.z)
	if d < 1 and bullet->active = 1 then
		bullet->active = 0
		PhasePlayer_Player_Hit 6
	end if
	
	math_normalize3f delta
	
	if bullet->homeTime < system_ticks then
		bullet->velocity.x = delta.x
		bullet->velocity.y = delta.y
		bullet->velocity.z = delta.z
	end if
	
	'math_normalize3f bullet->velocity
	
	vSpeed = system_ticksPassed / 1000
	vSpeed *= 6.4
	
	bullet->position.x += bullet->velocity.x * vSpeed
	bullet->position.y += bullet->velocity.y * vSpeed
	bullet->position.z += bullet->velocity.z * vSpeed
 

end sub


sub PhasePlayer_Bullets_Upd_Bullet_Bomb (bullet as BulletType ptr)

	dim as single vSpeed, d, jutter, jd2
	dim as vector3d delta
	dim as vector4d position
	
	Matrix_LoadIdentity @bullet->matrix(0)
	
	't/r to camera coordinates
	Matrix_Rotate @bullet->matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
	Matrix_Rotate @bullet->matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
	
	Matrix_Translate @bullet->matrix(0), 0, 0, PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	Matrix_Rotate @bullet->matrix(0), -(PhaseDataGlobals.phaseSequence.generator[0].angle.y + (PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.y * 4.3) * system_ticksPassed / 1000), 0, 1, 0
	Matrix_Rotate @bullet->matrix(0), -(PhaseDataGlobals.phaseSequence.generator[0].angle.x + (PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.x * 4.3) * system_ticksPassed / 1000), 1, 0, 0
	
	position.x = 0
	position.y = 0
	position.z = -1
	position.w = 1
	
	
	Matrix_Multiply_Point @bullet->matrix(0), position
	delta.x = position.x - bullet->position.x
	delta.y = position.y - bullet->position.y
	delta.z = position.z - bullet->position.z
	
	d = sqr(delta.x * delta.x + delta.y * delta.y + delta.z * delta.z)
	if d < 1 and bullet->active = 1 then
		bullet->active = 0
		PhasePlayer_Player_Hit 12
	end if
	
	vSpeed = system_ticksPassed / 1000
	vSpeed *= 6.4
	
	bullet->position.x += bullet->velocity.x * vSpeed
	bullet->position.y += bullet->velocity.y * vSpeed
	bullet->position.z += bullet->velocity.z * vSpeed
 

end sub


