

sub PhasePlayer_Explosions_New (position as Vector3D, expClass as integer)


	PhasePlayer_Explosions_upd_LastExplosion
	
	dim as integer e, ei
	
	dim as ScoreType ptr score
	
	score = @PhasePlayerGlobals.player.score
	
	e = 0
	do
		if PhasePlayerGlobals.explosion[e].active = 0 then exit do
		if e >= PhasePlayerGlobals.nExplosions then exit do
		e += 1
	loop
	
	if e >= PhasePlayerGlobals.nExplosions then exit sub
	
	PhasePlayerGlobals.explosion[e].active = 1
	
	PhasePlayerGlobals.explosion[e].position.x = position.x
	PhasePlayerGlobals.explosion[e].position.y = position.y
	PhasePlayerGlobals.explosion[e].position.z = position.z
	
	PhasePlayerGlobals.explosion[e].class = expClass
	
	if expClass = EC_NORMAL or expClass = EC_SMALL then PhasePlayer_Init_Explosion_Regenerate @PhasePlayerGlobals.explosion[e]
	
	if expClass = EC_NORMAL then PhasePlayerGlobals.player.fuzzTime = system_ticks + 220
	
	if expClass = EC_SHRAPNULL then PhasePlayerGlobals.explosion[e].active = 0
	
	'---- determine affected projectiles
	
	dim as vector4d PositionR, d
	dim as integer gen, p, i
	dim as single angleMag, velocityMag, rt
	
	if expClass = EC_NORMAL or expClass = EC_SMALL then
	
		for gen = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
		
			if PhaseDataGlobals.phaseSequence.generator[gen].class = GC_BLOCK_TORUS or PhaseDataGlobals.phaseSequence.generator[gen].class = GC_HEX_TUNNEL then 
			for p = 0 to PhaseDataGlobals.phaseSequence.generator[gen].nProjectiles - 1
				Matrix_LoadIdentity @PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].matrix(0)
				PhasePlayer_Render_Scene_Align_Projectile_No_Camera @PhaseDataGlobals.phaseSequence.generator[gen], @PhaseDataGlobals.phaseSequence.generator[gen].projectile[p]
				
				positionR.x = PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].mesh.meanVertex.x
				positionR.y = PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].mesh.meanVertex.y
				positionR.z = PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].mesh.meanVertex.z
				positionR.w = 1
				
				Matrix_Multiply_Point @PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].matrix(0), positionR
				
				d.x = positionR.x - position.x
				d.y = positionR.y - position.y
				d.z = positionR.z - position.z
				d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
				
				positionR.x = 0
				positionR.y = 0
				positionR.z = 0
				positionR.w = 1
				
				Matrix_Multiply_Point @PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].matrix(0), positionR
				
				rt = .7
				if PhaseDataGlobals.phaseSequence.generator[gen].class = GC_HEX_TUNNEL then rt = 2.43
				
				if d.w < PhasePlayerGlobals.explosionClass[expClass].fallOff * rt then
					score->mapDestroyed.value += 1
				
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].lock = 1
					
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].position.x = positionR.x
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].position.y = positionR.y
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].position.z = positionR.z
					
					velocityMag = 10
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].velocity.x = rnd * velocityMag - velocityMag / 2
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].velocity.y = rnd * velocityMag - velocityMag / 2
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].velocity.z = rnd * velocityMag - velocityMag / 2
					
					'Math_Normalize3f PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].velocity
					 
					angleMag = rnd * 300
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.x = rnd * angleMag - angleMag / 2
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.y = rnd * angleMag - angleMag / 2
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.z = 0'rnd * angleMag - angleMag / 2
					
					Math_Normalize3f PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.x *= angleMag
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.y *= angleMag
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].angularVelocity.z *= angleMag
					
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].accelMag = .5
					
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].accelVector.x = 0
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].accelVector.y = -1
					PhaseDataGlobals.phaseSequence.generator[gen].projectile[p].accelVector.z = 0
					
				end if
				
			next
			end if
		next
	
	end if
	
	dim as integer a, b, nSpawn, nWaves, g, nn
	dim as WaveClassType ptr wave
	dim as WaveSpawnType ptr spawn
	dim as GenProjectileType ptr proj
	
	nWaves = PhaseDataGlobals.phaseSequence.nWaves
	
	dim as integer enableNextSpawn, enableNextSpawnWave, enableNextTime
	enableNextSpawn = -1
	enableNextTime = system_time
	dim as integer pass, bStart

	
	PhasePlayerGlobals.player.play_ricochet = 0
	
	for a = 0 to nWaves - 1
	
		wave = @PhaseDataGlobals.phaseSequence.wave[a]
		
		nSpawn = wave->nSpawn
		for b = 0 to nSpawn - 1
		
			spawn = @wave->spawn[b]
			
			if enableNextSpawn = b and spawn->active = 0 and enableNextSpawnWave = a then
				if spawn->spawnTime > enableNextTime then
					spawn->active = 1
					enableNextSpawn = 0
					if wave->class = WC_BOSS_DRAGON and b = 0 then
						PhaseDataGlobals.phaseSequence.bossActive = 1
						PhaseDataGlobals.phaseSequence.bossWave = a
						wave->nextBomb = system_time + 30
					end if
				end if
			end if
				
			if spawn->active = 1 and spawn->shield_on = 0 then
			
				d.x = spawn->position.x - position.x
				d.y = spawn->position.y - position.y
				d.z = spawn->position.z - position.z
				d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
				if d.w < PhasePlayerGlobals.explosionClass[expClass].fallOff or spawn->detonate = 1 then
				
					if expClass = EC_NORMAL or expClass = EC_SMALL then
						
						pass = 1
						if wave->class = WC_BOSS_DRAGON and wave->shield_on = 1 then pass = 0
						if wave->class = WC_BOSS_DRAGON and wave->shield_on = 0 and spawn->shield_on = 1 then pass = 0
						
						if pass = 0 then PhasePlayerGlobals.player.play_ricochet = 1
						
						if pass = 1 then
							spawn->health -= 250
							spawn->pulse = 1
							if spawn->health <= 0 then
								score->damage.value += 250 + spawn->health
								score->kills.value += 1
								spawn->health = 0
								spawn->detonate = 1
								enableNextSpawn = b + 1
								enableNextSpawnWave = a
							end if
							
							if spawn->detonate = 0 then
								nn = (25 / wave->maxHealth) * spawn->totalProjectiles
								
								if nn > 1 then
									for i = 0 to nn
										g = int(rnd * spawn->nGenerators)
										p = int(rnd * spawn->generator[g].nProjectiles)
										
										proj = @spawn->generator[g].projectile[p]
										
										if proj->active = 1 and proj->lock = 0 then
										
											Matrix_LoadIdentity @proj->matrix(0)
											PhasePlayer_Render_Scene_Align_Projectile_No_Camera @spawn->generator[g], proj
											
											positionR.x = 0
											positionR.y = 0
											positionR.z = 0
											positionR.w = 1
											
											Matrix_Multiply_Point @proj->matrix(0), positionR
											
											spawn->generator[g].projectile[p].lock = 1
											
											proj->position.x = positionR.x
											proj->position.y = positionR.y
											proj->position.z = positionR.z
											
											velocityMag = 3
											proj->velocity.x = rnd * velocityMag - velocityMag / 2
											proj->velocity.y = rnd * velocityMag - velocityMag / 2
											proj->velocity.z = rnd * velocityMag - velocityMag / 2
											
											'Math_Normalize3f proj->velocity
											 
											angleMag = rnd * 300
											proj->angularVelocity.x = rnd * angleMag - angleMag / 2
											proj->angularVelocity.y = rnd * angleMag - angleMag / 2
											proj->angularVelocity.z = 0'rnd * angleMag - angleMag / 2
											
											Math_Normalize3f proj->angularVelocity
											proj->angularVelocity.x *= angleMag
											proj->angularVelocity.y *= angleMag
											proj->angularVelocity.z *= angleMag
											
											proj->accelMag = .4
											
											proj->accelVector.x = 0
											proj->accelVector.y = -1
											proj->accelVector.z = 0
										end if
									next
								end if
							end if
							
							if spawn->detonate = 1 then
								spawn->active = 2 'dead but still displaying
								spawn->detonate = 0
								
								for g = 0 to spawn->nGenerators - 1
									for p = 0 to spawn->generator[g].nProjectiles - 1
										proj = @spawn->generator[g].projectile[p]
										
										if proj->active = 1 and proj->lock = 0 then
									
											Matrix_LoadIdentity @proj->matrix(0)
											PhasePlayer_Render_Scene_Align_Projectile_No_Camera @spawn->generator[g], proj
											
											positionR.x = 0
											positionR.y = 0
											positionR.z = 0
											positionR.w = 1
											
											Matrix_Multiply_Point @proj->matrix(0), positionR
											
											spawn->generator[g].projectile[p].lock = 1
											
											proj->position.x = positionR.x
											proj->position.y = positionR.y
											proj->position.z = positionR.z
											
											velocityMag = 6
											proj->velocity.x = rnd * velocityMag - velocityMag / 2
											proj->velocity.y = rnd * velocityMag - velocityMag / 2
											proj->velocity.z = rnd * velocityMag - velocityMag / 2
											
											'Math_Normalize3f proj->velocity
											 
											angleMag = rnd * 300
											proj->angularVelocity.x = rnd * angleMag - angleMag / 2
											proj->angularVelocity.y = rnd * angleMag - angleMag / 2
											proj->angularVelocity.z = 0'rnd * angleMag - angleMag / 2
											
											Math_Normalize3f proj->angularVelocity
											proj->angularVelocity.x *= angleMag
											proj->angularVelocity.y *= angleMag
											proj->angularVelocity.z *= angleMag
											
											proj->accelMag = .4
											
											proj->accelVector.x = 0
											proj->accelVector.y = -1
											proj->accelVector.z = 0
										
										end if
										
									next
								next
							end if
						end if
					elseif expClass = EC_SHRAPNULL then
					
						pass = 1
						if wave->class = WC_BOSS_DRAGON and wave->shield_on = 1 then pass = 0
						if wave->class = WC_BOSS_DRAGON and wave->shield_on = 0 and spawn->shield_on = 1 then pass = 0
						
						if pass = 0 then PhasePlayerGlobals.player.play_ricochet = 1
						
						if pass = 1 then
							spawn->health -= 25 * (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
							spawn->pulse = 1
								
							
							nn = (25 * (1 + PhaseMenuGlobals.winOptions.difficulty / 10) / wave->maxHealth) * spawn->totalProjectiles
							
							if nn > 1 then
								for i = 0 to nn
									g = int(rnd * spawn->nGenerators)
									p = int(rnd * spawn->generator[g].nProjectiles)
									
									proj = @spawn->generator[g].projectile[p]
									
									if proj->active = 1 and proj->lock = 0 then
									
										Matrix_LoadIdentity @proj->matrix(0)
										PhasePlayer_Render_Scene_Align_Projectile_No_Camera @spawn->generator[g], proj
										
										positionR.x = 0
										positionR.y = 0
										positionR.z = 0
										positionR.w = 1
										
										Matrix_Multiply_Point @proj->matrix(0), positionR
										
										spawn->generator[g].projectile[p].lock = 1
										
										proj->position.x = positionR.x
										proj->position.y = positionR.y
										proj->position.z = positionR.z
										
										velocityMag = 3
										proj->velocity.x = rnd * velocityMag - velocityMag / 2
										proj->velocity.y = rnd * velocityMag - velocityMag / 2
										proj->velocity.z = rnd * velocityMag - velocityMag / 2
										
										'Math_Normalize3f proj->velocity
										 
										angleMag = rnd * 300
										proj->angularVelocity.x = rnd * angleMag - angleMag / 2
										proj->angularVelocity.y = rnd * angleMag - angleMag / 2
										proj->angularVelocity.z = 0'rnd * angleMag - angleMag / 2
										
										Math_Normalize3f proj->angularVelocity
										proj->angularVelocity.x *= angleMag
										proj->angularVelocity.y *= angleMag
										proj->angularVelocity.z *= angleMag
										
										proj->accelMag = .4
										
										proj->accelVector.x = 0
										proj->accelVector.y = -1
										proj->accelVector.z = 0
									end if
								next
							end if
							
							if spawn->health <= 0 then
								score->damage.value += 25 + spawn->health
								spawn->health = 0
								spawn->detonate = 1
								enableNextSpawn = b + 1
								enableNextSpawnWave = a
								PhasePlayer_Explosions_New position, EC_SMALL
							else
								score->damage.value += 25
							end if
						end if
					end if
				
					
					'spawn->active = 2
				end if
	
			end if
			
		next
		
	next
	
	if PhasePlayerGlobals.player.play_ricochet = 1 then
		PhasePlayerGlobals.player.ricochetOn = 1
		PhasePlayerGlobals.player.ricochetEnd = system_time + .25

	end if
	
	
	dim as BulletType ptr bullet
	dim as single f0
	
	for b = 0 to PhasePlayerGlobals.lastBullet
		
		bullet = @PhasePlayerGlobals.bullet[b]
		
		if bullet->active = 1 then
		
			d.x = bullet->position.x - position.x
			d.y = bullet->position.y - position.y
			d.z = bullet->position.z - position.z
			d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
			
			f0 = PhasePlayerGlobals.explosionClass[expClass].fallOff
			
			if expClass = EC_NORMAL then f0 *= 2
			
			if d.w < f0 then
			
				bullet->active = 2
				
				for g = 0 to bullet->nGenerators - 1
					for p = 0 to bullet->generator[g].nProjectiles - 1
						proj = @bullet->generator[g].projectile[p]
						
						if proj->active = 1 and proj->lock = 0 then
					
							Matrix_LoadIdentity @proj->matrix(0)
							PhasePlayer_Render_Scene_Align_Projectile_No_Camera @bullet->generator[g], proj
							
							positionR.x = 0
							positionR.y = 0
							positionR.z = 0
							positionR.w = 1
							
							Matrix_Multiply_Point @proj->matrix(0), positionR
							
							bullet->generator[g].projectile[p].lock = 1
							
							proj->position.x = positionR.x
							proj->position.y = positionR.y
							proj->position.z = positionR.z
							
							velocityMag = 5
							proj->velocity.x = rnd * velocityMag - velocityMag / 2
							proj->velocity.y = rnd * velocityMag - velocityMag / 2
							proj->velocity.z = rnd * velocityMag - velocityMag / 2
							
							angleMag = rnd * 300
							proj->angularVelocity.x = rnd * angleMag - angleMag / 2
							proj->angularVelocity.y = rnd * angleMag - angleMag / 2
							proj->angularVelocity.z = 0
							
							Math_Normalize3f proj->angularVelocity
							proj->angularVelocity.x *= angleMag
							proj->angularVelocity.y *= angleMag
							proj->angularVelocity.z *= angleMag
							
							proj->accelMag = .1
							
							proj->accelVector.x = 0
							proj->accelVector.y = -1
							proj->accelVector.z = 0
							
						
						end if
						
					next
				next
				
			end if

		end if
		
	next
	
	
	if PhasePlayerglobals.powerUp.active = 1 then 
		if expClass = EC_NORMAL or expClass = EC_SMALL or expClass = EC_SHRAPNULL then
		
			positionR.x = PhasePlayerGlobals.powerUp.position.x
			positionR.y = PhasePlayerGlobals.powerUp.position.y
			positionR.z = PhasePlayerGlobals.powerUp.position.z
	
			d.x = positionR.x - position.x
			d.y = positionR.y - position.y
			d.z = positionR.z - position.z
			d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
	
			if d.w < PhasePlayerGlobals.explosionClass[expClass].fallOff * .7 then
			
				score->powerUps.value += 1
				PhasePlayerGlobals.powerUp.active = 2
				PhasePlayer_Player_PowerUp_Pickup PhasePlayerGlobals.powerUp.class
			
			end if
		
		end if
	end if
	
	PhasePlayer_Explosions_upd_LastExplosion
	
end sub



sub PhasePlayer_Init_Explosion_Regenerate (explosion as ExplosionType ptr)

	if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
		PhasePlayerGlobals.musicChannel(MH_SUB_DROP) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_SUB_DROP))
		if explosion->class = EC_SMALL THEN FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_SUB_DROP), PhaseMenuGlobals.winOptions.sfxVol * .6
		if explosion->class = EC_NORMAL THEN FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_SUB_DROP), PhaseMenuGlobals.winOptions.sfxVol
	end if
	
	dim as integer g, p
	
	if explosion->nGenerators > 0 then
		dim as integer g, i, p
		
		for g = 0 to explosion->nGenerators - 1
			for p = 0 to explosion->generator[g].nProjectiles - 1
			
				deallocate explosion->generator[g].projectile[p].mesh.vertices
				deallocate explosion->generator[g].projectile[p].mesh.triangles
				
			next
			
			deallocate explosion->generator[g].projectile
			deallocate explosion->generator[g].vicinityColor
			deallocate explosion->generator[g].colorLight
		next
		
		deallocate explosion->metaBall
		deallocate explosion->generator
	end if
	
	if explosion->class = EC_NORMAL then PhasePlayer_Init_Explosion_Regenerate_Normal explosion
	if explosion->class = EC_SMALL then PhasePlayer_Init_Explosion_Regenerate_Small explosion


end sub


sub PhasePlayer_Init_Explosion_Regenerate_Normal (explosion as ExplosionType ptr)

	
	explosion->nGenerators = 5
	explosion->generator = callocate(explosion->nGenerators * sizeof(GeneratorClassType))
	
	dim as integer i, g
	dim as GeneratorClassType ptr gen
	
	gen = @explosion->generator[0]
	
	gen->position.x = explosion->position.x
	gen->position.y = explosion->position.y
	gen->position.z = explosion->position.z
	
	gen->angle.x = rnd * 360
	gen->angle.y = rnd * 360
	gen->angle.z = rnd * 360
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->nVicinityColors = 0
	gen->nColorLights = 0
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nProjectiles = 200
	gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
	
	explosion->nMetaBalls = gen->nProjectiles
	explosion->metaBall = callocate(gen->nProjectiles * sizeOf(MetaBallType))
	
	explosion->nBlastRings = explosion->nGenerators - 1
	explosion->blastRing = callocate(explosion->nBlastRings * sizeOf(BlastRingType))
	
	dim as single startTime, d, an0, radius0
	
	startTime = system_time
	
	for i = 0 to gen->nProjectiles - 1
	
		an0 = rnd * 360
		radius0 = rnd * 2
		gen->projectile[i].position.x = rnd * 1 - .5
		gen->projectile[i].position.y = rnd * 1 - .5
		gen->projectile[i].position.z = rnd * 1 - .5
		
		math_normalize3f gen->projectile[i].position
		
		gen->projectile[i].position.x *= radius0
		gen->projectile[i].position.y *= radius0
		gen->projectile[i].position.z *= radius0
		
		gen->projectile[i].angle.x = 0
		gen->projectile[i].angle.y = 0
		gen->projectile[i].angle.z = 0
		gen->projectile[i].active = 1
		
		explosion->metaBall[i].startTime = startTime + rnd * 1
		explosion->metaBall[i].duration = .5
		explosion->metaBall[i].colorCenter.x = rnd * 1 - .5
		explosion->metaBall[i].colorCenter.y = rnd * 1 - .5
		explosion->metaBall[i].angle = rnd * 360
		explosion->metaBall[i].baseColorOffset = rnd * .5
		
		'd = sqr(gen->projectile[i].position.x * gen->projectile[i].position.x + gen->projectile[i].position.y * gen->projectile[i].position.y + gen->projectile[i].position.z * gen->projectile[i].position.z)
		
		explosion->metaBall[i].radius = rnd * 1
		
		
	next
	
	
	for g = 1 to explosion->nGenerators - 1
		gen = @explosion->generator[g]
		
		gen->position.x = explosion->position.x
		gen->position.y = explosion->position.y
		gen->position.z = explosion->position.z
		
		gen->angle.x = rnd * 360
		gen->angle.y = rnd * 360
		gen->angle.z = rnd * 360
		
		gen->nVicinityColors = 0
		gen->nColorLights = 0
		gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
		gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
		
		gen->nProjectiles = 1
		gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
		gen->projectile[0].active = 1
		
		startTime = system_time
		explosion->blastRing[g-1].startTime = startTime + rnd * .2
		explosion->blastRing[g-1].duration = 1
		explosion->blastRing[g-1].radius = rnd * 2 + 3
		
	next
	
end sub



sub PhasePlayer_Init_Explosion_Regenerate_Small (explosion as ExplosionType ptr)

	
	explosion->nGenerators = 3
	explosion->generator = callocate(explosion->nGenerators * sizeof(GeneratorClassType))
	
	dim as integer i, g
	dim as GeneratorClassType ptr gen
	
	gen = @explosion->generator[0]
	
	gen->position.x = explosion->position.x
	gen->position.y = explosion->position.y
	gen->position.z = explosion->position.z
	
	gen->angle.x = rnd * 360
	gen->angle.y = rnd * 360
	gen->angle.z = rnd * 360
	
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	
	gen->nVicinityColors = 0
	gen->nColorLights = 0
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	
	gen->nProjectiles = 20
	gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
	
	explosion->nMetaBalls = gen->nProjectiles
	explosion->metaBall = callocate(gen->nProjectiles * sizeOf(MetaBallType))
	
	explosion->nBlastRings = explosion->nGenerators - 1
	explosion->blastRing = callocate(explosion->nBlastRings * sizeOf(BlastRingType))
	
	dim as single startTime, d, an0, radius0
	
	startTime = system_time
	
	for i = 0 to gen->nProjectiles - 1
	
		an0 = rnd * 360
		radius0 = rnd * .8
		gen->projectile[i].position.x = rnd * 1 - .5
		gen->projectile[i].position.y = rnd * 1 - .5
		gen->projectile[i].position.z = rnd * 1 - .5
		
		math_normalize3f gen->projectile[i].position
		
		gen->projectile[i].position.x *= radius0
		gen->projectile[i].position.y *= radius0
		gen->projectile[i].position.z *= radius0
		
		gen->projectile[i].angle.x = 0
		gen->projectile[i].angle.y = 0
		gen->projectile[i].angle.z = 0
		gen->projectile[i].active = 1
		
		explosion->metaBall[i].startTime = startTime + rnd * 1
		explosion->metaBall[i].duration = .5
		explosion->metaBall[i].colorCenter.x = rnd * 1 - .5
		explosion->metaBall[i].colorCenter.y = rnd * 1 - .5
		explosion->metaBall[i].angle = rnd * 360
		explosion->metaBall[i].baseColorOffset = rnd * .5
		
		'd = sqr(gen->projectile[i].position.x * gen->projectile[i].position.x + gen->projectile[i].position.y * gen->projectile[i].position.y + gen->projectile[i].position.z * gen->projectile[i].position.z)
		
		explosion->metaBall[i].radius = rnd * .3
		
		
	next
	
	
	for g = 1 to explosion->nGenerators - 1
		gen = @explosion->generator[g]
		
		gen->position.x = explosion->position.x
		gen->position.y = explosion->position.y
		gen->position.z = explosion->position.z
		
		gen->angle.x = rnd * 360
		gen->angle.y = rnd * 360
		gen->angle.z = rnd * 360
		
		gen->nVicinityColors = 0
		gen->nColorLights = 0
		gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
		gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
		
		gen->nProjectiles = 1
		gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
		gen->projectile[0].active = 1
		
		startTime = system_time
		explosion->blastRing[g-1].startTime = startTime + rnd * .2
		explosion->blastRing[g-1].duration = 1
		explosion->blastRing[g-1].radius = rnd * 1 + 1
		
	next
	
end sub




sub PhasePlayer_Explosions_Upd_Explosions ()

	'--- update explosion position
	dim as integer b
	dim as ExplosionType ptr explosion
	dim as single d
	
	
	for b = 0 to PhasePlayerGlobals.lastExplosion
		
		explosion = @PhasePlayerGlobals.explosion[b]
		if explosion->active = 1 then
		
			if explosion->class = EC_NORMAL then PhasePlayer_Explosions_Upd_Explosions_Normal explosion
			
			PhasePlayer_Projectiles_Upd_Explosion_Projectiles explosion
			
		end if
	
	next
	
	
end sub


sub PhasePlayer_Explosions_Upd_Explosions_Normal (explosion as ExplosionType ptr)

	
 

end sub


sub PhasePlayer_Explosions_Clear_Explosions ()

	dim as integer m
	
	PhasePlayerGlobals.lastExplosion = -1
	
	for m = 0 to PhasePlayerGlobals.nExplosions - 1
		PhasePlayerGlobals.explosion[m].active = 0
	next
	
end sub



sub PhasePlayer_Explosions_upd_LastExplosion ()

	dim as integer m
	
	PhasePlayerGlobals.lastExplosion = -1
	
	for m = 0 to PhasePlayerGlobals.nExplosions - 1
		if PhasePlayerGlobals.explosion[m].active = 1 then PhasePlayerGlobals.lastExplosion = m
	next
	
end sub
