

sub PhasePlayer_Init_7Segment ()

	dim as integer i
	
	'--- 7 segment
	for i = 0 to 9
		PhasePlayerGlobals.sevenSegmentMID(i) = objFile_load ("data/7segment/" + str(i) + ".obj")
		Model_Normalize ModelDB[PhasePlayerGlobals.sevenSegmentMID(i)].modelHandle
		PhasePlayerGlobals.sevenSegmentDL(i) = glGenLists(1)
		glNewList PhasePlayerGlobals.sevenSegmentDL(i), GL_COMPILE
			Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(i)].modelHandle
		glEndList
	next
	PhasePlayerGlobals.sevenSegmentMID(10) = objFile_load ("data/7segment/colon.obj")
	Model_Normalize ModelDB[PhasePlayerGlobals.sevenSegmentMID(10)].modelHandle
	PhasePlayerGlobals.sevenSegmentDL(10) = glGenLists(1)
	glNewList PhasePlayerGlobals.sevenSegmentDL(10), GL_COMPILE
		Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(10)].modelHandle
	glEndList
	
	dim as string missionClock, m
	dim as integer f
	
	missionClock = "88:88:88.888"
	PhasePlayerGlobals.missionClockBGDL = glGenLists(1)
	glNewList PhasePlayerGlobals.missionClockBGDL, GL_COMPILE
	
	glColor4f .71 / 5, .69 / 5, .63 / 5, .73
	glPushMatrix
		glLoadIdentity
		
			glTranslatef 0, 12, -40
			
			glBegin GL_QUADS
				glVertex3f -8, +.6 * 2, 0
				glVertex3f -8 - .6, +.6, 0
				glVertex3f +8 + .6, +.6, 0
				glVertex3f +8, +.6 * 2, 0
				
				glVertex3f -8 - .6, +.6, 0
				glVertex3f -8 - .6, -.6, 0
				glVertex3f +8 + .6, -.6, 0
				glVertex3f +8 + .6, +.6, 0
				
				glVertex3f -8 - .6, -.6, 0
				glVertex3f -8, -.6 * 2, 0
				glVertex3f +8, -.6 * 2, 0
				glVertex3f +8 + .6, -.6, 0
				
			glEnd
				
			
	glPopMatrix
	
	
	glColor4f .71 / 2, .69 / 2, .63 / 2, .28
	glPushMatrix
		glLoadIdentity
		
		
		glTranslatef -7.3, 12, -40
		
		for i = 1 to 8
			m = mid(missionClock, i, 1)
			
			glTranslatef 1.3, 0, 0
			if m <> ":" then Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(8)].modelHandle
			if m = ":" then Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(10)].modelHandle
			
		next
		
		glScalef .6, .6, .6
		
		glTranslatef .5, -.6, 0
		for i = 9 to 12
			m = mid(missionClock, i, 1)
			
			glTranslatef 1.3, 0, 0
			if m = "." then
				glPushMatrix
					glScalef .5, .5, .5
					Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(10)].modelHandle
				glPopMatrix
			else
				Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(8)].modelHandle
			end if
		
		next
		
	glPopMatrix
	
	glEndList

end sub



sub PhasePlayer_Init_Bullets ()

	PhasePlayerGlobals.nBullets = 100
	PhasePlayerGlobals.lastBullet = 0
	PhasePlayerGlobals.Bullet = callocate (PhasePlayerGlobals.nBullets * sizeof(BulletType))
	
	PhasePlayerGlobals.nBulletClasses = 1
	PhasePlayerGlobals.BulletClass = callocate(PhasePlayerGlobals.nBulletClasses * sizeof(BulletClassType))

	
end sub



sub PhasePlayer_Init_Explosions ()

	PhasePlayerGlobals.nExplosions = 10
	PhasePlayerGlobals.lastExplosion = 0
	PhasePlayerGlobals.explosion = callocate (PhasePlayerGlobals.nExplosions * sizeof(ExplosionType))
	
	PhasePlayerGlobals.nExplosionClasses = 2
	PhasePlayerGlobals.explosionClass = callocate(PhasePlayerGlobals.nExplosionClasses * sizeof(ExplosionClassType))
	
	PhasePlayerGlobals.explosionClass[EC_NORMAL].fallOff = 2
	PhasePlayerGlobals.explosionClass[EC_SHRAPNULL].fallOff = 1.2
	PhasePlayerGlobals.explosionClass[EC_SMALL].fallOff = .6
	
	
end sub


sub PhasePlayer_Init_Missiles ()

	PhasePlayerGlobals.nMissiles = 100
	PhasePlayerGlobals.lastMissile = 0
	PhasePlayerGlobals.missile = callocate (PhasePlayerGlobals.nMissiles * sizeof(MissileType))
	
	dim as integer i
	
	for i = 0 to PhasePlayerGlobals.nMissiles - 1
		with PhasePlayerGlobals.missile[i]
			.active = 0
			.class = 0
			.owner = 0
			.position.x = 0
			.position.y = 0
			.position.z = 0
			.velocity.x = 0
			.velocity.y = 0
			.velocity.z = 0
			.accelVector.x = 0
			.accelVector.y = 0
			.accelVector.z = 0
			.accelMag = 0
			.mass = 0
		end with
	next
	
	PhasePlayerGlobals.nMissileClasses = 1.5
	PhasePlayerGlobals.missileClass = callocate(PhasePlayerGlobals.nMissileClasses * sizeof(MissileClassType))
	PhasePlayerGlobals.missileClass[MC_BULLET].mass = 50
	PhasePlayerGlobals.missileClass[MC_ROCKET].mass = 200

	PhasePlayer_Missiles_upd_LastMissile
	
end sub


sub PhasePlayer_Init_MissionClock ()
	
	dim as single totalTime
	dim as integer w
	
	totalTime = 0
	for w = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
		if totalTime < PhaseDataGlobals.phaseSequence.wave[w].startTime + PhaseDataGlobals.phaseSequence.wave[w].time then totalTime = PhaseDataGlobals.phaseSequence.wave[w].startTime + PhaseDataGlobals.phaseSequence.wave[w].time
	next
	
	PhaseDataGlobals.phaseSequence.totalPowerUps = totalTime / 20
	PhasePlayerGlobals.missionTotalTime = totalTime
	io_clock_set PhasePlayerGlobals.missionClock, 0, 0, PhasePlayerGlobals.missionTotalTime
	io_clock_start PhasePlayerGlobals.missionClock, IO_BACKWARD
	PhasePlayerGlobals.missionClock.alarm = 0
	
	
end sub


sub PhasePlayer_Init_Music ()

	fsound_init 44100, 32, 0
	
	PhasePlayerGlobals.musicHandle(MH_SONG) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/one.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_GUNS) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/guns.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_SUB_DROP) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/drop_solo.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_COCK) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/weaponSwitch.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_HIT) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/hit.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_RICOCHET) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/ricochet.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_POWERUP) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/powerup.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_NOAMMO) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/noammo.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_ALARM) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/alarm.ogg", 0, 0, 0)
	PhasePlayerGlobals.musicHandle(MH_SONG2) = FSOUND_Sample_Load(FSOUND_FREE, "data/sounds/two.ogg", 0, 0, 0)
	
	PhasePlayerGlobals.musicEnabled = 1
	if PhasePlayerGlobals.musicHandle(MH_SONG) = 0 then PhasePlayerGlobals.musicEnabled = 0
	
	FSOUND_Sample_SetMode PhasePlayerGlobals.musicHandle(MH_SONG), FSOUND_LOOP_NORMAL
	FSOUND_Sample_SetMode PhasePlayerGlobals.musicHandle(MH_SONG2), FSOUND_LOOP_NORMAL
	FSOUND_Sample_SetMode PhasePlayerGlobals.musicHandle(MH_GUNS), FSOUND_LOOP_NORMAL
	FSOUND_Sample_SetMode PhasePlayerGlobals.musicHandle(MH_RICOCHET), FSOUND_LOOP_NORMAL
	FSOUND_Sample_SetMode PhasePlayerGlobals.musicHandle(MH_ALARM), FSOUND_LOOP_NORMAL
	
end sub


sub PhasePlayer_Init_Player ()

	PhasePlayerGlobals.player.nWeapons = 2
	PhasePlayerGlobals.player.selWeapon = 0
	
	PhasePlayerGlobals.player.health = 100 * (1 - PhaseMenuGlobals.winOptions.difficulty / 10)
	PhasePlayerGlobals.player.maxHealth = PhasePlayerGlobals.player.health
	
	PhasePlayerGlobals.player.shield = 100 * (1 - PhaseMenuGlobals.winOptions.difficulty / 10)
	PhasePlayerGlobals.player.maxShield = PhasePlayerGlobals.player.shield
	
	PhasePlayerGlobals.player.weapon[0].class = WC_MACHINE_GUN
	
	PhasePlayerGlobals.player.weapon[1].class = WC_ROCKET_LAUNCHER
	PhasePlayerGlobals.player.weapon[1].rounds = 18
	PhasePlayerGlobals.player.weapon[0].lastFire = 0
	PhasePlayerGlobals.player.weapon[1].lastFire = 0
	
	PhaseDataGlobals.phaseSequence.bossActive = 0
	
	PhasePlayerGlobals.powerUp.active = 2
	PhaseMenuGlobals.uiFade = 1
	
	PhasePlayerGlobals.fuzzMode = 0
	
	PhasePlayerGlobals.player.gameOver = 0
	PhasePlayerGlobals.player.gameOverFadeRed = 0
	PhasePlayerGlobals.player.gameOverFadeBlackTime = 0
	
	PhasePlayerGlobals.player.score.shotsFired = 0
	PhasePlayerGlobals.player.score.shotsLanded = 0
	PhasePlayerGlobals.player.score.points = 0
	
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.kills, 10
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.damage, 6
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.mapDestroyed, 3
	'PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.timeRemaining, 5
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.powerUps, 3
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.healthLost, 4
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.shieldLost, 4
	PhasePlayer_Init_Score_Data @PhasePlayerGlobals.player.score.accuracy, 3
	
end sub


sub PhasePlayer_Init_Score_Data (v as ScoreDataType ptr, weight as integer)

	v->value = 0
	v->frequency = weight / 17
	v->weight = weight


end sub



sub PhasePlayer_Init_Spawn_Models (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)


	if wave->class = WC_BOSS_DRAGON then PhasePlayer_Init_Spawn_Models_BossDragon wave, spawn


end sub



sub PhasePlayer_Init_Spawn_Models_BossDragon (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)


	dim as integer modelHandle
	dim as GeneratorClassType ptr gen
	
	dim as integer spawnIndex
	dim as single spawnIndexR
	
	spawnIndex = spawn->spawnIndex
	
	spawnIndexR = spawnIndex / wave->nSpawn
	
	modelHandle = -1
	
	if spawnIndex = 0 then modelHandle = objFile_load("data/boss0/boss0_6.obj")
	if spawnIndex = 1 then modelHandle = objFile_load("data/boss0/boss0_0.obj")
	if spawnIndex = 34 then modelHandle = objFile_load("data/boss0/boss0_5.obj")
	
	if spawnIndex > 1 and modelHandle = -1 then
		if spawnIndex mod 2 = 1 then modelHandle = objFile_load("data/boss0/boss0_2.obj")
		if spawnIndex mod 2 = 0 then
			
			if spawnIndex = 10 or spawnIndex = 22 then
				modelHandle = objFile_load("data/boss0/boss0_4.obj")
			elseif spawnIndex mod 4 = 2 then
				modelHandle = objFile_load("data/boss0/boss0_1.obj")
			else
				modelHandle = objFile_load("data/boss0/boss0_3.obj")
			end if
			
		end if
	end if
	
	if modelHandle = -1 then modelHandle = objFile_load("data/boss0/boss0_3.obj")
	
	dim as Model3D ptr Model
	
	Model = ModelDB[modelHandle].modelHandle
	
	spawn->nGenerators = 1
	spawn->generator = callocate(spawn->nGenerators * sizeOf(GeneratorClassType))
	
	gen = @spawn->generator[0]
	gen->nVicinityColors = 2
	gen->nColorLights = 2
	gen->vicinityColor = callocate(gen->nVicinityColors * sizeOf(GeneratorColorType))
	gen->colorLight = callocate(gen->nColorLights * sizeOf(GeneratorColorType))
	gen->preAngularVelocityAngle.x = 0
	gen->preAngularVelocityAngle.y = 0
	gen->preAngularVelocityAngle.z = 0
	gen->position.x = spawn->position.x
	gen->position.y = spawn->position.y
	gen->position.z = spawn->position.z
	gen->preAngularVelocity.x = 0
	gen->preAngularVelocity.y = 0
	gen->preAngularVelocity.z = 0
	if spawn->spawnIndex = 0 then gen->preAngularVelocity.x = 400
	gen->mass = 200
	gen->shadowColor.r = .1
	gen->shadowColor.g = 0
	gen->shadowColor.b = 0
	
	gen->vicinityColor[0].position.x = 0
	gen->vicinityColor[0].position.y = 0
	gen->vicinityColor[0].position.z = 0
	gen->vicinityColor[0].color.r = 1
	gen->vicinityColor[0].color.g = 1
	gen->vicinityColor[0].color.b = 1
	gen->vicinityColor[0].fallOff = 5
	
	gen->colorLight[0].position.x = 10
	gen->colorLight[0].position.y = 10
	gen->colorLight[0].position.z = 10
	gen->colorLight[0].color.r = 1
	gen->colorLight[0].color.g = 1' - .2 * spawnIndexR
	gen->colorLight[0].color.b = 1' - .5 * spawnIndexR
	gen->colorLight[0].falloff = 20
	
	gen->colorLight[1].position.x = -10
	gen->colorLight[1].position.y = -10
	gen->colorLight[1].position.z = -10
	gen->colorLight[1].color.r = 1
	gen->colorLight[1].color.g = 1' - .2 * spawnIndexR
	gen->colorLight[1].color.b = 1' - .5 * spawnIndexR
	gen->colorLight[1].falloff = 20
	
	gen->nProjectiles = 1
	gen->projectile = callocate(gen->nProjectiles * sizeOf(GenProjectileType))
	
	
	dim as integer tri, pnt, point_id, normal
	
	gen->projectile[0].mesh.max_triangles = Model->max_triangles
	gen->projectile[0].mesh.max_vertices = Model->max_vertices
	gen->projectile[0].mesh.triangles = callocate (Model->max_triangles * sizeOf(GPTriangleType))
	gen->projectile[0].mesh.vertices = callocate (Model->max_vertices * sizeOF(Vector3D))
	gen->projectile[0].position.x = 0
	gen->projectile[0].position.y = 0
	gen->projectile[0].position.z = 0
	gen->projectile[0].angle.x = 0
	gen->projectile[0].angle.y = 0
	gen->projectile[0].angle.z = 0
	gen->projectile[0].active = 1
	gen->projectile[0].lock = 0
	gen->projectile[0].accelVector.x = 0
	gen->projectile[0].accelVector.y = 0
	gen->projectile[0].accelVector.z = 0
	gen->projectile[0].accelMag = 0
	gen->projectile[0].velocity.x = 0
	gen->projectile[0].velocity.y = 0
	gen->projectile[0].velocity.z = 0
	
	
	for tri = 0 to Model->max_triangles - 1
	
		for pnt = 1 to 3
		
			normal = Model->triangles[tri].vnormal(pnt)
			point_id = Model->triangles[tri].point_id(pnt)
			
			'glNormal3fv( @Model->vnormals[normal].X )
			'glVertex3fv( @Model->vertices[point_id].X )
			
			gen->projectile[0].mesh.triangles[tri].point_id(pnt) = point_id
			
			
			gen->projectile[0].mesh.vertices[point_id].x = Model->vertices[point_id].x
			gen->projectile[0].mesh.vertices[point_id].y = Model->vertices[point_id].y
			gen->projectile[0].mesh.vertices[point_id].z = Model->vertices[point_id].z
			gen->projectile[0].mesh.triangles[tri].vnormal(pnt).x = Model->vnormals[normal].x
			gen->projectile[0].mesh.triangles[tri].vnormal(pnt).y = Model->vnormals[normal].y
			gen->projectile[0].mesh.triangles[tri].vnormal(pnt).z = Model->vnormals[normal].z
			
		
		next
		
	next
	
	PhaseData_Projectile_Calc_MeanVertex @gen->projectile[0]
	PhaseData_Projectile_Calc_stdDeviation @gen->projectile[0]
	PhaseData_Projectile_Calc_Colors gen, @gen->projectile[0]
	
	
	'UnloadMesh Model
	

end sub



sub PhasePlayer_Init_Weapons ()

	PhasePlayerGlobals.nWeapons = 2
	PhasePlayerGlobals.weaponClass = callocate(PhasePlayerGlobals.nWeapons * sizeof(WeaponClassType))
	PhasePlayerGlobals.player.weapon = callocate(PhasePlayerGlobals.nWeapons * sizeof(WeaponType))
	
	PhasePlayerGlobals.weaponClass[WC_MACHINE_GUN].reloadTime = 1000
	PhasePlayerGlobals.weaponClass[WC_MACHINE_GUN].rpm = 1200
	PhasePlayerGlobals.weaponClass[WC_MACHINE_GUN].missileClass = MC_BULLET
	PhasePlayerGlobals.weaponClass[WC_MACHINE_GUN].jutter = 5
	
	PhasePlayerGlobals.weaponClass[WC_ROCKET_LAUNCHER].reloadTime = 2000	'ticks
	PhasePlayerGlobals.weaponClass[WC_ROCKET_LAUNCHER].rpm = 200
	PhasePlayerGlobals.weaponClass[WC_ROCKET_LAUNCHER].missileClass = MC_ROCKET
	PhasePlayerGlobals.weaponClass[WC_ROCKET_LAUNCHER].jutter = 20
	
	
end sub