

sub PhasePlayer_Missiles_Add (owner as integer, mClass as integer, position as Vector4D, accelVector as vector3D, accelMag as single)

	PhasePlayer_Missiles_upd_LastMissile
	
	dim as integer m, mi
	
	m = 0
	do
		if PhasePlayerGlobals.missile[m].active = 0 then exit do
		if m >= PhasePlayerGlobals.nMissiles then exit do
		m += 1
	loop
	
	if m >= PhasePlayerGlobals.nMissiles then exit sub
	
	PhasePlayerGlobals.player.score.shotsFired += 1
	
	PhasePlayerGlobals.missile[m].active = 1
	if mClass = MC_ROCKET THEN PhasePlayerGlobals.missile[m].explosionClass = EC_NORMAL
	if mClass = MC_BULLET THEN PhasePlayerGlobals.missile[m].explosionClass = EC_SHRAPNULL
	
	'PhasePlayerGlobals.missile[m].explosionClass = EC_NORMAL
	
	Matrix_LoadIdentity @PhasePlayerGlobals.missile[m].matrix(0)
	
	't/r to camera coordinates
	Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
	Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
	
	Matrix_Translate @PhasePlayerGlobals.missile[m].matrix(0), 0, 0, PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
	Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
	
	position.x = 0
	position.y = 0
	position.z = -2.5
	position.w = 1
	
	
	Matrix_Multiply_Point @PhasePlayerGlobals.missile[m].matrix(0), position
	PhasePlayerGlobals.cameraPosition.x = position.x
	PhasePlayerGlobals.cameraPosition.y = position.y
	PhasePlayerGlobals.cameraPosition.z = position.z


	PhasePlayerGlobals.missile[m].position.x = PhasePlayerGlobals.cameraPosition.x
	PhasePlayerGlobals.missile[m].position.y = PhasePlayerGlobals.cameraPosition.y
	PhasePlayerGlobals.missile[m].position.z = PhasePlayerGlobals.cameraPosition.z
	
	position.x = 0
	position.y = 0
	position.z = -4
	position.w = 1
	
	
	Matrix_Multiply_Point @PhasePlayerGlobals.missile[m].matrix(0), position
	
	PhasePlayerGlobals.missile[m].velocity.x = position.x - PhasePlayerGlobals.missile[m].position.x
	PhasePlayerGlobals.missile[m].velocity.y = position.y - PhasePlayerGlobals.missile[m].position.y
	PhasePlayerGlobals.missile[m].velocity.z = position.z - PhasePlayerGlobals.missile[m].position.z
	
	Math_Normalize3f PhasePlayerGlobals.missile[m].velocity
	
	PhasePlayerGlobals.missile[m].accelVector.x = PhasePlayerGlobals.missile[m].velocity.x
	PhasePlayerGlobals.missile[m].accelVector.y = PhasePlayerGlobals.missile[m].velocity.y
	PhasePlayerGlobals.missile[m].accelVector.z = PhasePlayerGlobals.missile[m].velocity.z
	
	PhasePlayerGlobals.missile[m].accelMag = 1
	PhasePlayerGlobals.missile[m].mass = PhasePlayerGlobals.missileClass[mClass].mass
	PhasePlayerGlobals.missile[m].class = mClass
	PhasePlayerGlobals.missile[m].impact = 0

	PhasePlayer_Missiles_upd_LastMissile

end sub


sub PhasePlayer_Missiles_CheckImpact_Proj (proj as GenProjectileType ptr)

	dim as integer m
	dim as vector4d positionR
	dim as vector4D d
	
	for m = 0 to PhasePlayerGlobals.lastMissile
	
		if PhasePlayerGlobals.missile[m].active and PhasePlayerGlobals.missile[m].impact = 0 and PhasePlayerGlobals.missile[m].class > MC_BULLET then
			
			positionR.x = proj->mesh.meanVertex.x
			positionR.y = proj->mesh.meanVertex.y
			positionR.z = proj->mesh.meanVertex.z
			positionR.w = 1
			
			Matrix_Multiply_Point @proj->matrix(0), positionR
			
			d.x = positionR.x - PhasePlayerGlobals.missile[m].position.x
			d.y = positionR.y - PhasePlayerGlobals.missile[m].position.y
			d.z = positionR.z - PhasePlayerGlobals.missile[m].position.z
			d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
			
			if d.w <= proj->mesh.stdDeviation * 1.2 then
				PhasePlayerGlobals.player.score.shotsLanded += 1
				PhasePlayerGlobals.missile[m].impact = 1
				PhasePlayer_Explosions_New PhasePlayerGlobals.missile[m].position, PhasePlayerGlobals.missile[m].explosionClass
			end if
			
		end if
		
	next
	
end sub


sub PhasePlayer_Missiles_CheckImpact_Spawn (spawn as WaveSpawnType ptr)

	dim as integer m, i
	dim as vector4d positionR
	dim as vector4D d
	
	dim as single d0
	
	for m = 0 to PhasePlayerGlobals.lastMissile
	
		for i = 0 to 2
			
			if PhasePlayerGlobals.missile[m].active and PhasePlayerGlobals.missile[m].impact = 0 then
		
				d0 = i / 3
				d.x = spawn->position.x - (PhasePlayerGlobals.missile[m].position.x + PhasePlayerGlobals.missile[m].nextposition.x * d0)
				d.y = spawn->position.y - (PhasePlayerGlobals.missile[m].position.y + PhasePlayerGlobals.missile[m].nextposition.y * d0)
				d.z = spawn->position.z - (PhasePlayerGlobals.missile[m].position.z + PhasePlayerGlobals.missile[m].nextposition.z * d0)
				d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
				
				if d.w <= .8 then
					PhasePlayerGlobals.player.score.shotsLanded += 1
					PhasePlayerGlobals.missile[m].impact = 1
					PhasePlayer_Explosions_New PhasePlayerGlobals.missile[m].position, PhasePlayerGlobals.missile[m].explosionClass
				end if
			
			end if
		
		next
		
	next
	
end sub


sub PhasePlayer_Missiles_CheckImpact_Bullet (bullet as BulletType ptr)

	dim as integer m, i
	dim as vector4d positionR
	dim as vector4D d
	dim as single d0
	
	for m = 0 to PhasePlayerGlobals.lastMissile
	
		for i = 0 to 2
			
			if PhasePlayerGlobals.missile[m].active and PhasePlayerGlobals.missile[m].impact = 0 then
		
				d0 = i / 3
				d.x = bullet->position.x - (PhasePlayerGlobals.missile[m].position.x + PhasePlayerGlobals.missile[m].nextposition.x * d0)
				d.y = bullet->position.y - (PhasePlayerGlobals.missile[m].position.y + PhasePlayerGlobals.missile[m].nextposition.y * d0)
				d.z = bullet->position.z - (PhasePlayerGlobals.missile[m].position.z + PhasePlayerGlobals.missile[m].nextposition.z * d0)
				d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
				
				if d.w <= .6 then
					PhasePlayerGlobals.player.score.shotsLanded += 1
					PhasePlayerGlobals.missile[m].impact = 1
					PhasePlayer_Explosions_New PhasePlayerGlobals.missile[m].position, PhasePlayerGlobals.missile[m].explosionClass
				end if
			
			end if
		
		next
		
	next
	
end sub


sub PhasePlayer_Missiles_CheckImpact_PowerUP ()


	dim as integer m, i
	dim as vector4d positionR
	dim as vector4D d
	dim as single d0
	
	if PhasePlayerglobals.powerUp.active <> 1 then exit sub

	for m = 0 to PhasePlayerGlobals.lastMissile
	
		for i = 0 to 2
			
			if PhasePlayerGlobals.missile[m].active and PhasePlayerGlobals.missile[m].impact = 0 then
		
				d0 = i / 3
				
				positionR.x = PhasePlayerGlobals.powerUp.position.x
				positionR.y = PhasePlayerGlobals.powerUp.position.y
				positionR.z = PhasePlayerGlobals.powerUp.position.z
		
				
				d.x = positionR.x - (PhasePlayerGlobals.missile[m].position.x + PhasePlayerGlobals.missile[m].nextposition.x * d0)
				d.y = positionR.y - (PhasePlayerGlobals.missile[m].position.y + PhasePlayerGlobals.missile[m].nextposition.y * d0)
				d.z = positionR.z - (PhasePlayerGlobals.missile[m].position.z + PhasePlayerGlobals.missile[m].nextposition.z * d0)
				d.w = sqr(d.x * d.x + d.y * d.y + d.z * d.z)
				
				if d.w < .6 then
					PhasePlayerGlobals.player.score.shotsLanded += 1
					PhasePlayerGlobals.player.score.powerUps.value += 1
					PhasePlayerGlobals.powerUp.active = 2
					PhasePlayer_Player_PowerUp_Pickup PhasePlayerGlobals.powerUp.class
			
				end if
			
			end if
		
		next
		
		
	next

end sub


sub PhasePlayer_Missiless_Clear_Missiles ()

	dim as integer m
	
	PhasePlayerGlobals.lastMissile = -1
	
	for m = 0 to PhasePlayerGlobals.nMissiles - 1
		PhasePlayerGlobals.missile[m].active = 0
	next


end sub


sub PhasePlayer_Missiles_upd_LastMissile ()

	dim as integer m
	
	PhasePlayerGlobals.lastMissile = -1
	
	for m = 0 to PhasePlayerGlobals.nMissiles - 1
		if PhasePlayerGlobals.missile[m].active = 1 then PhasePlayerGlobals.lastMissile = m
	next
	
end sub
	
	
	
sub PhasePlayer_Missiles_upd_Missiles ()

	dim as integer m
	
	dim as single vSpeed, dx, dy, dz, dm
	
	for m = 0 to PhasePlayerGlobals.lastMissile

		if PhasePlayerGlobals.missile[m].impact = 1 then PhasePlayerGlobals.missile[m].active = 0
		
		if PhasePlayerGlobals.missile[m].active then
			vSpeed = (system_ticksPassed * PhasePlayerGlobals.missile[m].accelMag) / PhasePlayerGlobals.missile[m].mass
			
			PhasePlayerGlobals.missile[m].velocity.x += PhasePlayerGlobals.missile[m].accelVector.x * vSpeed
			PhasePlayerGlobals.missile[m].velocity.y += PhasePlayerGlobals.missile[m].accelVector.y * vSpeed
			PhasePlayerGlobals.missile[m].velocity.z += PhasePlayerGlobals.missile[m].accelVector.z * vSpeed
			
			PhasePlayerGlobals.missile[m].position.x += PhasePlayerGlobals.missile[m].velocity.x * vSpeed
			PhasePlayerGlobals.missile[m].position.y += PhasePlayerGlobals.missile[m].velocity.y * vSpeed
			PhasePlayerGlobals.missile[m].position.z += PhasePlayerGlobals.missile[m].velocity.z * vSpeed
			
			PhasePlayerGlobals.missile[m].nextposition.x = PhasePlayerGlobals.missile[m].velocity.x * vSpeed
			PhasePlayerGlobals.missile[m].nextposition.y = PhasePlayerGlobals.missile[m].velocity.y * vSpeed
			PhasePlayerGlobals.missile[m].nextposition.z = PhasePlayerGlobals.missile[m].velocity.z * vSpeed
			
			'---- perform dist check to center of map. if > 50 then no longer active
			dx = PhasePlayerGlobals.missile[m].position.x
			dy = PhasePlayerGlobals.missile[m].position.y
			dz = PhasePlayerGlobals.missile[m].position.z
			
			dm = sqr(dx * dx + dy * dy + dz * dz)
			
			if dm > 50 then PhasePlayerGlobals.missile[m].active = 0
			
		end if
		
	next
	
end sub