sub PhasePlayer_Calculate_Score ()


	dim as single totalFreq
	
	dim as ScoreType ptr score
	
	score = @PhasePlayerGlobals.player.score
	
	totalFreq += score->kills.frequency * score->kills.value / PhaseDataGlobals.phaseSequence.totalSpawn
	
	totalFreq += score->damage.frequency * score->damage.value / PhaseDataGlobals.phaseSequence.totalHealth
	
	totalFreq += score->mapDestroyed.frequency * score->mapDestroyed.value / PhaseDataGlobals.phaseSequence.totalProjectiles
	
	totalFreq += score->powerUps.frequency * score->powerUps.value / PhaseDataGlobals.phaseSequence.totalPowerUps
	
	if score->healthLost.value > 500 then score->healthLost.value = 500
	if score->shieldLost.value > 500 then score->shieldLost.value = 500
	
	totalFreq -= score->healthLost.frequency * (score->healthLost.value / 500)
	totalFreq -= score->shieldLost.frequency * (score->shieldLost.value / 500)
	
	score->accuracy.value = score->shotsLanded / score->shotsFired
	
	score->timeBonus = PhasePlayerGlobals.missionClock.curr / PhasePlayerGlobals.missionTotalTime
	
	'totalFreq -= score->timeRemaining.frequency * (1 - PhasePlayerGlobals.missionClock.curr / PhasePlayerGlobals.missionTotalTime)
	
	totalFreq += score->accuracy.frequency * score->accuracy.value
	
	if totalFreq > 1 then totalFreq = 1
	if totalFreq < 0 then totalFreq = 0
	score->totalFreq = totalFreq
	
	score->points = score->totalFreq * (1 + PhaseMenuGlobals.winOptions.difficulty / 10) * 1000000
	
	

end sub



sub PhasePlayer_Player_FireWeapon ()


	dim as integer nextFire, selWeapon, weaponClass
	
	selWeapon = PhasePlayerGlobals.player.selWeapon
	weaponClass = PhasePlayerGlobals.player.weapon[selWeapon].class
	
	
	nextFire = PhasePlayerGlobals.player.weapon[selWeapon].lastFire
	nextFire += 60000 / PhasePlayerGlobals.weaponClass[weaponClass].rpm
	
	if nextFire > system_ticks then exit sub
	
	if PhasePlayerGlobals.player.weapon[selWeapon].rounds = 0 and weaponClass > WC_MACHINE_GUN then
		if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
			PhasePlayerGlobals.musicChannel(MH_NOAMMO) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_NOAMMO))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_NOAMMO), PhaseMenuGlobals.winOptions.sfxVol
		end if
		
		PhasePlayerGlobals.player.weapon[selWeapon].lastFire = system_ticks
		exit sub
	end if
	
	dim as vector3D aVector
	dim as vector4D position
	dim as single aVectorM
	
	aVector.x = 0
	aVector.y = 0
	aVector.z = 0
	
	position.x = 0
	position.y = 0
	position.z = PhaseDataGlobals.phaseSequence.generator[0].position.z / 2
	position.w = 1
	

	aVectorM = 1
	PhasePlayer_Missiles_Add 0, PhasePlayerGlobals.player.weapon[selWeapon].class, position, aVector, aVectorM
	
	dim as single jutter, jd2
	
	jutter = PhasePlayerGlobals.weaponClass[weaponClass].jutter
	jd2 = jutter / 2
	
	dim as integer dMouseX, dMouseY
	glfwGetMousePos @dMouseX, @dMouseY
	
	glfwSetMousePos dMouseX + rnd * jutter - jd2, dMouseY + rnd * jutter - jd2
	
	PhasePlayerGlobals.player.weapon[selWeapon].lastFire = system_ticks
	
	if weaponClass > WC_MACHINE_GUN then PhasePlayerGlobals.player.weapon[selWeapon].rounds -= 1
	
	PhasePlayerGlobals.player.fireSoundOn = 1
	PhasePlayerGlobals.player.fireSoundEnd = system_time + .1

end sub


sub PhasePlayer_Player_Find_Camera (byval matrix as single ptr)

	dim as vector4d position
	
	Matrix_LoadIdentity matrix
			
	't/r to camera coordinates
	Matrix_Rotate matrix, -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
	Matrix_Rotate matrix, -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
	
	Matrix_Translate matrix, 0, 0, PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	Matrix_Rotate matrix, -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
	Matrix_Rotate matrix, -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
	
	position.x = 0
	position.y = 0
	position.z = 0
	position.w = 1
	
	Matrix_Multiply_Point matrix, position
	
	PhasePlayerGlobals.cameraPosition.x = position.x
	PhasePlayerGlobals.cameraPosition.y = position.y
	PhasePlayerGlobals.cameraPosition.z = position.z
	
end sub


sub PhasePlayer_Player_Hit (damage as single)

	if PhasePlayerGlobals.player.gameOver > 0 then exit sub

	dim as single cDamage, jutter, jd2

	damage *= (1 + PhaseMenuGlobals.winOptions.difficulty / 10)
	
	PhasePlayerGlobals.player.score.shieldLost.value += damage
	PhasePlayerGlobals.player.Shield -= damage
	if PhasePlayerGlobals.player.Shield < 0 then PhasePlayerGlobals.player.Shield = 0
	
	cDamage = damage * (1 - PhasePlayerGlobals.player.Shield / PhasePlayerGlobals.player.maxShield)
	
	PhasePlayerGlobals.player.score.healthLost.value += cDamage
	PhasePlayerGlobals.player.health -= cDamage
	if PhasePlayerGlobals.player.health < 0 then PhasePlayerGlobals.player.health = 0
	
	PhasePlayerGlobals.player.flashHealthRed = 1
	PhasePlayerGlobals.player.flashShieldRed = 1
	
	if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
		PhasePlayerGlobals.musicChannel(MH_HIT) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_HIT))
		FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_HIT), PhaseMenuGlobals.winOptions.sfxVol
	end if
	
	PhasePlayerGlobals.player.fuzzTime = system_ticks + 220
	
	jutter = 20
	jd2 = jutter / 2
	
	glfwSetMousePos OpenGLProperties.SCR_WIDTH / 2 + rnd * jutter - jd2, OpenGLProperties.SCR_HEIGHT / 2 + rnd * jutter - jd2
	
	
end sub	



sub PhasePlayer_Player_PowerUp_Pickup (pClass as integer)

	if PhaseMenuGlobals.winOptions.sfxOn = 1 then 
		PhasePlayerGlobals.musicChannel(MH_POWERUP) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_POWERUP))
		FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_POWERUP), PhaseMenuGlobals.winOptions.sfxVol
	end if
	
	if pClass = PU_HEALTH then
		PhasePlayerGlobals.player.flashHealth = 1
		PhasePlayerGlobals.player.health += 50
		if PhasePlayerGlobals.player.health > PhasePlayerGlobals.player.maxHealth then PhasePlayerGlobals.player.health = PhasePlayerGlobals.player.maxHealth
	elseif pClass = PU_ARMOUR then
		PhasePlayerGlobals.player.flashShield = 1
		PhasePlayerGlobals.player.shield += 50
		if PhasePlayerGlobals.player.shield > PhasePlayerGlobals.player.maxShield then PhasePlayerGlobals.player.shield = PhasePlayerGlobals.player.maxShield
	elseif pClass = PU_AMMO then
		PhasePlayerGlobals.player.flashMissile = 1
		PhasePlayerGlobals.player.weapon[1].rounds += 5
		if PhasePlayerGlobals.player.weapon[1].rounds > 10 then PhasePlayerGlobals.player.weapon[1].rounds = 10
	end if

end sub



sub PhasePlayer_Player_Upd_Player ()

	PhasePlayerGlobals.player.weapon[PhasePlayerGlobals.player.selWeapon].angle += 100 * system_ticksPassed / 1000
	
	'upadate camera angle
	if PhasePlayerGlobals.player.lockCamera < system_ticks then
		PhaseDataGlobals.phaseSequence.generator[0].angle.x += PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.x * system_ticksPassed / 1000
		PhaseDataGlobals.phaseSequence.generator[0].angle.y += PhaseDataGlobals.phaseSequence.generator[0].preAngularVelocity.y * system_ticksPassed / 1000
	end if
	
	if PhaseMenuGlobals.winOptions.musicOn = 1 then 
		if PhasePlayerGlobals.player.musicPlaying = 0 then 
			PhasePlayerGlobals.musicChannel(MH_SONG) = FSOUND_PlaySound(FSOUND_FREE, PhasePlayerGlobals.musicHandle(MH_SONG))
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_SONG), PhaseMenuGlobals.winOptions.musicVol
			PhasePlayerGlobals.player.musicPlaying = 1
		end if
	end if
	
	PhasePlayerGlobals.player.hudCameraX += (PhasePlayerGlobals.player.targetCameraX - PhasePlayerGlobals.player.hudCameraX) * .22
	PhasePlayerGlobals.player.hudCameraY += (PhasePlayerGlobals.player.targetCameraY - PhasePlayerGlobals.player.hudCameraY) * .22
	
	dim as single w0
	
	if PhasePlayerGlobals.powerUp.active = 0 and PhasePlayerGlobals.powerUp.nextSpawn < system_ticks / 1000 then
		PhasePlayerglobals.powerUp.active = 1
	end if
	
	if PhasePlayerGlobals.powerUp.active = 2 then
		PhasePlayerGlobals.powerUp.nextSpawn = system_time + 20
		w0 = PhaseDataGlobals.phaseSequence.generator[0].position.z
		
		PhasePlayerGlobals.powerUp.position.x = rnd * w0 - w0 / 2
		PhasePlayerGlobals.powerUp.position.y = rnd * w0 - w0 / 2
		PhasePlayerGlobals.powerUp.position.z = rnd * w0 - w0 / 2
		
		PhasePlayerGlobals.powerUp.class = int(rnd * 3)
		PhasePlayerGlobals.powerUp.active = 0
	end if
	
	if PhasePlayerGlobals.player.health = 0 and PhasePlayerGlobals.player.gameOver = 0 then
		PhasePlayerGlobals.player.gameOver = 1
		PhasePlayerGlobals.player.gameOverFadeBlackTime = system_time + 4
		io_clock_stop PhasePlayerGlobals.missionClock
	end if
	
	if io_bit(PhasePlayerGlobals.missionClock.flags,fALARM) then
		io_clock_stop PhasePlayerGlobals.missionClock
		if PhasePlayerGlobals.player.gameOver = 0 then
			PhasePlayerGlobals.player.gameOver = 2
			PhasePlayerGlobals.player.gameOverFadeBlackTime = system_time + 4
		end if
	end if
	
	PhasePlayer_Missiles_CheckImpact_PowerUP
	
	
	PhasePlayer_Calculate_Score
	
end sub
