

sub PhasePlayer_Projectiles_Upd_Projectiles ()

	dim as integer gen, proj
	dim as single vSpeed
	
	for gen = 1 to PhaseDataGlobals.phaseSequence.nGenerators - 1
	
		PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocityAngle.x += PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocity.x * system_ticksPassed / 1000
		PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocityAngle.y += PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocity.y * system_ticksPassed / 1000
		PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocityAngle.z += PhaseDataGlobals.phaseSequence.generator[gen].preAngularVelocity.z * system_ticksPassed / 1000
		
		if PhaseDataGlobals.phaseSequence.generator[gen].class = GC_HEX_TUNNEL then PhaseDataGlobals.phaseSequence.generator[gen].textureScroll += 16 / 1000
	
		for proj = 0 to PhaseDataGlobals.phaseSequence.generator[gen].nProjectiles - 1
		
			if PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].lock = 1 and PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].active = 1 then
				
				vSpeed = (system_ticksPassed * PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].accelMag) / PhaseDataGlobals.phaseSequence.generator[gen].mass
				
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.x += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].accelVector.x * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.y += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].accelVector.y * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.z += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].accelVector.z * vSpeed
				
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].position.x += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.x * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].position.y += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.y * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].position.z += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].velocity.z * vSpeed
				
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angle.x += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angularVelocity.x * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angle.y += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angularVelocity.y * vSpeed
				PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angle.z += PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].angularVelocity.z * vSpeed
				
				if PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].position.y < -50 then PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].active = 0
				
			end if
			
			if int(rnd * 1000000) = 1 then PhasePlayer_Explosions_New PhaseDataGlobals.phaseSequence.generator[gen].projectile[proj].position, EC_NORMAL
		
		next
	next
	
	
end sub


sub PhasePlayer_Projectiles_Upd_Spawn_Projectiles (spawn as WaveSpawnType ptr)

	dim as integer gen, proj
	dim as single vSpeed
	dim as integer active
	
	active = 0
	for gen = 0 to spawn->nGenerators - 1
	
		spawn->generator[gen].position.x = spawn->position.x
		spawn->generator[gen].position.y = spawn->position.y
		spawn->generator[gen].position.z = spawn->position.z
	
		spawn->generator[gen].angle.x = spawn->angle.x
		spawn->generator[gen].angle.y = spawn->angle.y
		spawn->generator[gen].angle.z = spawn->angle.z
		
		spawn->generator[gen].preAngularVelocityAngle.x += spawn->generator[gen].preAngularVelocity.x * system_ticksPassed / 1000
		spawn->generator[gen].preAngularVelocityAngle.y += spawn->generator[gen].preAngularVelocity.y * system_ticksPassed / 1000
		spawn->generator[gen].preAngularVelocityAngle.z += spawn->generator[gen].preAngularVelocity.z * system_ticksPassed / 1000
	
		for proj = 0 to spawn->generator[gen].nProjectiles - 1
		
			if spawn->generator[gen].projectile[proj].active = 1 then active = 1
			
			if spawn->generator[gen].projectile[proj].lock = 1 and spawn->generator[gen].projectile[proj].active = 1 then
				
				active = 1
				vSpeed = (system_ticksPassed * spawn->generator[gen].projectile[proj].accelMag) / spawn->generator[gen].mass
				
				spawn->generator[gen].projectile[proj].velocity.x += spawn->generator[gen].projectile[proj].accelVector.x * vSpeed
				spawn->generator[gen].projectile[proj].velocity.y += spawn->generator[gen].projectile[proj].accelVector.y * vSpeed
				spawn->generator[gen].projectile[proj].velocity.z += spawn->generator[gen].projectile[proj].accelVector.z * vSpeed
				
				spawn->generator[gen].projectile[proj].position.x += spawn->generator[gen].projectile[proj].velocity.x * vSpeed
				spawn->generator[gen].projectile[proj].position.y += spawn->generator[gen].projectile[proj].velocity.y * vSpeed
				spawn->generator[gen].projectile[proj].position.z += spawn->generator[gen].projectile[proj].velocity.z * vSpeed
				
				spawn->generator[gen].projectile[proj].angle.x += spawn->generator[gen].projectile[proj].angularVelocity.x * vSpeed
				spawn->generator[gen].projectile[proj].angle.y += spawn->generator[gen].projectile[proj].angularVelocity.y * vSpeed
				spawn->generator[gen].projectile[proj].angle.z += spawn->generator[gen].projectile[proj].angularVelocity.z * vSpeed
				
				if spawn->generator[gen].projectile[proj].position.y < -50 then spawn->generator[gen].projectile[proj].active = 0
				
			end if
		
		next
	next
	
	if active = 0 then spawn->active = 3
	
end sub


sub PhasePlayer_Projectiles_Upd_Bullet_Projectiles (bullet as BulletType ptr)

	dim as integer gen, proj
	dim as single vSpeed
	dim as integer active
	
	active = 0
	for gen = 0 to bullet->nGenerators - 1
	
		bullet->generator[gen].position.x = bullet->position.x
		bullet->generator[gen].position.y = bullet->position.y
		bullet->generator[gen].position.z = bullet->position.z
	
		bullet->generator[gen].angle.x = bullet->angle.x
		bullet->generator[gen].angle.y = bullet->angle.y
		bullet->generator[gen].angle.z = bullet->angle.z
		
		bullet->generator[gen].preAngularVelocityAngle.x += bullet->generator[gen].preAngularVelocity.x * system_ticksPassed / 1000
		bullet->generator[gen].preAngularVelocityAngle.y += bullet->generator[gen].preAngularVelocity.y * system_ticksPassed / 1000
		bullet->generator[gen].preAngularVelocityAngle.z += bullet->generator[gen].preAngularVelocity.z * system_ticksPassed / 1000
	
		for proj = 0 to bullet->generator[gen].nProjectiles - 1
		
			if bullet->generator[gen].projectile[proj].active = 1 then active = 1
			
			if bullet->generator[gen].projectile[proj].lock = 1 and bullet->generator[gen].projectile[proj].active = 1 then
				
				active = 1
				vSpeed = (system_ticksPassed * bullet->generator[gen].projectile[proj].accelMag) / bullet->generator[gen].mass
				
				bullet->generator[gen].projectile[proj].velocity.x += bullet->generator[gen].projectile[proj].accelVector.x * vSpeed
				bullet->generator[gen].projectile[proj].velocity.y += bullet->generator[gen].projectile[proj].accelVector.y * vSpeed
				bullet->generator[gen].projectile[proj].velocity.z += bullet->generator[gen].projectile[proj].accelVector.z * vSpeed
				
				bullet->generator[gen].projectile[proj].position.x += bullet->generator[gen].projectile[proj].velocity.x * vSpeed
				bullet->generator[gen].projectile[proj].position.y += bullet->generator[gen].projectile[proj].velocity.y * vSpeed
				bullet->generator[gen].projectile[proj].position.z += bullet->generator[gen].projectile[proj].velocity.z * vSpeed
				
				bullet->generator[gen].projectile[proj].angle.x += bullet->generator[gen].projectile[proj].angularVelocity.x * vSpeed
				bullet->generator[gen].projectile[proj].angle.y += bullet->generator[gen].projectile[proj].angularVelocity.y * vSpeed
				bullet->generator[gen].projectile[proj].angle.z += bullet->generator[gen].projectile[proj].angularVelocity.z * vSpeed
				
				if bullet->generator[gen].projectile[proj].position.y < -50 then bullet->generator[gen].projectile[proj].active = 0
				
			end if
		
		next
	next
	
	if active = 0 then bullet->active = 0
	
end sub



sub PhasePlayer_Projectiles_Upd_Explosion_Projectiles (explosion as ExplosionType ptr)

	dim as integer gen
	
	for gen = 0 to explosion->nGenerators - 1
	
		explosion->generator[gen].position.x = explosion->position.x
		explosion->generator[gen].position.y = explosion->position.y
		explosion->generator[gen].position.z = explosion->position.z
		
		explosion->generator[gen].preAngularVelocityAngle.x += explosion->generator[gen].preAngularVelocity.x * system_ticksPassed / 1000
		explosion->generator[gen].preAngularVelocityAngle.y += explosion->generator[gen].preAngularVelocity.y * system_ticksPassed / 1000
		explosion->generator[gen].preAngularVelocityAngle.z += explosion->generator[gen].preAngularVelocity.z * system_ticksPassed / 1000
	
	next
	
	
end sub