sub PhasePlayer_HUD_UpdFlash ()

	if PhasePlayerGlobals.player.flashShield > 0 then PhasePlayerGlobals.player.flashShield -= .05 * fpsr
	if PhasePlayerGlobals.player.flashMissile > 0 then PhasePlayerGlobals.player.flashMissile -= .05 * fpsr
	if PhasePlayerGlobals.player.flashTime > 0 then PhasePlayerGlobals.player.flashTime -= .05 * fpsr
	if PhasePlayerGlobals.player.flashHealth > 0 then PhasePlayerGlobals.player.flashHealth -= .05 * fpsr
	
	if PhasePlayerGlobals.player.flashShield < 0 then PhasePlayerGlobals.player.flashShield = 0
	if PhasePlayerGlobals.player.flashMissile < 0 then PhasePlayerGlobals.player.flashMissile = 0
	if PhasePlayerGlobals.player.flashTime < 0 then PhasePlayerGlobals.player.flashTime = 0
	if PhasePlayerGlobals.player.flashHealth < 0 then PhasePlayerGlobals.player.flashHealth = 0
	
	if PhasePlayerGlobals.player.flashHealthRed > 0 then PhasePlayerGlobals.player.flashHealthRed -= .05 * fpsr
	if PhasePlayerGlobals.player.flashHealthRed < 0 then PhasePlayerGlobals.player.flashHealthRed = 0
	if PhasePlayerGlobals.player.flashShieldRed > 0 then PhasePlayerGlobals.player.flashShieldRed -= .05 * fpsr
	if PhasePlayerGlobals.player.flashShieldRed < 0 then PhasePlayerGlobals.player.flashShieldRed = 0
	if PhasePlayerGlobals.player.flashMissileRed > 0 then PhasePlayerGlobals.player.flashMissileRed -= .05 * fpsr
	if PhasePlayerGlobals.player.flashMissileRed < 0 then PhasePlayerGlobals.player.flashMissileRed = 0

end sub
	
	
sub PhasePlayer_Render_HUD ()

	dim as single timeLen
	timeLen = PhasePlayerGlobals.missionClock.curr / PhasePlayerGlobals.missionTotalTime
	
	if timeLen < .2 then PhasePlayer_Render_HUD_TopClock

	
	PhasePlayer_Render_HUD_WaveIndex
	
	PhasePlayer_Render_HUD_Score

	system_2dplane_set_full
	'-------------
	
	'glColor3f 1, 1, 1
	'font_draw 0, 0, str(fps)
	
	dim as integer dx
	dx = OpenGLProperties.SCR_WIDTH / 640
	
	glPushMatrix
		glTranslatef -(PhasePlayerGlobals.player.hudCameraX - PhasePlayerGlobals.player.targetCameraX) * dx * 2.4, -(PhasePlayerGlobals.player.hudCameraY - PhasePlayerGlobals.player.targetCameraY) * dx * 2.4, 0
	
		PhasePlayer_Render_HUD_Clock
		PhasePlayer_Render_HUD_Health
		PhasePlayer_Render_HUD_Shield
		PhasePlayer_Render_HUD_Missiles
		Phaseplayer_Render_HUD_CenterArrow
		
	glPopMatrix
	
	PhasePlayer_Render_HUD_Boss_Health
	Phaseplayer_Render_HUD_Reticle
	
	PhasePlayer_HUD_UpdFlash
	
	
	PhasePlayer_Render_HUD_Fades

	
	'-------------
	system_2dplane_clear
	
	glDisable GL_LIGHTING
	
	PhasePlayer_Render_HUD_UI
	
	PhasePlayer_Render_HUD_GameOver
	
end sub



sub Phaseplayer_Render_HUD_CenterArrow ()

	
	dim as integer cx, cy, dx
	dim as single d0, r0, r1, x0, y0
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	cx = OpenGLProperties.SCR_WIDTH / 2
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	dim as single an1, an2, an3, an4, an5, an6
	
	an1 = PhasePlayerGlobals.cameraAngle.x
	an2 = PhasePlayerGlobals.cameraAngle.y
	
	d0 = sqr(an1 * an1 + an2 * an2)
	
	dim as integer i
	
	if d0 > 32 then 
		r0 = dx * 142
		r1 = dx * 169
		
		an3 = atan2(an2,an1)
		an4 = (3.14159 / 180) * 5
		
		glBegin GL_LINES
			glColor3f 1, 0, 0
			x0 = cx + r1 * cos(an3)
			y0 = cy + r1 * sin(an3)
			glVertex2f x0, y0
			
			x0 = cx + r0 * cos(an3 + an4)
			y0 = cy + r0 * sin(an3 + an4)
			glVertex2f x0, y0
			
			x0 = cx + r1 * cos(an3)
			y0 = cy + r1 * sin(an3)
			glVertex2f x0, y0
			
			x0 = cx + r0 * cos(an3 - an4)
			y0 = cy + r0 * sin(an3 - an4)
			glVertex2f x0, y0
			
			for i = 0 to 7
				an5 = an4 * 2 * i / 8
				an6 = an5 + an4 / 4
				x0 = cx + r0 * cos(an3 - an4 + an5)
				y0 = cy + r0 * sin(an3 - an4 + an5)
				glVertex2f x0, y0
				x0 = cx + r0 * cos(an3 - an4 + an6)
				y0 = cy + r0 * sin(an3 - an4 + an6)
				glVertex2f x0, y0
			next
			
		glEnd
	
	end if
	


end sub



sub PhasePlayer_Render_HUD_Boss_Health ()


	if PhaseDataGlobals.phaseSequence.bossActive = 0 then exit sub
	
	dim as integer totalhealth, curHealth
	dim as integer w, s
	
	w = PhaseDataGlobals.phaseSequence.bossWave
	
	totalHealth = PhaseDataGlobals.phaseSequence.wave[w].nSpawn * PhaseDataGlobals.phaseSequence.wave[w].maxHealth
	
	for s = 0 to PhaseDataGlobals.phaseSequence.wave[w].nSpawn - 1
		curHealth += PhaseDataGlobals.phaseSequence.wave[w].spawn[s].health
	next
	
	
	
	if PhaseDataGlobals.phaseSequence.bossActive = 1 then
	
		glBegin GL_QUADS
			glColor3f 1, .2, .1
			glVertex2f 0, 0
			glVertex2f 0, (OpenGLProperties.SCR_HEIGHT / 400) * 10
			glVertex2f OpenGLProperties.SCR_WIDTH * curhealth / totalHealth, (OpenGLProperties.SCR_HEIGHT / 400) * 10
			glVertex2f OpenGLProperties.SCR_WIDTH * curHealth / totalHealth, 0
		glEnd
	
	end if
	
	
end sub


sub PhasePlayer_Render_HUD_Clock ()


	dim as integer i, nSteps, dx
	dim as single startAn, endAn, an0, an1, radius0, radius1
	dim as single timeLen
	dim as integer cx, cy
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	cx = OpenGLProperties.SCR_WIDTH * 4.5 / 10
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	timeLen = PhasePlayerGlobals.missionClock.curr / PhasePlayerGlobals.missionTotalTime
	
	if timeLen < .2 then
		if PhasePlayerGlobals.player.flashTime = 0 then PhasePlayerGlobals.player.flashTime = 1
	end if
	
	
	dim as rgbalpha c0
	c0.r = 1
	c0.g = 1
	c0.b = 1
	c0.a = .36
	
	if PhasePlayerGlobals.player.flashTime > 0 then
		c0.r = PhasePlayerGlobals.player.flashTime
		c0.g = PhasePlayerGlobals.player.flashTime
		c0.b = 0
		c0.a = 1
	end if
	
	glColor4fv @c0.r
	
	glBegin GL_LINES
		
		startAn = 180 - timeLen * 90
		endAn = 180 + timeLen * 90
		nSteps = 100
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (70) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (64) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		an0 = startAn
		an1 = endAn
		
		radius0 = (70) * dx
		radius1 = (64) * dx
		
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an1), cy + radius1 * sin(3.14159 / 180 * an1)
		
		
		startAn = 0
		endAn = 360
		nSteps = 100
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (9.6) * dx
			
			glVertex2f cx - 47.6 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx - 47.6 * dx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (8) * dx
			
			glVertex2f cx - 47.6 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx - 47.6 * dx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		glVertex2f cx - 47.6 * dx, cy
		glVertex2f cx - 47.6 * dx, cy - 5 * dx
		
		glVertex2f cx - 47.6 * dx, cy
		glVertex2f cx - 47.6 * dx + 4.8 * dx, cy + 4.8 * dx
		
	glEnd

end sub



sub PhasePlayer_Render_HUD_Fades()


	dim as single d0, curTime
	dim as single an0, xOfs, yOfs
	dim as integer i, nStp
	
	curTime = system_time
	
	if PhasePlayerGlobals.player.fadeInTime > system_ticks then
	
		d0 = (PhasePlayerGlobals.player.fadeInTime - system_ticks) / 1000
		glBegin GL_QUADS
			glColor4f 0, 0, 0, d0
			glVertex2f 0, 0
			glVertex2f 0, OpenGLProperties.SCR_HEIGHT
			glVertex2f OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
			glVertex2f OpenGLProperties.SCR_WIDTH, 0
		glEnd
	end if
	
	if PhasePlayerGlobals.player.gameOver > 0 then
	
		for i = 1 to MH_SONG2 - 1
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(i), PhaseMenuGlobals.winOptions.sfxVol * (1 - PhasePlayerGlobals.player.gameOverFadeRed)
		next
			
		if PhasePlayerGlobals.player.gameOverFadeBlackTime > curTime then
			if PhasePlayerGlobals.player.gameOver < 3 then PhasePlayerGlobals.player.gameOverFadeRed += system_ticksPassed / 1000
			if PhasePlayerGlobals.player.gameOver = 3 then PhasePlayerGlobals.player.gameOverFadeRed += .1 * system_ticksPassed / 1000
			
			if PhasePlayerGlobals.player.gameOverFadeRed > 1 then PhasePlayerGlobals.player.gameOverFadeRed = 1
			
			glBegin GL_QUADS
				if PhasePlayerGlobals.player.gameOver < 3 then glColor4f 1, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
				if PhasePlayerGlobals.player.gameOver = 3 then glColor4f 0, .5, .8, PhasePlayerGlobals.player.gameOverFadeRed
				glVertex2f 0, 0
				glVertex2f 0, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, 0
			glEnd
			
			glPushMatrix
				glTranslatef 0, 0, -18
				
				glColor4f 0, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
				Render_Model_Plain ModelDB[PhaseMenuGlobals.gameOverMID].modelHandle
				
				
				glColor4f 0, 0, 0, .077 * PhasePlayerGlobals.player.gameOverFadeRed
				
				nStp = 20
				for i = 0 to nStp - 1
				
					an0 = i / nStp
					xOfs = .028 * cos(3.1415 * 2 * an0)
					yOfs = .028 * sin(3.1415 * 2 * an0)
					
					glPushmatrix
						glTranslatef xOfs, yOfs, 0
						Render_Model_Plain ModelDB[PhaseMenuGlobals.gameOverMID].modelHandle
					glPopMatrix
				
				next
			glPopMatrix
			
		else
			glBegin GL_QUADS
				if PhasePlayerGlobals.player.gameOver < 3 then glColor4f 1, 0, 0, 1
				if PhasePlayerGlobals.player.gameOver = 3 then glColor4f 0, .5, .8, 1
				glVertex2f 0, 0
				glVertex2f 0, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, 0
			glEnd
			
			d0 = (curTime - PhasePlayerGlobals.player.gameOverFadeBlackTime) / 2
			
			if d0 > 1 then
				d0 = 1
				PhasePlayerGlobals.exitCode = 1
				PhaseEditorGlobals.winActive(WIN_NEW_HIGH_SCORE) = 1
				PhaseEditorGlobals.winLock(WIN_MAIN) = 1
				if PhasePlayerGlobals.player.gameOver < 3 then PhasePlayerGlobals.player.score.timeBonus = 0
				for i = 0 to MH_SONG2 - 1
					fsound_stopsound PhasePlayerGlobals.musicChannel(i)
				next
			end if
			
			FSOUND_setVolume PhasePlayerGlobals.musicChannel(MH_SONG), PhaseMenuGlobals.winOptions.musicVol * (1 - d0)
			glBegin GL_QUADS
				glColor4f 0, 0, 0, d0
				glVertex2f 0, 0
				glVertex2f 0, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
				glVertex2f OpenGLProperties.SCR_WIDTH, 0
			glEnd
		end if
	end if
	
end sub


sub PhasePlayer_Render_HUD_GameOver()

	glDisable GL_CULL_FACE
	glDisable GL_DEPTH_TEST
	glDepthMask GL_FALSE
	glDisable GL_LIGHTING
	

	dim as single d0, curTime
	dim as single an0, xOfs, yOfs
	dim as integer i, nStp, md
	
	if PhasePlayerGlobals.player.gameOver = 1 then md = PhaseMenuGlobals.GOOOHMID
	if PhasePlayerGlobals.player.gameOver = 2 then md = PhaseMenuGlobals.GOOOTMID
	
	curTime = system_time
	
	if PhasePlayerGlobals.player.gameOver > 0 and PhasePlayerGlobals.player.gameOver < 3 then
	
		glPushMatrix
			glLoadIdentity
			glTranslatef 0, 0, -18
			
			glColor4f 0, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
			Render_Model_Plain ModelDB[PhaseMenuGlobals.gameOverMID].modelHandle
			
			
			glColor4f 0, 0, 0, .077 * PhasePlayerGlobals.player.gameOverFadeRed
			
			nStp = 20
			for i = 0 to nStp - 1
			
				an0 = i / nStp
				xOfs = .028 * cos(3.1415 * 2 * an0)
				yOfs = .028 * sin(3.1415 * 2 * an0)
				
				glPushmatrix
					glTranslatef xOfs, yOfs, 0
					Render_Model_Plain ModelDB[PhaseMenuGlobals.gameOverMID].modelHandle
				glPopMatrix
			
			next
			
			
			glTranslatef 0, -1, 0
			
			glColor4f 0, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
			Render_Model_Plain ModelDB[md].modelHandle
			
			
			glColor4f 0, 0, 0, .077 * PhasePlayerGlobals.player.gameOverFadeRed
			
			nStp = 20
			for i = 0 to nStp - 1
			
				an0 = i / nStp
				xOfs = .028 * cos(3.1415 * 2 * an0)
				yOfs = .028 * sin(3.1415 * 2 * an0)
				
				glPushmatrix
					glTranslatef xOfs, yOfs, 0
					Render_Model_Plain ModelDB[md].modelHandle
				glPopMatrix
			
			next
		glPopMatrix

	end if
	
	if PhasePlayerGlobals.player.gameOver = 3 then
	
		glPushMatrix
			glLoadIdentity
			glTranslatef 0, .88, -18
			
			glColor4f 0, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
			Render_Model_Plain ModelDB[PhaseMenuGlobals.titleMID].modelHandle
			
			
			glColor4f 0, 0, 0, .077 * PhasePlayerGlobals.player.gameOverFadeRed
			
			nStp = 20
			for i = 0 to nStp - 1
			
				an0 = i / nStp
				xOfs = .028 * cos(3.1415 * 2 * an0)
				yOfs = .028 * sin(3.1415 * 2 * an0)
				
				glPushmatrix
					glTranslatef xOfs, yOfs, 0
					Render_Model_Plain ModelDB[PhaseMenuGlobals.titleMID].modelHandle
				glPopMatrix
			
			next
			
			glTranslatef 0, -1, 0
			
			glColor4f 0, 0, 0, PhasePlayerGlobals.player.gameOverFadeRed
			Render_Model_Plain ModelDB[PhaseMenuGlobals.theEndMID].modelHandle
			
			
			glColor4f 0, 0, 0, .077 * PhasePlayerGlobals.player.gameOverFadeRed
			
			nStp = 20
			for i = 0 to nStp - 1
			
				an0 = i / nStp
				xOfs = .028 * cos(3.1415 * 2 * an0)
				yOfs = .028 * sin(3.1415 * 2 * an0)
				
				glPushmatrix
					glTranslatef xOfs, yOfs, 0
					Render_Model_Plain ModelDB[PhaseMenuGlobals.theEndMID].modelHandle
				glPopMatrix
			
			next
			
		glPopMatrix

	end if
	
	glEnable GL_CULL_FACE
	glEnable GL_DEPTH_TEST
	glDepthMask GL_TRUE
	glEnable GL_LIGHTING
	
end sub



sub PhasePlayer_Render_HUD_Health ()

	dim as integer cx, cy, dx
	dim as single dx2, dx3
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	cx = OpenGLProperties.SCR_WIDTH * 4.5 / 10
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	dim as integer nSteps, i
	dim as single an0, an1, an2, an3, radius0, radius1, radius2, radius3
	dim as single x0, y0, x1, y1, x2, y2, x3, y3
	dim as single anW, anS
	dim as single startAn, endAn
	
	dim as single healthRatio
	
	healthRatio = PhasePlayerGlobals.player.health / PhasePlayerGlobals.player.maxHealth
	
	if healthRatio < .4 then
		if PhasePlayerGlobals.player.flashHealthRed = 0 then PhasePlayerGlobals.player.flashHealthRed = 1
	end if
	
	glDisable GL_CULL_FACE
	
	dim as rgbalpha c0
	c0.r = 1
	c0.g = 1
	c0.b = 1
	c0.a = .36
	
	if PhasePlayerGlobals.player.flashHealthRed > 0 then
		c0.r = PhasePlayerGlobals.player.flashHealthRed
		c0.g = 0
		c0.b = 0
		c0.a = 1
	end if
	
	if PhasePlayerGlobals.player.flashHealth > 0 then
		c0.r = 0
		c0.g = PhasePlayerGlobals.player.flashHealth
		c0.b = PhasePlayerGlobals.player.flashHealth
		c0.a = 1
	end if
	
	glColor4fv @c0.r
	
	
	glBegin GL_LINES
		startAn = 180 - 90 * healthRatio
		endAn = 180 + 90 * healthRatio
		
		nSteps = (endAn - StartAn) / 7
		if nSteps = 0 then nSteps = 1
		
		anW = 8
		anS = anW / 6
		
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * 180 * healthRatio + anS
			an1 = startAn + (i / nSteps) * 180 * healthRatio + anS * 2
			an2 = startAn + ((i + 1) / nSteps) * 180 * healthRatio - anS * 2
			an3 = startAn + ((i + 1) / nSteps) * 180 * healthRatio - anS
			
			radius0 = 100 * dx
			radius1 = 98 * dx
			radius2 = 88 * dx
			radius3 = 86 * dx
			
			#ifdef 0
			glColor3f 0, 1, 0
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			
			
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			glColor3f 0, .2, 0
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			
			glColor3f 0, 1, 0
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			glColor3f 0, .2, 0
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius3 * sin(3.14159 / 180 * an3)
			
			
			#endif
			
			'#ifdef 0
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			
			'#endif
			
		next
	glEnd
	
	glColor4fv @c0.r
	
		
	glBegin GL_LINES
		startAn = 90-1.5
		endAn = startAn + 10
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		endAn = 271.5
		startAn = endAn - 10

		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		an0 = 90 - 1.5
		radius0 = 105 * dx
		radius1 = 100 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = 90 - 1.5
		radius0 = 81 * dx
		radius1 = 86 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = 270 + 1.5
		radius0 = 81 * dx
		radius1 = 86 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = 270 + 1.5
		radius0 = 105 * dx
		radius1 = 100 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		
		startAn = 90 + 67
		endAn = startAn + 10
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		endAn = 270 - 67
		startAn = endAn - 10
		
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
	glEnd
	
	glPushMatrix
	
		glTranslatef cx - (126.5) * dx, cy, 0
		
		for i = 0 to 3
			
			y0 = 2.8 * dx
			x0 = 3.1 * dx
			x1 = x0 + 12 * dx
			glBegin GL_LINES
				glVertex2f x0, +y0
				glVertex2f x1, +y0
				
				glVertex2f x1, +y0
				glVertex2f x1, -y0
				
				glVertex2f x1, -y0
				glVertex2f x0, -y0
			glEnd
			
			glRotatef 90, 0, 0, 1
		next
	
	glPopMatrix
	
	
	glBegin GL_LINES
		an0 = 193
		radius0 = 105 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = 167
		radius0 = 105 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = 193
		radius0 = 105 * dx
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + 10 * dx + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = 167
		radius0 = 105 * dx
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx - 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy - 10 * dx + radius0 * sin(3.14159 / 180 * an0)
	glEnd
	
	glEnable GL_CULL_FACE
	
end sub


sub PhasePlayer_Render_HUD_Missiles ()

	dim as integer cx, cy, dx, dy
	dim as single dx2, dx3
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	
	
	cx = OpenGLProperties.SCR_WIDTH * (1 - 4.5 / 10)
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	dim as integer nSteps, i
	dim as single an0, an1, an2, an3, radius0, radius1, radius2, radius3
	dim as single x0, y0, x1, y1, x2, y2, x3, y3, w0, h0
	dim as single anW, anS
	dim as single startAn, endAn
	
	dim as rgbalpha c0
	c0.r = 1
	c0.g = 1
	c0.b = 1
	c0.a = .36
	
	if PhasePlayerGlobals.player.flashMissileRed > 0 then 
		c0.r = PhasePlayerGlobals.player.flashMissileRed
		c0.g = 0
		c0.b = 0
		c0.a = 1
	end if
	
	if PhasePlayerGlobals.player.flashMissile > 0 then 
		c0.r = 0
		c0.g = PhasePlayerGlobals.player.flashMissile
		c0.b = PhasePlayerGlobals.player.flashMissile
		c0.a = 1
	end if
	
	glColor4fv @c0.r
	
	if PhasePlayerGlobals.player.selWeapon = 1 then
	
		glBegin GL_LINES
			nSteps = PhasePlayerGlobals.player.weapon[1].rounds
			anW = 10
			anS = anW / 6
			
			if nSteps < 4 and PhasePlayerGlobals.player.flashMissileRed = 0 then PhasePlayerGlobals.player.flashMissileRed = 1
			
			startAn = -anW * nSteps
			startAn -= startAn / 2
			startAn += anW / 2
			
			for i = 0 to nSteps - 1
			
				an0 = startAn + i * anW + anW / 2 - anS
				an1 = startAn + i * anW 
				an2 = startAn + i * anW - anW / 2 + anS
				
				radius0 = 70 * dx
				radius1 = 60 * dx
				radius2 = 55 * dx
				
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
				
				glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
				glVertex2f cx + radius2 * cos(3.14159 / 180 * an1), cy + radius2 * sin(3.14159 / 180 * an1)
				
				glVertex2f cx + radius2 * cos(3.14159 / 180 * an1), cy + radius2 * sin(3.14159 / 180 * an1)
				glVertex2f cx + radius1 * cos(3.14159 / 180 * an2), cy + radius1 * sin(3.14159 / 180 * an2)
				
				glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				
				glVertex2f cx + radius1 * cos(3.14159 / 180 * an2), cy + radius1 * sin(3.14159 / 180 * an2)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
				
				
			next
			
			
			x0 = cx - 7 * dx + 45.1 * dx
			x1 = x0 + 6 * dx
			x2 = (x1 + x0) / 2
			x3 = 3 * dx
			
			y0 = cy + -1.6 * dx - 6.4 * dx
			y1 = cy + -1.6 * dx + 6.4 * dx
			y2 = 3.7 * dx
			
			glVertex2f x0, y0
			glVertex2f x0, y1
			
			glVertex2f x1, y0
			glVertex2f x1, y1
			
			glVertex2f x0, y0
			glVertex2f x2, y0 - y2
			
			glVertex2f x2, y0 - y2
			glVertex2f x1, y0
			
			glVertex2f x0, y1
			glVertex2f x0 - x3, y1 + y2 
			
			glVertex2f x0 - x3, y1 + y2 
			glVertex2f x0 - x3, y1 + y2 * 2
			
			glVertex2f x0 - x3, y1 + y2 * 2
			glVertex2f x1 + x3, y1 + y2 * 2
			
			glVertex2f x1 + x3, y1 + y2 * 2
			glVertex2f x1 + x3, y1 + y2
			
			glVertex2f x1 + x3, y1 + y2
			glVertex2f x1, y1
			
		glEnd
		
	else
	
		glBegin GL_LINES
			startAn = -90
			endAn = 90
			nSteps = 100
			for i = 0 to nSteps - 1
				
				an0 = startAn + (i / nSteps) * (endAn - startAn)
				an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
				
				radius0 = (70) * dx
				
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				
				an0 = startAn + (i / nSteps) * (endAn - startAn)
				an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
				
				radius0 = (64) * dx
				
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				
			next
			
			an0 = startAn
			an1 = endAn
			
			radius0 = (70) * dx
			radius1 = (64) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an1), cy + radius1 * sin(3.14159 / 180 * an1)
			
			
			for i = 0 to 5
				an0 = i / 6 * 360 - 90 - 11.5
				an1 = i / 6 * 360 - 90 + 11.5
				
				radius0 = 11.2 * dx
				radius1 = 5.8 * dx
				
				glVertex2f cx + 45.1 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				glVertex2f cx + 45.1 * dx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				
				glVertex2f cx + 45.1 * dx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
				glVertex2f cx + 45.1 * dx + radius1 * cos(3.14159 / 180 * an1), cy + radius1 * sin(3.14159 / 180 * an1)
				
				glVertex2f cx + 45.1 * dx + radius1 * cos(3.14159 / 180 * an1), cy + radius1 * sin(3.14159 / 180 * an1)
				glVertex2f cx + 45.1 * dx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
				
				glVertex2f cx + 45.1 * dx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
				glVertex2f cx + 45.1 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
				
			next
			
		glEnd
		
	end if
	
end sub


sub PhasePlayer_Render_HUD_Reticle ()

	dim as integer cx, cy, dx
	dim as single dx2, dx3
	
	dx = OpenGLProperties.SCR_WIDTH / 640 * 7
	
	dx2 = (OpenGLProperties.SCR_WIDTH / 640) * -19.4
	dx3 = (OpenGLProperties.SCR_WIDTH / 640) * -4.17
	
	cx = OpenGLProperties.SCR_WIDTH / 2
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	dim as integer g
	dim as single an0
	
	for g = 0 to 2
		
		glPushMatrix
		glTranslatef cx, cy, 0
		
		glRotatef g * 120 + 90, 0, 0, 1
		glTranslatef dx2, 0, 0
	
		glBegin GL_LINES
			glColor3f 1, 1, 1
			
			glVertex2f 0, -dx
			glVertex2f -dx3, 0
			
			glVertex2f -dx3, 0
			glVertex2f 0, dx
			
			glVertex2f 0, dx
			
			glColor4f 1, 1, 1, .5
			glVertex2f dx*2, 0
			
			glVertex2f dx*2, 0
			
			glColor3f 1, 1, 1
			glVertex2f 0, -dx
			
		glEnd
		
		glPopMatrix
	
	next
	
end sub



sub PhasePlayer_Render_HUD_Shield ()

	dim as integer cx, cy, dx
	dim as single dx2, dx3
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	
	
	cx = OpenGLProperties.SCR_WIDTH * (1 - 4.5 / 10)
	cy = OpenGLProperties.SCR_HEIGHT / 2
	
	dim as integer nSteps, i
	dim as single an0, an1, an2, an3, radius0, radius1, radius2, radius3
	dim as single x0, y0, x1, y1, x2, y2, x3, y3, w0, h0
	dim as single anW, anS
	dim as single startAn, endAn
	
	dim as single shieldRatio
	shieldRatio = PhasePlayerGlobals.player.shield / PhasePlayerGlobals.player.maxShield
	
	if shieldRatio < .2 and PhasePlayerGlobals.player.flashShieldRed = 0 then PhasePlayerGlobals.player.flashShieldRed = 1
	
	glDisable GL_CULL_FACE
	
	dim as rgbalpha c0
	c0.r = 1
	c0.g = 1
	c0.b = 1
	c0.a = .36
	
	if PhasePlayerGlobals.player.flashShieldRed > 0 then
		c0.r = PhasePlayerGlobals.player.flashShieldRed
		c0.g = 0
		c0.b = 0
		c0.a = 1
	end if
	
	if PhasePlayerGlobals.player.flashShield > 0 then
		c0.r = 0
		c0.g = PhasePlayerGlobals.player.flashShield
		c0.b = PhasePlayerGlobals.player.flashShield
		c0.a = 1
	end if
	
	
	glColor4fv @c0.r
	
	
	glBegin GL_LINES
		startAn =  - 90 * shieldRatio
		endAn = 90 * shieldRatio
		
		nSteps = (endAn - StartAn) / 7
		if nSteps = 0 then nSteps = 1
		
		anW = 8
		anS = anW / 6
		
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * 180 * shieldRatio + anS
			an1 = startAn + (i / nSteps) * 180 * shieldRatio + anS * 2
			an2 = startAn + ((i + 1) / nSteps) * 180 * shieldRatio - anS * 2
			an3 = startAn + ((i + 1) / nSteps) * 180 * shieldRatio - anS
			
			radius0 = 100 * dx
			radius1 = 98 * dx
			radius2 = 88 * dx
			radius3 = 86 * dx
			
			#ifdef 0
			
			glColor3f 0, 1, 1
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			
			glColor3f 0, .2, .2
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			#endif
			
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an2), cy + radius0 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an3), cy + radius1 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an3), cy + radius2 * sin(3.14159 / 180 * an3)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an2), cy + radius3 * sin(3.14159 / 180 * an2)
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			
			glVertex2f cx + radius3 * cos(3.14159 / 180 * an1), cy + radius3 * sin(3.14159 / 180 * an1)
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			
			glVertex2f cx + radius2 * cos(3.14159 / 180 * an0), cy + radius2 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
			
	
		next
	
	
		startAn = -90-1.5
		endAn = startAn + 10
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		endAn = -268.5
		startAn = endAn - 10
		
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		an0 = -90 - 1.5
		radius0 = 105 * dx
		radius1 = 100 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = -90 - 1.5
		radius0 = 81 * dx
		radius1 = 86 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = -270 + 1.5
		radius0 = 81 * dx
		radius1 = 86 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		an0 = -270 + 1.5
		radius0 = 105 * dx
		radius1 = 100 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + radius1 * cos(3.14159 / 180 * an0), cy + radius1 * sin(3.14159 / 180 * an0)
		
		
		startAn = -90 + 67
		endAn = startAn + 10
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
		endAn = -270 - 67
		startAn = endAn - 10
		
		nSteps = 10
		for i = 0 to nSteps - 1
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (81) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
			an0 = startAn + (i / nSteps) * (endAn - startAn)
			an1 = startAn + ((i + 1) / nSteps) * (endAn - startAn)
			
			radius0 = (105) * dx
			
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
			glVertex2f cx + radius0 * cos(3.14159 / 180 * an1), cy + radius0 * sin(3.14159 / 180 * an1)
			
		next
		
	glEnd
	
	glPushMatrix
	
		glTranslatef cx + (126.5) * dx, cy, 0
		
		w0 = 10 * dx
		h0 = 14 * dx
		x0 = 1.68
		
		glBegin GL_LINES
			glVertex2f -w0, -h0
			glVertex2f -w0, h0 - h0 / x0
			
			glVertex2f -w0, h0 - h0 / x0
			glVertex2f -w0 + w0 / x0, h0
			
			glVertex2f -w0 + w0 / x0, h0
			glVertex2f w0 - w0 / x0, h0
			
			glVertex2f w0 - w0 / x0, h0
			glVertex2f w0, h0 - h0 / x0
			
			glVertex2f w0, h0 - h0 / x0
			glVertex2f w0, -h0
			
			glVertex2f w0, -h0
			glVertex2f -w0, -h0
			
		glEnd
		
		w0 -= dx * 3.15
		h0 -= dx * 4.15
		
		glBegin GL_LINES
			glVertex2f -w0, -h0
			glVertex2f -w0, h0 - h0 / x0
			
			glVertex2f -w0, h0 - h0 / x0
			glVertex2f -w0 + w0 / x0, h0
			
			glVertex2f -w0 + w0 / x0, h0
			glVertex2f w0 - w0 / x0, h0
			
			glVertex2f w0 - w0 / x0, h0
			glVertex2f w0, h0 - h0 / x0
			
			glVertex2f w0, h0 - h0 / x0
			glVertex2f w0, -h0
			
			glVertex2f w0, -h0
			glVertex2f -w0, -h0
			
		glEnd

	glPopMatrix
	
	
	glBegin GL_LINES
		an0 = -13
		radius0 = 105 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = -347
		radius0 = 105 * dx
		glVertex2f cx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = -13
		radius0 = 105 * dx
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx - 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + 10 * dx + radius0 * sin(3.14159 / 180 * an0)
		
		an0 = -347
		radius0 = 105 * dx
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx - 10 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy + radius0 * sin(3.14159 / 180 * an0)
		glVertex2f cx + 50 * dx + radius0 * cos(3.14159 / 180 * an0), cy - 10 * dx + radius0 * sin(3.14159 / 180 * an0)
		
	glEnd
	
	glEnable GL_CULL_FACE
	
end sub


sub PhasePlayer_Render_HUD_Score ()

	glDisable GL_CULL_FACE
	glDisable GL_DEPTH_TEST
	glDepthMask GL_FALSE
	
	dim as integer num, i, ii, f
	dim as string m, nums
	
	nums = str(PhasePlayerGlobals.player.score.points)
	
	dim as integer nStp
	dim as single an0, xOfs, yOfs, c0
	
	
	c0 = .581
	
	nStp = 10
	for i = 0 to nStp - 1
	
		an0 = i / nStp
		xOfs = .046 * cos(3.1415 * 2 * an0)
		yOfs = .046 * sin(3.1415 * 2 * an0)
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef -2.66, -12.44, -40.82
			
			glColor4f c0, c0, c0, .139
			Render_Model_Plain ModelDB[PhaseMenuGlobals.scoreMID].modelHandle
			
			glTranslatef .8, -.3, 0
			
			for ii = 1 to len(nums)
				m = mid(nums, ii, 1)
				f = asc(m) - 48
				Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
				glTranslatef 1.42, 0, 0
			next
		
		glPopMatrix
	next
	
	
	glPushMatrix
		glLoadIdentity
	
		glTranslatef -2.66, -12.44, -40.82
		
		glColor4f 1, 1, 1, 1
		Render_Model_Plain ModelDB[PhaseMenuGlobals.scoreMID].modelHandle
		
		glTranslatef .8, -.3, 0
		
		for i = 1 to len(nums)
			m = mid(nums, i, 1)
			f = asc(m) - 48
			Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
			glTranslatef 1.42, 0, 0
		next
	
	glPopMatrix
	
	glEnable GL_CULL_FACE
	glEnable GL_DEPTH_TEST
	glDepthMask GL_TRUE
	
	
end sub



sub PhasePlayer_Render_HUD_TopClock ()

	glDisable GL_DEPTH_TEST
	
	dim as string missionClock, m
	dim as integer i, f
	
	missionClock = io_time_hms(PhasePlayerGlobals.missionClock.curr)
	
	glCallList PhasePlayerGlobals.missionClockBGDL
	
	'see AR_Load_Misc for missionClockBGDL display list creation
	
	dim as rgbalpha c0
	
	if PhasePlayerGlobals.player.flashTime > 0 then
		c0.r = PhasePlayerGlobals.player.flashTime
		c0.g = PhasePlayerGlobals.player.flashTime
		c0.b = 0
		c0.a = 1
	end if
	
	glColor4fv @c0.r
	
	
	glPushMatrix
		glLoadIdentity
		
		glTranslatef -7.3, 12, -40
		
		for i = 1 to 8
			m = mid(missionClock, i, 1)
			
			if m = ":" then
				f = 10
			else
				f = asc(m) - 48
			end if
			
			glTranslatef 1.3, 0, 0
			glCallList PhasePlayerGlobals.sevenSegmentDL(f)'Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
		next
		
		glScalef .6, .6, .6
		
		glTranslatef .5, -.6, 0
		for i = 9 to 12
			m = mid(missionClock, i, 1)
			
			glTranslatef 1.3, 0, 0
			if m = "." then
				glPushMatrix
					glScalef .5, .5, .5
					glCallList PhasePlayerGlobals.sevenSegmentDL(10)'Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
				glPopMatrix
			else
				f = asc(m) - 48
				glCallList PhasePlayerGlobals.sevenSegmentDL(f)'Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
			end if
		
		next
		
	glPopMatrix
	
	glEnable GL_DEPTH_TEST
	
end sub



sub PhasePlayer_Render_HUD_WaveIndex ()

	glDisable GL_CULL_FACE
	glDisable GL_DEPTH_TEST
	glDepthMask GL_FALSE
	
	dim as integer num, i, ii, f
	dim as string m, nums
	num = PhaseMenuGlobals.waveNumber
	
	nums = str(num)
	
	dim as integer nStp
	dim as single an0, xOfs, yOfs, c0
	
	c0 = .115
	
	PhaseMenuGlobals.waveFade -= .928 * system_ticksPassed / 1000
	if PhaseMenuGlobals.waveFade < 0 then PhaseMenuGlobals.waveFade = 0
	
	c0 = .581
	
	nStp = 20
	for i = 0 to nStp - 1
	
		an0 = i / nStp
		xOfs = .046 * cos(3.1415 * 2 * an0)
		yOfs = .046 * sin(3.1415 * 2 * an0)
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef .523, 3 + PhaseMenuGlobals.waveFade, -18
			
			glColor4f c0, c0, c0, .139 * PhaseMenuGlobals.waveFade
			Render_Model_Plain ModelDB[PhaseMenuGlobals.waveMID].modelHandle
			
			glTranslatef .8, -.3, 0
			
			for ii = 1 to len(nums)
				m = mid(nums, ii, 1)
				f = asc(m) - 48
				Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
				glTranslatef 1.42, 0, 0
			next
		
		glPopMatrix
	next
	
	
	glPushMatrix
		glLoadIdentity
	
		glTranslatef .523, 3 + PhaseMenuGlobals.waveFade, -18
		
		glColor4f 1, 1, 1, 1 * PhaseMenuGlobals.waveFade
		Render_Model_Plain ModelDB[PhaseMenuGlobals.waveMID].modelHandle
		
		glTranslatef .8, -.3, 0
		
		for i = 1 to len(nums)
			m = mid(nums, i, 1)
			f = asc(m) - 48
			Render_Model_Plain ModelDB[PhasePlayerGlobals.sevenSegmentMID(f)].modelHandle
			glTranslatef 1.42, 0, 0
		next
	
	glPopMatrix
	
	glEnable GL_CULL_FACE
	glEnable GL_DEPTH_TEST
	glDepthMask GL_TRUE
	
	
end sub



sub PhasePlayer_Render_HUD_UI ()

	glDisable GL_CULL_FACE
	glDisable GL_DEPTH_TEST
	glDepthMask GL_FALSE
	
	
	dim as integer num, i, ii, f
	dim as string m, nums
	
	dim as integer nStp, dx
	dim as single an0, xOfs, yOfs, c0, zOfs
	
	dx = OpenGLProperties.SCR_WIDTH / 640
	
	zOfs = 1.03 * dx
	
	
	PhaseMenuGlobals.uiFade -= .1 * system_ticksPassed / 1000
	if PhaseMenuGlobals.uiFade < 0 then PhaseMenuGlobals.uiFade = 0
	
	c0 = .581
	nStp = 20
	for i = 0 to nStp - 1
	
		an0 = i / nStp
		xOfs = .046 * cos(3.1415 * 2 * an0)
		yOfs = .046 * sin(3.1415 * 2 * an0)
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef -5.3, -3.56, -25.7 + zOfs
		
			glColor4f c0, c0, c0, .139 * PhaseMenuGlobals.uiFade
			Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_healthMID].modelHandle
		
		glPopMatrix
		
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef 1.27, 1.5, -30 + zOfs
		
			glColor4f c0, c0, c0, .139 * PhaseMenuGlobals.uiFade
			Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_clockMID].modelHandle
		
		glPopMatrix
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef 2.55, 3.14, -29 + zOfs
		
			glColor4f c0, c0, c0, .139 * PhaseMenuGlobals.uiFade
			Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_ammoMID].modelHandle
		
		glPopMatrix
		
		glPushMatrix
			glLoadIdentity
			glTranslatef xOfs, yOfs, 0
			glTranslatef 10.8, -3.0, -29 + zOfs
		
			glColor4f c0, c0, c0, .139 * PhaseMenuGlobals.uiFade
			Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_shieldMID].modelHandle
		
		glPopMatrix
		
		
	next
		
		
		
		
			
	glPushMatrix
		glLoadIdentity
		
		glTranslatef -5.3, -3.56, -25.7 + zOfs
	
		glColor4f 1, 1, 1, 1 * PhaseMenuGlobals.uiFade
		Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_healthMID].modelHandle
	
	glPopMatrix
	
	
	glPushMatrix
		glLoadIdentity
		
		glTranslatef 1.27, 1.5, -30 + zOfs
	
		glColor4f 1, 1, 1, 1 * PhaseMenuGlobals.uiFade
		Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_clockMID].modelHandle
	
	glPopMatrix
	
	glPushMatrix
		glLoadIdentity
		
		glTranslatef 2.55, 3.14, -29 + zOfs
	
		glColor4f 1, 1, 1, 1 * PhaseMenuGlobals.uiFade
		Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_ammoMID].modelHandle
	
	glPopMatrix
	
	glPushMatrix
		glLoadIdentity

		glTranslatef 10.8, -3.0, -29 + zOfs
	
		glColor4f 1, 1, 1, 1 * PhaseMenuGlobals.uiFade
		Render_Model_Plain ModelDB[PhaseMenuGlobals.hud_shieldMID].modelHandle
	
	glPopMatrix
	
	glEnable GL_CULL_FACE
	glEnable GL_DEPTH_TEST
	glDepthMask GL_TRUE
	
	
end sub