

sub PhasePlayer_Render_Scene ()


	glDisable GL_LIGHTING
	
	PhasePlayer_Render_Scene_Generators
	PhasePlayer_Render_Scene_Spawn
	PhasePlayer_Render_Scene_Bullets
	PhasePlayer_Render_Scene_Missiles
	PhasePlayer_Render_Scene_Explosions
	PhasePlayer_Render_Scene_PowerUp
	
	
end sub



sub PhasePlayer_Render_Scene_Generators ()

	
	dim as integer GenID
	
	for genID = 1 to PhaseDataGlobals.phaseSequence.nGenerators - 1
	
		if PhaseDataGlobals.phaseSequence.generator[genID].class = GC_BLOCK_TORUS then PhasePlayer_Render_Scene_Block_Torus @PhaseDataGlobals.phaseSequence.generator[genID]
		if PhaseDataGlobals.phaseSequence.generator[genID].class = GC_HEX_TUNNEL then PhasePlayer_Render_Scene_Hex_Tunnel @PhaseDataGlobals.phaseSequence.generator[genID]
		if PhaseDataGlobals.phaseSequence.generator[genID].class = GC_META_BALL_CLOUD then PhasePlayer_Render_Scene_Meta_Ball_Cloud @PhaseDataGlobals.phaseSequence.generator[genID]
		if PhaseDataGlobals.phaseSequence.generator[genID].class = GC_META_BALL_DISC then PhasePlayer_Render_Scene_Meta_Ball_Disc @PhaseDataGlobals.phaseSequence.generator[genID]
		
	next
	
end sub


sub PhasePlayer_Render_Scene_Bullets ()
	
	dim as integer b
	
	'---- draw active bullets
	for b = 0 to PhasePlayerGlobals.lastBullet
		
		if PhasePlayerGlobals.bullet[b].active = 1 or PhasePlayerGlobals.bullet[b].active = 2 then
		
			if PhasePlayerGlobals.bullet[b].class = BC_TYPE_I then PhasePlayer_Render_Scene_Bullet_TypeI @PhasePlayerGlobals.bullet[b]
			
		end if
		
	next
	


end sub



sub PhasePlayer_Render_Scene_Explosions ()
	
	dim as integer b
	
	'---- draw active explosions
	for b = 0 to PhasePlayerGlobals.lastExplosion
		
		if PhasePlayerGlobals.explosion[b].active = 1 then
		
			if PhasePlayerGlobals.explosion[b].class = EC_NORMAL then PhasePlayer_Render_Scene_Explosion_Normal @PhasePlayerGlobals.explosion[b]
			if PhasePlayerGlobals.explosion[b].class = EC_SMALL then PhasePlayer_Render_Scene_Explosion_Small @PhasePlayerGlobals.explosion[b]
			
		end if
		
	next
	


end sub


sub PhasePlayer_Render_Scene_Missiles ()
	
	dim as integer m, i, g, nSlices, t, tailLength, nIter
	dim as vector4d position
	dim as single vSpeed
	dim as single w, wd2
	dim as single an0, an1, radius, w0, a0
	dim as single tPos, ballScale
	dim as rgbalpha c0, c1
	
	w = .5
	wd2 = w / 2
	
	glDepthMask GL_FALSE
	
	for m = 0 to PhasePlayerGlobals.lastMissile
		if PhasePlayerGlobals.missile[m].active = 1 then
	
			Matrix_LoadIdentity @PhasePlayerGlobals.missile[m].matrix(0)
			
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
				
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				
				Matrix_Translate @PhasePlayerGlobals.missile[m].matrix(0), PhasePlayerGlobals.missile[m].position.x, PhasePlayerGlobals.missile[m].position.y, PhasePlayerGlobals.missile[m].position.z
				
				't/r to camera coordinates
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				
				Matrix_Translate @PhasePlayerGlobals.missile[m].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
				
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
				Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				
			glLoadMatrixf @PhasePlayerGlobals.missile[m].matrix(0)
			
			
			if PhasePlayerGlobals.missile[m].class = MC_BULLET then
				nSlices = 8
		
				glBegin GL_TRIANGLES
					for g = 0 to nSlices - 1
						
						glColor4f 1, 1, 1, 1
						glVertex2f 0, 0
						
						an0 = rnd * 360
						an1 = an0 + rnd * 90
						radius = .1
						radius += rnd * radius
						
						glColor4f 1, 1, 1, 0
						
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
					next
				glEnd
				
			elseif PhasePlayerGlobals.missile[m].class = MC_ROCKET then
				nSlices = 8
		
				
				glBegin GL_LINES
				for g = 0 to 2
				
					w0 = rnd * 120
					for i = 0 to nSlices - 1
					
						an0 = g * (360 / 3) + PhasePlayerGlobals.player.weapon[PhasePlayerGlobals.player.selWeapon].angle * 5 - w0 / 2
						an0 += w0 * i / nSlices
						an1 = an0 + w0 / nSlices
					
						a0 = abs(((i / nSlices) - .5) / .5)
						
						glColor4f 1, 1, 1, a0
						radius = .2 + rnd * .1
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
						
					next
					
					
				next
				glEnd
				
				glBegin GL_TRIANGLES
					for g = 0 to 2
					
						an0 = g * (360 / 3) + PhasePlayerGlobals.player.weapon[PhasePlayerGlobals.player.selWeapon].angle
						
						radius = rnd * .7
						glColor4f 1, 1, 1, 0
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
						radius = .05
						glColor4f 1, 1, 1, 1
						an0 = an0 + 5
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
						an0 = an0 - 10
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
						an0 += 180
						radius = rnd * .25
						glColor4f 1, 1, 1, 0
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
						radius = .05
						glColor4f 1, 1, 1, 1
						an0 = an0 + 5
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
						an0 = an0 - 10
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						
					next
					
					for g = 0 to nSlices - 1
						glColor4f 1, 1, 1, 1
						glVertex2f 0, 0
						
						an0 = g / nSlices * 360
						an1 = (g + 1) / nSlices * 360
						
						radius = .1
						glColor4f 1, 1, 1, 0
						
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
					
					next
					
					for g = 0 to nSlices - 1
						
						glColor4f 1, 1, 1, 1
						glVertex2f 0, 0
						
						an0 = rnd * 360
						an1 = an0 + rnd * 90
						radius = .1
						radius += rnd * radius
						
						glColor4f 1, 1, 1, 0
						
						glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
						glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
					next
					
				glEnd
				
				
				tailLength = 10
				nIter = tailLength * 10
				for t = 0 to niter
					tPos = t / niter * 5
					
					position.x = -PhasePlayerGlobals.missile[m].accelVector.x
					position.y = -PhasePlayerGlobals.missile[m].accelVector.y
					position.z = -PhasePlayerGlobals.missile[m].accelVector.z
					position.w = 1
					
					math_normalize position
					
					position.x *= tPos
					position.y *= tPos
					position.z *= tPos
					
					position.x += PhasePlayerGlobals.missile[m].position.x
					position.y += PhasePlayerGlobals.missile[m].position.y
					position.z += PhasePlayerGlobals.missile[m].position.z
					
					Matrix_LoadIdentity @PhasePlayerGlobals.missile[m].matrix(0)
					
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
						
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
						
						Matrix_Translate @PhasePlayerGlobals.missile[m].matrix(0), position.x, position.y, position.z
						
						't/r to camera coordinates
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
						
						Matrix_Translate @PhasePlayerGlobals.missile[m].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
						
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
						Matrix_Rotate @PhasePlayerGlobals.missile[m].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
						
					glLoadMatrixf @PhasePlayerGlobals.missile[m].matrix(0)
					
					nSlices = 8
					
					ballScale = .03 * (1 - t / nIter)
					glBegin GL_TRIANGLES
						for g = 0 to nSlices - 1
							
							c1.r = rnd * .3
							c1.g = c1.r
							c1.b = c1.r
							c1.a = 1
							
							glColor4fv @c1.r
							glVertex2f 0, 0
							
							an0 = rnd * 360
							an1 = an0 + rnd * 90
							radius = ballScale
							radius += rnd * radius
							
							c1.a = 0
							glColor4fv @c1.r
							
							glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
							glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
						next
					glEnd
					
				next
				
			end if
			
		end if
		
	next
	
	glDepthMask GL_TRUE
	
end sub


sub PhasePlayer_Render_Scene_Spawn ()
	
	dim as integer nWaves, nSpawn, a, b
	nWaves = PhaseDataGlobals.phaseSequence.nWaves

	'---- activate spawns if available
	for a = 0 to nWaves - 1
	
		
		nSpawn = PhaseDataGlobals.phaseSequence.wave[a].nSpawn
		for b = 0 to nSpawn - 1
		
			if PhaseDataGlobals.phaseSequence.wave[a].spawn[b].active = 1 or PhaseDataGlobals.phaseSequence.wave[a].spawn[b].active = 2 then
			
				if PhaseDataGlobals.phaseSequence.wave[a].class = WC_FLIES then PhasePlayer_Render_Scene_Spawn_Flies @PhaseDataGlobals.phaseSequence.wave[a].spawn[b]
				if PhaseDataGlobals.phaseSequence.wave[a].class = WC_BOSS_DRAGON then PhasePlayer_Render_Scene_Spawn_BossDragon @PhaseDataGlobals.phaseSequence.wave[a], @PhaseDataGlobals.phaseSequence.wave[a].spawn[b]
			
			end if
			
		next
		
	next
	
end sub


sub PhasePlayer_Render_Scene_Fuzz ()


	'----- draw scene
	glViewPort 0, 0, 128, 128
	'glViewPort 0, 0, 256, 256
	glLoadIdentity
	
	PhasePlayer_Render_Scene
	
	'----- copy Scene
	glEnable GL_TEXTURE_2D
	glBindTexture GL_TEXTURE_2D, blankTex
	glCopyTexImage2D GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 128, 128, 0
	
	glBindTexture GL_TEXTURE_2D, blendTex
	glCopyTexImage2D GL_TEXTURE_2D, 0, GL_RGB, 0, 0, 128, 128, 0
	
	
	glClear  GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT
	glViewport 0, 0, OpenGLProperties.SCR_WIDTH, OpenGLProperties.SCR_HEIGHT
	
	glDisable GL_TEXTURE_2D
	
	
	system_2dplane_set_full
	'---- draw scene scaled
	
	dim as single x0, y0, x1, y1, nStp, stp, ratio, radius, ofsX, ofsY
	dim i as integer
	dim r as single
	dim as single an, h, w, d
	
	w = OpenGLProperties.SCR_WIDTH / 2
	h = OpenGLProperties.SCR_HEIGHT / 2
	
	glEnable GL_TEXTURE_2D
	
	
	glBindTexture GL_TEXTURE_2D, blankTex
	ratio = 1
	glColor3f 1, 1, 1
	
	x0 = w - w * ratio
	y0 = h - h * ratio
	x1 = w + w * ratio
	y1 = h + h * ratio
	
	glBegin GL_QUADS
		glTexCoord2d 0, 1
		glVertex3f x0, y0, 0
		glTexCoord2d 0, 0
		glVertex3f x0, y1, 0
		glTexCoord2d 1, 0
		glVertex3f x1, y1, 0
		glTexCoord2d 1, 1
		glVertex3f x1, y0, 0
	glEnd
	
	
	
	
	glBlendFunc GL_SRC_ALPHA, GL_ONE
	'glBlendFunc GL_ONE, GL_ONE
		
	glBindTexture GL_TEXTURE_2D, blendTex
	
	nStp = 12
	
	for stp = 0 to nStp - 1
	
		radius = w / 640 * stp * 2
		ofsX = radius * cos(3.1415 * 2 * stp / nStp)
		ofsY = radius * sin(3.1415 * 2 * stp / nStp)
		
		ratio = 1 + stp/nStp * .05
		glColor4f 1, 1, 1, .1'(1 - ratio / 2) * .25
		
		x0 = w - w * ratio
		y0 = h - h * ratio
		x1 = w + w * ratio
		y1 = h + h * ratio
		
		glPushMatrix
			glTranslatef ofsX, ofsY, 0
			glBegin GL_QUADS
				glTexCoord2d 0, 1
				glVertex3f x0, y0, 0
				glTexCoord2d 0, 0
				glVertex3f x0, y1, 0
				glTexCoord2d 1, 0
				glVertex3f x1, y1, 0
				glTexCoord2d 1, 1
				glVertex3f x1, y0, 0
			glEnd
		glPopMatrix
	next
	
	
	glBlendFunc GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA
	
	
	glDisable GL_TEXTURE_2D
	
	
	
	system_2dplane_clear
	
	
	
end sub



sub PhasePlayer_Render_Scene_Block_Torus (gen as GeneratorClassType ptr)

	
	dim as single length, innerRadius, outterRadius
	dim as integer proj, vert, tri, pointid
	
	for proj = 0 to gen->nProjectiles - 1
	
		if gen->projectile[proj].active = 1 then
	
			glPushMatrix
				Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
				PhasePlayer_Render_Scene_Align_Projectile gen, @gen->projectile[proj]
				glLoadMatrixf @gen->projectile[proj].matrix(0)
				
				'if proj = 0 then PhasePlayer_Missiles_CheckImpact @gen->projectile[proj]
				
				glBegin GL_TRIANGLES
					glColor3f 1, 1, 1
					for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
						for vert = 1 to 3
							pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
							glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
							glNormal3fv @gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x
							glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
						next
					next
				glEnd
				#ifdef 0
				glBegin GL_LINES
					glColor3f 1, 1, 1
					for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
						for vert = 1 to 3
							pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
							glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
							glVertex3f gen->projectile[proj].mesh.vertices[pointid].x + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x, _
								gen->projectile[proj].mesh.vertices[pointid].y + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).y, _
								gen->projectile[proj].mesh.vertices[pointid].z + gen->projectile[proj].mesh.triangles[tri].vnormal(vert).z
						next
					next
				glEnd
				#endif
			glPopMatrix
		end if
	next
	
	
end sub


sub PhasePlayer_Render_Scene_Hex_Tunnel (gen as GeneratorClassType ptr)

	
	dim as single length, innerRadius, outterRadius
	dim as integer proj, vert, tri, pointid
	dim as rgbalpha c0
	
	
	glEnable GL_TEXTURE_2D
	glBindTexture GL_TEXTURE_2D, PhasePlayerGlobals.chromeTex
	
	for proj = 0 to gen->nProjectiles - 1
	
		if gen->projectile[proj].active = 1 then
	
			glPushMatrix
				Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
				PhasePlayer_Render_Scene_Align_Projectile gen, @gen->projectile[proj]
				glLoadMatrixf @gen->projectile[proj].matrix(0)
				
				glBegin GL_TRIANGLES
					for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
						for vert = 1 to 3
							pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
							glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
							glTexCoord2f gen->projectile[proj].mesh.triangles[tri].uv(vert).u + gen->textureScroll, gen->projectile[proj].mesh.triangles[tri].uv(vert).v + gen->textureScroll / 10
							glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
						next
					next
				glEnd
				
			glPopMatrix
		end if
	next
	
	glDisable GL_TEXTURE_2D

end sub


sub PhasePlayer_Render_Scene_Meta_Ball_Cloud (gen as GeneratorClassType ptr)

	
	dim as integer proj, vert, tri, pointid
	dim as integer nSlices, g
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	'glDisable GL_DEPTH_TEST
	

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.z, 0, 0, 1
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.x, 1, 0, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
				
				't/r to camera coordinates
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				
				
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			nSlices = 24
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, .7
					glVertex2f 0, 0
					
					an0 = 360 * g / nSlices
					an1 = an0 + 360 / nSlices
					radius = gen->cloudSize
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
			nSlices = 8
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, .7
					glVertex2f 0, 0
					
					an0 = rnd * 360
					an1 = an0 + rnd * 90
					radius = gen->cloudSize
					radius += rnd * radius
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
		glPopMatrix
	next
	
	glDepthMask GL_TRUE
	'glEnable GL_DEPTH_TEST
	

end sub


sub PhasePlayer_Render_Scene_Meta_Ball_Disc (gen as GeneratorClassType ptr)

	dim as integer proj, vert, tri, pointid
	
	dim as integer nSlices, g
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	

	for proj = 0 to gen->nProjectiles - 1
	
		glPushMatrix
			Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
			
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.z, 0, 0, 1
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), -gen->preAngularVelocityAngle.x, 1, 0, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
				
				Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
				
				't/r to camera coordinates
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
				
				Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
				
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
				Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
				
			
			glLoadMatrixf @gen->projectile[proj].matrix(0)
			
			nSlices = 12
		
			glBegin GL_TRIANGLES
				for g = 0 to nSlices - 1
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, .7
					glVertex2f 0, 0
					
					an0 = 360 * g / nSlices
					an1 = an0 + 360 / nSlices
					radius = gen->cloudSize
					
					glColor4f gen->projectile[proj].mesh.triangles[0].color(1).r, gen->projectile[proj].mesh.triangles[0].color(1).g, gen->projectile[proj].mesh.triangles[0].color(1).b, 0
					
					glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
					glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
				next
			glEnd
			
			
		glPopMatrix
	next
	
	glDepthMask GL_TRUE
	

end sub



sub PhasePlayer_Render_Scene_Spawn_BossDragon (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)

	dim as integer proj, vert, tri, pointid, g
	dim as GeneratorClassType ptr gen
	
	for g = 0 to spawn->nGenerators - 1
		gen = @spawn->generator[g]
		
		for proj = 0 to gen->nProjectiles - 1
		
			if gen->projectile[proj].active = 1 then
		
				glPushMatrix
					Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
					PhasePlayer_Render_Scene_Align_Projectile gen, @gen->projectile[proj]
					glLoadMatrixf @gen->projectile[proj].matrix(0)
					
					'if proj = 0 then PhasePlayer_Missiles_CheckImpact @gen->projectile[proj]
					
					glBegin GL_TRIANGLES
						glColor3f 1, 1, 1
						for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
							for vert = 1 to 3
								pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
								glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
								glNormal3fv @gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x
								glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
							next
						next
					glEnd
					
				glPopMatrix
			end if
		next
	next
	
	dim as single matrix(16)
	dim as integer nSlices
	dim as single an0, an1, radius, sRadius
	dim as rgbalpha c0
	
	glDepthMask GL_FALSE
	
	if spawn->active = 1 then
	
		Matrix_LoadIdentity @matrix(0)
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		
		Matrix_Translate @matrix(0), spawn->position.x, spawn->position.y, spawn->position.z
		
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		
		Matrix_Translate @matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
		
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		
		glLoadMatrixf @matrix(0)
		
		nSlices = 8
		sRadius = .7
		if spawn->spawnIndex = 0 then sRadius = 1.4
		sRadius += sRadius * spawn->pulse
		
		c0.r = 1
		c0.g = 1 * spawn->pulse
		c0.b = .25 * spawn->pulse
		
		glBegin GL_TRIANGLES
			for g = 0 to nSlices - 1
				
				c0.a = 1
				glColor4fv @c0.r
				if wave->shield_on = 1 then glColor4f 0, 0, 1, 1
				glVertex2f 0, 0
				
				an0 = rnd * 360
				an1 = an0 + rnd * 90
				radius = sRadius
				radius += rnd * radius
				
				c0.a = 0
				glColor4fv @c0.r
				if wave->shield_on = 1 then glColor4f 1, 1, 1, 0
				
				glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
				glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
			next
		glEnd
		
	end if
	
	glDepthMask GL_TRUE
	

end sub


sub PhasePlayer_Render_Scene_Spawn_Flies (spawn as WaveSpawnType ptr)

	dim as integer proj, vert, tri, pointid, g
	dim as GeneratorClassType ptr gen
	
	for g = 0 to spawn->nGenerators - 1
		gen = @spawn->generator[g]
		
		for proj = 0 to gen->nProjectiles - 1
		
			if gen->projectile[proj].active = 1 then
		
				glPushMatrix
					Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
					PhasePlayer_Render_Scene_Align_Projectile gen, @gen->projectile[proj]
					glLoadMatrixf @gen->projectile[proj].matrix(0)
					
					'if proj = 0 then PhasePlayer_Missiles_CheckImpact @gen->projectile[proj]
					
					glBegin GL_TRIANGLES
						glColor3f 1, 1, 1
						for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
							for vert = 1 to 3
								pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
								glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
								glNormal3fv @gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x
								glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
							next
						next
					glEnd
					
				glPopMatrix
			end if
		next
	next
	
	dim as single matrix(16)
	dim as integer nSlices
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	
	if spawn->active = 1 then
	
		Matrix_LoadIdentity @matrix(0)
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		
		Matrix_Translate @matrix(0), spawn->position.x, spawn->position.y, spawn->position.z
		
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		
		Matrix_Translate @matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
		
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		
		glLoadMatrixf @matrix(0)
		
		nSlices = 8
		
		glBegin GL_TRIANGLES
			for g = 0 to nSlices - 1
				
				glColor4f 1, 0, 0, 1
				glVertex2f 0, 0
				
				an0 = rnd * 360
				an1 = an0 + rnd * 90
				radius = .25
				radius += rnd * radius
				
				glColor4f 1, 0, 0, 0
				
				glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
				glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
			next
		glEnd
		
		'--- target box
		
		'glColor4f 1, 0, 0, .5
		'glBegin GL_LINES
			
		
	end if
	
	glDepthMask GL_TRUE
	

end sub



sub PhasePlayer_Render_Scene_Bullet_TypeI (bullet as BulletType ptr)

	dim as integer proj, vert, tri, pointid, g
	dim as GeneratorClassType ptr gen
	
	for g = 0 to bullet->nGenerators - 1
		gen = @bullet->generator[g]
		
		for proj = 0 to gen->nProjectiles - 1
		
			if gen->projectile[proj].active = 1 then
		

				Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
				PhasePlayer_Render_Scene_Align_Projectile gen, @gen->projectile[proj]
				glLoadMatrixf @gen->projectile[proj].matrix(0)
				
				glBegin GL_TRIANGLES
					glColor3f 1, 1, 1
					for tri = 0 to gen->projectile[proj].mesh.max_triangles - 1
						for vert = 1 to 3
							pointid = gen->projectile[proj].mesh.triangles[tri].point_id(vert)
							glColor4fv @gen->projectile[proj].mesh.triangles[tri].color(vert).r
							glNormal3fv @gen->projectile[proj].mesh.triangles[tri].vnormal(vert).x
							glVertex3fv @gen->projectile[proj].mesh.vertices[pointid].x
						next
					next
				glEnd
					
				
			end if
		next
	next
	
	dim as single matrix(16)
	dim as integer nSlices
	dim as single an0, an1, radius
	
	glDepthMask GL_FALSE
	if bullet->active = 1 then
	
		Matrix_LoadIdentity @matrix(0)
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		Matrix_Rotate @matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		Matrix_Rotate @matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		
		Matrix_Translate @matrix(0), bullet->position.x, bullet->position.y, bullet->position.z
		
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		Matrix_Rotate @matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		
		Matrix_Translate @matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
		
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		Matrix_Rotate @matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		
		glLoadMatrixf @matrix(0)
		
		nSlices = 8
		
		glBegin GL_TRIANGLES
			for g = 0 to nSlices - 1
				
				glColor4f 1, 0, 0, 1
				glVertex2f 0, 0
				
				an0 = rnd * 360
				an1 = an0 + rnd * 90
				radius = .1
				radius += rnd * radius
				
				glColor4f 1, 0, 0, 0
				
				glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
				glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
			next
		glEnd
		
	end if
	
	glDepthMask GL_TRUE
	
	
end sub


sub PhasePlayer_Render_Scene_Explosion_Normal (explosion as ExplosionType ptr)

	dim as integer proj, vert, tri, pointid, g
	dim as GeneratorClassType ptr gen
	
	dim as integer nSlices, i
	dim as single an0, an1, radius0, radius1, a0
	
	dim as single colorOfs0, colorOfs1
	dim as single curTime, startTime, duration, timeIndex
	dim as vector3D colorCenter
	dim as rgbalpha c0, c1, c2
	
	curTime = system_time
	
	glDepthMask GL_FALSE
	
	dim as integer active
	
	active = 0
	for g = explosion->nGenerators - 1 to 0 step -1
		gen = @explosion->generator[g]
		
		for proj = 0 to gen->nProjectiles - 1
			
			if gen->projectile[proj].active = 1 then
			
				active = 1
			
				'--- blast rings
				if g > 0 then
					startTime = explosion->blastRing[g-1].startTime
					duration = explosion->blastRing[g-1].duration
					
					if startTime <= curTime then
						glDisable GL_CULL_FACE
					
						nSlices = 64
						
						c0.r = 1
						c0.g = 1
						c0.b = 0
						c0.r = 1
						
						c1.r = 1
						c1.g = 0
						c1.b = 0
						c1.a = 0
						
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.z, 0, 0, 1
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								a0 = 1
								radius0 = timeIndex / 5
								if timeIndex <= 1 then a0 = timeIndex
								if timeIndex > 1 and timeIndex < 5 then a0 = 1 - (timeIndex - 1) / 4
								if timeIndex >= 5 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
								
								a0 *= a0
									
								radius0 *= explosion->blastRing[g-1].radius
								radius1 = radius0 + radius0 * .3
								
								
								'-- outter ring
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								glColor4fv @c1.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an0), radius1 * sin(3.1415 / 180 * an0)
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								glColor4fv @c1.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								
							next
						glEnd
						glEnable GL_CULL_FACE
						
					end if
				end if
				
				'--- meta balls
				if g = 0 then
					startTime = explosion->metaBall[proj].startTime
					duration = explosion->metaBall[proj].duration
					
					if startTime <= curTime then
					
						'--- pass 0
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x / 3, gen->projectile[proj].position.y / 3, gen->projectile[proj].position.z / 3
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						nSlices = 32
						
						c0.r = 1
						c0.g = 1
						c0.b = 0
						
						c1.r = 1
						c1.g = 0
						c1.b = 0
						
						c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
						c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
						c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								colorOfs0 = i * 2 / nSlices
								colorOfs1 = colorOfs0 + 2 / nSlices
								
								a0 = 1
								radius0 = .5
								if timeIndex <= 1 then
									radius0 *= timeIndex
									a0 = timeIndex
								end if
								if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
								if timeIndex >= 6 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
									
								radius0 *= explosion->metaBall[proj].radius * 3
								radius1 = radius0 + .15
								
								colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
								colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
								
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f colorCenter.x, colorCenter.y
								
								if colorOfs0 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs0
									c2.g = c0.g + (c1.g - c0.g) * colorOfs0
									c2.b = c0.b + (c1.b - c0.b) * colorOfs0
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
								end if
									
								c2.a = 0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								if colorOfs1 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs1
									c2.g = c0.g + (c1.g - c0.g) * colorOfs1
									c2.b = c0.b + (c1.b - c0.b) * colorOfs1
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
								end if
								c2.a = 0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								
								
							next
						glEnd
						
						
						'--- pass 1
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						nSlices = 32
						
						c0.r = 1
						c0.g = 1
						c0.b = 0
						
						c1.r = 1
						c1.g = 0
						c1.b = 0
						
						c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
						c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
						c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								colorOfs0 = i * 2 / nSlices
								colorOfs1 = colorOfs0 + 2 / nSlices
								
								a0 = 1
								radius0 = .5
								if timeIndex <= 1 then
									radius0 *= timeIndex
									a0 = timeIndex
								end if
								if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
								if timeIndex >= 6 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
									
								radius0 *= explosion->metaBall[proj].radius
								radius1 = radius0 + .15
								
								colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
								colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
								
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f colorCenter.x, colorCenter.y
								
								if colorOfs0 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs0
									c2.g = c0.g + (c1.g - c0.g) * colorOfs0
									c2.b = c0.b + (c1.b - c0.b) * colorOfs0
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
								end if
									
								c2.a = a0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								if colorOfs1 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs1
									c2.g = c0.g + (c1.g - c0.g) * colorOfs1
									c2.b = c0.b + (c1.b - c0.b) * colorOfs1
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
								end if
								c2.a = a0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								
								
								'-- outter ring
								c0.a = 0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								c0.a = 0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an0), radius1 * sin(3.1415 / 180 * an0)
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								
							next
						glEnd
						
						
						if proj < 25 then
							'--- pass 2
							Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
								
								Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x / 3, gen->projectile[proj].position.y / 3, gen->projectile[proj].position.z / 3
								Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
								
								Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
								
							glLoadMatrixf @gen->projectile[proj].matrix(0)
							
							nSlices = 32
							
							c0.r = 1
							c0.g = 1
							c0.b = 0
							
							c1.r = 1
							c1.g = 0
							c1.b = 0
							
							c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
							c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
							c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
							
							glBegin GL_TRIANGLES
								for i = 0 to nSlices - 1
									
									an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
									an1 = an0 + 360 / nSlices
									
									timeIndex = (curTime - startTime) * 5 / duration
									
									colorOfs0 = i * 2 / nSlices
									colorOfs1 = colorOfs0 + 2 / nSlices
									
									a0 = 1
									radius0 = .5
									if timeIndex <= 1 then
										radius0 *= timeIndex
										a0 = timeIndex
									end if
									if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
									if timeIndex >= 6 then
										gen->projectile[proj].active = 0
										a0 = 0
									end if
										
									a0 *= .1
									radius0 *= explosion->metaBall[proj].radius * 30
									radius1 = radius0 + .15
									
									colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
									colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
									
									c0.a = a0
									glColor4fv @c0.r
									glVertex2f colorCenter.x, colorCenter.y
									
									if colorOfs0 <= 1 then
										c2.r = c0.r + (c1.r - c0.r) * colorOfs0
										c2.g = c0.g + (c1.g - c0.g) * colorOfs0
										c2.b = c0.b + (c1.b - c0.b) * colorOfs0
									else
										c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
										c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
										c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
									end if
										
									c2.a = 0
									glColor4fv @c2.r
									glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
									
									if colorOfs1 <= 1 then
										c2.r = c0.r + (c1.r - c0.r) * colorOfs1
										c2.g = c0.g + (c1.g - c0.g) * colorOfs1
										c2.b = c0.b + (c1.b - c0.b) * colorOfs1
									else
										c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
										c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
										c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
									end if
									c2.a = 0
									glColor4fv @c2.r
									glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
									
									
								next
							glEnd
						
						end if
						
						
					end if
					
				end if
				
			end if
		next
	next
	
	glDepthMask GL_TRUE
	
	if active = 0 then explosion->active = 0
	
end sub



sub PhasePlayer_Render_Scene_Explosion_Small (explosion as ExplosionType ptr)

	dim as integer proj, vert, tri, pointid, g
	dim as GeneratorClassType ptr gen
	
	dim as integer nSlices, i
	dim as single an0, an1, radius0, radius1, a0
	
	dim as single colorOfs0, colorOfs1
	dim as single curTime, startTime, duration, timeIndex
	dim as vector3D colorCenter
	dim as rgbalpha c0, c1, c2
	
	curTime = system_time
	
	glDepthMask GL_FALSE
	
	dim as integer active
	
	active = 0
	for g = explosion->nGenerators - 1 to 0 step -1
		gen = @explosion->generator[g]
		
		for proj = 0 to gen->nProjectiles - 1
			
			if gen->projectile[proj].active = 1 then
			
				active = 1
			
				'--- blast rings
				if g > 0 then
					startTime = explosion->blastRing[g-1].startTime
					duration = explosion->blastRing[g-1].duration
					
					if startTime <= curTime then
						glDisable GL_CULL_FACE
					
						nSlices = 64
						
						c0.r = 1
						c0.g = 0
						c0.b = 0
						c0.r = 1
						
						c1.r = 0
						c1.g = 0
						c1.b = 1
						c1.a = 0
						
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), gen->angle.z, 0, 0, 1
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								a0 = 1
								radius0 = timeIndex / 5
								if timeIndex <= 1 then a0 = timeIndex
								if timeIndex > 1 and timeIndex < 5 then a0 = 1 - (timeIndex - 1) / 4
								if timeIndex >= 5 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
									
								a0 *= a0
								
								radius0 *= explosion->blastRing[g-1].radius
								radius1 = radius0 + radius0 * .3
								
								
								'-- outter ring
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								glColor4fv @c1.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an0), radius1 * sin(3.1415 / 180 * an0)
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								glColor4fv @c1.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								
							next
						glEnd
						glEnable GL_CULL_FACE
						
					end if
				end if
				
				'--- meta balls
				if g = 0 then
					startTime = explosion->metaBall[proj].startTime
					duration = explosion->metaBall[proj].duration
					
					if startTime <= curTime then
					
						'--- pass 0
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x / 3, gen->projectile[proj].position.y / 3, gen->projectile[proj].position.z / 3
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						nSlices = 32
						
						c0.r = 1
						c0.g = 0
						c0.b = 0
						
						c1.r = 1
						c1.g = 0
						c1.b = 0
						
						c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
						c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
						c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								colorOfs0 = i * 2 / nSlices
								colorOfs1 = colorOfs0 + 2 / nSlices
								
								a0 = 1
								radius0 = .5
								if timeIndex <= 1 then
									radius0 *= timeIndex
									a0 = timeIndex
								end if
								if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
								if timeIndex >= 6 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
									
								radius0 *= explosion->metaBall[proj].radius * 3
								radius1 = radius0 + .15
								
								colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
								colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
								
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f colorCenter.x, colorCenter.y
								
								if colorOfs0 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs0
									c2.g = c0.g + (c1.g - c0.g) * colorOfs0
									c2.b = c0.b + (c1.b - c0.b) * colorOfs0
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
								end if
									
								c2.a = 0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								if colorOfs1 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs1
									c2.g = c0.g + (c1.g - c0.g) * colorOfs1
									c2.b = c0.b + (c1.b - c0.b) * colorOfs1
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
								end if
								c2.a = 0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								
								
							next
						glEnd
						
						
						'--- pass 1
						Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x, gen->projectile[proj].position.y, gen->projectile[proj].position.z
							
							Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
							
							Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
							
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
							Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
							
						glLoadMatrixf @gen->projectile[proj].matrix(0)
						
						nSlices = 32
						
						c0.r = 1
						c0.g = 0
						c0.b = 0
						
						c1.r = 0
						c1.g = 0
						c1.b = 1
						
						c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
						c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
						c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
						
						glBegin GL_TRIANGLES
							for i = 0 to nSlices - 1
								
								an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
								an1 = an0 + 360 / nSlices
								
								timeIndex = (curTime - startTime) * 5 / duration
								
								colorOfs0 = i * 2 / nSlices
								colorOfs1 = colorOfs0 + 2 / nSlices
								
								a0 = 1
								radius0 = .5
								if timeIndex <= 1 then
									radius0 *= timeIndex
									a0 = timeIndex
								end if
								if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
								if timeIndex >= 6 then
									gen->projectile[proj].active = 0
									a0 = 0
								end if
									
								radius0 *= explosion->metaBall[proj].radius
								radius1 = radius0 + .15
								
								colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
								colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
								
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f colorCenter.x, colorCenter.y
								
								if colorOfs0 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs0
									c2.g = c0.g + (c1.g - c0.g) * colorOfs0
									c2.b = c0.b + (c1.b - c0.b) * colorOfs0
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
								end if
									
								c2.a = a0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								if colorOfs1 <= 1 then
									c2.r = c0.r + (c1.r - c0.r) * colorOfs1
									c2.g = c0.g + (c1.g - c0.g) * colorOfs1
									c2.b = c0.b + (c1.b - c0.b) * colorOfs1
								else
									c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
									c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
									c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
								end if
								c2.a = a0
								glColor4fv @c2.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								
								
								'-- outter ring
								c0.a = 0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								c0.a = 0
								glColor4fv @c0.r
								glVertex2f radius1 * cos(3.1415 / 180 * an0), radius1 * sin(3.1415 / 180 * an0)
								glVertex2f radius1 * cos(3.1415 / 180 * an1), radius1 * sin(3.1415 / 180 * an1)
								c0.a = a0
								glColor4fv @c0.r
								glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
								
								
							next
						glEnd
						
						
						if proj < 10 then
							'--- pass 2
							Matrix_LoadIdentity @gen->projectile[proj].matrix(0)
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
								
								Matrix_Translate @gen->projectile[proj].matrix(0), gen->projectile[proj].position.x / 3, gen->projectile[proj].position.y / 3, gen->projectile[proj].position.z / 3
								Matrix_Translate @gen->projectile[proj].matrix(0), gen->position.x, gen->position.y, gen->position.z
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
								
								Matrix_Translate @gen->projectile[proj].matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
								
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
								Matrix_Rotate @gen->projectile[proj].matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
								
							glLoadMatrixf @gen->projectile[proj].matrix(0)
							
							nSlices = 32
							
							c0.r = 1
							c0.g = 0
							c0.b = 0
							
							c1.r = 1
							c1.g = 0
							c1.b = 0
							
							c1.r = c1.r + (c0.r - c1.r) * explosion->metaBall[proj].baseColorOffset
							c1.g = c1.g + (c0.g - c1.g) * explosion->metaBall[proj].baseColorOffset
							c1.b = c1.b + (c0.b - c1.b) * explosion->metaBall[proj].baseColorOffset
							
							glBegin GL_TRIANGLES
								for i = 0 to nSlices - 1
									
									an0 = (i / nSlices) * 360 + explosion->metaBall[proj].angle
									an1 = an0 + 360 / nSlices
									
									timeIndex = (curTime - startTime) * 5 / duration
									
									colorOfs0 = i * 2 / nSlices
									colorOfs1 = colorOfs0 + 2 / nSlices
									
									a0 = 1
									radius0 = .5
									if timeIndex <= 1 then
										radius0 *= timeIndex
										a0 = timeIndex
									end if
									if timeIndex > 4 and timeIndex < 6 then a0 = 1 - (timeIndex - 4) / 2
									if timeIndex >= 6 then
										gen->projectile[proj].active = 0
										a0 = 0
									end if
										
									a0 *= .1
									radius0 *= explosion->metaBall[proj].radius * 30
									radius1 = radius0 + .15
									
									colorCenter.x = explosion->metaBall[proj].colorCenter.x * radius0
									colorCenter.y = explosion->metaBall[proj].colorCenter.y * radius0
									
									c0.a = a0
									glColor4fv @c0.r
									glVertex2f colorCenter.x, colorCenter.y
									
									if colorOfs0 <= 1 then
										c2.r = c0.r + (c1.r - c0.r) * colorOfs0
										c2.g = c0.g + (c1.g - c0.g) * colorOfs0
										c2.b = c0.b + (c1.b - c0.b) * colorOfs0
									else
										c2.r = c1.r + (c0.r - c1.r) * (colorOfs0 - 1)
										c2.g = c1.g + (c0.g - c1.g) * (colorOfs0 - 1)
										c2.b = c1.b + (c0.b - c1.b) * (colorOfs0 - 1)
									end if
										
									c2.a = 0
									glColor4fv @c2.r
									glVertex2f radius0 * cos(3.1415 / 180 * an0), radius0 * sin(3.1415 / 180 * an0)
									
									if colorOfs1 <= 1 then
										c2.r = c0.r + (c1.r - c0.r) * colorOfs1
										c2.g = c0.g + (c1.g - c0.g) * colorOfs1
										c2.b = c0.b + (c1.b - c0.b) * colorOfs1
									else
										c2.r = c1.r + (c0.r - c1.r) * (colorOfs1 - 1)
										c2.g = c1.g + (c0.g - c1.g) * (colorOfs1 - 1)
										c2.b = c1.b + (c0.b - c1.b) * (colorOfs1 - 1)
									end if
									c2.a = 0
									glColor4fv @c2.r
									glVertex2f radius0 * cos(3.1415 / 180 * an1), radius0 * sin(3.1415 / 180 * an1)
									
									
								next
							glEnd
						end if
						
					end if
					
				end if
				
			end if
		next
	next
	
	glDepthMask GL_TRUE
	
	if active = 0 then explosion->active = 0
	
end sub


sub PhasePlayer_Render_Scene_PowerUp ()

	dim as integer g, nSlices
	
	dim as single an0, an1, radius
	glDepthMask GL_FALSE
	
	if PhasePlayerGlobals.powerUp.active = 1 then
	
		Matrix_LoadIdentity @PhasePlayerGlobals.powerUp.matrix(0)
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), -PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), -PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), -PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		
		Matrix_Translate @PhasePlayerGlobals.powerUp.matrix(0), PhasePlayerGlobals.powerUp.position.x, PhasePlayerGlobals.powerUp.position.y, PhasePlayerGlobals.powerUp.position.z
		
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
		
		Matrix_Translate @PhasePlayerGlobals.powerUp.matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
		
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
		Matrix_Rotate @PhasePlayerGlobals.powerUp.matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
		
		glLoadMatrixf @PhasePlayerGlobals.powerUp.matrix(0)
		
		nSlices = 8
		
		glBegin GL_TRIANGLES
			for g = 0 to nSlices - 1
				
				glColor4f 0, 1, 1, 1
				glVertex2f 0, 0
				
				an0 = rnd * 360
				an1 = an0 + rnd * 90
				radius = .3
				radius += rnd * radius
				
				glColor4f 0, 0, 1, 0
				
				glVertex2f radius * cos(3.1415 / 180 * an0), radius * sin(3.1415 / 180 * an0)
				glVertex2f radius * cos(3.1415 / 180 * an1), radius * sin(3.1415 / 180 * an1)
			next
		glEnd
		
	end if
	
	glDepthMask GL_TRUE
	
	
end sub



sub PhasePlayer_Render_Scene_Align_Projectile (byref gen as GeneratorClassType ptr, byval proj as GenProjectileType ptr)
	
	PhasePlayer_Render_Scene_Align_Projectile_No_Camera gen, proj
	
	if gen->class = GC_BLOCK_TORUS or gen->class = GC_HEX_TUNNEL then PhasePlayer_Missiles_CheckImpact_Proj proj
	
	't/r to camera coordinates
	if PhaseDataGlobals.phaseSequence.generator[0].angle.x <> 0 then Matrix_Rotate @proj->matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.x, 1, 0, 0
	if PhaseDataGlobals.phaseSequence.generator[0].angle.y <> 0 then Matrix_Rotate @proj->matrix(0), PhaseDataGlobals.phaseSequence.generator[0].angle.y, 0, 1, 0
	
	Matrix_Translate @proj->matrix(0), 0, 0, -PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	Matrix_Rotate @proj->matrix(0), PhasePlayerGlobals.cameraAngle.x, 0, 1, 0
	Matrix_Rotate @proj->matrix(0), PhasePlayerGlobals.cameraAngle.y, 1, 0, 0
	
end sub



sub PhasePlayer_Render_Scene_Align_Projectile_No_Camera (byref gen as GeneratorClassType ptr, byval proj as GenProjectileType ptr)

	
	Matrix_Rotate @proj->matrix(0), proj->angle.z, 0, 0, 1
	Matrix_Rotate @proj->matrix(0), proj->angle.x, 1, 0, 0
	Matrix_Rotate @proj->matrix(0), proj->angle.y, 0, 1, 0
	Matrix_Translate @proj->matrix(0), proj->position.x, proj->position.y, proj->position.z
	
	if proj->lock = 0 then
		if gen->preAngularVelocityAngle.x <> 0 then Matrix_Rotate @proj->matrix(0), gen->preAngularVelocityAngle.x, 1, 0, 0
		if gen->preAngularVelocityAngle.y <> 0 then Matrix_Rotate @proj->matrix(0), gen->preAngularVelocityAngle.y, 0, 1, 0
		if gen->preAngularVelocityAngle.z <> 0 then Matrix_Rotate @proj->matrix(0), gen->preAngularVelocityAngle.z, 0, 0, 1
		
		if gen->angle.x <> 0 then Matrix_Rotate @proj->matrix(0), gen->angle.x, 1, 0, 0
		if gen->angle.y <> 0 then Matrix_Rotate @proj->matrix(0), gen->angle.y, 0, 1, 0
		if gen->angle.z <> 0 then Matrix_Rotate @proj->matrix(0), gen->angle.z, 0, 0, 1
		
		Matrix_Translate @proj->matrix(0), gen->position.x, gen->position.y, gen->position.z
	end if
	
end sub