


sub PhasePlayer_Waves_CheckFire (curTime as single, wave as WaveClassType ptr, spawn as WaveSpawnType ptr)

	dim as single lastFire, nextFire
	
	lastFire = spawn->lastFire
	nextFire = lastFire + 60 / wave->rateOfFire
	
	dim as vector3d accel
	
	dim as integer i
	
	if nextFire < curTime then
	
		if wave->bulletPattern = BP_ONE_SHOT then
			PhasePlayer_Bullets_Add 0, wave->bulletClass, wave->bulletPattern, spawn->position, 1
		elseif wave->bulletPattern = BP_BOMB then
			for i = 0 to 50
				PhasePlayer_Bullets_Add 0, wave->bulletClass, wave->bulletPattern, spawn->position, 1
			next
		elseif wave->bulletPattern = BP_MULT_SHOT_AND_BOMB then
			if wave->class = WC_BOSS_DRAGON then
				if spawn->spawnIndex = 0 then
					if wave->nextbomb < curTime then
						for i = 0 to 50
							PhasePlayer_Bullets_Add 0, wave->bulletClass, BP_BOMB, spawn->position, 1
						next
						wave->nextBomb = curTime + 30
					end if
					
					for i = 0 to 2
						PhasePlayer_Bullets_Add 0, wave->bulletClass, BP_ONE_SHOT, spawn->position, 1
					next
				end if
			end if
		end if
		
		spawn->lastFire = curTime
		
	end if


end sub



sub PhasePlayer_Waves_Subtract_StartTime (waveNum as integer , curTime as single)

	dim as integer a, b
	dim as single timeDelta
	
	timeDelta = PhaseDataGlobals.phaseSequence.wave[waveNum].startTime + PhaseDataGlobals.phaseSequence.startTime + 1 - curTime
	
	for a = waveNum to PhaseDataGlobals.phaseSequence.nWaves - 1
	
		PhaseDataGlobals.phaseSequence.wave[a].startTime -= timeDelta
		
		for b = 0 to PhaseDataGlobals.phaseSequence.wave[a].nSpawn - 1
			PhaseDataGlobals.phaseSequence.wave[a].spawn[b].spawnTime = -1
		next
		
	next


end sub



sub PhasePlayer_Waves_Upd_Waves ()

	dim as single curTime, spawnTime, d, spawnTimeOffset
	dim as integer a, b, nSpawn, nWaves, pattern
	dim as WaveSpawnType ptr spawn
	dim as WaveClassType ptr wave
	dim as vector3d positionR
	
	curTime = system_time
	
	nWaves = PhaseDataGlobals.phaseSequence.nWaves
	
		
	dim as integer enableNextSpawn, enableNextSpawnWave, enableNextTime
	enableNextSpawn = -1
	enableNextTime = system_time
	
	
	'---- activate spawns if available
	for a = 0 to nWaves - 1
	
		wave = @PhaseDataGlobals.phaseSequence.wave[a]
		
		wave->nActive = 0
		
		nSpawn = PhaseDataGlobals.phaseSequence.wave[a].nSpawn
		for b = 0 to nSpawn - 1
		
			spawn = @PhaseDataGlobals.phaseSequence.wave[a].spawn[b]
			
			if spawn->spawnTime = -1 then
				spawnTimeOffset = wave->time / wave->nSpawn
				spawn->spawnTime = wave->startTime + spawnTimeOffset * b + PhaseDataGlobals.phaseSequence.startTime
				
				if wave->class =  WC_BOSS_DRAGON then
					spawnTimeOffset = .1
					spawn->spawnTime = wave->startTime + spawnTimeOffset * b + PhaseDataGlobals.phaseSequence.startTime
					wave->shield_on = 1
					wave->shield_wait_len = 10 * 1000
					wave->shield_ticks = system_ticks + wave->shield_wait_len
					
				end if
			end if
			
			if spawn->active = 0 then
			
				if enableNextSpawn = b and enableNextSpawnWave = a then
					if spawn->spawnTime > enableNextTime then
						spawn->active = 1
						enableNextSpawn = 0
					end if
				end if
	
				spawnTime = spawn->spawnTime
				if spawnTime < curTime then
					spawn->active = 1
					spawn->lastFire = curTime - rnd * (60 / wave->rateOfFire)
					
					if spawn->spawnIndex = 0 then
						PhaseMenuGlobals.waveFade = 1
						PhaseMenuGlobals.waveNumber = a
					end if
					
					if wave->class = WC_BOSS_DRAGON and b = 0 then
						PhaseDataGlobals.phaseSequence.bossActive = 1
						PhaseDataGlobals.phaseSequence.bossWave = a
						wave->nextBomb = curTime + 30
					end if
				end if
			
			elseif spawn->active = 1 then
			
				wave->nActive += 1
				if spawn->spawnTime > curTime then
					spawn->spawnTime = curTime
					spawn->lastFire = curTime - rnd * (60 / wave->rateOfFire)
				end if
			
				'---- perform updates on active spawn
				pattern = wave->pattern
				
				if pattern = WP_ORBITAL then PhasePlayer_Waves_Upd_Wave_Orbital wave, spawn
				if pattern = WP_TYPE_I then PhasePlayer_Waves_Upd_Wave_Type_I wave, spawn
				if pattern = WP_ORBITAL_TYPE_II then PhasePlayer_Waves_Upd_Wave_Orbital_Type_II wave, spawn
				
				PhasePlayer_Projectiles_Upd_Spawn_Projectiles spawn
				PhasePlayer_Missiles_CheckImpact_Spawn spawn
				
				d = sqr(spawn->position.x * spawn->position.x + spawn->position.y * spawn->position.y + spawn->position.z * spawn->position.z)
				
				if d < PhaseDataGlobals.phaseSequence.generator[0].position.z then PhasePlayer_Waves_CheckFire curTime, wave, spawn
				if d > 35 then
					spawn->active = 3
					enableNextSpawn = b + 1
					enableNextSpawnWave = a
				end if
				
				spawn->shield_on = 0
				spawn->pulse -= .05 * fpsr
				if spawn->pulse < 0 then spawn->pulse = 0
			
			elseif spawn->active = 2 then	'dead but still displaying
				
				PhasePlayer_Projectiles_Upd_Spawn_Projectiles spawn
				
			end if
			
		next
		
		if wave->class = WC_BOSS_DRAGON then
			wave->radius += .695 * system_ticksPassed / 1000
			if wave->nActive > 1 then wave->spawn[0].shield_on = 1
			if wave->nActive > 2 then wave->spawn[1].shield_on = 1
			if wave->nActive > 3 then wave->spawn[34].shield_on = 1
		end if
		
	next
	
	a = 0
	b = 0
	do
		if a < PhaseDataGlobals.phaseSequence.nWaves - 1 then
			if PhaseDataGlobals.phaseSequence.wave[a].startTime + PhaseDataGlobals.phaseSequence.startTime + 5 < curTime then
				if PhaseDataGlobals.phaseSequence.wave[a].nActive = 0 then
					if PhaseDataGlobals.phaseSequence.wave[a+1].startTime + PhaseDataGlobals.phaseSequence.startTime > curTime then
						PhasePlayer_Waves_Subtract_StartTime a+1, curTime
						exit do
					end if
					a += 1
				end if
			end if
		end if
		b+=1
		if b = PhaseDataGlobals.phaseSequence.nWaves then exit do
	loop
	
	
	dim as integer anyActive
	
	anyActive = 0
	'---- activate spawns if available
	for a = 0 to nWaves - 1
	
		wave = @PhaseDataGlobals.phaseSequence.wave[a]
		nSpawn = PhaseDataGlobals.phaseSequence.wave[a].nSpawn
		for b = 0 to nSpawn - 1
			if wave->spawn[b].active < 2 then anyActive = 1
		next
	next
		
		
	if anyActive = 0 and PhasePlayerGlobals.player.gameOverExplosionTime < system_time then
	
		PhasePlayerGlobals.player.gameOverExplosionTime = system_time + .5
		
		positionR.x = rnd * 1 - .5
		positionR.y = rnd * 1 - .5
		positionR.z = rnd * 1 - .5
		
		math_normalize3f positionR
		
		positionR.x *= PhaseDataGlobals.phaseSequence.generator[0].position.z / 4
		positionR.y *= PhaseDataGlobals.phaseSequence.generator[0].position.z / 4
		positionR.z *= PhaseDataGlobals.phaseSequence.generator[0].position.z / 4
		
		PhasePlayer_Explosions_New positionR, EC_NORMAL
		
	end if
	
	if anyActive = 0 and PhasePlayerGlobals.player.gameOver = 0 then
		PhasePlayerGlobals.player.gameOver = 3
		PhasePlayerGlobals.player.gameOverFadeBlackTime = system_time + 10
		io_clock_stop PhasePlayerGlobals.missionClock
	end if

end sub


sub PhasePlayer_Waves_Upd_Wave_Orbital (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)

	dim as single zofs, vSpeed
	dim as vector3d delta

	zofs = 50 / PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	spawn->angle.y += (system_ticksPassed / 1000) * wave->speed * 4
	
	if spawn->orbitalClass = 0 then 
		spawn->velocity.x = cos(3.14159 / 180 * spawn->angle.y)
		spawn->velocity.y = 0
		spawn->velocity.z = sin(3.14159 / 180 * spawn->angle.y)
	elseif spawn->orbitalClass = 1 then
		spawn->velocity.x = 0
		spawn->velocity.y = cos(3.14159 / 180 * spawn->angle.y)
		spawn->velocity.z = sin(3.14159 / 180 * spawn->angle.y)
	elseif spawn->orbitalClass = 2 then
		spawn->velocity.x = sin(3.14159 / 180 * spawn->angle.y)
		spawn->velocity.y = cos(3.14159 / 180 * spawn->angle.y)
		spawn->velocity.z = 0
	end if
	
	math_normalize3f spawn->velocity
	
	vSpeed = (system_ticksPassed / 1000) * wave->speed * .21
	
	spawn->position.x += spawn->velocity.x * vSpeed
	spawn->position.y += spawn->velocity.y * vSpeed
	spawn->position.z += spawn->velocity.z * vSpeed
	
end sub


sub PhasePlayer_Waves_Upd_Wave_Orbital_Type_II (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)

	dim as single zofs, vSpeed, dist, d, spawnIndexR
	dim as vector3d delta
	dim as integer preIndex
	
	
	if spawn->spawnIndex = 0 then
	
		spawn->ringAngle.y += (system_ticksPassed / 1000) * wave->speed * 4
		
		if wave->orbital2_figure8_swap = 1 then spawn->targetVelocity.x = sin(3.14159 / 180 * spawn->ringAngle.y)
		if wave->orbital2_figure8_swap = 0 then spawn->targetVelocity.x = -sin(3.14159 / 180 * spawn->ringAngle.y)
		
		spawn->targetVelocity.y = cos(3.14159 / 180 * spawn->ringAngle.y)
		spawn->targetVelocity.z = 0
		
		math_normalize3f spawn->velocity
		
		d = sqr(spawn->position.x ^ 2 + spawn->position.y ^ 2 + spawn->position.z ^ 2)
		if d < 2 and wave->orbital2_figure8_swap_next < system_ticks then
			wave->orbital2_figure8_swap = 1 - wave->orbital2_figure8_swap
			wave->orbital2_figure8_swap_next = system_ticks + 2000
		end if
		
	else
	
		preIndex = spawn->spawnIndex
		do
			preIndex = preIndex - 1
			if preIndex > -1 then
				if wave->spawn[preIndex].active = 1 then exit do
			else
				exit do
			end if
		loop
	
		if preIndex > -1 then
			delta.x = wave->spawn[preIndex].position.x - spawn->position.x
			delta.y = wave->spawn[preIndex].position.y - spawn->position.y
			delta.z = wave->spawn[preIndex].position.z - spawn->position.z
			
			d = sqr(delta.x * delta.x + delta.y * delta.y + delta.z * delta.z)
			
			dist = -.1
			
			if d > dist * (1.34) then
			
				math_normalize3f delta
				
				delta.x = wave->spawn[preIndex].position.x - delta.x * dist - spawn->position.x
				delta.y = wave->spawn[preIndex].position.y - delta.y * dist - spawn->position.y
				delta.z = wave->spawn[preIndex].position.z - delta.z * dist - spawn->position.z
				
				spawn->targetVelocity.x = delta.x
				spawn->targetVelocity.y = delta.y
				spawn->targetVelocity.z = delta.z
				
				math_normalize3f spawn->velocity
				
			end if
		end if
		
		
	end if
	
	spawn->velocity.x += (spawn->targetVelocity.x - spawn->velocity.x) * .5
	spawn->velocity.y += (spawn->targetVelocity.y - spawn->velocity.y) * .5
	spawn->velocity.z += (spawn->targetVelocity.z - spawn->velocity.z) * .5
	
	vSpeed = (system_ticksPassed / 1000) * wave->speed * (.38 + .15 * sin(wave->radius))
	
	spawn->position.x += spawn->velocity.x * vSpeed
	spawn->position.y += spawn->velocity.y * vSpeed
	spawn->position.z += spawn->velocity.z * vSpeed
	
	
	dim as single an1, an2
	
	spawn->angle.z = 180-atan2(spawn->velocity.y, spawn->velocity.x) * 180 / 3.14159
	
	
	'--- shield activation
	if wave->shield_ticks < system_ticks then
		wave->shield_on = 1 - wave->shield_on
		wave->shield_ticks = system_ticks + wave->shield_wait_len
	end if

end sub


sub PhasePlayer_Waves_Upd_Wave_Type_I (wave as WaveClassType ptr, spawn as WaveSpawnType ptr)

	dim as single zofs, vSpeed, d
	dim as vector3d delta

	zofs = 100 / PhaseDataGlobals.phaseSequence.generator[0].position.z
	
	delta.x = PhasePlayerGlobals.cameraPosition.x * zofs - spawn->position.x
	delta.y = PhasePlayerGlobals.cameraPosition.y * zofs - spawn->position.y
	delta.z = PhasePlayerGlobals.cameraPosition.z * zofs - spawn->position.z
	
	math_normalize3f delta
	
	spawn->velocity.x += delta.x
	spawn->velocity.y += delta.y
	spawn->velocity.z += delta.z
	
	
	delta.x = PhasePlayerGlobals.cameraPosition.x - spawn->position.x
	delta.y = PhasePlayerGlobals.cameraPosition.y - spawn->position.y
	delta.z = PhasePlayerGlobals.cameraPosition.z - spawn->position.z
	
	math_normalize3f spawn->velocity
	
	vSpeed = (system_ticksPassed / 1000) * wave->speed * .36
	
	spawn->position.x += spawn->velocity.x * vSpeed
	spawn->position.y += spawn->velocity.y * vSpeed
	spawn->position.z += spawn->velocity.z * vSpeed
	
end sub