sub PhaseEditor_Render_Gui_MeshProperties ()

	dim as integer dropout, ret
	dim as integer win, active
	dim as single alpha
	win = WIN_MESH_PROPERTIES
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim gen as GeneratorClassType ptr
	gen = PhaseEditorGlobals.winMeshProperties.gen
	
	
	dim as integer winX0, winY0, winW, winH
	winW = 332
	if gen->class > GC_CAMERA then 
		if gen->class = GC_BLOCK_TORUS then winH = 332 + (gen->nColorLights + gen->nVicinityColors) * 48
		if gen->class = GC_HEX_TUNNEL then winH = 332 + (gen->nColorLights + gen->nVicinityColors) * 48
		if gen->class = GC_META_BALL_CLOUD then winH = 332 + (gen->nColorLights + gen->nVicinityColors) * 48
		if gen->class = GC_META_BALL_DISC then winH = 332 + (gen->nColorLights + gen->nVicinityColors) * 48
	else
		winH = 200
	end if
	winW += winW * (1 - alpha)
	winH *= alpha
	
	cx = scrWidth - 20 - winW / 2'cx - winW / 2
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	dim as string gcTitle
	dim as integer rowHeight, curY, buttonX
	dim as integer c0, i
	
	
	if PhaseEditorGlobals.winMeshProperties.forceRegen = 1 then
		for i = 1 to PhaseDataGlobals.phaseSequence.nGenerators - 1
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_BLOCK_TORUS then PhaseData_Init_Block_Torus_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_HEX_TUNNEL then PhaseData_Init_Hex_Tunnel_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_META_BALL_CLOUD then PhaseData_Init_Meta_Ball_Cloud_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
			if PhaseDataGlobals.phaseSequence.generator[i].class = GC_META_BALL_DISC then PhaseData_Init_Meta_Ball_Disc_Regenerate @PhaseDataGlobals.phaseSequence.generator[i]
		next
		PhaseDataGlobals.phaseSequence.generator[0].angle.x = 0
		PhaseDataGlobals.phaseSequence.generator[0].angle.y = 0
	end if
	PhaseEditorGlobals.winMeshProperties.forceRegen = 0
	
	if gen->nProjectilesReturn > -1 then
		if gen->class = GC_BLOCK_TORUS then
			PhaseEditor_Init_Block_Torus_Resize gen, int(gen->nProjectilesReturn)
			PhaseData_Init_Block_Torus_Regenerate gen
		elseif gen->class = GC_META_BALL_CLOUD then
			PhaseEditor_Init_Meta_Ball_Cloud_Resize gen, int(gen->nProjectilesReturn)
			PhaseData_Init_Meta_Ball_Cloud_Regenerate gen
		elseif gen->class = GC_META_BALL_DISC then
			PhaseEditor_Init_Meta_Ball_Disc_Resize gen, int(gen->nProjectilesReturn)
			PhaseData_Init_Meta_Ball_Disc_Regenerate gen
		end if
	end if
	
	if gen->rowsReturn > -1 then
		if gen->class = GC_HEX_TUNNEL then
			PhaseEditor_Init_Hex_Tunnel_Resize gen, int(gen->rowsReturn)
			PhaseData_Init_Hex_Tunnel_Regenerate gen
		end if
	end if
	gen->nProjectilesReturn = -1
	gen->rowsReturn = -1
	
	buttonX = 155
	rowHeight = 24
	curY = winY0 + 30
	
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	if gen->class > GC_CAMERA then
		font_draw winX0 + 5, winY0 + 5, "MESH PROPERTIES - " + gen->title
		font_draw winX0 + 5, winY0 + 5, "MESH PROPERTIES - " + gen->title
		
		if gen->class = GC_BLOCK_TORUS then
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Projectiles:"
			PhaseEditor_Render_Gui_Button str(gen->nProjectiles), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->nProjectilesReturn
				PhaseEditorGlobals.winNumberbox.title = "Projectiles"
				PhaseEditor_Window_Init_NumberBoxWindow gen->nProjectiles, 5
			end if
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Length:"
			PhaseEditor_Render_Gui_Button str(gen->length), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->length
				PhaseEditorGlobals.winNumberbox.title = "Length"
				PhaseEditor_Window_Init_NumberBoxWindow gen->length, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "InnerRadius:"
			PhaseEditor_Render_Gui_Button str(gen->innerRadius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->innerRadius
				PhaseEditorGlobals.winNumberbox.title = "InnerRadius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->innerRadius, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "OutterRadius:"
			PhaseEditor_Render_Gui_Button str(gen->OutterRadius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->outterRadius
				PhaseEditorGlobals.winNumberbox.title = "OutterRadius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->outterRadius, 5
			end if
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "BlockSize:"
			PhaseEditor_Render_Gui_Button str(gen->blockSize), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->blockSize
				PhaseEditorGlobals.winNumberbox.title = "BlockSize"
				PhaseEditor_Window_Init_NumberBoxWindow gen->blockSize, 5
			end if
		
		elseif gen->class = GC_HEX_TUNNEL then

			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Rows:"
			PhaseEditor_Render_Gui_Button str(gen->rows), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->rowsReturn
				PhaseEditorGlobals.winNumberbox.title = "Rows"
				PhaseEditor_Window_Init_NumberBoxWindow gen->rows, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Radius:"
			PhaseEditor_Render_Gui_Button str(gen->radius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->radius
				PhaseEditorGlobals.winNumberbox.title = "Radius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->radius, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "CellSpacing:"
			PhaseEditor_Render_Gui_Button str(gen->cellSpacing), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->cellSpacing
				PhaseEditorGlobals.winNumberbox.title = "CellSpacing"
				PhaseEditor_Window_Init_NumberBoxWindow gen->cellSpacing, 5
			end if
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Border:"
			PhaseEditor_Render_Gui_Button "YES", winX0 + buttonX, curY - 3, 0, 0, win
			
		elseif gen->class = GC_META_BALL_CLOUD then

			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Projectiles:"
			PhaseEditor_Render_Gui_Button str(gen->nProjectiles), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->nProjectilesReturn
				PhaseEditorGlobals.winNumberbox.title = "Projectiles"
				PhaseEditor_Window_Init_NumberBoxWindow gen->nProjectiles, 5
			end if
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "CloudSize:"
			PhaseEditor_Render_Gui_Button str(gen->cloudSize), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->cloudSize
				PhaseEditorGlobals.winNumberbox.title = "Cloud Size"
				PhaseEditor_Window_Init_NumberBoxWindow gen->cloudSize, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Radius:"
			PhaseEditor_Render_Gui_Button str(gen->radius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->radius
				PhaseEditorGlobals.winNumberbox.title = "Radius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->radius, 5
			end if
			
			
			
		elseif gen->class = GC_META_BALL_DISC then

			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Projectiles:"
			PhaseEditor_Render_Gui_Button str(gen->nProjectiles), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->nProjectilesReturn
				PhaseEditorGlobals.winNumberbox.title = "Projectiles"
				PhaseEditor_Window_Init_NumberBoxWindow gen->nProjectiles, 5
			end if
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "CloudSize:"
			PhaseEditor_Render_Gui_Button str(gen->cloudSize), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->cloudSize
				PhaseEditorGlobals.winNumberbox.title = "Cloud Size"
				PhaseEditor_Window_Init_NumberBoxWindow gen->cloudSize, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "Length:"
			PhaseEditor_Render_Gui_Button str(gen->length), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->length
				PhaseEditorGlobals.winNumberbox.title = "Length"
				PhaseEditor_Window_Init_NumberBoxWindow gen->length, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "InnerRadius:"
			PhaseEditor_Render_Gui_Button str(gen->innerRadius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->innerRadius
				PhaseEditorGlobals.winNumberbox.title = "InnerRadius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->innerRadius, 5
			end if
			
			
			curY += rowHeight
			PhaseEditor_SetColor PEC_SEQ_TITLE, win
			font_draw winX0 + 5, curY, "OutterRadius:"
			PhaseEditor_Render_Gui_Button str(gen->OutterRadius), winX0 + buttonX, curY - 3, 0, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->outterRadius
				PhaseEditorGlobals.winNumberbox.title = "OutterRadius"
				PhaseEditor_Window_Init_NumberBoxWindow gen->outterRadius, 5
			end if
			
			
		end if
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Position:"
		gcTitle = "<" + left(str(gen->position.x), 6) + " " + left(str(gen->position.y), 6) + " " + left(str(gen->position.z), 6) + ">"
		PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
			PhaseEditorGlobals.winCoorbox.returnWindow = win
			PhaseEditorGlobals.winCoorbox.title = "Position"
			PhaseEditorGlobals.winCoorBox.returnVal = @gen->position
			PhaseEditor_Window_Init_CoorBoxWindow 8
		end if
		
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Angle:"
		gcTitle = "<" + left(str(gen->angle.x), 6) + " " + left(str(gen->angle.y), 6) + " " + left(str(gen->angle.z), 6) + ">"
		PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
			PhaseEditorGlobals.winCoorbox.returnWindow = win
			PhaseEditorGlobals.winCoorbox.title = "Angle"
			PhaseEditorGlobals.winCoorBox.returnVal = @gen->angle
			PhaseEditor_Window_Init_CoorBoxWindow 8
		end if
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Pre Angular Velocity:"
		gcTitle = "<" + left(str(gen->preAngularVelocity.x), 6) + " " + left(str(gen->preAngularVelocity.y), 6) + " " + left(str(gen->preAngularVelocity.z), 6) + ">"
		PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
			PhaseEditorGlobals.winCoorbox.returnWindow = win
			PhaseEditorGlobals.winCoorbox.title = "Pre Angular Velocity"
			PhaseEditorGlobals.winCoorBox.returnVal = @gen->preAngularVelocity
			PhaseEditor_Window_Init_CoorBoxWindow 8
		end if
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Vicinity Colors:"
		PhaseEditor_Render_Gui_Button "New", winX0 + ButtonX, curY - 3, 0, 0, win
		if active and PhaseEditorGlobals.mouseLeft and PhaseEditorGlobals.winMeshProperties.waitTicks < system_ticks then
			gen->nVicinityColors += 1
			gen->vicinityColor = reallocate(gen->vicinityColor, gen->nVicinityColors * sizeOf(GeneratorColorType))
			gen->vicinityColor[gen->nVicinityColors-1].color.r = 0
			gen->vicinityColor[gen->nVicinityColors-1].color.g = 0
			gen->vicinityColor[gen->nVicinityColors-1].color.b = 0
			gen->vicinityColor[gen->nVicinityColors-1].fallOff = 20
			gen->vicinityColor[gen->nVicinityColors-1].position.x = 0
			gen->vicinityColor[gen->nVicinityColors-1].position.y = 0
			gen->vicinityColor[gen->nVicinityColors-1].position.z = 0
			PhaseEditorGlobals.winMeshProperties.waitTicks = system_ticks + 1000
		end if
		
		for c0 = 0 to gen->nVicinityColors - 1
			curY += rowHeight
			PhaseEditor_Render_Gui_Button "Remove", winX0 + ButtonX - 65, curY - 3, 60, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditor_Generator_RemoveColor gen, RC_VICINITY_COLOR, c0
				PhaseEditorGlobals.winMeshProperties.forceRegen = 1
			end if
			PhaseEditor_Render_Gui_ColorButton gen->vicinityColor[c0].color.r, gen->vicinityColor[c0].color.g, gen->vicinityColor[c0].color.b, winX0 + buttonX, curY - 3, 60, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_SELECT_COLOR) = 1
				PhaseEditorGlobals.winSelectColor.returnWindow = win
				PhaseEditorGlobals.winSelectColor.title = "Vicinity Color (" + str(c0) + ")"
				PhaseEditorGlobals.winSelectColor.returnRGB = @gen->vicinityColor[c0].color
				PhaseEditor_Window_Init_SelectColor gen->vicinityColor[c0].color
			end if
			
			PhaseEditor_Render_Gui_Button "FallOff: " + str(gen->vicinityColor[c0].fallOff), winX0 + 220, curY - 3, 107, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->vicinityColor[c0].fallOff
				PhaseEditorGlobals.winNumberbox.title = "Vicinity Color (" + str(c0) + ") Fall Off"
				PhaseEditor_Window_Init_NumberBoxWindow gen->vicinityColor[c0].fallOff, 5
			end if
			curY += rowHeight
			gcTitle = "<" + left(str(gen->vicinityColor[c0].position.x), 7) + " " + left(str(gen->vicinityColor[c0].position.y), 7) + " " + left(str(gen->vicinityColor[c0].position.z), 7) + ">"
			PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
				PhaseEditorGlobals.winCoorbox.returnWindow = win
				PhaseEditorGlobals.winCoorbox.title = "Vicinity Color (" + str(c0) + ") Position"
				PhaseEditorGlobals.winCoorBox.returnVal = @gen->vicinityColor[c0].position
				PhaseEditor_Window_Init_CoorBoxWindow 8
			end if
		next
		
		
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Color Light:"
		PhaseEditor_Render_Gui_Button "New", winX0 + ButtonX, curY - 3, 0, 0, win
		if active and PhaseEditorGlobals.mouseLeft and PhaseEditorGlobals.winMeshProperties.waitTicks < system_ticks then
			gen->nColorLights += 1
			gen->colorLight = reallocate(gen->colorLight, gen->nColorLights * sizeOf(GeneratorColorType))
			gen->colorLight[gen->nColorLights-1].color.r = 0
			gen->colorLight[gen->nColorLights-1].color.g = 0
			gen->colorLight[gen->nColorLights-1].color.b = 0
			gen->colorLight[gen->nColorLights-1].fallOff = 20
			gen->colorLight[gen->nColorLights-1].position.x = 0
			gen->colorLight[gen->nColorLights-1].position.y = 0
			gen->colorLight[gen->nColorLights-1].position.z = 0
			PhaseEditorGlobals.winMeshProperties.waitTicks = system_ticks + 1000
		end if
		
		for c0 = 0 to gen->nColorLights - 1
			curY += rowHeight
			PhaseEditor_Render_Gui_Button "Remove", winX0 + ButtonX - 65, curY - 3, 60, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditor_Generator_RemoveColor gen, RC_COLOR_LIGHT, c0
				PhaseEditorGlobals.winMeshProperties.forceRegen = 1
			end if
			PhaseEditor_Render_Gui_ColorButton gen->colorLight[c0].color.r, gen->colorLight[c0].color.g, gen->colorLight[c0].color.b, winX0 + buttonX, curY - 3, 60, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_SELECT_COLOR) = 1
				PhaseEditorGlobals.winSelectColor.returnWindow = win
				PhaseEditorGlobals.winSelectColor.title = "Color Light (" + str(c0) + ")"
				PhaseEditorGlobals.winSelectColor.returnRGB = @gen->colorLight[c0].color
				PhaseEditor_Window_Init_SelectColor gen->colorLight[c0].color
			end if
			
			PhaseEditor_Render_Gui_Button "FallOff: " + str(gen->colorLight[c0].fallOff), winX0 + 220, curY - 3, 107, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
				PhaseEditorGlobals.winNumberbox.returnWindow = win
				PhaseEditorGlobals.winNumberbox.returnValue = @gen->colorLight[c0].fallOff
				PhaseEditorGlobals.winNumberbox.title = "Color Light (" + str(c0) + ") Fall Off"
				PhaseEditor_Window_Init_NumberBoxWindow gen->colorLight[c0].fallOff, 5
			end if
			curY += rowHeight
			gcTitle = "<" + left(str(gen->colorLight[c0].position.x), 7) + " " + left(str(gen->colorLight[c0].position.y), 7) + " " + left(str(gen->colorLight[c0].position.z), 7) + ">"
			PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				PhaseEditorGlobals.winLock(win) = 1
				PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
				PhaseEditorGlobals.winCoorbox.returnWindow = win
				PhaseEditorGlobals.winCoorbox.title = "Color Light (" + str(c0) + ") Position"
				PhaseEditorGlobals.winCoorBox.returnVal = @gen->colorLight[c0].position
				PhaseEditor_Window_Init_CoorBoxWindow 8
			end if
		next
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Shadow Color:"
		PhaseEditor_Render_Gui_ColorButton gen->shadowColor.r, gen->shadowColor.g, gen->shadowColor.b, winX0 + ButtonX, curY - 3, 60, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_SELECT_COLOR) = 1
			PhaseEditorGlobals.winSelectColor.returnWindow = win
			PhaseEditorGlobals.winSelectColor.title = "Shadow Color"
			PhaseEditorGlobals.winSelectColor.returnRGB = @gen->shadowColor
			PhaseEditor_Window_Init_SelectColor gen->shadowColor
		end if
	
	else
		font_draw winX0 + 5, winY0 + 5, "CAMERA PROPERTIES"
		font_draw winX0 + 5, winY0 + 5, "CAMERA PROPERTIES"
		
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Z Offset:"
		PhaseEditor_Render_Gui_Button str(gen->position.z), winX0 + buttonX, curY - 3, 0, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
			PhaseEditorGlobals.winNumberbox.returnWindow = win
			PhaseEditorGlobals.winNumberbox.returnValue = @gen->position.z
			PhaseEditorGlobals.winNumberbox.title = "Z Offset"
			PhaseEditor_Window_Init_NumberBoxWindow gen->position.z, 5
		end if
		
		curY += rowHeight
		PhaseEditor_SetColor PEC_SEQ_TITLE, win
		font_draw winX0 + 5, curY, "Angle Velocity:"
		gcTitle = "<" + left(str(gen->preAngularVelocity.x), 6) + " " + left(str(gen->preAngularVelocity.y), 6) + ">"
		PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
			PhaseEditorGlobals.winCoorbox.returnWindow = win
			PhaseEditorGlobals.winCoorbox.title = "Angle Velocity"
			PhaseEditorGlobals.winCoorBox.returnVal = @gen->preAngularVelocity
			PhaseEditor_Window_Init_CoorBoxWindow 8
		end if
		
	end if
	
	
	
	PhaseEditor_Render_Gui_Button "SAVE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
		
		'PhaseEditor_Init_New_Phase
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
	end if
	
end sub


sub PhaseEditor_Window_Init_MeshProperties ()

	PhaseEditorGlobals.winMeshProperties.gen = @PhaseDataGlobals.phaseSequence.generator[PhaseEditorGlobals.winSequencer.selGenerator]
	
end sub
	