sub PhaseEditor_Render_Gui_NewPhase ()

	dim as integer dropout, ret
	dim as integer win, active
	dim as single alpha
	win = WIN_NEW_PHASE
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 300
	winH = 150
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, winY0 + 5, "NEW PHASE SEQUENCE"
	font_draw winX0 + 5, winY0 + 5, "NEW PHASE SEQUENCE"
	
	dim as string gcTitle
	dim as integer rowHeight, curY
	
	
	if PhaseEditorGlobals.winNewPhase.roomClass = -1 then gcTitle = "SELECT"
	if PhaseEditorGlobals.winNewPhase.roomClass = RC_SPHERE then gcTitle = "Sphere"
	if PhaseEditorGlobals.winNewPhase.roomClass = RC_TUNNEL then gcTitle = "Tunnel"
	
	rowHeight = 24
	curY = winY0 + 30
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Room Class:"
	PhaseEditor_Render_Gui_Button gcTitle, winX0 + 100, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @PhaseEditorGlobals.winnewPhase.roomClass
		PhaseEditorGlobals.winSelectTable.title = "Select Room Class"
		PhaseEditorGlobals.winSelectTable.Options = "<Sphere><Tunnel>"
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	gcTitle = "ENTER_NAME"
	if PhaseEditorGlobals.winNewPhase.phaseTitle <> "" then gcTitle = PhaseEditorGlobals.winNewPhase.phaseTitle
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Phase Title:"
	PhaseEditor_Render_Gui_Button gcTitle, winX0 + 100, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_TEXT_BOX) = 1
		PhaseEditorGlobals.winTextbox.returnWindow = win
		PhaseEditorGlobals.winTextbox.returnValue = @PhaseEditorGlobals.winNewPhase.phaseTitle
		PhaseEditorGlobals.winTextbox.title = "Phase Title"
		PhaseEditor_Window_Init_TextBoxWindow PhaseEditorGlobals.winNewPhase.phaseTitle, 4
	end if
	
	PhaseEditor_Render_Gui_Button "CREATE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
		
		PhaseEditor_Init_New_Phase
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
	end if
	
end sub


sub PhaseEditor_Window_Init_NewPhase ()

	PhaseEditorGlobals.winNewPhase.roomClass = -1
	PhaseEditorGlobals.winNewPhase.phaseTitle = ""
	
end sub
	