sub PhaseEditor_Render_Gui_SelectColor ()

	dim as integer dropout, ret
	dim as integer win, active
	dim as single alpha
	win = WIN_SELECT_COLOR
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	dim as integer w, h
	
	dim as string gcTitle
	gcTitle = "Select Color - " + PhaseEditorGlobals.winSelectColor.title
	font_xy w, h, gctitle
	winW = 200
	if w > 190 then winW = w + 17
	winH = 300
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	
	font_draw winX0 + 5, winY0 + 5, gcTitle
	font_draw winX0 + 5, winY0 + 5, gctitle
	
	dim as integer rowHeight, curY, buttonX, buttonH
	dim as integer clickedGradient, mx, my
	dim as integer i
	dim gen as GeneratorClassType ptr
	dim as rgbalpha saturation0, saturation1, value0, value1
	
	gen = PhaseEditorGlobals.winMeshProperties.gen
	
	buttonX = 155
	buttonH = winH - 75
	
	rowHeight = 24
	curY = winY0 + 30
	
	buttonX = (winW - 6) / 4
	
	clickedGradient = -1
	for i = 0 to 2
		PhaseEditor_Render_Gui_IconButton winX0 + buttonX * i + 6, curY, buttonX - 5, buttonH, win
		if active and PhaseEditorGlobals.mouseLeft = 1 then
			clickedGradient = i
			mx = PhaseEditorGlobals.mouseX
			my = PhaseEditorGlobals.mouseY
		end if
	next
	
	dim as single gx0, gy0, gx1, gy1, gy2, gcx, r, r2
	
	dim as single cirX, cirY
	dim as integer ang
	'----- hue gradient
	for i = 0 to 5
		gx0 = winX0 + 13
		gy0 = curY + 6 + (buttonH - 13) / 6 * i
		gx1 = gx0 + buttonX - 18
		gy1 = gy0 + (buttonH - 5) / 6
		
		glBegin GL_QUADS
			if i = 0 then glColor4f 1, 0, 0, alpha
			if i = 1 then glColor4f 1, 0, 1, alpha
			if i = 2 then glColor4f 0, 0, 1, alpha
			if i = 3 then glColor4f 0, 1, 1, alpha
			if i = 4 then glColor4f 0, 1, 0, alpha
			if i = 5 then glColor4f 1, 1, 0, alpha
			glVertex2f gx1, gy0
			glVertex2f gx0, gy0
			if i = 0 then glColor4f 1, 0, 1, alpha
			if i = 1 then glColor4f 0, 0, 1, alpha
			if i = 2 then glColor4f 0, 1, 1, alpha
			if i = 3 then glColor4f 0, 1, 0, alpha
			if i = 4 then glColor4f 1, 1, 0, alpha
			if i = 5 then glColor4f 1, 0, 0, alpha
			glVertex2f gx0, gy1
			glVertex2f gx1, gy1
		glEnd
		
	next
	gx0 = winX0 + 13
	gy0 = curY + 6
	gx1 = gx0 + buttonX - 18
	gy1 = gy0 + buttonH - 13
	gcx = (gx0 + gx1) / 2
	
	gy2 = PhaseEditorGlobals.winSelectColor.hsv.h
	if clickedGradient = 0 then
		gy2 = (my - gy0) / (gy1 - gy0)
		if gy2 < 0 then gy2 = 0
		if gy2 > 1 then gy2 = 1
		PhaseEditorGlobals.winSelectColor.hsv.h = gy2
	end if
		
	r = 5.7
	r2 = 6.8
	
	glBegin GL_LINES
	for ang = 0 to 7
		glColor4f 0, 0, 0, .5
		
		cirX = gcx + r * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
		
		glColor3f 1, 1, 1
		
		cirX = gcx + r2 * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r2 * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
	next
	glEnd
	
	'---- determine selected color
	dim as integer sections
	dim as single colorLocation, colorOffset
	dim as integer colorStart
	sections = 6
	colorLocation = sections * gy2
	colorStart = int(colorLocation)
	colorOffset = colorLocation - colorStart
	
	dim as rgbalpha c0, c1
	if colorStart = 0 then
		c0.r = 1: c0.g = 0: c0.b = 0
		c1.r = 1: c1.g = 0: c1.b = 1
	elseif colorStart = 1 then
		c0.r = 1: c0.g = 0: c0.b = 1
		c1.r = 0: c1.g = 0: c1.b = 1
	elseif colorStart = 2 then
		c0.r = 0: c0.g = 0: c0.b = 1
		c1.r = 0: c1.g = 1: c1.b = 1
	elseif colorStart = 3 then
		c0.r = 0: c0.g = 1: c0.b = 1
		c1.r = 0: c1.g = 1: c1.b = 0
	elseif colorStart = 4 then
		c0.r = 0: c0.g = 1: c0.b = 0
		c1.r = 1: c1.g = 1: c1.b = 0
	elseif colorStart = 5 then
		c0.r = 1: c0.g = 1: c0.b = 0
		c1.r = 1: c1.g = 0: c1.b = 0
	elseif colorStart = 6 then
		c0.r = 1: c0.g = 0: c0.b = 0
		c1.r = 1: c1.g = 0: c1.b = 0
	end if
	
	saturation0.r = c0.r + (c1.r - c0.r) * colorOffset
	saturation0.g = c0.g + (c1.g - c0.g) * colorOffset
	saturation0.b = c0.b + (c1.b - c0.b) * colorOffset
	saturation0.a = alpha

	dim as single max, min
	max = 0
	min = 1
	
	saturation1.r = 1
	saturation1.g = 1
	saturation1.b = 1
	saturation1.a = alpha

	
	'----- saturation gradient
	gx0 = winX0 + buttonX + 13
	gy0 = curY + 6
	gx1 = gx0 + buttonX - 18
	gy1 = gy0 + buttonH - 13
	
	glBegin GL_QUADS
		glColor4fv @saturation0.r
		glVertex2f gx1, gy0
		glVertex2f gx0, gy0
		glColor4fv @saturation1.r
		glVertex2f gx0, gy1
		glVertex2f gx1, gy1
	glEnd
	
	gcx = (gx0 + gx1) / 2
	
	gy2 = PhaseEditorGlobals.winSelectColor.hsv.s
	if clickedGradient = 1 then
		gy2 = (my - gy0) / (gy1 - gy0)
		if gy2 < 0 then gy2 = 0
		if gy2 > 1 then gy2 = 1
		PhaseEditorGlobals.winSelectColor.hsv.s = gy2
	end if
	
	value0.r = saturation0.r + (1 - saturation0.r) * gy2
	value0.g = saturation0.g + (1 - saturation0.g) * gy2
	value0.b = saturation0.b + (1 - saturation0.b) * gy2
	value0.a = alpha
	
	value1.r = 0
	value1.g = 0
	value1.b = 0
	value1.a = alpha
	
	r = 5.7
	r2 = 6.8
	
	glBegin GL_LINES
	for ang = 0 to 7
		glColor4f 0, 0, 0, .5
		
		cirX = gcx + r * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
		
		glColor3f 1, 1, 1
		
		cirX = gcx + r2 * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r2 * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
	next
	glEnd
	
	'----- brightness gradient
	gx0 = winX0 + buttonX * 2 + 13
	gy0 = curY + 6
	gx1 = gx0 + buttonX - 18
	gy1 = gy0 + buttonH - 13
	
	glBegin GL_QUADS
		glColor4fv @value0.r
		glVertex2f gx1, gy0
		glVertex2f gx0, gy0
		glColor3f 0, 0, 0
		glVertex2f gx0, gy1
		glVertex2f gx1, gy1
	glEnd
	
	gcx = (gx0 + gx1) / 2
	
	gy2 = PhaseEditorGlobals.winSelectColor.hsv.v
	if clickedGradient = 2 then
		gy2 = (my - gy0) / (gy1 - gy0)
		if gy2 < 0 then gy2 = 0
		if gy2 > 1 then gy2 = 1
		PhaseEditorGlobals.winSelectColor.hsv.v = gy2
	end if
	
	PhaseEditorGlobals.winSelectColor.rgb.r = value0.r + (0 - value0.r) * gy2
	PhaseEditorGlobals.winSelectColor.rgb.g = value0.g + (0 - value0.g) * gy2
	PhaseEditorGlobals.winSelectColor.rgb.b = value0.b + (0 - value0.b) * gy2
	
	r = 5.7
	r2 = 6.8
	
	glBegin GL_LINES
	for ang = 0 to 7
		glColor4f 0, 0, 0, .5
		
		cirX = gcx + r * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
		
		glColor3f 1, 1, 1
		
		cirX = gcx + r2 * cos(3.14159 * 2 * ang / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * ang / 8)
		glVertex2f cirX, cirY
		
		cirX = gcx + r2 * cos(3.14159 * 2 * (ang + 1) / 8)
		cirY = gy0 + (gy1 - gy0) * gy2 + r2 * sin(3.14159 * 2 * (ang + 1) / 8)
		glVertex2f cirX, cirY
	next
	glEnd
	
	'------------
	
	i = 3
	PhaseEditor_Render_Gui_IconButton winX0 + buttonX * i + 6, curY, buttonX - 5, buttonX - 5, win
	
	
	PhaseEditorGlobals.winSelectColor.rgb.a = 1
	
	gx0 = winX0 + buttonX * 3 + 13
	gy0 = curY + 6
	gx1 = gx0 + buttonX - 18
	gy1 = gy0 + buttonX - 18
	
	glBegin GL_QUADS
		glColor4f PhaseEditorGlobals.winSelectColor.rgb.r, PhaseEditorGlobals.winSelectColor.rgb.g, PhaseEditorGlobals.winSelectColor.rgb.b, alpha
		glVertex2f gx1, gy0
		glVertex2f gx0, gy0
		glVertex2f gx0, gy1
		glVertex2f gx1, gy1
	glEnd
	
	
	PhaseEditor_Render_Gui_Button "SELECT", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		dropout = 1
		*PhaseEditorGlobals.winSelectColor.returnRGB = PhaseEditorGlobals.winSelectColor.rgb
		if PhaseEditorGlobals.winSelectColor.returnWindow = WIN_MESH_PROPERTIES then PhaseEditorGlobals.winMeshProperties.forceRegen = 1
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		dropout = 1
	end if
	
	if dropout = 1 then
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(PhaseEditorGlobals.winSelectColor.returnWindow) = 0
	end if
	
end sub



sub PhaseEditor_Window_Init_SelectColor (c0 as rgbalpha)

	dim as single min, max, h, s, v, l
	min = 1
	max = 0
	if c0.r > max then max = c0.r
	if c0.g > max then max = c0.g
	if c0.b > max then max = c0.b
	if c0.r < min then min = c0.r
	if c0.g < min then min = c0.g
	if c0.b < min then min = c0.b
	
	if min = max then h = 0
	if max = c0.r then h = (60 * (c0.g - c0.b) / (max - min)) mod 360
	if max = c0.g then h = (60 * (c0.b - c0.r) / (max - min)) + 120
	if max = c0.b then h = (60 * (c0.r - c0.g) / (max - min)) + 240
	
	h /= 360
	
	if max = min then s = 0
	s = 1 - (min / max)
	
	v = max
	

	PhaseEditorGlobals.winSelectColor.hsv.h = 1 - h
	PhaseEditorGlobals.winSelectColor.hsv.s = 1 - s
	PhaseEditorGlobals.winSelectColor.hsv.v = 1 - v
	
end sub
	