sub PhaseEditor_Render_Gui_SelectTable_Game ()

	dim as integer dropout, ret
	dim as integer win, active
	dim as single alpha
	win = WIN_SELECT_TABLE
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = 0
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = PhaseEditorGlobals.winSelectTable.overallWidth
	winH = PhaseEditorGlobals.winSelectTable.overallHeight
	winW += winW * (1 - alpha)
	winH *= alpha
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	PhaseEditor_Render_Gui_WindowGame winX0, winY0, winX0 + winW, winY0 + winH, PEC_TEXTBOX_BG, PMC_WINDOW_BG_DARK, win
	
	PhaseEditor_SetColor PEC_TEXTBOX_BG, win
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winSelectTable.title
	font_draw winX0 + 5, winY0 + 5, PhaseEditorGlobals.winSelectTable.title
	
	ret = *PhaseEditorGlobals.winSelectTable.returnValue
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx - 30, winY0 + winH - 25, 0, 0, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		dropout = 1
	end if
	
	dim as integer nColumns, nRows, x0, y0, tablex0, tabley0, cellWidth
	
	nColumns = PhaseEditorGlobals.winSelectTable.nColumns
	nRows = PhaseEditorGlobals.winSelectTable.nRows
	cellWidth = PhaseEditorGlobals.winSelectTable.cellWidth
	
	tableX0 = cx - nColumns * (cellWidth + 10) / 2
	tableY0 = winY0 + 30
	
	dim as string options
	options = PhaseEditorGlobals.winSelectTable.options
	
	dim optionTextLen as integer
	optionTextLen = len(options)
	
	
	dim as integer a, b, c
	dim as integer buttonTextStart, buttonTextEnd
	dim m as string
	dim buttonText as string
	dim as integer col, row, colX, colY, curButton
	
	for a = 1 to optionTextLen
		m = mid(options, a, 1)
		if m = "<" then
			buttonTextStart = a + 1
			b = a + 1
			do
				m = mid(options, b, 1)
				if m = ">" then
					buttonTextEnd = b - 1
					exit do
				end if
				b += 1
			loop while b <= optionTextLen
			
			a = b
			
			buttonText = mid(options, buttonTextStart, buttonTextEnd - buttonTextStart + 1)
			col = curButton mod nColumns
			row = (curButton - col) / nColumns
			
			colX = tableX0 + col * (cellWidth + 10) + 5
			colY = tableY0 + row * 24
			PhaseEditor_Render_Gui_Button buttonText, colX, colY, cellWidth, 0, win
			if active and PhaseEditorGlobals.mouseLeft then
				ret = curButton + PhaseEditorGlobals.winSelectTable.returnOffset
				dropout = 1
				active = 0
			end if
			
			curButton += 1
		end if
	next
	
	
	
	
	if dropout = 1 then
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(PhaseEditorGlobals.winSelectTable.returnWindow) = 0
		*PhaseEditorGlobals.winSelectTable.returnValue = ret
	end if
	
end sub
