sub PhaseEditor_Render_Gui_Sequencer ()


	dim as integer win, active
	win = WIN_SEQUENCER
	active = PhaseEditorGlobals.winActive(win)
		
	PhaseEditorGlobals.winAlpha(win) += .1 * fpsr
	if PhaseEditorGlobals.winAlpha(win) > 1 then PhaseEditorGlobals.winAlpha(win) = 1
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer seqheight, scrHeight, scrWidth
	dim as integer separatorHeight, separatorX
	
	scrHeight = OpenGLProperties.SCR_HEIGHT - 1
	scrWidth = OpenGLProperties.SCR_WIDTH - 1
	
	seqheight = 20
	
	PhaseEditor_Render_Gui_Window 0, scrHeight - seqHeight, scrWidth, scrHeight, PEC_SEQ, PEC_SEQ_DARK, win
	
	dim as string gcTitle
	
	gcTitle = "SEQUENCER // " + PhaseDataGlobals.phaseSequence.phaseTitle
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw 5, scrHeight - seqHeight + 5, gcTitle
	font_draw 5, scrHeight - seqHeight + 5, gcTitle
	
	dim as integer i, w, h, a, nBars
	font_xy w, h, gcTitle
	
	dim as integer buttonheight
	buttonHeight = 17
	
	separatorHeight = seqHeight + (PhaseDataGlobals.phaseSequence.nGenerators + 2 + PhaseDataGlobals.phaseSequence.nWaves) * buttonHeight
	separatorX = w + 20
	
	
	PhaseEditor_Render_Gui_Window 0, 0, scrWidth, 21, PEC_SEQ, PEC_SEQ_DARK, win
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw 5, 5, "PHASE EDITOR"
	font_draw 5, 5, "PHASE EDITOR"
	
	PhaseEditor_Render_Gui_Button "New", 100, 21, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NEW_PHASE) = 1
		PhaseEditor_Window_Init_NewPhase
	end if
	
	PhaseEditor_Render_Gui_Button "Save", 160, 21, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then PhaseEditor_PhaseSequence_Save "0.seq"
	PhaseEditor_Render_Gui_Button "Load", 220, 21, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then PhaseData_PhaseSequence_Load "0.seq"
	PhaseEditor_Render_Gui_Button "Exit", 280, 21, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then PhaseEditorGlobals.exitCode = 1
	
	PhaseEditor_Render_Gui_BarWindow 0, scrHeight - separatorHeight, scrWidth, scrHeight - seqHeight, PEC_SEQ, PEC_SEQ_DARK, buttonHeight, win
	
	dim as integer xoffset
	for i = 0 to PhaseDataGlobals.phaseSequence.nGenerators - 1
		gcTitle = PhaseDataGlobals.phaseSequence.generator[i].title
		xoffset = 0
		if PhaseEditorGlobals.winSequencer.selGenerator = i then xoffset = 20
		PhaseEditor_Render_Gui_Button gcTitle, xoffset, scrHeight - seqHeight - (i + 1) * buttonHeight, w, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winSequencer.selGenerator = i
		end if
		if active and PhaseEditorGlobals.mouseRight then
			PhaseEditorGlobals.winSequencer.selGenerator = i
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_MESH_PROPERTIES) = 1
			PhaseEditor_Window_Init_MeshProperties
		end if
	next
	
	
	for i = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
		gcTitle = PhaseDataGlobals.phaseSequence.wave[i].title
		xoffset = 0
		if PhaseEditorGlobals.winSequencer.selWave = i then xoffset = 20
		PhaseEditor_Render_Gui_Button gcTitle, xoffset, scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1) - (i + 1) * buttonHeight, w, 0, win
		if active and PhaseEditorGlobals.mouseLeft then
			PhaseEditorGlobals.winSequencer.selWave = i
		end if
		if active and PhaseEditorGlobals.mouseRight then
			PhaseEditorGlobals.winSequencer.selWave = i
			PhaseEditorGlobals.winLock(win) = 1
			PhaseEditorGlobals.winActive(WIN_WAVE_PROPERTIES) = 1
			PhaseEditor_Window_Init_WaveProperties
		end if
	next
	
	dim as integer curY
	'---- draw vertical separator
	glBegin GL_LINES
	PhaseEditor_SetColor PEC_SEQ_SEPARATOR, win
	for i = separatorHeight to 0 step -4
		glVertex2f separatorX, scrHeight - i
		glVertex2f separatorX, scrHeight - i + 2
	next
	glEnd
	
	
	
	'---- draw wave bars
	dim as integer deltaX, startX, nWaves, totalTime, spacerX, yOffset, waveTime, oneEight
	deltaX = (scrWidth - 2) - (separatorX + 2)
	startX = separatorX + 2
	nWaves = PhaseDataGlobals.phaseSequence.nWaves
	totalTime = 0
	spacerX = 0
	if nWaves > 0 then
	
		for i = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
			if PhaseDataGlobals.phaseSequence.wave[i].startTime + PhaseDataGlobals.phaseSequence.wave[i].time > totalTime then totalTime = PhaseDataGlobals.phaseSequence.wave[i].startTime + PhaseDataGlobals.phaseSequence.wave[i].time
		next
		
		yOffset = scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1) - (nWaves + 1) * buttonHeight
		gcTitle = "Total Time: " + str(totalTime) + "s"
		gcTitle += " (" + str(int(totalTime / 60)) + mid(str((totalTime - int(totalTime / 60) * 60) / 60), 2, 3)
		gctitle += "m)"
		font_xy w, h, gcTitle
		font_draw scrWidth - w - 10, yOffset + 3, gcTitle
		
		'draw background bars
		nBars = totalTime / 60
		for a = 1 to nBars
			xOffset = (a * 60 / totalTime) * deltaX
			glBegin GL_LINES
			PhaseEditor_SetColor PEC_SEQ_SEPARATOR, win
			for i = separatorHeight to 0 step -4
				glVertex2f separatorX + xOffset + 2, scrHeight - i
				glVertex2f separatorX + xOffset + 2, scrHeight - i + 2
			next
			glEnd
		next
		
		for i = 0 to PhaseDataGlobals.phaseSequence.nWaves - 1
			waveTime = PhaseDataGlobals.phaseSequence.wave[i].time
			xOffset = PhaseDataGlobals.phaseSequence.wave[i].time / totalTime * deltaX
			startX = separatorX + 2 + PhaseDataGlobals.phaseSequence.wave[i].startTime / totalTime * deltaX
			oneEight = xOffset / 8
			xOffset -= oneEight * 2
			yOffset = scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1) - (i + 1) * buttonHeight
			glBegin GL_QUADS
				glColor4f 0, 0, 1, 0
				glVertex2f startX, yOffset + 1
				glVertex2f startX, yOffset + buttonHeight - 1
				glColor4f 0, 0, 1, 1
				glVertex2f startX + oneEight, yOffset + buttonheight - 1
				glVertex2f startX + oneEight, yOffset + 1
				
				startX += oneEight
				glVertex2f startX, yOffset + 1
				glVertex2f startX, yOffset + buttonHeight - 1
				glVertex2f startX + xOffset, yOffset + buttonheight - 1
				glVertex2f startX + xOffset, yOffset + 1
				
				startX += xOffset
				glVertex2f startX, yOffset + 1
				glVertex2f startX, yOffset + buttonHeight - 1
				glColor4f 0, 0, 1, 0
				glVertex2f startX + oneEight, yOffset + buttonheight - 1
				glVertex2f startX + oneEight, yOffset + 1
				
			glEnd
			startX += oneEight' + spacerX
		next
	
	end if
	
	
	
	
	'---- draw new mesh button
	curY = scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1 + PhaseDataGlobals.phaseSequence.nWaves + 1)
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw 5, curY + 3, "Wave:"
	PhaseEditor_Render_Gui_Button "New", 60, curY, 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NEW_WAVE) = 1
		PhaseEditor_Window_Init_NewWave
	end if
	PhaseEditor_Render_Gui_Button "Delete", 120, curY, 60, BUTTON_CENTER, win
	PhaseEditor_Render_Gui_Button "Properties", 180, curY, 90, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winSequencer.selWave = PhaseEditorGlobals.winSequencer.selWave
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_WAVE_PROPERTIES) = 1
		PhaseEditor_Window_Init_WaveProperties
	end if
	
	curY = scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1)
	
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw 5, curY + 3, "Mesh:"
	PhaseEditor_Render_Gui_Button "New", 60, scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1), 60, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NEW_MESH) = 1
		PhaseEditorGlobals.winNewMesh.generatorClass = -1
	end if
	PhaseEditor_Render_Gui_Button "Delete", 120, scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1), 60, BUTTON_CENTER, win
	PhaseEditor_Render_Gui_Button "Properties", 180, scrHeight - seqHeight - buttonHeight * (PhaseDataGlobals.phaseSequence.nGenerators + 1), 90, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winSequencer.selGenerator = PhaseEditorGlobals.winSequencer.selGenerator
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_MESH_PROPERTIES) = 1
		PhaseEditor_Window_Init_MeshProperties
	end if
	
end sub