sub PhaseEditor_Render_Gui_WaveProperties ()

	dim as integer win, active
	dim as single alpha
	win = WIN_WAVE_PROPERTIES
	PhaseEditor_Update_WindowAlpha win
	active = PhaseEditorGlobals.winActive(win)
	alpha = PhaseEditorGlobals.winAlpha(win)
	if active = 0 and alpha = 0 then exit sub
	PhaseEditorGlobals.windowLock = PhaseEditorGlobals.winLock(win)
	
	dim as integer scrWidth, scrHeight
	scrWidth = OpenGLProperties.SCR_WIDTH
	scrHeight = OpenGLProperties.SCR_HEIGHT
	
	dim as integer cx, cy, i
	cx = scrWidth / 2
	cy = scrHeight / 2
	
	dim as integer winX0, winY0, winW, winH
	winW = 293
	winH = 336
	winW += winW * (1 - alpha)
	winH *= alpha
	
	cx = scrWidth - 20 - winW / 2'cx - winW / 2
	winX0 = cx - winW / 2
	winY0 = cy - winH / 2
	
	dim as integer buttonX
	buttonX = 115
	
	PhaseEditor_Render_Gui_Window winX0, winY0, winX0 + winW, winY0 + winH, PEC_SEQ, PEC_SEQ_DARK, win
	
	dim as string gcTitle
	dim as integer rowHeight, curY
	
	dim as WaveClassType ptr wave
	
	wave = @PhaseDataGlobals.phaseSequence.wave[PhaseEditorGlobals.winSequencer.selWave]
	
	gcTitle = "WAVE PROPERTIES - " + PhaseEditorGlobals.waveClass(wave->class).title
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, winY0 + 5, gcTitle
	font_draw winX0 + 5, winY0 + 5, gcTitle
	
	rowHeight = 24
	
	curY = winY0 + 30
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Pattern:"
	PhaseEditor_Render_Gui_Button PhaseEditorGlobals.wavePattern(wave->pattern).title, winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @wave->pattern
		PhaseEditorGlobals.winSelectTable.title = "Select Wave Pattern"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = ""
		for i = 0 to PhaseEditorGlobals.wavePatternLast
			PhaseEditorGlobals.winSelectTable.Options += "<" + PhaseEditorGlobals.wavePattern(i).title + ">"
		next
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Time (seconds):"
	PhaseEditor_Render_Gui_Button str(wave->time), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->time
		PhaseEditorGlobals.winNumberbox.title = "Time"
		PhaseEditor_Window_Init_NumberBoxWindow wave->time, 5
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "StartTime:"
	PhaseEditor_Render_Gui_Button str(wave->startTime), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->startTime
		PhaseEditorGlobals.winNumberbox.title = "StartTime"
		PhaseEditor_Window_Init_NumberBoxWindow wave->startTime, 5
	end if
	
	
	if wave->nSpawnReturn > 0 then
		wave->nSpawn = int(wave->nSpawnReturn)
		wave->nSpawnReturn = 0
	end if

	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "nSpawn:"
	PhaseEditor_Render_Gui_Button str(wave->nSpawn), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->nSpawnReturn
		PhaseEditorGlobals.winNumberbox.title = "nSpawn"
		PhaseEditor_Window_Init_NumberBoxWindow wave->nSpawn, 5
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Speed:"
	PhaseEditor_Render_Gui_Button str(wave->speed), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->speed
		PhaseEditorGlobals.winNumberbox.title = "Speed"
		PhaseEditor_Window_Init_NumberBoxWindow wave->speed, 5
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "Position:"
	gcTitle = "<" + left(str(wave->position.x), 6) + " " + left(str(wave->position.y), 6) + " " + left(str(wave->position.z), 6) + ">"
	PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
		PhaseEditorGlobals.winCoorbox.returnWindow = win
		PhaseEditorGlobals.winCoorbox.title = "Position"
		PhaseEditorGlobals.winCoorBox.returnVal = @wave->position
		PhaseEditor_Window_Init_CoorBoxWindow 8
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "PositionOffset:"
	gcTitle = "<" + left(str(wave->positionOffset.x), 6) + " " + left(str(wave->positionOffset.y), 6) + " " + left(str(wave->positionOffset.z), 6) + ">"
	PhaseEditor_Render_Gui_Button gcTitle, winX0 + buttonX, curY - 3, 172, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_COOR_BOX) = 1
		PhaseEditorGlobals.winCoorbox.returnWindow = win
		PhaseEditorGlobals.winCoorbox.title = "PositionOffset"
		PhaseEditorGlobals.winCoorBox.returnVal = @wave->positionOffset
		PhaseEditor_Window_Init_CoorBoxWindow 8
	end if
	
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "MaxHealth:"
	PhaseEditor_Render_Gui_Button str(wave->maxHealth), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->maxHealth
		PhaseEditorGlobals.winNumberbox.title = "Speed"
		PhaseEditor_Window_Init_NumberBoxWindow wave->maxHealth, 5
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "RateOfFire:"
	PhaseEditor_Render_Gui_Button str(wave->rateOfFire), winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_NUMBER_BOX) = 1
		PhaseEditorGlobals.winNumberbox.returnWindow = win
		PhaseEditorGlobals.winNumberbox.returnValue = @wave->rateOfFire
		PhaseEditorGlobals.winNumberbox.title = "RateOfFire"
		PhaseEditor_Window_Init_NumberBoxWindow wave->rateOfFire, 5
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "BulletPattern:"
	PhaseEditor_Render_Gui_Button PhaseEditorGlobals.bulletPattern(wave->bulletPattern).title, winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @wave->bulletPattern
		PhaseEditorGlobals.winSelectTable.title = "Select Bullet Pattern"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = ""
		for i = 0 to PhaseEditorGlobals.bulletPatternLast
			PhaseEditorGlobals.winSelectTable.Options += "<" + PhaseEditorGlobals.bulletPattern(i).title + ">"
		next
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	curY += rowHeight
	PhaseEditor_SetColor PEC_SEQ_TITLE, win
	font_draw winX0 + 5, curY, "BulletClass:"
	PhaseEditor_Render_Gui_Button PhaseEditorGlobals.bulletClass(wave->bulletClass).title, winX0 + buttonX, curY - 3, 0, 0, win
	if active and PhaseEditorGlobals.mouseLeft then
		'active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(win) = 1
		PhaseEditorGlobals.winActive(WIN_SELECT_TABLE) = 1
		PhaseEditorGlobals.winSelectTable.returnWindow = win
		PhaseEditorGlobals.winSelectTable.returnValue = @wave->bulletClass
		PhaseEditorGlobals.winSelectTable.title = "Select Bullet Class"
		PhaseEditorGlobals.winSelectTable.returnOffset = 0
		PhaseEditorGlobals.winSelectTable.Options = ""
		for i = 0 to PhaseEditorGlobals.bulletClassLast
			PhaseEditorGlobals.winSelectTable.Options += "<" + PhaseEditorGlobals.bulletClass(i).title + ">"
		next
		PhaseEditor_Window_Init_SelectTable PhaseEditorGlobals.winSelectTable.Options
	end if
	
	
	PhaseEditor_Render_Gui_Button "SAVE", cx - 75, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.mouseLeft then
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
		
		'PhaseEditor_Init_New_Phase
	end if
	
	PhaseEditor_Render_Gui_Button "CANCEL", cx + 10, winY0 + winH - 25, 65, BUTTON_CENTER, win
	if active and PhaseEditorGlobals.winLock(win) = 0 and (PhaseEditorGlobals.mouseLeft or (glfwGetKey(GLFW_KEY_ESC) and PhaseEditorGlobals.waitTicks < system_ticks)) then
		PhaseEditorGlobals.waitTicks = system_ticks + 200
		active = 0: PhaseEditorGlobals.winActive(win) = active
		PhaseEditorGlobals.winLock(WIN_SEQUENCER) = 0
	end if
	
end sub



sub PhaseEditor_Window_Init_WaveProperties ()

	
end sub