#include once "str_explode.bi"

declare function objFile_getDirectory (filename as string) as string
declare function objFile_load (filename as string) as integer
declare sub      objFile_loadMaterialLibrary (curModel as integer, filename as string)


function objFile_getDirectory (filename as string) as string
    
    dim dr as string, nameLen as integer, midLoc as integer, m as string
    dr = filename
    nameLen = len(dr)
    
    midLoc = 0
    do
        m = mid$(dr, nameLen - midLoc, 1)
        if m = "/" then
            dr = left$(dr, nameLen - midLoc)
            exit do
        end if
        
        midLoc += 1
        if midLoc = nameLen then exit do
    loop
    
    objFile_getDirectory = dr
    
end function


'---------------------
' objFile_load - loads the model then returns modelDB index to the data
'---------------------
function objFile_load (filename as string) as integer

	'print "Loading: "; filename; "...";
	
	'////// check if already loaded
	dim modl as integer
	for modl = 0 to modelDBLength - 1
		if modelDB[modl].modelFile = filename then
			return modl
			exit function
		end if
	next
	
	
	dim as integer numVertii, numFaces, numNormals, numMaterials, curModel, indicies, numUvs, ff
	dim as integer curVertex, curUV, curObject, curFace, curNormal
	dim materialFile as string, objFileDirectory as string, materialHandle as integer
	dim fileRow as string, row as string
	dim scale as single, i as integer
    dim array(3) as string, pntr as any ptr
	
	dim as integer loopTimes, triangleLoop, vert
    
    objFileDirectory = objFile_getDirectory (filename)
    
    modelDBLength += 1
    modelDB = reallocate(modelDB, modelDBLength * sizeof(modelDBType))
    curModel = modelDBLength - 1
	
	dim Model as Model3D Ptr
	
	Model = Callocate( Sizeof( Model3D ))
	
	modelDB[curModel].modelHandle = Model
    
	Model->max_vertices = 0
	Model->max_triangles = 0
	Model->max_surfaces = 0
	Model->max_uvs = 0
	Model->max_normals = 0
	
    numFaces = 0
	numVertii = 0
    numNormals = 0
    numUvs = 0
	
	modelDB[curModel].modelFile = left$(filename, 64)
    
	'objFile_load = curModel
	'exit function
	
	
	ff = freefile
    open filename for input as #ff
    
    while not eof(ff)
        input #ff, fileRow
        
        row = fileRow
        str_explode " ", row
        indicies = ubound(explodeArray)
        if explodeArray(0) = "v" then 
            Model->max_vertices += 1
        end if
        if explodeArray(0) = "vt" then 
            Model->max_uvs += 1
        end if
        if explodeArray(0) = "vn" then
            Model->max_normals += 1
        end if
        
        
    wend
    
    close #ff
    
	open filename for input as #ff
    
    Model->vertices      = Callocate( Model->max_vertices * Sizeof( Vector3D ) )
	Model->vertexColors  = Callocate( Model->max_vertices * Sizeof( Rgbalpha ) )
	Model->vnormals      = Callocate( Model->max_normals * Sizeof( Vector3D ) )
	Model->triangles	 = Callocate( Sizeof( Triangle3D ) )
	Model->uvs			 = Callocate( Model->max_uvs * Sizeof( Vector2D) )
    
	curVertex = 0
    curUV = 0
    curNormal = 0
    curObject = 0
    materialHandle = 0
    
    scale = 1
    while not eof(ff)
        input #ff, fileRow
        
        row = fileRow
        str_explode " ", row
        indicies = ubound(explodeArray)
        
        if explodeArray(0) = "mtllib" then objFile_loadMaterialLibrary curModel, objFileDirectory + explodeArray(1)
        if explodeArray(0) = "v" then
			Model->vertices[curVertex].X = val(explodeArray(1)) * scale
			Model->vertices[curVertex].Z = -val(explodeArray(2)) * scale
            Model->vertices[curVertex].Y = val(explodeArray(3)) * scale
		    curVertex += 1
        end if
        if explodeArray(0) = "vt" then
			Model->uvs[curUV].u = val(explodeArray(1))
			Model->uvs[curUV].v = -val(explodeArray(2))
            curUV += 1
        end if
        if explodeArray(0) = "vn" then
			Model->vnormals[curNormal].X = val(explodeArray(1))
			Model->vnormals[curNormal].Z = -val(explodeArray(2))
            Model->vnormals[curNormal].Y = val(explodeArray(3))
		    curNormal += 1
        end if
        if explodeArray(0) = "usemtl" then
            for i = 0 to Model->max_materials - 1'modelData[curModel].numMaterials - 1
                'if modelData[curModel].material[i].materialName = explodeArray(1) then materialHandle = i
				if Model->materials[i].materialName = explodeArray(1) then materialHandle = i
            next
        end if
        if explodeArray(0) = "f" then
			for i = 1 to indicies
                array(i - 1) = explodeArray(i)
            next
            loopTimes = 1
			if indicies = 4 then loopTimes = 2
			for triangleLoop = 1 to loopTimes
			
			
				curFace = Model->max_triangles
				
				Model->max_triangles += 1
				
				pntr = reallocate(Model->triangles, Model->max_triangles * sizeof(Triangle3D))
				
				if pntr <> null then
					Model->triangles = pntr
				else
					print "Unable to Resize Faces"
				end if
				for i = 1 to 3
					if loopTimes = 1 then vert = i - 1
					if loopTimes = 2 then
						if triangleLoop = 1 then
							if i = 1 then vert = 0
							if i = 2 then vert = 1
							if i = 3 then vert = 3
						elseif triangleLoop = 2 then
							if i = 1 then vert = 1
							if i = 2 then vert = 2
							if i = 3 then vert = 3
						end if
					end if
					row = array(vert)
					str_explode "/", row
					
					Model->triangles[curFace].point_id(i) = val(explodeArray(0)) - 1
					Model->triangles[curFace].texcoord(i).u = Model->uvs[val(explodeArray(1)) - 1].u
					Model->triangles[curFace].texcoord(i).v = Model->uvs[val(explodeArray(1)) - 1].v
					Model->triangles[curFace].vnormal(i) = val(explodeArray(2)) - 1
					Model->triangles[curFace].material = materialHandle
				next
				
			next
			
        end if
        
    wend
    
    close #ff
	
	Model->Volume = new Vector3D[ Model->max_triangles * 9 ]
	Calc_Planes Model
	Set_Poly_Neighbors Model
	
	'print "loading: " ; right(filename, 14)
    'Print "Loaded:";curVertex; " Vertii, "; curUV; " UVs, "; curNormal; " Normals, "; curFace; " Faces "
    objFile_load = curModel
	
    
end function


sub objFile_loadMaterialLibrary (curModel as integer, filename as string)
    
    dim as integer ff, curMaterial, indicies
	dim as single p
	dim as string objFileDirectory, fileRow, row, texfile
	dim as any ptr pntr
	dim as integer texspace
	
    'dim texspace as SDL_Surface ptr
    
    objFileDirectory = objFile_getDirectory (filename)
    
	dim Model as Model3d ptr
    ff = freefile
    
	Model = modelDB[curModel].modelHandle
	
	Model->materials = callocate(sizeof(modelMaterialType))
    Model->max_materials = 0
	
    open filename for input as #ff
    while not eof(ff)
        input #ff, fileRow
        
        row = fileRow
        str_explode " ", row
        indicies = ubound(explodeArray)
        
        'print row,;
        'if curModel = 2 then waitSpace
        
        if explodeArray(0) = "newmtl" then
            'modelData[curModel].numMaterials += 1
			curMaterial = Model->max_materials
			Model->max_materials += 1
            'curMaterial = modelData[curModel].numMaterials - 1
			
			pntr = reallocate(Model->materials, Model->max_materials * sizeof(ModelMaterialType))
            'pntr = reallocate(modelData[curModel].material, modelData[curModel].numMaterials * sizeof(modelMaterialType))
            if pntr <> null then
                'modelData[curModel].material = pntr
				Model->materials = pntr
            else
                print "Unable to Resize Material"
            end if
            'modelData[curModel].material[curMaterial].materialName = explodeArray(1)
			Model->materials[curMaterial].materialName = explodeArray(1)
        end if
        
        if explodeArray(0) = "d" then
			'modelData[curModel].material[curMaterial].alpha = val(explodeArray(1))
			Model->materials[curMaterial].alpha = val(explodeArray(1))
		end if
		
		if explodeArray(0) = "Kd" then
            'modelData[curModel].material[curMaterial].r = val(explodeArray(1))
            'modelData[curModel].material[curMaterial].g = val(explodeArray(2))
            'modelData[curModel].material[curMaterial].b = val(explodeArray(3))
			Model->materials[curMaterial].r = val(explodeArray(1))
			Model->materials[curMaterial].g = val(explodeArray(2))
			Model->materials[curMaterial].b = val(explodeArray(3))
        end if
        
        if explodeArray(0) = "Ns" then
            p = val(explodeArray(1)) / 1024 * 128
            if p < 0 then p = 0
            if p > 128 then p = 128
            'modelData[curModel].material[curMaterial].hardness = p
			Model->materials[curMaterial].hardness = p
        end if
        
        
		if explodeArray(0) = "map_Kd" then
            'modelData[curModel].material[curMaterial].hasTex = 1
			Model->materials[curMaterial].hasTex = 1
			
            
			'------load material image
            texfile = objFileDirectory + explodeArray(1)
			Load_Texture texspace, texfile
			
			Model->materials[curMaterial].texture = texspace
			
        end if
		
        
        'print "pass"
        'if curModel = 2 then waitSpace
         
    wend
    close #ff

    
end sub