


sub Physics_CalcCenterofMass ( byref PhysicsObject as PhysicsObjectType )

	
	dim Model as Model3D ptr
	dim as integer point_id, pnt, tri
	dim as Vector3D com, points(3), v1, v2, v0
	dim as single totalMass, mass, area, mag
	
	
	mass = PhysicsObject.mass
	
	
	Model = modelDB[PhysicsObject.modelDBIndex].modelHandle
	
    
    
	
	for tri = 0 to Model->max_triangles - 1
		
		'build point array
		'-----------------
		for pnt = 1 to 3
		
			point_id = Model->triangles[tri].point_id(pnt)
			points(pnt).x = Model->vertices[point_id].x
			points(pnt).y = Model->vertices[point_id].y
			points(pnt).z = Model->vertices[point_id].z
			
		next
		
		v1.x = points(2).x - points(1).x
		v1.y = points(2).y - points(1).y
		v1.z = points(2).z - points(1).z
		
		v2.x = points(3).x - points(1).x
		v2.y = points(3).y - points(1).y
		v2.z = points(3).z - points(1).z
		
		
		'perform cross product to get parallelogram
		'uses Dr_D's x method
		'---------------------
		v0.x = (v1.y * v2.z) - (v2.y * v1.z)
		v0.y = (v1.z * v2.x) - (v2.z * v1.x)
		v0.z = (v1.x * v2.y) - (v2.x * v1.y)
		
		mag = sqr(v0.x * v0.x + v0.y * v0.y + v0.z * v0.z)
		
		area = mag / 2
		
		
		'find centroid
		'--------------
		v0.x = (points(1).x + points(2).x + points(3).x) / 3
		v0.y = (points(1).y + points(2).y + points(3).y) / 3
		v0.z = (points(1).z + points(2).z + points(3).z) / 3
		
		
		'add weighted mass of the polygon to the center of mass
		
		com.X += v0.X * mass * area
		com.Y += v0.Y * mass * area
		com.Z += v0.Z * mass * area
		
		totalMass += mass * area
	
	next
	
	com.x /= totalMass
	com.y /= totalMass
	com.z /= totalMass

	PhysicsObject.centerOfMass.X = com.X
	PhysicsObject.centerOfMass.Y = com.Y
	PhysicsObject.centerOfMass.Z = com.Z

end sub



sub Physics_CalcEffectiveContactRadius ( byref PhysicsObject as PhysicsObjectType )


	dim Model as Model3D ptr
	
	dim as integer point_id
	dim as Vector3D pnt
	
	dim as single maxDist, dist
	
	
	maxDist = 0
	
	Model = modelDB[PhysicsObject.modelDBIndex].modelHandle
	
    For point_id = 0 To Model->max_vertices - 1
		
        pnt.X = Model->vertices[point_id].X
		pnt.Y = Model->vertices[point_id].Y
		pnt.Z = Model->vertices[point_id].Z
		
		dist = sqr(pnt.x ^ 2 + pnt.y ^ 2 + pnt.z ^ 2)
		
		if dist > maxDist then maxDist = dist
		
	next
	
	PhysicsObject.effectiveContactRadius = maxDist
	
	
end sub





sub Physics_CalcMomentOfInertia ( byref PhysicsObject as PhysicsObjectType )

	dim Model as Model3D ptr
	dim as integer point_id, pnt, tri
	dim as Vector3D com, points(3), v1, v2, v0, d
	dim as single totalMass, mass, area, mag, moi
	
	
	mass = PhysicsObject.mass
	
	Model = modelDB[PhysicsObject.modelDBIndex].modelHandle
	
    'For point_id = 0 To Model->max_vertices - 1
	'	
    '    pnt.X = Model->vertices[point_id].X
	'	pnt.Y = Model->vertices[point_id].Y
	'	pnt.Z = Model->vertices[point_id].Z
	'	
	'	dx = pnt.X - PhysicsObject.centerOfMass.X
	'	dy = pnt.y - PhysicsObject.centerOfMass.y
	'	dz = pnt.z - PhysicsObject.centerOfMass.z
	'	
	'	moi += mass * (dy * dy + dx * dx + dz * dz)
	'	
	'next
	
	'PhysicsObject.momentOfInertia = moi
	
	
	'PhysicsObject.momentOfInertia = 0
	
	for tri = 0 to Model->max_triangles - 1
		
		'build point array
		'-----------------
		for pnt = 1 to 3
		
			point_id = Model->triangles[tri].point_id(pnt)
			points(pnt).x = Model->vertices[point_id].x
			points(pnt).y = Model->vertices[point_id].y
			points(pnt).z = Model->vertices[point_id].z
			
		next
		
		v1.x = points(2).x - points(1).x
		v1.y = points(2).y - points(1).y
		v1.z = points(2).z - points(1).z
		
		v2.x = points(3).x - points(1).x
		v2.y = points(3).y - points(1).y
		v2.z = points(3).z - points(1).z
		
		
		'perform cross product to get parallelogram
		'uses Dr_D's x method
		'---------------------
		v0.x = (v1.y * v2.z) - (v2.y * v1.z)
		v0.y = (v1.z * v2.x) - (v2.z * v1.x)
		v0.z = (v1.x * v2.y) - (v2.x * v1.y)
		
		mag = sqr(v0.x * v0.x + v0.y * v0.y + v0.z * v0.z)
		
		area = mag / 2
		
		
		'find centroid
		'--------------
		v0.x = (points(1).x + points(2).x + points(3).x) / 3
		v0.y = (points(1).y + points(2).y + points(3).y) / 3
		v0.z = (points(1).z + points(2).z + points(3).z) / 3
		
		
		d.x = v0.X - PhysicsObject.centerOfMass.X
		d.y = v0.y - PhysicsObject.centerOfMass.y
		d.z = v0.z - PhysicsObject.centerOfMass.z
		
		moi += mass * area * (d.y * d.y + d.x * d.x + d.z * d.z)
	
	
	'add weighted mass of the polygon to the center of mass
		
		'com.X += v0.X * mass * area
		'com.Y += v0.Y * mass * area
		'com.Z += v0.Z * mass * area
		
		'totalMass += mass * area
	
	next
	
	PhysicsObject.momentOfInertia = moi
	
	
end sub



function Physics_CalcWithinECR ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType ) as integer


	'PhysicsObjectA.withinEffectiveContactRadius = 0
	
	dim as integer retVal
	
	retVal = 0
	dim delta as Vector3D
	dim deltaMag as single
	
	
	delta.X = PhysicsObjectA.position.x - PhysicsObjectB.position.x
	delta.y = PhysicsObjectA.position.y - PhysicsObjectB.position.y
	delta.z = PhysicsObjectA.position.z - PhysicsObjectB.position.z
	
	deltaMag = sqr(delta.x * delta.X + delta.Y * delta.Y + delta.Z * delta.Z)
	
	PhysicsObjectA.withinEffectiveContactRadius = 0
	
	if deltaMag <= PhysicsObjectA.effectiveContactRadius + PhysicsObjectB.effectiveContactRadius then
		PhysicsObjectA.withinEffectiveContactRadius = 1
		retVal = 1
	end if
	
	return retVal
	
	
	
end function



sub Physics_Initialize ()


	PhysicsData.universalFrictionConstant = .75
	
	
end sub




function Physics_CheckCollision2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType) as integer


	dim as integer pass, retVal
	
	dim as integer wall_id, wall_idB
	
	dim as vector3d wallBase, wallNormal
	dim as vector4d rotBase, rotNormal
	
	dim as vector3d wallB, wallBaseB
	dim as vector4d rotBaseB, rotWallB
	
	dim as vector3d v1, v2
	dim as single cosRadBase, cosRadWall
	
	dim as vector3D SeparatingPlaneNormalBackup
	dim as single spnMag
	
	SeparatingPlaneNormalBackup.x = PhysicsObjectA.SeparatingPlaneNormal.x
	SeparatingPlaneNormalBackup.y = PhysicsObjectA.SeparatingPlaneNormal.y
	
	PhysicsObjectA.SeparatingPlaneNormal.x = 0
	PhysicsObjectA.SeparatingPlaneNormal.y = 0
	
	retVal = 1
	
	#ifdef 0
	'first check previous separating walls
	'-------------------------------------
	wall_id = 0
	do
		
		if PhysicsObjectA.collisionWall->separatingPlane[wall_id] = 1 then
			
			wallBase = 	 PhysicsObjectA.collisionWall->wallBase[wall_id]
			wallNormal = PhysicsObjectA.collisionWall->wallNormal[wall_id]
			
			rotBase.x = wallBase.x
			rotBase.y = wallBase.y
			rotBase.z = wallBase.z
			rotBase.w = 1
			
			rotNormal.x = wallNormal.x + wallBase.x
			rotNormal.y = wallNormal.y + wallBase.y
			rotNormal.z = wallNormal.z + wallBase.z
			rotNormal.w = 1
			
			Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotBase
			Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotNormal
			
			v1.x = rotNormal.x - rotBase.x
			v1.y = rotNormal.y - rotBase.y
			v1.z = rotNormal.z - rotBase.z
			
			pass = 1
			
			wall_idB = 0
			do
			
				wallB = 	  PhysicsObjectB.collisionWall->wall[wall_idB]
				wallBaseB =   PhysicsObjectB.collisionWall->wallBase[wall_idB]
				
				rotBaseB.x = wallBaseB.x
				rotBaseB.y = wallBaseB.y
				rotBaseB.z = wallBaseB.z
				rotBaseB.w = 1
				
				rotWallB.x = wallB.x + wallBaseB.x
				rotWallB.y = wallB.y + wallBaseB.y
				rotWallB.z = wallB.z + wallBaseB.z
				rotWallB.w = 1
				
				Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotBaseB
				Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotWallB
				
				v2.x = rotBaseB.x - rotBase.x
				v2.y = rotBaseB.y - rotBase.y
				v2.z = rotBaseB.z - rotBase.z
				
				cosRadBase = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
				
				v2.x = rotWallB.x - rotBase.x
				v2.y = rotWallB.y - rotBase.y
				v2.z = rotWallB.z - rotBase.z
				
				cosRadWall = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
				
				if cosRadBase > 0 or cosRadWall > 0 then
					pass = 0
					exit do
				end if
				
				wall_idB += 1
			loop until wall_idB = PhysicsObjectB.CollisionWall->max_walls
			
			'if initial check still worked then drop out of sub
			'--------------------------------------------------
			if pass = 1 then return 0
		
		end if
		
		wall_id += 1
	loop until wall_id = PhysicsObjectA.CollisionWall->max_walls
	
	'if failed check other object
	'----------------------------
	wall_id = 0
	do
		
		if PhysicsObjectA.collisionWall->separatingPlane[wall_id] = 1 then
			
			wallBase = 	 PhysicsObjectB.collisionWall->wallBase[wall_id]
			wallNormal = PhysicsObjectB.collisionWall->wallNormal[wall_id]
			
			rotBase.x = wallBase.x
			rotBase.y = wallBase.y
			rotBase.z = wallBase.z
			rotBase.w = 1
			
			rotNormal.x = wallNormal.x + wallBase.x
			rotNormal.y = wallNormal.y + wallBase.y
			rotNormal.z = wallNormal.z + wallBase.z
			rotNormal.w = 1
			
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotBase
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotNormal
			
			v1.x = rotNormal.x - rotBase.x
			v1.y = rotNormal.y - rotBase.y
			v1.z = rotNormal.z - rotBase.z
			
			pass = 1
			
			wall_idB = 0
			do
			
				wallB = 	  PhysicsObjectB.collisionWall->wall[wall_idB]
				wallBaseB =   PhysicsObjectB.collisionWall->wallBase[wall_idB]
				
				rotBaseB.x = wallBaseB.x
				rotBaseB.y = wallBaseB.y
				rotBaseB.z = wallBaseB.z
				rotBaseB.w = 1
				
				rotWallB.x = wallB.x + wallBaseB.x
				rotWallB.y = wallB.y + wallBaseB.y
				rotWallB.z = wallB.z + wallBaseB.z
				rotWallB.w = 1
				
				Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotBaseB
				Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotWallB
				
				v2.x = rotBaseB.x - rotBase.x
				v2.y = rotBaseB.y - rotBase.y
				v2.z = rotBaseB.z - rotBase.z
				
				cosRadBase = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
				
				v2.x = rotWallB.x - rotBase.x
				v2.y = rotWallB.y - rotBase.y
				v2.z = rotWallB.z - rotBase.z
				
				cosRadWall = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
				
				if cosRadBase > 0 or cosRadWall > 0 then
					pass = 0
					exit do
				end if
				
				wall_idB += 1
			loop until wall_idB = PhysicsObjectA.CollisionWall->max_walls
			
			'if initial check still worked then drop out of sub
			'--------------------------------------------------
			if pass = 1 then return 0
		
		end if
		
		wall_id += 1
	loop until wall_id = PhysicsObjectB.CollisionWall->max_walls
	
	#endif
	
	'previous walls did not pass, reset planes
	'-----------------------------------------
	for wall_id = 0 to PhysicsObjectA.CollisionWall->max_walls - 1
	
		PhysicsObjectA.collisionWall->separatingPlane[wall_id] = 0
		
	next
	for wall_id = 0 to PhysicsObjectB.CollisionWall->max_walls - 1
	
		PhysicsObjectB.collisionWall->separatingPlane[wall_id] = 0
		
	next
	
	
	'initially check current object
	'------------------------------
	wall_id = 0	
	do
	
	
		wallBase = 	 PhysicsObjectA.collisionWall->wallBase[wall_id]
		wallNormal = PhysicsObjectA.collisionWall->wallNormal[wall_id]
		
		rotBase.x = wallBase.x
		rotBase.y = wallBase.y
		rotBase.z = wallBase.z
		rotBase.w = 1
		
		rotNormal.x = wallNormal.x + wallBase.x
		rotNormal.y = wallNormal.y + wallBase.y
		rotNormal.z = wallNormal.z + wallBase.z
		rotNormal.w = 1
		
		Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotBase
		Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotNormal
		
		v1.x = rotNormal.x - rotBase.x
		v1.y = rotNormal.y - rotBase.y
		v1.z = rotNormal.z - rotBase.z
		
		pass = 1
		
		wall_idB = 0
		do
	
			wallB = 	  PhysicsObjectB.collisionWall->wall[wall_idB]
			wallBaseB =   PhysicsObjectB.collisionWall->wallBase[wall_idB]
			
			rotBaseB.x = wallBaseB.x
			rotBaseB.y = wallBaseB.y
			rotBaseB.z = wallBaseB.z
			rotBaseB.w = 1
			
			rotWallB.x = wallB.x + wallBaseB.x
			rotWallB.y = wallB.y + wallBaseB.y
			rotWallB.z = wallB.z + wallBaseB.z
			rotWallB.w = 1
			
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotBaseB
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotWallB
			
			v2.x = rotBaseB.x - rotBase.x
			v2.y = rotBaseB.y - rotBase.y
			v2.z = rotBaseB.z - rotBase.z
			
			cosRadBase = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
			
			v2.x = rotWallB.x - rotBase.x
			v2.y = rotWallB.y - rotBase.y
			v2.z = rotWallB.z - rotBase.z
			
			cosRadWall = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
			
			if cosRadBase > 0 or cosRadWall > 0 then
				pass = 0
				exit do
			end if
			
			wall_idB += 1
		loop until wall_idB = PhysicsObjectB.CollisionWall->max_walls
		
		
		'if pass then there is no collision, return
		'------------------------------------------
		if pass = 1 then
			PhysicsObjectA.collisionWall->separatingPlane[wall_id] = 1
			
			PhysicsObjectA.SeparatingPlaneNormal.x += v1.x
			PhysicsObjectA.SeparatingPlaneNormal.y += v1.y
			
			retVal = 0
		end if
		
		
		wall_id += 1
	loop until wall_id = PhysicsObjectA.CollisionWall->max_walls
	
	
	'now check comparator object
	'---------------------------
	wall_id = 0	
	do
	
	
		wallBase = 	 PhysicsObjectB.collisionWall->wallBase[wall_id]
		wallNormal = PhysicsObjectB.collisionWall->wallNormal[wall_id]
		
		rotBase.x = wallBase.x
		rotBase.y = wallBase.y
		rotBase.z = wallBase.z
		rotBase.w = 1
		
		rotNormal.x = wallNormal.x + wallBase.x
		rotNormal.y = wallNormal.y + wallBase.y
		rotNormal.z = wallNormal.z + wallBase.z
		rotNormal.w = 1
		
		Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotBase
		Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotNormal
		
		v1.x = rotNormal.x - rotBase.x
		v1.y = rotNormal.y - rotBase.y
		v1.z = rotNormal.z - rotBase.z
		
		pass = 1
		
		wall_idB = 0
		do
	
			wallB = 	  PhysicsObjectA.collisionWall->wall[wall_idB]
			wallBaseB =   PhysicsObjectA.collisionWall->wallBase[wall_idB]
			
			rotBaseB.x = wallBaseB.x
			rotBaseB.y = wallBaseB.y
			rotBaseB.z = wallBaseB.z
			rotBaseB.w = 1
			
			rotWallB.x = wallB.x + wallBaseB.x
			rotWallB.y = wallB.y + wallBaseB.y
			rotWallB.z = wallB.z + wallBaseB.z
			rotWallB.w = 1
			
			Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotBaseB
			Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotWallB
			
			v2.x = rotBaseB.x - rotBase.x
			v2.y = rotBaseB.y - rotBase.y
			v2.z = rotBaseB.z - rotBase.z
			
			cosRadBase = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
			
			v2.x = rotWallB.x - rotBase.x
			v2.y = rotWallB.y - rotBase.y
			v2.z = rotWallB.z - rotBase.z
			
			cosRadWall = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
			
			if cosRadBase > 0 or cosRadWall > 0 then
				pass = 0
				exit do
			end if
			
			wall_idB += 1
		loop until wall_idB = PhysicsObjectA.CollisionWall->max_walls
		
		
		'if pass then there is no collision, return
		'------------------------------------------
		if pass = 1 then
			PhysicsObjectB.collisionWall->separatingPlane[wall_id] = 1
			
			PhysicsObjectA.SeparatingPlaneNormal.x -= v1.x
			PhysicsObjectA.SeparatingPlaneNormal.y -= v1.y
			
			retVal = 0
		end if
		
		
		wall_id += 1
	loop until wall_id = PhysicsObjectB.CollisionWall->max_walls
	
	
	if retVal = 1 then
		PhysicsObjectA.SeparatingPlaneNormal.x = SeparatingPlaneNormalBackup.x
		PhysicsObjectA.SeparatingPlaneNormal.y = SeparatingPlaneNormalBackup.y
	else
	
		spnMag = sqr(PhysicsObjectA.SeparatingPlaneNormal.x ^ 2 + PhysicsObjectA.SeparatingPlaneNormal.y ^ 2)
		
		PhysicsObjectA.SeparatingPlaneNormal.x /= spnMag
		PhysicsObjectA.SeparatingPlaneNormal.y /= spnMag
	end if
	
	
	'return true, collision occured, no separating walls
	return retVal


end function



'-------------------------------------------------------------
' ProcessPhysics - Performs Physics processing.
' an attempt to make a universal differentiator
'-------------------------------------------------------------
sub Physics_ProcessPhysics ( byref PhysicsObject as PhysicsObjectType )

	
	PhysicsObject.positionBackup.x = PhysicsObject.position.x
	PhysicsObject.positionBackup.z = PhysicsObject.position.z
	
	PhysicsObject.linearAcceleration.x = PhysicsObject.linearForce.x / PhysicsObject.mass
	PhysicsObject.linearAcceleration.z = PhysicsObject.linearForce.z / PhysicsObject.mass
	
	PhysicsObject.linearAcceleration.x -= PhysicsObject.linearVelocity.x * PhysicsData.universalFrictionConstant / PhysicsObject.mass
	PhysicsObject.linearAcceleration.z -= PhysicsObject.linearVelocity.z * PhysicsData.universalFrictionConstant / PhysicsObject.mass
	
	PhysicsObject.linearVelocity.x += PhysicsObject.linearAcceleration.x / 2 * PhysicsData.tickspassedWeighted' * fpsr
	PhysicsObject.linearVelocity.z += PhysicsObject.linearAcceleration.z / 2 * PhysicsData.tickspassedWeighted' * fpsr
	
	PhysicsObject.position.x += PhysicsObject.linearVelocity.x * PhysicsData.tickspassedWeighted
	PhysicsObject.position.z += PhysicsObject.linearVelocity.z * PhysicsData.tickspassedWeighted
	
	
	PhysicsObject.linearForce.x = 0
	PhysicsObject.linearForce.z = 0


	PhysicsObject.angularAcceleration = PhysicsObject.totalTorque / PhysicsObject.MomentOfInertia
	PhysicsObject.angularAcceleration -= PhysicsObject.angularVelocity / PhysicsData.universalTorqueFrictionConstant
	PhysicsObject.angularVelocity += PhysicsObject.angularAcceleration / 2 * PhysicsData.tickspassedWeighted' * fpsr
	PhysicsObject.angle += PhysicsObject.angularVelocity * PhysicsData.tickspassedWeighted
	PhysicsObject.totalTorqueLast = PhysicsObject.totalTorque
	PhysicsObject.totalTorque = 0
	
	
	
	Physics_UpdateObjectMatrix PhysicsObject
	
	
	#ifdef 0
	dim as Vector3D thrustVector, perp, r, linearForce, rotatedForce
	dim as single cosRad, atan
	
	if TorqueTestGlobals.ship.thrust <> 0 then
		thrustVector.x = cos(3.14159 / 180 * TorqueTestGlobals.ship.thrustAngle) * -TorqueTestGlobals.ship.thrust
		thrustVector.y = sin(3.14159 / 180 * TorqueTestGlobals.ship.thrustAngle) * -TorqueTestGlobals.ship.thrust
	
		r.X = TorqueTestGlobals.ship.thrustPoint.X - TorqueTestGlobals.ship.centerOfMass.X
		r.Y = TorqueTestGlobals.ship.thrustPoint.Z - TorqueTestGlobals.ship.centerOfMass.Z
		
		perp.X = -r.Y
		perp.Y = r.X
		
		'mags
		thrustVector.z = sqr(thrustVector.x ^ 2 + thrustVector.Y ^ 2)
		perp.z = sqr(perp.x ^ 2 + perp.Y ^ 2)
		
		cosRad = (thrustVector.x * perp.x + thrustVector.y * perp.y) / (thrustVector.z * perp.z)
		
		TorqueTestGlobals.ship.totalTorque += cosRad * TorqueTestGlobals.ship.thrust
		
		
		'cosRad = (thrustVector.x * perp.x + thrustVector.y * perp.y) / (perp.z * perp.z)
		linearForce.X = thrustVector.x - cosRad * (perp.x / perp.z) * thrustVector.z
		linearForce.Y = thrustVector.y - cosRad * (perp.y / perp.z) * thrustVector.z
		
		rotatedForce.x = linearForce.x * cos(3.14159 / 180 * TorqueTestGlobals.ship.angle) - linearForce.y * sin(3.14159 / 180 * TorqueTestGlobals.ship.angle)
		rotatedForce.y = linearForce.x * sin(3.14159 / 180 * TorqueTestGlobals.ship.angle) + linearForce.y * cos(3.14159 / 180 * TorqueTestGlobals.ship.angle)
		
		TorqueTestGlobals.ship.linearForce.x += rotatedForce.x / 100
		TorqueTestGlobals.ship.linearForce.y += rotatedForce.y / 100
		
		
		TorqueTestGlobals.ship.thrust = 0
	end if
	
	
	TorqueTestGlobals.ship.linearAcceleration.x = TorqueTestGlobals.ship.linearForce.x / TorqueTestGlobals.ship.mass
	TorqueTestGlobals.ship.linearAcceleration.y = TorqueTestGlobals.ship.linearForce.y / TorqueTestGlobals.ship.mass
	
	TorqueTestGlobals.ship.linearAcceleration.x -= TorqueTestGlobals.ship.linearVelocity.x / (TorqueTestGlobals.ship.mass * 2)
	TorqueTestGlobals.ship.linearAcceleration.y -= TorqueTestGlobals.ship.linearVelocity.y / (TorqueTestGlobals.ship.mass * 2)
	
	TorqueTestGlobals.ship.linearVelocity.x += TorqueTestGlobals.ship.linearAcceleration.x / 2 * TorqueTestGlobals.tickspassed
	TorqueTestGlobals.ship.linearVelocity.y += TorqueTestGlobals.ship.linearAcceleration.y / 2 * TorqueTestGlobals.tickspassed
	
	TorqueTestGlobals.ship.position.x += TorqueTestGlobals.ship.linearVelocity.x * TorqueTestGlobals.tickspassed
	TorqueTestGlobals.ship.position.y += TorqueTestGlobals.ship.linearVelocity.y * TorqueTestGlobals.tickspassed
	
	
	TorqueTestGlobals.ship.linearForce.x = 0
	TorqueTestGlobals.ship.linearForce.y = 0


	TorqueTestGlobals.ship.angularAcceleration = TorqueTestGlobals.ship.totalTorque / TorqueTestGlobals.ship.MomentOfInertia
	
	TorqueTestGlobals.ship.angularAcceleration -= TorqueTestGlobals.ship.angularVelocity / TorqueTestGlobals.ship.MomentOfInertia
	
	TorqueTestGlobals.ship.angularVelocity += TorqueTestGlobals.ship.angularAcceleration / 2 * TorqueTestGlobals.tickspassed
	
	TorqueTestGlobals.ship.angle += TorqueTestGlobals.ship.angularVelocity * TorqueTestGlobals.tickspassed

	TorqueTestGlobals.ship.totalTorque = 0
	
	#endif

end sub


'----------------------------------------------------------------------------------
' ProcessCollisionPoint2D - find point of collision and perform physics adjustments
'----------------------------------------------------------------------------------
sub Physics_ProcessCollisionPoint2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType)

	'compare all walls in a to walls in b
	'if a wall in b overlaps a wall in a,
	'  find the point of intersection
	'  determine if point is inside wall a
	'  if so, this is your collision point
	
	
	dim as integer wall_id, wall_idB
	dim as integer pass, collisionPass
	
	dim as vector3d wall, wallBase, wallNormal
	dim as vector3d wallB, wallBaseB, wallNormalB
	dim as vector4d rotBase, rotNormal, rotWall
	dim as vector4d rotBaseB, rotWallB, rotWallNormalB
	
	dim as vector3d v1, v2, v3
	dim as single cosRadBase, cosRadWall, cosRadOffset
	dim as single v1mag, v2mag
	
	dim as single px, py, pmag, pmag3, pmag4
	dim as single x1, y1, x2, y2, x3, y3, x4, y4
	
	
	'collision vars
	dim as single uB, uA
	
	collisionPass = 0
	collisionPoint.x = 0
	collisionPoint.y = 0
	
	
	dim as vector3d collisionNormalsA, collisionNormalsB, collisionNormalsABackup
	dim as integer saveNormal
	

	dim as integer nRegisteredA, nRegisteredB

	'if PhysicsObjectA.CollisionChecked = 1 then exit sub
	if PhysicsObjectB.CollisionChecked = 1 then exit sub
	PhysicsObjectA.CollisionChecked = 1
	
	
	for wall_id = 0 to PhysicsObjectA.CollisionWall->max_walls - 1
	
		wall = 		 PhysicsObjectA.collisionWall->wall[wall_id]
		wallBase = 	 PhysicsObjectA.collisionWall->wallBase[wall_id]
		wallNormal = PhysicsObjectA.collisionWall->wallNormal[wall_id]
		
		rotBase.x = wallBase.x
		rotBase.y = wallBase.y
		rotBase.z = wallBase.z
		rotBase.w = 1
		
		rotWall.x = wall.x + wallBase.x
		rotWall.y = wall.y + wallBase.y
		rotWall.z = wall.z + wallBase.z
		rotWall.w = 1
		
		
		rotNormal.x = wallNormal.x + wallBase.x
		rotNormal.y = wallNormal.y + wallBase.y
		rotNormal.z = wallNormal.z + wallBase.z
		rotNormal.w = 1
		
		Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotBase
		Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotNormal
		Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotWall
		
		v1.x = rotNormal.x - rotBase.x
		v1.y = rotNormal.y - rotBase.y
		v1.z = rotNormal.z - rotBase.z
		
		for wall_idB = 0 to PhysicsObjectB.CollisionWall->max_walls - 1
			
			wallB = 	  PhysicsObjectB.collisionWall->wall[wall_idB]
			wallBaseB =   PhysicsObjectB.collisionWall->wallBase[wall_idB]
			wallNormalB =   PhysicsObjectB.collisionWall->wallNormal[wall_idB]
			
			rotBaseB.x = wallBaseB.x
			rotBaseB.y = wallBaseB.y
			rotBaseB.z = wallBaseB.z
			rotBaseB.w = 1
			
			rotWallB.x = wallB.x + wallBaseB.x
			rotWallB.y = wallB.y + wallBaseB.y
			rotWallB.z = wallB.z + wallBaseB.z
			rotWallB.w = 1
			
			rotWallNormalB.x = wallNormalB.x + wallBaseB.x
			rotWallNormalB.y = wallNormalB.y + wallBaseB.y
			rotWallNormalB.z = wallNormalB.z + wallBaseB.z
			rotWallNormalB.w = 1
			
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotBaseB
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotWallB
			Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotWallNormalB
			
			v2.x = rotBaseB.x - rotBase.x
			v2.y = rotBaseB.y - rotBase.y
			v2.z = rotBaseB.z - rotBase.z
			
			cosRadBase = v2.x * v1.x + v2.y * v1.y + v2.z * v1.z
			
			v3.x = rotWallB.x - rotBase.x
			v3.y = rotWallB.y - rotBase.y
			v3.z = rotWallB.z - rotBase.z
			
			cosRadWall = v3.x * v1.x + v3.y * v1.y + v3.z * v1.z
			
			pass = 0
			
			if cosRadBase < 0 and cosRadWall >= 0 then pass = 1
			if cosRadWall < 0 and cosRadBase >= 0 then pass = 1
			
			cosRadOffset = .01
			
			if cosRadBase > -cosRadOffset and cosRadBase < cosRadOffset and cosRadWall > -cosRadOffset and cosRadWall < cosRadOffset then pass = 0
			
			if pass = 1 then
			
				x1 = rotBase.x
				y1 = rotBase.y
				x2 = rotWall.x
				y2 = rotWall.y
				v1mag = sqr((x2 - x1) ^ 2 + (y2 - y1) ^ 2) / 2
				
				x3 = rotBaseB.x
				y3 = rotBaseB.y
				x4 = rotWallB.x
				y4 = rotWallB.y
				v2mag = sqr((x4 - x3) ^ 2 + (y4 - y3) ^ 2) / 2
				
				
				'connect base of wallA to edges of wallB
				'---------------------------------------
				if (x2 - x1) <> 0 and (y2 - y1) <> 0 then
					uB = (((x3 - x1) / (x2 - x1)) - ((y3 - y1) / (y2 - y1))) / (((y4 - y3) / (y2 - y1)) - ((x4 - x3) / (x2 - x1)))
					px = x3 + uB * (x4 - x3)
					py = y3 + uB * (y4 - y3)
				end if
				
				if (x2 - x1) = 0 or (y2 - y1) = 0 then
					uA = (((x1 - x3) / (x4 - x3)) - ((y1 - y3) / (y4 - y3))) / (((y2 - y1) / (y4 - y3)) - ((x2 - x1) / (x4 - x3)))
					px = x1 + uA * (x2 - x1)
					py = y1 + uA * (y2 - y1)
				end if
				
				
				Physics_NewGlobalLine px-.1, py-.1, px+.1, py+.1, 1, .5, .25
				Physics_NewGlobalLine px-.1, py+.1, px+.1, py-.1, 1, .5, .25
				
				pmag = sqr((px - (x3 + x4) / 2) ^ 2 + (py - (y3 + y4) / 2) ^ 2)
				if pmag <= v2mag then
				
					pmag = sqr((px - (x1 + x2) / 2) ^ 2 + (py - (y1 + y2) / 2) ^ 2)
					if pmag <= v1mag then
						
						PhysicsObjectB.collisionWall->colorCode[wall_idB] = 2
						
						Physics_NewGlobalLine px-.1, py-.1, px+.1, py+.1, 0, .5, .5
						Physics_NewGlobalLine px-.1, py+.1, px+.1, py-.1, 0, .5, .5
						
						CollisionPass += 1
						CollisionPoint.x += px
						CollisionPoint.y += py
						
						PhysicsObjectB.CollisionWall->registered[wall_idB] = 1
						
					end if
					
				end if
				
				
			end if
			
		next
		
		
	next
	
	
	
	'find average of collision points
	'--------------------------------
	dim as single e, j, vABMag, nmMag
	dim as vector3d wallNormalc, vAB
	
	if collisionPass > 0 then
		collisionPoint.x /= collisionPass
		collisionPoint.y /= collisionPass
	end if
	
	Physics_NewGlobalLine CollisionPoint.x-.1, CollisionPoint.y-.1, CollisionPoint.x+.1, CollisionPoint.y+.1, 0, 1, 1
	Physics_NewGlobalLine CollisionPoint.x-.1, CollisionPoint.y+.1, CollisionPoint.x+.1, CollisionPoint.y-.1, 0, 1, 1
	
	
	'determine wallNormal
	'--------------------
	wallNormalc.x = PhysicsObjectA.SeparatingPlaneNormal.x
	wallNormalc.y = PhysicsObjectA.SeparatingPlaneNormal.y
	
	
	'do something
	'------------
	dim as single dotRAP, dotRBP, rAPMag, rBPMag
	dim as vector4D rotCOMA, rotCOMB
	dim as vector3D rAP, rBP
	
	rotCOMA.x = PhysicsObjectA.centerOfMass.x
	rotCOMA.y = PhysicsObjectA.centerOfMass.y
	rotCOMA.z = 0
	rotCOMA.w = 1
	
	rotCOMB.x = PhysicsObjectB.centerOfMass.x
	rotCOMB.y = PhysicsObjectB.centerOfMass.y
	rotCOMB.z = 0
	rotCOMB.w = 1
	
	Matrix_Multiply_Point @PhysicsObjectA.matrix(0), rotCOMA
	Matrix_Multiply_Point @PhysicsObjectB.matrix(0), rotCOMB
	
	
	v1.x = CollisionPoint.x - rotCOMA.x
	v1.y = CollisionPoint.y - rotCOMA.y
	rAP.x = v1.y
	rAP.y = -v1.x
	rAPMag = PhysicsObjectA.mass/ PhysicsObjectA.MomentOfInertia'sqr(rAP.x ^ 2 + rAP.y ^ 2)
	
	
	dotRAP = rAP.x * wallNormalC.x + rAP.y * wallNormalC.y
	
	v1.x = CollisionPoint.x - rotCOMB.x
	v1.y = CollisionPoint.y - rotCOMB.y
	rBP.x = v1.y
	rBP.y = -v1.x
	rBPMag = PhysicsObjectB.mass/ PhysicsObjectB.MomentOfInertia'sqr(rBP.x ^ 2 + rBP.y ^ 2)
	
	dotRBP = rBP.x * wallNormalC.x + rBP.y * wallNormalC.y
	
	
	'draw normal
	'-----------
	Physics_NewGlobalLine CollisionPoint.x, CollisionPoint.y, CollisionPoint.x + PhysicsObjectA.SeparatingPlaneNormal.x, CollisionPoint.y + PhysicsObjectA.SeparatingPlaneNormal.y, 0, 1, 1
	
	'draw rAP/BP and r
	'--------------
	Physics_NewGlobalLine CollisionPoint.x, CollisionPoint.y, CollisionPoint.x + rAP.x / rAPMag, CollisionPoint.y + rAP.y / rAPMag, 1, .5, .25
	Physics_NewGlobalLine CollisionPoint.x, CollisionPoint.y, CollisionPoint.x + rBP.x / rBPMag, CollisionPoint.y + rBP.y / rBPMag, 1, 0, 1
	Physics_NewGlobalLine rotCOMA.x, rotCOMA.y, CollisionPoint.x, CollisionPoint.y, 1, .5, .25
	Physics_NewGlobalLine rotCOMB.x, rotCOMB.y, CollisionPoint.x, CollisionPoint.y, 1, 0, 1
	
	
	'calculate the change in velocity
	'--------------------------------
	vAB.x = (PhysicsObjectB.linearVelocity.x + PhysicsObjectB.angularVelocity * rBP.x / rBPMag) - (PhysicsObjectA.linearVelocity.x + PhysicsObjectA.angularVelocity * rAP.x / rAPMag)
	vAB.y = (PhysicsObjectB.linearVelocity.y + PhysicsObjectB.angularVelocity * rBP.y / rBPMag) - (PhysicsObjectA.linearVelocity.y + PhysicsObjectA.angularVelocity * rAP.y / rAPMag)
	
	vAB.x = PhysicsObjectB.linearVelocity.x - PhysicsObjectA.linearVelocity.x
	vAB.y = PhysicsObjectB.linearVelocity.y - PhysicsObjectA.linearVelocity.y
	
	'draw this new velocity vector
	'-----------------------------
	vAB.z = sqr(vAB.x * vAB.x + vAB.y * vAB.y)
	Physics_NewGlobalLine 0, 0, vAB.x / vAB.z, vAB.y / vAB.z, 1, 0, 0
	
	'elasticity
	'----------
	e = 1'.5
	
	'calculate j
	'-----------
	j = -(1+e) * (vAB.x * wallNormalC.x + vAB.y * wallNormalC.y)  / _
		(((wallNormalC.x * wallNormalC.x + wallNormalC.y * wallNormalC.y) * (1/PhysicsObjectA.mass + 1/PhysicsObjectB.mass)) +(dotRAP ^ 2)/PhysicsObjectA.MomentOfInertia + (dotRBP ^ 2)/PhysicsObjectA.MomentOfInertia)
		
	j = -(1+e) * (vAB.x * wallNormalC.x + vAB.y * wallNormalC.y)  / _
		((wallNormalC.x * wallNormalC.x + wallNormalC.y * wallNormalC.y) * (1/PhysicsObjectA.mass + 1/PhysicsObjectB.mass))
	
	
	PhysicsObjectA.linearVelocity.x -= j * wallNormalc.x / PhysicsObjectA.mass' * 100)
	PhysicsObjectA.linearVelocity.y -= j * wallNormalc.y / PhysicsObjectA.mass' * 100)
	
	PhysicsObjectB.linearVelocity.x += j * wallNormalc.x / PhysicsObjectB.mass' * 100)
	PhysicsObjectB.linearVelocity.y += j * wallNormalc.y / PhysicsObjectB.mass' * 100)
	
	'PhysicsObjectA.angularVelocity -= j * dotRAP / PhysicsObjectA.MomentOfInertia
	'PhysicsObjectB.angularVelocity += j * dotRBP / PhysicsObjectB.MomentOfInertia
	
	
	
end sub



sub Physics_UpdateObjectMatrix ( byref PhysicsObject as PhysicsObjectType )

	'PhysicsObject.MatrixBackup = Physicsobject.Matrix
	
	Matrix_LoadIdentity @PhysicsObject.matrix(0)
	Matrix_LoadIdentity @PhysicsObject.matrix2(0)
	Matrix_LoadIdentity @PhysicsObject.matrixCam(0)
	'CollideTestGlobals.object(i).matrix(0)
	
	Matrix_Rotate @PhysicsObject.matrix(0), PhysicsObject.zAngle, 0, 0, 1
	Matrix_Rotate @PhysicsObject.matrix(0), PhysicsObject.xAngle, 1, 0, 0
	Matrix_Rotate @PhysicsObject.matrix(0), PhysicsObject.angle, 0, 1, 0
	
	Matrix_Rotate @PhysicsObject.matrix2(0), PhysicsObject.angle, 0, 1, 0
	Matrix_Rotate @PhysicsObject.matrixCam(0), PhysicsObject.angle, 0, -1, 0
	
	Matrix_Translate @PhysicsObject.matrix(0), PhysicsObject.position.x, PhysicsObject.position.y, PhysicsObject.position.z
	Matrix_Translate @PhysicsObject.matrix2(0), PhysicsObject.position.x, PhysicsObject.position.y, PhysicsObject.position.z
	Matrix_Translate @PhysicsObject.matrixCam(0), -PhysicsObject.position.x, -PhysicsObject.position.y, -PhysicsObject.position.z
	
	
	
	
end sub




sub Physics_NewGlobalLine (x0 as single, y0 as single, x1 as single, y1 as single, r as single, g as single, b as single)

	globalLine(maxGlobalLines).x0 = x0
	globalLine(maxGlobalLines).y0 = y0
	globalLine(maxGlobalLines).x1 = x1
	globalLine(maxGlobalLines).y1 = y1
	globalLine(maxGlobalLines).r = r
	globalLine(maxGlobalLines).g = g
	globalLine(maxGlobalLines).b = b
	maxGlobalLines += 1

end sub

