

type CollideTest2dCollisionWallType

	max_walls	as integer
	wall		as Vector3D ptr
	wallBase	as Vector3D ptr
	wallNormal	as Vector3D ptr
	
	registered	as integer ptr
	separatingPlane	as integer ptr
	colorCode	as integer ptr
	
end type




type PhysicsObjectType

	modelDBIndex	as integer
	
	objectTypeCode	as integer
	
	objectNum		as integer
	
	Matrix(15)			as single
	Matrix2(15)			as single
	MatrixBackup(15)	as single
	MatrixCam(15)		as single
	
	angle		as single
	xAngle		as single
	zAngle		as single
	targetxAngle		as single
	targetzAngle		as single

	position		as Vector3D
	positionBackup	as Vector3D
	
	thrust		as single
	thrustAngle	as single
	thrustForce	as Vector3D
	thrustPoint	as Vector3D
	
	linearForce			as Vector3D
	linearAcceleration	as Vector3D
	linearVelocity		as Vector3D
	
	totalTorque			as single
	totalTorqueLast		as single
	angularAcceleration	as single
	angularVelocity		as single
	
	centerOfMass		as Vector3D
	MomentOfInertia		as single
	
	mass				as single
	
	
	effectiveContactRadius	as single
	withinEffectiveContactRadius	as integer
	
	CollisionWall		as CollideTest2DCollisionWallType ptr
	
	CollisionChecked	as integer
	
	SeparatingPlaneNormal	as Vector3D
	
end type


type PhysicsDataType


	ticks				as single
	tickspassed			as single
	tickspassedBackup	as single
	tickspassedWeighted	as single
	
	universalFrictionConstant	as single
	universalTorqueFrictionConstant	as single
	
end type


dim shared PhysicsData as PhysicsDataType

dim shared collisionPass as integer, collisionPoint as vector3d


type globalLineType
	x0	as single
	y0	as single
	x1	as single
	y1	as single
	r	as single
	g	as single
	b	as single
end type


dim shared globalLine(100) as globalLineType, maxGlobalLines as integer

DECLARE sub Physics_CalcCenterofMass ( byref PhysicsObject as PhysicsObjectType )
DECLARE sub Physics_CalcEffectiveContactRadius ( byref PhysicsObject as PhysicsObjectType )
DECLARE sub Physics_CalcMomentOfInertia ( byref PhysicsObject as PhysicsObjectType )
DECLARE function Physics_CalcWithinECR ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType ) as integer
'DECLARE function Physics_CheckCollision2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType, byref SeparatingPlaneNormal as vector3D ) as integer
DECLARE function Physics_CheckCollision2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType ) as integer
DECLARE sub Physics_Initialize ()
DECLARE sub Physics_ProcessPhysics (byref PhysicsObject as PhysicsObjectType )
'DECLARE sub Physics_ProcessCollisionPoint2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType, byref SeparatingPlaneNormal as vector3D )
DECLARE sub Physics_ProcessCollisionPoint2D ( byref PhysicsObjectA as PhysicsObjectType, byref PhysicsObjectB as PhysicsObjectType )
DECLARE sub Physics_UpdateObjectMatrix ( byref PhysicsObject as PhysicsObjectType )


DECLARE sub Physics_NewGlobalLine (x0 as single, y0 as single, x1 as single, y1 as single, r as single, g as single, b as single)
