#include once "model_module.bi"

sub Begin_Shadow_Pass()
    
	glDisable(GL_LIGHTING)
	glDepthMask(GL_FALSE)
	glDepthFunc(GL_LEQUAL)
    
	glEnable(GL_STENCIL_TEST)
	glColorMask(0, 0, 0, 0)
	glStencilFunc(GL_ALWAYS, 8, -1)
    
    glenable( GL_VERTEX_ARRAY )
	glenable( GL_POLYGON_OFFSET_FILL )
	glpolygonoffset( 0.1, 4 )

end sub



Sub Build_Stencil_Cube( Byref List As Gluint )
    List = GlGenLists(1)
    GlNewList( List, GL_COMPILE )
    glDisable( GL_POLYGON_OFFSET_FILL )
	gldisable( GL_VERTEX_ARRAY )
    glFrontFace( GL_CCW)
    glColorMask( 1, 1, 1, 1 )
    glStencilFunc( GL_NOTEQUAL, 0, -1 )
    glStencilOp( GL_KEEP, GL_KEEP, GL_KEEP )
    
	dim as single yy
	
	yy = 36 / 100
    glPushMatrix()
		glLoadIdentity()
		glBegin( GL_TRIANGLE_STRIP )
			glColor4f 0, 0, 0, 0
			glVertex3f(-1, yy, -1)
			
			glColor4f 0, 0, 0, .5
			glVertex3f(-1,-yy, -1)
			
			glColor4f 0, 0, 0, 0
			glVertex3f( 1, yy, -1)
			
			glColor4f 0, 0, 0, .5
			glVertex3f( 1,-yy, -1)
		Glend()
	glPopMatrix
    
    glDepthFunc(GL_LEQUAL)
    glDepthMask(GL_TRUE)
    glEnable(GL_LIGHTING)
    glDisable(GL_STENCIL_TEST)
    glShadeModel(GL_SMOOTH)
    GlEndList
End Sub



sub Calc_Planes( byref Model as Model3D ptr )
    dim as integer i
    dim v1 as Vector3D, V2 as Vector3D, V3 as Vector3D
    
    
    for i = 0 to Model->max_triangles-1
        V1.X = Model->vertices[Model->triangles[i].point_Id(1)].X
        V1.y = Model->vertices[Model->triangles[i].point_Id(1)].Y
        V1.Z = Model->vertices[Model->triangles[i].point_Id(1)].Z
        
        V2.X = Model->vertices[Model->triangles[i].point_Id(2)].X
        V2.y = Model->vertices[Model->triangles[i].point_Id(2)].Y
        V2.Z = Model->vertices[Model->triangles[i].point_Id(2)].Z
        
        V3.X = Model->vertices[Model->triangles[i].point_Id(3)].X
        V3.y = Model->vertices[Model->triangles[i].point_Id(3)].Y
        V3.Z = Model->vertices[Model->triangles[i].point_Id(3)].Z
        
        Model->triangles[i].Plane.X = v1.y * (v2.z-v3.z) + v2.y * (v3.z-v1.z) + v3.y * (v1.z-v2.z)
        Model->triangles[i].Plane.Y = v1.z*(v2.x-v3.x) + v2.z*(v3.x-v1.x) + v3.z*(v1.x-v2.x)
        Model->triangles[i].Plane.Z = v1.x*(v2.y-v3.y) + v2.x*(v3.y-v1.y) + v3.x*(v1.y-v2.y)
        Model->triangles[i].Plane.W = -( v1.x*( v2.y*v3.z - v3.y*v2.z ) + v2.x*(v3.y*v1.z - v1.y*v3.z) + v3.x*(v1.y*v2.z - v2.y*v1.z) )
    next
end sub




sub calc_shadow_volume ( byval Model as Model3D ptr, byref lp as Vector4D )
    
    
    for i as integer = 0 to Model->max_triangles-1
        Model->triangles[i].visible = 0
        if math_dot(Model->triangles[i].Plane, Lp) > 0 then Model->triangles[i].visible = 1
    next
    
    dim as integer p1, p2, j, jj, f_Hits, cf_Hits, cr_Hits
    dim as Vector3D v1,v2,v3,v4
    
    with *Model
        
        for i as integer = 0 to .max_triangles-1
            if .triangles[i].visible <> 0 then
                for j=1 to 3
                    dim as integer k = .triangles[i].con(j)
                    if k = 0 or .triangles[k-1].Visible = 0 then
                        'if .triangles[k-1].invisible = 0 then
                        p1 = .triangles[i].Point_Id(j)
                        JJ = J+1
                        if JJ>3 then JJ = 1
                        
                        p2 = .triangles[i].Point_Id(jj)
                        
                        v1 = (.vertices[p1] - lp) * Shadow_Infinity
                        v2 = (.vertices[p2] - lp) * Shadow_Infinity
                        v3 = .vertices[p1] + v1
                        v4 = .vertices[p2] + v2
                        
                        .Volume[f_Hits]   = .vertices[p1]
                        .Volume[f_Hits+1] = v3
                        .Volume[f_Hits+2] = .vertices[p2]
                        
                        .Volume[f_Hits+3] = .vertices[p2]
                        .Volume[f_Hits+4] = v3
                        .Volume[f_Hits+5] = v4
                        
                        f_Hits+=6
                        'end if
                    end if
                    
                next
                
                for t as integer = 1 to 3 step 1
                    dim as integer tt = .triangles[i].point_ID(t)
                    .Volume[f_Hits]  =  .vertices[tt]
                    f_Hits+=1
                    
                next
            else
                
                for t as integer = 1 to 3 step 1
                    dim as integer tt = .triangles[i].point_ID(t)
                    .Volume[f_Hits]  =  .vertices[tt]+((.vertices[tt] - lp) * shadow_infinity)
                    f_Hits+=1
                next
                
            end if
        next
        
        .fCnt = f_Hits
        
        
    end with
    
end sub



sub do_shadow_pass( byref Model as Model3D ptr)', byref lp as Vector4D )
	
	'glenable( GL_DEPTH_CLAMP_NV )
	
	glcullface GL_FRONT
	glstencilop(GL_KEEP, GL_INCR_WRAP, GL_KEEP)
	render_quick_volume( Model )
    
	glcullface( GL_BACK )
	glstencilop(GL_KEEP, GL_DECR_WRAP, GL_KEEP )
	render_quick_volume( Model )
    	
	'gldisable( GL_DEPTH_CLAMP_NV )
end sub


sub render_quick_volume( byref Model as Model3D ptr )
    
	glvertexpointer( 3,  GL_FLOAT,  0, @Model->Volume[0].x )
	gldrawarrays(GL_TRIANGLES, 0, Model->fCnt )
    
end sub


'section for rendering precalculated shadow volumes of volume3d type 
sub calc_shadow_volume_PRECALC( byval Model as Model3D ptr, byref Shadow as volume3d ptr, byref lp as Vector4D )
    
    for i as integer = 0 to Model->max_triangles-1
        Model->triangles[i].visible = 0
        if math_dot(Model->triangles[i].Plane, Lp) > 0 then Model->triangles[i].visible = 1
    next
    
    dim as integer p1, p2, j, jj, f_Hits, cf_Hits, cr_Hits
    dim as Vector3D v1,v2,v3,v4
    
    with *Model
        
        for i as integer = 0 to .max_triangles-1
            if .triangles[i].visible <> 0 then
                for j=1 to 3
                    dim as integer k = .triangles[i].con(j)
                    if k = 0 or .triangles[k-1].Visible = 0 then
                        'if .triangles[k-1].invisible = 0 then
                        p1 = .triangles[i].Point_Id(j)
                        JJ = J+1
                        if JJ>3 then JJ = 1
                        
                        p2 = .triangles[i].Point_Id(jj)
                        
                        v1 = (.vertices[p1] - lp) * Shadow_Infinity
                        v2 = (.vertices[p2] - lp) * Shadow_Infinity
                        v3 = .vertices[p1] + v1
                        v4 = .vertices[p2] + v2
                        
                        '.Volume[f_Hits]   = .vertices[p1]
                        '.Volume[f_Hits+1] = v3
                        '.Volume[f_Hits+2] = .vertices[p2]
                        
                        '.Volume[f_Hits+3] = .vertices[p2]
                        '.Volume[f_Hits+4] = v3
                        '.Volume[f_Hits+5] = v4
                        
                       Shadow->Volume[f_Hits]   = .vertices[p1]
                       Shadow->Volume[f_Hits+1] = v3
                       Shadow->Volume[f_Hits+2] = .vertices[p2]
                       
                        Shadow->Volume[f_Hits+3] = .vertices[p2]
                        Shadow->Volume[f_Hits+4] = v3
                        Shadow->Volume[f_Hits+5] = v4 
                        
                        
                        f_Hits+=6
                        'end if
                    end if
                    
                next
                
                for t as integer = 1 to 3 step 1
                    dim as integer tt = .triangles[i].point_ID(t)
                    Shadow->Volume[f_Hits]  =  .vertices[tt]
                    f_Hits+=1
                    
                next
            else
                
                for t as integer = 1 to 3 step 1
                    dim as integer tt = .triangles[i].point_ID(t)
                    Shadow->Volume[f_Hits]  =  .vertices[tt]+((.vertices[tt] - lp) * shadow_infinity)
                    f_Hits+=1
                next
                
            end if
        next
		
		
        '.fCnt = f_Hits
        Shadow->fCnt = f_Hits
        
    end with
    
end sub



sub do_shadow_pass_PRECALC( byref Shadow as Volume3D ptr )
	
	'glenable( GL_DEPTH_CLAMP_NV )
	
	glcullface GL_FRONT
	glstencilop(GL_KEEP, GL_INCR_WRAP, GL_KEEP)
	render_quick_volume_PRECALC( Shadow )
    
	glcullface( GL_BACK )
	glstencilop(GL_KEEP, GL_DECR_WRAP, GL_KEEP )
	render_quick_volume_PRECALC( Shadow )
    	
	'gldisable( GL_DEPTH_CLAMP_NV )
end sub


sub render_quick_volume_PRECALC( byref Shadow as volume3D ptr )
    
	glvertexpointer( 3,  GL_FLOAT,  0, @Shadow->Volume[0].x )
	gldrawarrays(GL_TRIANGLES, 0, Shadow->fCnt )
    
end sub
'end precalculated shadow vlume routines



sub Set_Poly_Neighbors( byref Model as Model3D ptr )
    dim as integer f, f2
    dim as integer i, i2
    dim as integer Hitcnt
    dim as integer P1a, P1b, P2a, P2b, C1a, C2a, C1b, C2b
    
    for f = 0 to Model->max_triangles-1
        for i = 1 to 3
            Model->triangles[f].Con(i) = 0
        next
    next
    
    for f = 0 to Model->max_triangles-2
        for f2 = f+1 to Model->max_triangles-1
            for i = 1 to 3
                if Model->triangles[f].Con(i) = 0 then
                    for i2 = 1 to 3
                        
                        P1a = i
                        P1b = i2
                        P2a = (P1a mod 3) + 1
                        P2b = (P1b mod 3) + 1
                        
                        P1a = Model->triangles[f].Point_ID(P1a)
                        P2a = Model->triangles[f].Point_ID(P2a)
                        P1b = Model->triangles[f2].Point_ID(P1b)
                        P2b = Model->triangles[f2].Point_ID(P2b)
                        
                        C1a=((P1a+P2a) - abs(P1a-P2a)) \ 2
						C2a=((P1a+P2a) + abs(P1a-P2a)) \ 2
						C1b=((P1b+P2b) - abs(P1b-P2b)) \ 2
						C2b=((P1b+P2b) + abs(P1b-P2b)) \ 2
                        
                        if (C1a = C1b) and (C2a = C2b) then
                            Model->triangles[f].Con(i) = f2+1
                            Model->triangles[f2].Con(i2) = f+1
                        end if
                        
                    next
                end if
            next
        next
    next
end sub


